/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Configuration Properties Clause</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getMode1 <em>Mode1</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getProperties <em>Properties</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getMode2 <em>Mode2</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getConfigurationPropertiesClause()
 * @model
 * @generated
 */
public interface ConfigurationPropertiesClause extends EObject
{
  /**
   * Returns the value of the '<em><b>Mode1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mode1</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mode1</em>' attribute.
   * @see #setMode1(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getConfigurationPropertiesClause_Mode1()
   * @model
   * @generated
   */
  String getMode1();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getMode1 <em>Mode1</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mode1</em>' attribute.
   * @see #getMode1()
   * @generated
   */
  void setMode1(String value);

  /**
   * Returns the value of the '<em><b>Properties</b></em>' containment reference list.
   * The list contents are of type {@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Properties</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Properties</em>' containment reference list.
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getConfigurationPropertiesClause_Properties()
   * @model containment="true"
   * @generated
   */
  EList<ConfigurationPropertyClause> getProperties();

  /**
   * Returns the value of the '<em><b>Mode2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mode2</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mode2</em>' attribute.
   * @see #setMode2(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getConfigurationPropertiesClause_Mode2()
   * @model
   * @generated
   */
  String getMode2();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getMode2 <em>Mode2</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mode2</em>' attribute.
   * @see #getMode2()
   * @generated
   */
  void setMode2(String value);

} // ConfigurationPropertiesClause
