/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>List Metrics Query</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ListMetricsQuery#getMode <em>Mode</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ListMetricsQuery#getEntityReferenceClause <em>Entity Reference Clause</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getListMetricsQuery()
 * @model
 * @generated
 */
public interface ListMetricsQuery extends EObject
{
  /**
   * Returns the value of the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mode</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mode</em>' attribute.
   * @see #setMode(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getListMetricsQuery_Mode()
   * @model
   * @generated
   */
  String getMode();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.ListMetricsQuery#getMode <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mode</em>' attribute.
   * @see #getMode()
   * @generated
   */
  void setMode(String value);

  /**
   * Returns the value of the '<em><b>Entity Reference Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Entity Reference Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Entity Reference Clause</em>' containment reference.
   * @see #setEntityReferenceClause(EntityReferenceClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getListMetricsQuery_EntityReferenceClause()
   * @model containment="true"
   * @generated
   */
  EntityReferenceClause getEntityReferenceClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.ListMetricsQuery#getEntityReferenceClause <em>Entity Reference Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Entity Reference Clause</em>' containment reference.
   * @see #getEntityReferenceClause()
   * @generated
   */
  void setEntityReferenceClause(EntityReferenceClause value);

} // ListMetricsQuery
