/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause;
import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Exploration Strategy Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ExplorationStrategyClauseImpl#getMode <em>Mode</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ExplorationStrategyClauseImpl#getName <em>Name</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ExplorationStrategyClauseImpl#getParameterClause <em>Parameter Clause</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ExplorationStrategyClauseImpl extends MinimalEObjectImpl.Container implements ExplorationStrategyClause
{
  /**
   * The default value of the '{@link #getMode() <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode()
   * @generated
   * @ordered
   */
  protected static final String MODE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMode() <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode()
   * @generated
   * @ordered
   */
  protected String mode = MODE_EDEFAULT;

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The cached value of the '{@link #getParameterClause() <em>Parameter Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParameterClause()
   * @generated
   * @ordered
   */
  protected ConfigurationPropertiesClause parameterClause;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ExplorationStrategyClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.EXPLORATION_STRATEGY_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getMode()
  {
    return mode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMode(String newMode)
  {
    String oldMode = mode;
    mode = newMode;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__MODE, oldMode, mode));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConfigurationPropertiesClause getParameterClause()
  {
    return parameterClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetParameterClause(ConfigurationPropertiesClause newParameterClause, NotificationChain msgs)
  {
    ConfigurationPropertiesClause oldParameterClause = parameterClause;
    parameterClause = newParameterClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE, oldParameterClause, newParameterClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParameterClause(ConfigurationPropertiesClause newParameterClause)
  {
    if (newParameterClause != parameterClause)
    {
      NotificationChain msgs = null;
      if (parameterClause != null)
        msgs = ((InternalEObject)parameterClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE, null, msgs);
      if (newParameterClause != null)
        msgs = ((InternalEObject)newParameterClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE, null, msgs);
      msgs = basicSetParameterClause(newParameterClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE, newParameterClause, newParameterClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE:
        return basicSetParameterClause(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__MODE:
        return getMode();
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__NAME:
        return getName();
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE:
        return getParameterClause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__MODE:
        setMode((String)newValue);
        return;
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__NAME:
        setName((String)newValue);
        return;
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE:
        setParameterClause((ConfigurationPropertiesClause)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__MODE:
        setMode(MODE_EDEFAULT);
        return;
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__NAME:
        setName(NAME_EDEFAULT);
        return;
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE:
        setParameterClause((ConfigurationPropertiesClause)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__MODE:
        return MODE_EDEFAULT == null ? mode != null : !MODE_EDEFAULT.equals(mode);
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE:
        return parameterClause != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (mode: ");
    result.append(mode);
    result.append(", name: ");
    result.append(name);
    result.append(')');
    return result.toString();
  }

} //ExplorationStrategyClauseImpl
