/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.FilterClause;
import tools.descartes.dql.lang.descartesQL.FilterConditionClause;
import tools.descartes.dql.lang.descartesQL.FilterConjunction;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Filter Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.FilterClauseImpl#getMode <em>Mode</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.FilterClauseImpl#getFilterConditions <em>Filter Conditions</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.FilterClauseImpl#getFilterConjunctions <em>Filter Conjunctions</em>}</li>
 * </ul>
 *
 * @generated
 */
public class FilterClauseImpl extends MinimalEObjectImpl.Container implements FilterClause
{
  /**
   * The default value of the '{@link #getMode() <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode()
   * @generated
   * @ordered
   */
  protected static final String MODE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMode() <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode()
   * @generated
   * @ordered
   */
  protected String mode = MODE_EDEFAULT;

  /**
   * The cached value of the '{@link #getFilterConditions() <em>Filter Conditions</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFilterConditions()
   * @generated
   * @ordered
   */
  protected EList<FilterConditionClause> filterConditions;

  /**
   * The cached value of the '{@link #getFilterConjunctions() <em>Filter Conjunctions</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFilterConjunctions()
   * @generated
   * @ordered
   */
  protected EList<FilterConjunction> filterConjunctions;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FilterClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.FILTER_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getMode()
  {
    return mode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMode(String newMode)
  {
    String oldMode = mode;
    mode = newMode;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.FILTER_CLAUSE__MODE, oldMode, mode));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FilterConditionClause> getFilterConditions()
  {
    if (filterConditions == null)
    {
      filterConditions = new EObjectContainmentEList<FilterConditionClause>(FilterConditionClause.class, this, DescartesQLPackage.FILTER_CLAUSE__FILTER_CONDITIONS);
    }
    return filterConditions;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FilterConjunction> getFilterConjunctions()
  {
    if (filterConjunctions == null)
    {
      filterConjunctions = new EDataTypeEList<FilterConjunction>(FilterConjunction.class, this, DescartesQLPackage.FILTER_CLAUSE__FILTER_CONJUNCTIONS);
    }
    return filterConjunctions;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONDITIONS:
        return ((InternalEList<?>)getFilterConditions()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTER_CLAUSE__MODE:
        return getMode();
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONDITIONS:
        return getFilterConditions();
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONJUNCTIONS:
        return getFilterConjunctions();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTER_CLAUSE__MODE:
        setMode((String)newValue);
        return;
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONDITIONS:
        getFilterConditions().clear();
        getFilterConditions().addAll((Collection<? extends FilterConditionClause>)newValue);
        return;
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONJUNCTIONS:
        getFilterConjunctions().clear();
        getFilterConjunctions().addAll((Collection<? extends FilterConjunction>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTER_CLAUSE__MODE:
        setMode(MODE_EDEFAULT);
        return;
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONDITIONS:
        getFilterConditions().clear();
        return;
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONJUNCTIONS:
        getFilterConjunctions().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTER_CLAUSE__MODE:
        return MODE_EDEFAULT == null ? mode != null : !MODE_EDEFAULT.equals(mode);
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONDITIONS:
        return filterConditions != null && !filterConditions.isEmpty();
      case DescartesQLPackage.FILTER_CLAUSE__FILTER_CONJUNCTIONS:
        return filterConjunctions != null && !filterConjunctions.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (mode: ");
    result.append(mode);
    result.append(", filterConjunctions: ");
    result.append(filterConjunctions);
    result.append(')');
    return result.toString();
  }

} //FilterClauseImpl
