/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.ObservationClause;
import tools.descartes.dql.lang.descartesQL.ObserveClause;
import tools.descartes.dql.lang.descartesQL.SampleClause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Observe Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ObserveClauseImpl#getMode <em>Mode</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ObserveClauseImpl#getObservation <em>Observation</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ObserveClauseImpl#getSampleClause <em>Sample Clause</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ObserveClauseImpl extends MinimalEObjectImpl.Container implements ObserveClause
{
  /**
   * The default value of the '{@link #getMode() <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode()
   * @generated
   * @ordered
   */
  protected static final String MODE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMode() <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode()
   * @generated
   * @ordered
   */
  protected String mode = MODE_EDEFAULT;

  /**
   * The cached value of the '{@link #getObservation() <em>Observation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObservation()
   * @generated
   * @ordered
   */
  protected ObservationClause observation;

  /**
   * The cached value of the '{@link #getSampleClause() <em>Sample Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSampleClause()
   * @generated
   * @ordered
   */
  protected SampleClause sampleClause;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ObserveClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.OBSERVE_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getMode()
  {
    return mode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMode(String newMode)
  {
    String oldMode = mode;
    mode = newMode;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.OBSERVE_CLAUSE__MODE, oldMode, mode));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObservationClause getObservation()
  {
    return observation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObservation(ObservationClause newObservation, NotificationChain msgs)
  {
    ObservationClause oldObservation = observation;
    observation = newObservation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION, oldObservation, newObservation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObservation(ObservationClause newObservation)
  {
    if (newObservation != observation)
    {
      NotificationChain msgs = null;
      if (observation != null)
        msgs = ((InternalEObject)observation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION, null, msgs);
      if (newObservation != null)
        msgs = ((InternalEObject)newObservation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION, null, msgs);
      msgs = basicSetObservation(newObservation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION, newObservation, newObservation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SampleClause getSampleClause()
  {
    return sampleClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetSampleClause(SampleClause newSampleClause, NotificationChain msgs)
  {
    SampleClause oldSampleClause = sampleClause;
    sampleClause = newSampleClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE, oldSampleClause, newSampleClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSampleClause(SampleClause newSampleClause)
  {
    if (newSampleClause != sampleClause)
    {
      NotificationChain msgs = null;
      if (sampleClause != null)
        msgs = ((InternalEObject)sampleClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE, null, msgs);
      if (newSampleClause != null)
        msgs = ((InternalEObject)newSampleClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE, null, msgs);
      msgs = basicSetSampleClause(newSampleClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE, newSampleClause, newSampleClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION:
        return basicSetObservation(null, msgs);
      case DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE:
        return basicSetSampleClause(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_CLAUSE__MODE:
        return getMode();
      case DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION:
        return getObservation();
      case DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE:
        return getSampleClause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_CLAUSE__MODE:
        setMode((String)newValue);
        return;
      case DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION:
        setObservation((ObservationClause)newValue);
        return;
      case DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE:
        setSampleClause((SampleClause)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_CLAUSE__MODE:
        setMode(MODE_EDEFAULT);
        return;
      case DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION:
        setObservation((ObservationClause)null);
        return;
      case DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE:
        setSampleClause((SampleClause)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_CLAUSE__MODE:
        return MODE_EDEFAULT == null ? mode != null : !MODE_EDEFAULT.equals(mode);
      case DescartesQLPackage.OBSERVE_CLAUSE__OBSERVATION:
        return observation != null;
      case DescartesQLPackage.OBSERVE_CLAUSE__SAMPLE_CLAUSE:
        return sampleClause != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (mode: ");
    result.append(mode);
    result.append(')');
    return result.toString();
  }

} //ObserveClauseImpl
