/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.ObserveRelativeClause;
import tools.descartes.dql.lang.descartesQL.ObserveRelativeDirectionType;
import tools.descartes.dql.lang.descartesQL.TimeClause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Observe Relative Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ObserveRelativeClauseImpl#getDirection <em>Direction</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ObserveRelativeClauseImpl#getTimeTarget <em>Time Target</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ObserveRelativeClauseImpl extends ObservationClauseImpl implements ObserveRelativeClause
{
  /**
   * The default value of the '{@link #getDirection() <em>Direction</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDirection()
   * @generated
   * @ordered
   */
  protected static final ObserveRelativeDirectionType DIRECTION_EDEFAULT = ObserveRelativeDirectionType.SINCE;

  /**
   * The cached value of the '{@link #getDirection() <em>Direction</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDirection()
   * @generated
   * @ordered
   */
  protected ObserveRelativeDirectionType direction = DIRECTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getTimeTarget() <em>Time Target</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimeTarget()
   * @generated
   * @ordered
   */
  protected TimeClause timeTarget;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ObserveRelativeClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.OBSERVE_RELATIVE_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObserveRelativeDirectionType getDirection()
  {
    return direction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDirection(ObserveRelativeDirectionType newDirection)
  {
    ObserveRelativeDirectionType oldDirection = direction;
    direction = newDirection == null ? DIRECTION_EDEFAULT : newDirection;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__DIRECTION, oldDirection, direction));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TimeClause getTimeTarget()
  {
    return timeTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetTimeTarget(TimeClause newTimeTarget, NotificationChain msgs)
  {
    TimeClause oldTimeTarget = timeTarget;
    timeTarget = newTimeTarget;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET, oldTimeTarget, newTimeTarget);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTimeTarget(TimeClause newTimeTarget)
  {
    if (newTimeTarget != timeTarget)
    {
      NotificationChain msgs = null;
      if (timeTarget != null)
        msgs = ((InternalEObject)timeTarget).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET, null, msgs);
      if (newTimeTarget != null)
        msgs = ((InternalEObject)newTimeTarget).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET, null, msgs);
      msgs = basicSetTimeTarget(newTimeTarget, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET, newTimeTarget, newTimeTarget));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET:
        return basicSetTimeTarget(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__DIRECTION:
        return getDirection();
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET:
        return getTimeTarget();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__DIRECTION:
        setDirection((ObserveRelativeDirectionType)newValue);
        return;
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET:
        setTimeTarget((TimeClause)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__DIRECTION:
        setDirection(DIRECTION_EDEFAULT);
        return;
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET:
        setTimeTarget((TimeClause)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__DIRECTION:
        return direction != DIRECTION_EDEFAULT;
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE__TIME_TARGET:
        return timeTarget != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (direction: ");
    result.append(direction);
    result.append(')');
    return result.toString();
  }

} //ObserveRelativeClauseImpl
