/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.domain;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Online Result</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.OnlineResult#getResult <em>Result</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getOnlineResult()
 * @model
 * @generated
 */
public interface OnlineResult extends Result {
	/**
	 * Returns the value of the '<em><b>Result</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Result</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Result</em>' containment reference.
	 * @see #setResult(Result)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getOnlineResult_Result()
	 * @model containment="true"
	 * @generated
	 */
	Result getResult();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.OnlineResult#getResult <em>Result</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Result</em>' containment reference.
	 * @see #getResult()
	 * @generated
	 */
	void setResult(Result value);
	
	/**
	 * Returns the value of the '<em><b>XAxis Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>XAxis Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>XAxis Description</em>' attribute.
	 * @see #setXAxisDescription(String)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getAbstractSeriesResult_XAxisDescription()
	 * @model
	 * @generated
	 */
	String getXAxisDescription();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.AbstractSeriesResult#getXAxisDescription <em>XAxis Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>XAxis Description</em>' attribute.
	 * @see #getXAxisDescription()
	 * @generated
	 */
	void setXAxisDescription(String value);

	/**
	 * Returns the value of the '<em><b>YAxis Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>YAxis Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>YAxis Description</em>' attribute.
	 * @see #setYAxisDescription(String)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getAbstractSeriesResult_YAxisDescription()
	 * @model
	 * @generated
	 */
	String getYAxisDescription();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.AbstractSeriesResult#getYAxisDescription <em>YAxis Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>YAxis Description</em>' attribute.
	 * @see #getYAxisDescription()
	 * @generated
	 */
	void setYAxisDescription(String value);

	/**
	 * Returns the value of the '<em><b>Elements</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.mapping.domain.SeriesResultElement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Elements</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Elements</em>' containment reference list.
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getAbstractSeriesResult_Elements()
	 * @model containment="true"
	 * @generated
	 */

} // OnlineResult
