/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.repository;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Observable Impact</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link tools.descartes.dql.models.repository.ObservableImpact#getBefore <em>Before</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.ObservableImpact#getAfter <em>After</em>}</li>
 * </ul>
 * </p>
 *
 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservableImpact()
 * @model
 * @generated
 */
public interface ObservableImpact extends Identfier, TemporalObservation {
	/**
	 * Returns the value of the '<em><b>Before</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Before</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Before</em>' reference.
	 * @see #setBefore(Observation)
	 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservableImpact_Before()
	 * @model required="true"
	 * @generated
	 */
	Observation getBefore();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.repository.ObservableImpact#getBefore <em>Before</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Before</em>' reference.
	 * @see #getBefore()
	 * @generated
	 */
	void setBefore(Observation value);

	/**
	 * Returns the value of the '<em><b>After</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>After</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>After</em>' reference.
	 * @see #setAfter(Observation)
	 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservableImpact_After()
	 * @model required="true"
	 * @generated
	 */
	Observation getAfter();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.repository.ObservableImpact#getAfter <em>After</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>After</em>' reference.
	 * @see #getAfter()
	 * @generated
	 */
	void setAfter(Observation value);

} // ObservableImpact
