package tools.descartes.dql.lang.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import tools.descartes.dql.lang.services.DescartesQLGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
@SuppressWarnings("all")
public class InternalDescartesQLParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_DOUBLE", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "';'", "'ENSURE'", "'MONITOR'", "'EVALUATE'", "'GENERATE'", "'SATISFACTION-LEVEL'", "'PERCENT'", "'AGREEMENTS'", "','", "'GOALS'", "'CONTAINS'", "'('", "')'", "':'", "'*'", "'FUZZINESS'", "'PENALTY'", "'PER'", "'VIOLATIONS'", "'LIST'", "'GET'", "'CONSTRAINTS'", "'EXPLORATION STRATEGIES'", "'TIME UNITS'", "'DOF'", "'ENTITIES'", "'METRICS'", "'SELECT'", "'DETECT'", "'BOTTLENECKS'", "'CONSTRAINED AS'", "'EVALUATE DOF'", "'GUIDED BY'", "'['", "']'", "'.'", "'='", "'<'", "'>'", "'..'", "'BY'", "'VARYING'", "'*.'", "'children'", "'parent'", "'find('", "'FOR'", "'AS'", "'USING'", "'WITH'", "'@'", "'FILTERED BY'", "'CONDITION'", "'OBSERVE'", "'SAMPLED BY'", "'BETWEEN'", "'AND'", "'WHAT IF'", "'DELTA'", "'FILTERING'", "'%'", "'ADD'", "'SUB'", "'MULTIPLY'", "'<='", "'>='", "'=='", "'EUR'", "'USD'", "'XOR'", "'OR'", "'INSTANCEOF'", "'CLASSREGEX'", "'SINCE'", "'NEXT'", "'-'", "'+'", "'y'", "'m'", "'w'", "'d'", "'h'", "'M'", "'s'", "'S'", "'MIN'", "'MAX'", "'GEOMEAN'", "'N'", "'SUM'", "'SUMOFSQUARES'", "'STDDEV'", "'VAR'", "'PERCENTILE'", "'MEAN'"
    };
    public static final int T__50=50;
    public static final int T__59=59;
    public static final int T__55=55;
    public static final int T__56=56;
    public static final int T__57=57;
    public static final int T__58=58;
    public static final int T__51=51;
    public static final int T__52=52;
    public static final int T__53=53;
    public static final int T__54=54;
    public static final int T__60=60;
    public static final int T__61=61;
    public static final int RULE_ID=5;
    public static final int RULE_INT=6;
    public static final int T__66=66;
    public static final int RULE_ML_COMMENT=8;
    public static final int T__67=67;
    public static final int T__68=68;
    public static final int T__69=69;
    public static final int T__62=62;
    public static final int T__63=63;
    public static final int T__64=64;
    public static final int T__65=65;
    public static final int T__37=37;
    public static final int T__38=38;
    public static final int T__39=39;
    public static final int T__33=33;
    public static final int T__34=34;
    public static final int T__35=35;
    public static final int T__36=36;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int T__48=48;
    public static final int T__49=49;
    public static final int T__44=44;
    public static final int T__45=45;
    public static final int T__46=46;
    public static final int T__47=47;
    public static final int T__40=40;
    public static final int T__41=41;
    public static final int T__42=42;
    public static final int T__43=43;
    public static final int T__91=91;
    public static final int T__100=100;
    public static final int T__92=92;
    public static final int T__93=93;
    public static final int T__102=102;
    public static final int T__94=94;
    public static final int T__101=101;
    public static final int T__90=90;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__99=99;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int T__95=95;
    public static final int T__96=96;
    public static final int T__97=97;
    public static final int T__98=98;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__20=20;
    public static final int T__21=21;
    public static final int T__70=70;
    public static final int T__71=71;
    public static final int T__72=72;
    public static final int RULE_STRING=7;
    public static final int RULE_SL_COMMENT=9;
    public static final int RULE_DOUBLE=4;
    public static final int T__77=77;
    public static final int T__78=78;
    public static final int T__79=79;
    public static final int T__73=73;
    public static final int EOF=-1;
    public static final int T__74=74;
    public static final int T__75=75;
    public static final int T__76=76;
    public static final int T__80=80;
    public static final int T__81=81;
    public static final int T__82=82;
    public static final int T__83=83;
    public static final int RULE_WS=10;
    public static final int RULE_ANY_OTHER=11;
    public static final int T__88=88;
    public static final int T__89=89;
    public static final int T__84=84;
    public static final int T__104=104;
    public static final int T__85=85;
    public static final int T__103=103;
    public static final int T__86=86;
    public static final int T__106=106;
    public static final int T__87=87;
    public static final int T__105=105;

    // delegates
    // delegators


        public InternalDescartesQLParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDescartesQLParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDescartesQLParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDescartesQL.g"; }



     	private DescartesQLGrammarAccess grammarAccess;
     	
        public InternalDescartesQLParser(TokenStream input, DescartesQLGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "DescartesQL";	
       	}
       	
       	@Override
       	protected DescartesQLGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleDescartesQL"
    // InternalDescartesQL.g:91:1: entryRuleDescartesQL returns [EObject current=null] : iv_ruleDescartesQL= ruleDescartesQL EOF ;
    public final EObject entryRuleDescartesQL() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDescartesQL = null;


        try {
            // InternalDescartesQL.g:92:2: (iv_ruleDescartesQL= ruleDescartesQL EOF )
            // InternalDescartesQL.g:93:2: iv_ruleDescartesQL= ruleDescartesQL EOF
            {
             newCompositeNode(grammarAccess.getDescartesQLRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDescartesQL=ruleDescartesQL();

            state._fsp--;

             current =iv_ruleDescartesQL; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDescartesQL"


    // $ANTLR start "ruleDescartesQL"
    // InternalDescartesQL.g:100:1: ruleDescartesQL returns [EObject current=null] : ( ( ( (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern ) ) ) otherlv_1= ';' ) ;
    public final EObject ruleDescartesQL() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_query_0_1 = null;

        EObject lv_query_0_2 = null;

        EObject lv_query_0_3 = null;

        EObject lv_query_0_4 = null;

        EObject lv_query_0_5 = null;

        EObject lv_query_0_6 = null;

        EObject lv_query_0_7 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:103:28: ( ( ( ( (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern ) ) ) otherlv_1= ';' ) )
            // InternalDescartesQL.g:104:1: ( ( ( (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern ) ) ) otherlv_1= ';' )
            {
            // InternalDescartesQL.g:104:1: ( ( ( (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern ) ) ) otherlv_1= ';' )
            // InternalDescartesQL.g:104:2: ( ( (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern ) ) ) otherlv_1= ';'
            {
            // InternalDescartesQL.g:104:2: ( ( (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern ) ) )
            // InternalDescartesQL.g:105:1: ( (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern ) )
            {
            // InternalDescartesQL.g:105:1: ( (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern ) )
            // InternalDescartesQL.g:106:1: (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern )
            {
            // InternalDescartesQL.g:106:1: (lv_query_0_1= ruleModelStructureQuery | lv_query_0_2= rulePerformanceMetricsQuery | lv_query_0_3= rulePerformanceIssueQuery | lv_query_0_4= ruleConnectorCapabilityQuery | lv_query_0_5= ruleWhatIfQuery | lv_query_0_6= ruleGoal | lv_query_0_7= ruleGenerateSLAConcern )
            int alt1=7;
            switch ( input.LA(1) ) {
            case 31:
                {
                alt1=1;
                }
                break;
            case 39:
                {
                alt1=2;
                }
                break;
            case 40:
                {
                alt1=3;
                }
                break;
            case 32:
                {
                alt1=4;
                }
                break;
            case 69:
                {
                alt1=5;
                }
                break;
            case 13:
            case 14:
            case 15:
                {
                alt1=6;
                }
                break;
            case 16:
                {
                alt1=7;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }

            switch (alt1) {
                case 1 :
                    // InternalDescartesQL.g:107:3: lv_query_0_1= ruleModelStructureQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getDescartesQLAccess().getQueryModelStructureQueryParserRuleCall_0_0_0()); 
                    	    
                    pushFollow(FOLLOW_3);
                    lv_query_0_1=ruleModelStructureQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDescartesQLRule());
                    	        }
                           		set(
                           			current, 
                           			"query",
                            		lv_query_0_1, 
                            		"tools.descartes.dql.lang.DescartesQL.ModelStructureQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:122:8: lv_query_0_2= rulePerformanceMetricsQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getDescartesQLAccess().getQueryPerformanceMetricsQueryParserRuleCall_0_0_1()); 
                    	    
                    pushFollow(FOLLOW_3);
                    lv_query_0_2=rulePerformanceMetricsQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDescartesQLRule());
                    	        }
                           		set(
                           			current, 
                           			"query",
                            		lv_query_0_2, 
                            		"tools.descartes.dql.lang.DescartesQL.PerformanceMetricsQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:137:8: lv_query_0_3= rulePerformanceIssueQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getDescartesQLAccess().getQueryPerformanceIssueQueryParserRuleCall_0_0_2()); 
                    	    
                    pushFollow(FOLLOW_3);
                    lv_query_0_3=rulePerformanceIssueQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDescartesQLRule());
                    	        }
                           		set(
                           			current, 
                           			"query",
                            		lv_query_0_3, 
                            		"tools.descartes.dql.lang.DescartesQL.PerformanceIssueQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 4 :
                    // InternalDescartesQL.g:152:8: lv_query_0_4= ruleConnectorCapabilityQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getDescartesQLAccess().getQueryConnectorCapabilityQueryParserRuleCall_0_0_3()); 
                    	    
                    pushFollow(FOLLOW_3);
                    lv_query_0_4=ruleConnectorCapabilityQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDescartesQLRule());
                    	        }
                           		set(
                           			current, 
                           			"query",
                            		lv_query_0_4, 
                            		"tools.descartes.dql.lang.DescartesQL.ConnectorCapabilityQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 5 :
                    // InternalDescartesQL.g:167:8: lv_query_0_5= ruleWhatIfQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getDescartesQLAccess().getQueryWhatIfQueryParserRuleCall_0_0_4()); 
                    	    
                    pushFollow(FOLLOW_3);
                    lv_query_0_5=ruleWhatIfQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDescartesQLRule());
                    	        }
                           		set(
                           			current, 
                           			"query",
                            		lv_query_0_5, 
                            		"tools.descartes.dql.lang.DescartesQL.WhatIfQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 6 :
                    // InternalDescartesQL.g:182:8: lv_query_0_6= ruleGoal
                    {
                     
                    	        newCompositeNode(grammarAccess.getDescartesQLAccess().getQueryGoalParserRuleCall_0_0_5()); 
                    	    
                    pushFollow(FOLLOW_3);
                    lv_query_0_6=ruleGoal();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDescartesQLRule());
                    	        }
                           		set(
                           			current, 
                           			"query",
                            		lv_query_0_6, 
                            		"tools.descartes.dql.lang.DescartesQL.Goal");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 7 :
                    // InternalDescartesQL.g:197:8: lv_query_0_7= ruleGenerateSLAConcern
                    {
                     
                    	        newCompositeNode(grammarAccess.getDescartesQLAccess().getQueryGenerateSLAConcernParserRuleCall_0_0_6()); 
                    	    
                    pushFollow(FOLLOW_3);
                    lv_query_0_7=ruleGenerateSLAConcern();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDescartesQLRule());
                    	        }
                           		set(
                           			current, 
                           			"query",
                            		lv_query_0_7, 
                            		"tools.descartes.dql.lang.DescartesQL.GenerateSLAConcern");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }

            otherlv_1=(Token)match(input,12,FOLLOW_2); 

                	newLeafNode(otherlv_1, grammarAccess.getDescartesQLAccess().getSemicolonKeyword_1());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDescartesQL"


    // $ANTLR start "entryRuleGoal"
    // InternalDescartesQL.g:227:1: entryRuleGoal returns [EObject current=null] : iv_ruleGoal= ruleGoal EOF ;
    public final EObject entryRuleGoal() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGoal = null;


        try {
            // InternalDescartesQL.g:228:2: (iv_ruleGoal= ruleGoal EOF )
            // InternalDescartesQL.g:229:2: iv_ruleGoal= ruleGoal EOF
            {
             newCompositeNode(grammarAccess.getGoalRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleGoal=ruleGoal();

            state._fsp--;

             current =iv_ruleGoal; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGoal"


    // $ANTLR start "ruleGoal"
    // InternalDescartesQL.g:236:1: ruleGoal returns [EObject current=null] : ( ( ( (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' ) ) ) ( (lv_slaQuery_1_0= ruleSlaQuery ) ) ( (lv_sloQuery_2_0= ruleSloQuery ) ) ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_dofClause_4_0= ruleDoFClause ) )? ( (lv_forClause_5_0= ruleForClause ) )? ( (lv_usingClause_6_0= ruleUsingClause ) ) ) ;
    public final EObject ruleGoal() throws RecognitionException {
        EObject current = null;

        Token lv_queryType_0_1=null;
        Token lv_queryType_0_2=null;
        Token lv_queryType_0_3=null;
        EObject lv_slaQuery_1_0 = null;

        EObject lv_sloQuery_2_0 = null;

        EObject lv_constraintClause_3_0 = null;

        EObject lv_dofClause_4_0 = null;

        EObject lv_forClause_5_0 = null;

        EObject lv_usingClause_6_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:239:28: ( ( ( ( (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' ) ) ) ( (lv_slaQuery_1_0= ruleSlaQuery ) ) ( (lv_sloQuery_2_0= ruleSloQuery ) ) ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_dofClause_4_0= ruleDoFClause ) )? ( (lv_forClause_5_0= ruleForClause ) )? ( (lv_usingClause_6_0= ruleUsingClause ) ) ) )
            // InternalDescartesQL.g:240:1: ( ( ( (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' ) ) ) ( (lv_slaQuery_1_0= ruleSlaQuery ) ) ( (lv_sloQuery_2_0= ruleSloQuery ) ) ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_dofClause_4_0= ruleDoFClause ) )? ( (lv_forClause_5_0= ruleForClause ) )? ( (lv_usingClause_6_0= ruleUsingClause ) ) )
            {
            // InternalDescartesQL.g:240:1: ( ( ( (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' ) ) ) ( (lv_slaQuery_1_0= ruleSlaQuery ) ) ( (lv_sloQuery_2_0= ruleSloQuery ) ) ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_dofClause_4_0= ruleDoFClause ) )? ( (lv_forClause_5_0= ruleForClause ) )? ( (lv_usingClause_6_0= ruleUsingClause ) ) )
            // InternalDescartesQL.g:240:2: ( ( (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' ) ) ) ( (lv_slaQuery_1_0= ruleSlaQuery ) ) ( (lv_sloQuery_2_0= ruleSloQuery ) ) ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_dofClause_4_0= ruleDoFClause ) )? ( (lv_forClause_5_0= ruleForClause ) )? ( (lv_usingClause_6_0= ruleUsingClause ) )
            {
            // InternalDescartesQL.g:240:2: ( ( (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' ) ) )
            // InternalDescartesQL.g:241:1: ( (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' ) )
            {
            // InternalDescartesQL.g:241:1: ( (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' ) )
            // InternalDescartesQL.g:242:1: (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' )
            {
            // InternalDescartesQL.g:242:1: (lv_queryType_0_1= 'ENSURE' | lv_queryType_0_2= 'MONITOR' | lv_queryType_0_3= 'EVALUATE' )
            int alt2=3;
            switch ( input.LA(1) ) {
            case 13:
                {
                alt2=1;
                }
                break;
            case 14:
                {
                alt2=2;
                }
                break;
            case 15:
                {
                alt2=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // InternalDescartesQL.g:243:3: lv_queryType_0_1= 'ENSURE'
                    {
                    lv_queryType_0_1=(Token)match(input,13,FOLLOW_4); 

                            newLeafNode(lv_queryType_0_1, grammarAccess.getGoalAccess().getQueryTypeENSUREKeyword_0_0_0());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getGoalRule());
                    	        }
                           		setWithLastConsumed(current, "queryType", lv_queryType_0_1, null);
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:255:8: lv_queryType_0_2= 'MONITOR'
                    {
                    lv_queryType_0_2=(Token)match(input,14,FOLLOW_4); 

                            newLeafNode(lv_queryType_0_2, grammarAccess.getGoalAccess().getQueryTypeMONITORKeyword_0_0_1());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getGoalRule());
                    	        }
                           		setWithLastConsumed(current, "queryType", lv_queryType_0_2, null);
                    	    

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:267:8: lv_queryType_0_3= 'EVALUATE'
                    {
                    lv_queryType_0_3=(Token)match(input,15,FOLLOW_4); 

                            newLeafNode(lv_queryType_0_3, grammarAccess.getGoalAccess().getQueryTypeEVALUATEKeyword_0_0_2());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getGoalRule());
                    	        }
                           		setWithLastConsumed(current, "queryType", lv_queryType_0_3, null);
                    	    

                    }
                    break;

            }


            }


            }

            // InternalDescartesQL.g:282:2: ( (lv_slaQuery_1_0= ruleSlaQuery ) )
            // InternalDescartesQL.g:283:1: (lv_slaQuery_1_0= ruleSlaQuery )
            {
            // InternalDescartesQL.g:283:1: (lv_slaQuery_1_0= ruleSlaQuery )
            // InternalDescartesQL.g:284:3: lv_slaQuery_1_0= ruleSlaQuery
            {
             
            	        newCompositeNode(grammarAccess.getGoalAccess().getSlaQuerySlaQueryParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_5);
            lv_slaQuery_1_0=ruleSlaQuery();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getGoalRule());
            	        }
                   		set(
                   			current, 
                   			"slaQuery",
                    		lv_slaQuery_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.SlaQuery");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:300:2: ( (lv_sloQuery_2_0= ruleSloQuery ) )
            // InternalDescartesQL.g:301:1: (lv_sloQuery_2_0= ruleSloQuery )
            {
            // InternalDescartesQL.g:301:1: (lv_sloQuery_2_0= ruleSloQuery )
            // InternalDescartesQL.g:302:3: lv_sloQuery_2_0= ruleSloQuery
            {
             
            	        newCompositeNode(grammarAccess.getGoalAccess().getSloQuerySloQueryParserRuleCall_2_0()); 
            	    
            pushFollow(FOLLOW_6);
            lv_sloQuery_2_0=ruleSloQuery();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getGoalRule());
            	        }
                   		set(
                   			current, 
                   			"sloQuery",
                    		lv_sloQuery_2_0, 
                    		"tools.descartes.dql.lang.DescartesQL.SloQuery");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:318:2: ( (lv_constraintClause_3_0= ruleConstraintClause ) )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==42) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // InternalDescartesQL.g:319:1: (lv_constraintClause_3_0= ruleConstraintClause )
                    {
                    // InternalDescartesQL.g:319:1: (lv_constraintClause_3_0= ruleConstraintClause )
                    // InternalDescartesQL.g:320:3: lv_constraintClause_3_0= ruleConstraintClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getGoalAccess().getConstraintClauseConstraintClauseParserRuleCall_3_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_constraintClause_3_0=ruleConstraintClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGoalRule());
                    	        }
                           		set(
                           			current, 
                           			"constraintClause",
                            		lv_constraintClause_3_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ConstraintClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:336:3: ( (lv_dofClause_4_0= ruleDoFClause ) )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==43) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalDescartesQL.g:337:1: (lv_dofClause_4_0= ruleDoFClause )
                    {
                    // InternalDescartesQL.g:337:1: (lv_dofClause_4_0= ruleDoFClause )
                    // InternalDescartesQL.g:338:3: lv_dofClause_4_0= ruleDoFClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getGoalAccess().getDofClauseDoFClauseParserRuleCall_4_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_dofClause_4_0=ruleDoFClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGoalRule());
                    	        }
                           		set(
                           			current, 
                           			"dofClause",
                            		lv_dofClause_4_0, 
                            		"tools.descartes.dql.lang.DescartesQL.DoFClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:354:3: ( (lv_forClause_5_0= ruleForClause ) )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==58) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // InternalDescartesQL.g:355:1: (lv_forClause_5_0= ruleForClause )
                    {
                    // InternalDescartesQL.g:355:1: (lv_forClause_5_0= ruleForClause )
                    // InternalDescartesQL.g:356:3: lv_forClause_5_0= ruleForClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getGoalAccess().getForClauseForClauseParserRuleCall_5_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_forClause_5_0=ruleForClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGoalRule());
                    	        }
                           		set(
                           			current, 
                           			"forClause",
                            		lv_forClause_5_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ForClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:372:3: ( (lv_usingClause_6_0= ruleUsingClause ) )
            // InternalDescartesQL.g:373:1: (lv_usingClause_6_0= ruleUsingClause )
            {
            // InternalDescartesQL.g:373:1: (lv_usingClause_6_0= ruleUsingClause )
            // InternalDescartesQL.g:374:3: lv_usingClause_6_0= ruleUsingClause
            {
             
            	        newCompositeNode(grammarAccess.getGoalAccess().getUsingClauseUsingClauseParserRuleCall_6_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_usingClause_6_0=ruleUsingClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getGoalRule());
            	        }
                   		set(
                   			current, 
                   			"usingClause",
                    		lv_usingClause_6_0, 
                    		"tools.descartes.dql.lang.DescartesQL.UsingClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGoal"


    // $ANTLR start "entryRuleGenerateSLAConcern"
    // InternalDescartesQL.g:398:1: entryRuleGenerateSLAConcern returns [EObject current=null] : iv_ruleGenerateSLAConcern= ruleGenerateSLAConcern EOF ;
    public final EObject entryRuleGenerateSLAConcern() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGenerateSLAConcern = null;


        try {
            // InternalDescartesQL.g:399:2: (iv_ruleGenerateSLAConcern= ruleGenerateSLAConcern EOF )
            // InternalDescartesQL.g:400:2: iv_ruleGenerateSLAConcern= ruleGenerateSLAConcern EOF
            {
             newCompositeNode(grammarAccess.getGenerateSLAConcernRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleGenerateSLAConcern=ruleGenerateSLAConcern();

            state._fsp--;

             current =iv_ruleGenerateSLAConcern; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGenerateSLAConcern"


    // $ANTLR start "ruleGenerateSLAConcern"
    // InternalDescartesQL.g:407:1: ruleGenerateSLAConcern returns [EObject current=null] : (otherlv_0= 'GENERATE' ( (lv_offset_1_0= ruleMultipleArithmeticClause ) )? (otherlv_2= 'SATISFACTION-LEVEL' ( (lv_percentage_3_0= RULE_DOUBLE ) ) otherlv_4= 'PERCENT' )? ( (lv_constraintClause_5_0= ruleConstraintClause ) )? ( (lv_dofClause_6_0= ruleDoFClause ) )? ( (lv_forClause_7_0= ruleForClause ) )? ( (lv_usingClause_8_0= ruleUsingClause ) ) ) ;
    public final EObject ruleGenerateSLAConcern() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token lv_percentage_3_0=null;
        Token otherlv_4=null;
        EObject lv_offset_1_0 = null;

        EObject lv_constraintClause_5_0 = null;

        EObject lv_dofClause_6_0 = null;

        EObject lv_forClause_7_0 = null;

        EObject lv_usingClause_8_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:410:28: ( (otherlv_0= 'GENERATE' ( (lv_offset_1_0= ruleMultipleArithmeticClause ) )? (otherlv_2= 'SATISFACTION-LEVEL' ( (lv_percentage_3_0= RULE_DOUBLE ) ) otherlv_4= 'PERCENT' )? ( (lv_constraintClause_5_0= ruleConstraintClause ) )? ( (lv_dofClause_6_0= ruleDoFClause ) )? ( (lv_forClause_7_0= ruleForClause ) )? ( (lv_usingClause_8_0= ruleUsingClause ) ) ) )
            // InternalDescartesQL.g:411:1: (otherlv_0= 'GENERATE' ( (lv_offset_1_0= ruleMultipleArithmeticClause ) )? (otherlv_2= 'SATISFACTION-LEVEL' ( (lv_percentage_3_0= RULE_DOUBLE ) ) otherlv_4= 'PERCENT' )? ( (lv_constraintClause_5_0= ruleConstraintClause ) )? ( (lv_dofClause_6_0= ruleDoFClause ) )? ( (lv_forClause_7_0= ruleForClause ) )? ( (lv_usingClause_8_0= ruleUsingClause ) ) )
            {
            // InternalDescartesQL.g:411:1: (otherlv_0= 'GENERATE' ( (lv_offset_1_0= ruleMultipleArithmeticClause ) )? (otherlv_2= 'SATISFACTION-LEVEL' ( (lv_percentage_3_0= RULE_DOUBLE ) ) otherlv_4= 'PERCENT' )? ( (lv_constraintClause_5_0= ruleConstraintClause ) )? ( (lv_dofClause_6_0= ruleDoFClause ) )? ( (lv_forClause_7_0= ruleForClause ) )? ( (lv_usingClause_8_0= ruleUsingClause ) ) )
            // InternalDescartesQL.g:411:3: otherlv_0= 'GENERATE' ( (lv_offset_1_0= ruleMultipleArithmeticClause ) )? (otherlv_2= 'SATISFACTION-LEVEL' ( (lv_percentage_3_0= RULE_DOUBLE ) ) otherlv_4= 'PERCENT' )? ( (lv_constraintClause_5_0= ruleConstraintClause ) )? ( (lv_dofClause_6_0= ruleDoFClause ) )? ( (lv_forClause_7_0= ruleForClause ) )? ( (lv_usingClause_8_0= ruleUsingClause ) )
            {
            otherlv_0=(Token)match(input,16,FOLLOW_7); 

                	newLeafNode(otherlv_0, grammarAccess.getGenerateSLAConcernAccess().getGENERATEKeyword_0());
                
            // InternalDescartesQL.g:415:1: ( (lv_offset_1_0= ruleMultipleArithmeticClause ) )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==49) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // InternalDescartesQL.g:416:1: (lv_offset_1_0= ruleMultipleArithmeticClause )
                    {
                    // InternalDescartesQL.g:416:1: (lv_offset_1_0= ruleMultipleArithmeticClause )
                    // InternalDescartesQL.g:417:3: lv_offset_1_0= ruleMultipleArithmeticClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getGenerateSLAConcernAccess().getOffsetMultipleArithmeticClauseParserRuleCall_1_0()); 
                    	    
                    pushFollow(FOLLOW_8);
                    lv_offset_1_0=ruleMultipleArithmeticClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGenerateSLAConcernRule());
                    	        }
                           		set(
                           			current, 
                           			"offset",
                            		lv_offset_1_0, 
                            		"tools.descartes.dql.lang.DescartesQL.MultipleArithmeticClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:433:3: (otherlv_2= 'SATISFACTION-LEVEL' ( (lv_percentage_3_0= RULE_DOUBLE ) ) otherlv_4= 'PERCENT' )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==17) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // InternalDescartesQL.g:433:5: otherlv_2= 'SATISFACTION-LEVEL' ( (lv_percentage_3_0= RULE_DOUBLE ) ) otherlv_4= 'PERCENT'
                    {
                    otherlv_2=(Token)match(input,17,FOLLOW_9); 

                        	newLeafNode(otherlv_2, grammarAccess.getGenerateSLAConcernAccess().getSATISFACTIONLEVELKeyword_2_0());
                        
                    // InternalDescartesQL.g:437:1: ( (lv_percentage_3_0= RULE_DOUBLE ) )
                    // InternalDescartesQL.g:438:1: (lv_percentage_3_0= RULE_DOUBLE )
                    {
                    // InternalDescartesQL.g:438:1: (lv_percentage_3_0= RULE_DOUBLE )
                    // InternalDescartesQL.g:439:3: lv_percentage_3_0= RULE_DOUBLE
                    {
                    lv_percentage_3_0=(Token)match(input,RULE_DOUBLE,FOLLOW_10); 

                    			newLeafNode(lv_percentage_3_0, grammarAccess.getGenerateSLAConcernAccess().getPercentageDOUBLETerminalRuleCall_2_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getGenerateSLAConcernRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"percentage",
                            		lv_percentage_3_0, 
                            		"tools.descartes.dql.lang.DescartesQL.DOUBLE");
                    	    

                    }


                    }

                    otherlv_4=(Token)match(input,18,FOLLOW_6); 

                        	newLeafNode(otherlv_4, grammarAccess.getGenerateSLAConcernAccess().getPERCENTKeyword_2_2());
                        

                    }
                    break;

            }

            // InternalDescartesQL.g:459:3: ( (lv_constraintClause_5_0= ruleConstraintClause ) )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==42) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // InternalDescartesQL.g:460:1: (lv_constraintClause_5_0= ruleConstraintClause )
                    {
                    // InternalDescartesQL.g:460:1: (lv_constraintClause_5_0= ruleConstraintClause )
                    // InternalDescartesQL.g:461:3: lv_constraintClause_5_0= ruleConstraintClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getGenerateSLAConcernAccess().getConstraintClauseConstraintClauseParserRuleCall_3_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_constraintClause_5_0=ruleConstraintClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGenerateSLAConcernRule());
                    	        }
                           		set(
                           			current, 
                           			"constraintClause",
                            		lv_constraintClause_5_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ConstraintClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:477:3: ( (lv_dofClause_6_0= ruleDoFClause ) )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==43) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // InternalDescartesQL.g:478:1: (lv_dofClause_6_0= ruleDoFClause )
                    {
                    // InternalDescartesQL.g:478:1: (lv_dofClause_6_0= ruleDoFClause )
                    // InternalDescartesQL.g:479:3: lv_dofClause_6_0= ruleDoFClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getGenerateSLAConcernAccess().getDofClauseDoFClauseParserRuleCall_4_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_dofClause_6_0=ruleDoFClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGenerateSLAConcernRule());
                    	        }
                           		set(
                           			current, 
                           			"dofClause",
                            		lv_dofClause_6_0, 
                            		"tools.descartes.dql.lang.DescartesQL.DoFClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:495:3: ( (lv_forClause_7_0= ruleForClause ) )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==58) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // InternalDescartesQL.g:496:1: (lv_forClause_7_0= ruleForClause )
                    {
                    // InternalDescartesQL.g:496:1: (lv_forClause_7_0= ruleForClause )
                    // InternalDescartesQL.g:497:3: lv_forClause_7_0= ruleForClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getGenerateSLAConcernAccess().getForClauseForClauseParserRuleCall_5_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_forClause_7_0=ruleForClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGenerateSLAConcernRule());
                    	        }
                           		set(
                           			current, 
                           			"forClause",
                            		lv_forClause_7_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ForClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:513:3: ( (lv_usingClause_8_0= ruleUsingClause ) )
            // InternalDescartesQL.g:514:1: (lv_usingClause_8_0= ruleUsingClause )
            {
            // InternalDescartesQL.g:514:1: (lv_usingClause_8_0= ruleUsingClause )
            // InternalDescartesQL.g:515:3: lv_usingClause_8_0= ruleUsingClause
            {
             
            	        newCompositeNode(grammarAccess.getGenerateSLAConcernAccess().getUsingClauseUsingClauseParserRuleCall_6_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_usingClause_8_0=ruleUsingClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getGenerateSLAConcernRule());
            	        }
                   		set(
                   			current, 
                   			"usingClause",
                    		lv_usingClause_8_0, 
                    		"tools.descartes.dql.lang.DescartesQL.UsingClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGenerateSLAConcern"


    // $ANTLR start "entryRuleSlaQuery"
    // InternalDescartesQL.g:539:1: entryRuleSlaQuery returns [EObject current=null] : iv_ruleSlaQuery= ruleSlaQuery EOF ;
    public final EObject entryRuleSlaQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSlaQuery = null;


        try {
            // InternalDescartesQL.g:540:2: (iv_ruleSlaQuery= ruleSlaQuery EOF )
            // InternalDescartesQL.g:541:2: iv_ruleSlaQuery= ruleSlaQuery EOF
            {
             newCompositeNode(grammarAccess.getSlaQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSlaQuery=ruleSlaQuery();

            state._fsp--;

             current =iv_ruleSlaQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSlaQuery"


    // $ANTLR start "ruleSlaQuery"
    // InternalDescartesQL.g:548:1: ruleSlaQuery returns [EObject current=null] : ( ( (lv_type_0_0= 'AGREEMENTS' ) ) ( (lv_slas_1_0= ruleSla ) ) (otherlv_2= ',' ( (lv_slas_3_0= ruleSla ) ) )* ) ;
    public final EObject ruleSlaQuery() throws RecognitionException {
        EObject current = null;

        Token lv_type_0_0=null;
        Token otherlv_2=null;
        EObject lv_slas_1_0 = null;

        EObject lv_slas_3_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:551:28: ( ( ( (lv_type_0_0= 'AGREEMENTS' ) ) ( (lv_slas_1_0= ruleSla ) ) (otherlv_2= ',' ( (lv_slas_3_0= ruleSla ) ) )* ) )
            // InternalDescartesQL.g:552:1: ( ( (lv_type_0_0= 'AGREEMENTS' ) ) ( (lv_slas_1_0= ruleSla ) ) (otherlv_2= ',' ( (lv_slas_3_0= ruleSla ) ) )* )
            {
            // InternalDescartesQL.g:552:1: ( ( (lv_type_0_0= 'AGREEMENTS' ) ) ( (lv_slas_1_0= ruleSla ) ) (otherlv_2= ',' ( (lv_slas_3_0= ruleSla ) ) )* )
            // InternalDescartesQL.g:552:2: ( (lv_type_0_0= 'AGREEMENTS' ) ) ( (lv_slas_1_0= ruleSla ) ) (otherlv_2= ',' ( (lv_slas_3_0= ruleSla ) ) )*
            {
            // InternalDescartesQL.g:552:2: ( (lv_type_0_0= 'AGREEMENTS' ) )
            // InternalDescartesQL.g:553:1: (lv_type_0_0= 'AGREEMENTS' )
            {
            // InternalDescartesQL.g:553:1: (lv_type_0_0= 'AGREEMENTS' )
            // InternalDescartesQL.g:554:3: lv_type_0_0= 'AGREEMENTS'
            {
            lv_type_0_0=(Token)match(input,19,FOLLOW_11); 

                    newLeafNode(lv_type_0_0, grammarAccess.getSlaQueryAccess().getTypeAGREEMENTSKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getSlaQueryRule());
            	        }
                   		setWithLastConsumed(current, "type", lv_type_0_0, "AGREEMENTS");
            	    

            }


            }

            // InternalDescartesQL.g:567:2: ( (lv_slas_1_0= ruleSla ) )
            // InternalDescartesQL.g:568:1: (lv_slas_1_0= ruleSla )
            {
            // InternalDescartesQL.g:568:1: (lv_slas_1_0= ruleSla )
            // InternalDescartesQL.g:569:3: lv_slas_1_0= ruleSla
            {
             
            	        newCompositeNode(grammarAccess.getSlaQueryAccess().getSlasSlaParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_12);
            lv_slas_1_0=ruleSla();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSlaQueryRule());
            	        }
                   		add(
                   			current, 
                   			"slas",
                    		lv_slas_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.Sla");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:585:2: (otherlv_2= ',' ( (lv_slas_3_0= ruleSla ) ) )*
            loop11:
            do {
                int alt11=2;
                int LA11_0 = input.LA(1);

                if ( (LA11_0==20) ) {
                    alt11=1;
                }


                switch (alt11) {
            	case 1 :
            	    // InternalDescartesQL.g:585:4: otherlv_2= ',' ( (lv_slas_3_0= ruleSla ) )
            	    {
            	    otherlv_2=(Token)match(input,20,FOLLOW_11); 

            	        	newLeafNode(otherlv_2, grammarAccess.getSlaQueryAccess().getCommaKeyword_2_0());
            	        
            	    // InternalDescartesQL.g:589:1: ( (lv_slas_3_0= ruleSla ) )
            	    // InternalDescartesQL.g:590:1: (lv_slas_3_0= ruleSla )
            	    {
            	    // InternalDescartesQL.g:590:1: (lv_slas_3_0= ruleSla )
            	    // InternalDescartesQL.g:591:3: lv_slas_3_0= ruleSla
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSlaQueryAccess().getSlasSlaParserRuleCall_2_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_12);
            	    lv_slas_3_0=ruleSla();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSlaQueryRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"slas",
            	            		lv_slas_3_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.Sla");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop11;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSlaQuery"


    // $ANTLR start "entryRuleSloQuery"
    // InternalDescartesQL.g:615:1: entryRuleSloQuery returns [EObject current=null] : iv_ruleSloQuery= ruleSloQuery EOF ;
    public final EObject entryRuleSloQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSloQuery = null;


        try {
            // InternalDescartesQL.g:616:2: (iv_ruleSloQuery= ruleSloQuery EOF )
            // InternalDescartesQL.g:617:2: iv_ruleSloQuery= ruleSloQuery EOF
            {
             newCompositeNode(grammarAccess.getSloQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSloQuery=ruleSloQuery();

            state._fsp--;

             current =iv_ruleSloQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSloQuery"


    // $ANTLR start "ruleSloQuery"
    // InternalDescartesQL.g:624:1: ruleSloQuery returns [EObject current=null] : ( ( (lv_type_0_0= 'GOALS' ) ) ( (lv_slos_1_0= ruleSlo ) ) (otherlv_2= ',' ( (lv_slos_3_0= ruleSlo ) ) )* ) ;
    public final EObject ruleSloQuery() throws RecognitionException {
        EObject current = null;

        Token lv_type_0_0=null;
        Token otherlv_2=null;
        EObject lv_slos_1_0 = null;

        EObject lv_slos_3_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:627:28: ( ( ( (lv_type_0_0= 'GOALS' ) ) ( (lv_slos_1_0= ruleSlo ) ) (otherlv_2= ',' ( (lv_slos_3_0= ruleSlo ) ) )* ) )
            // InternalDescartesQL.g:628:1: ( ( (lv_type_0_0= 'GOALS' ) ) ( (lv_slos_1_0= ruleSlo ) ) (otherlv_2= ',' ( (lv_slos_3_0= ruleSlo ) ) )* )
            {
            // InternalDescartesQL.g:628:1: ( ( (lv_type_0_0= 'GOALS' ) ) ( (lv_slos_1_0= ruleSlo ) ) (otherlv_2= ',' ( (lv_slos_3_0= ruleSlo ) ) )* )
            // InternalDescartesQL.g:628:2: ( (lv_type_0_0= 'GOALS' ) ) ( (lv_slos_1_0= ruleSlo ) ) (otherlv_2= ',' ( (lv_slos_3_0= ruleSlo ) ) )*
            {
            // InternalDescartesQL.g:628:2: ( (lv_type_0_0= 'GOALS' ) )
            // InternalDescartesQL.g:629:1: (lv_type_0_0= 'GOALS' )
            {
            // InternalDescartesQL.g:629:1: (lv_type_0_0= 'GOALS' )
            // InternalDescartesQL.g:630:3: lv_type_0_0= 'GOALS'
            {
            lv_type_0_0=(Token)match(input,21,FOLLOW_11); 

                    newLeafNode(lv_type_0_0, grammarAccess.getSloQueryAccess().getTypeGOALSKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getSloQueryRule());
            	        }
                   		setWithLastConsumed(current, "type", lv_type_0_0, "GOALS");
            	    

            }


            }

            // InternalDescartesQL.g:643:2: ( (lv_slos_1_0= ruleSlo ) )
            // InternalDescartesQL.g:644:1: (lv_slos_1_0= ruleSlo )
            {
            // InternalDescartesQL.g:644:1: (lv_slos_1_0= ruleSlo )
            // InternalDescartesQL.g:645:3: lv_slos_1_0= ruleSlo
            {
             
            	        newCompositeNode(grammarAccess.getSloQueryAccess().getSlosSloParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_12);
            lv_slos_1_0=ruleSlo();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSloQueryRule());
            	        }
                   		add(
                   			current, 
                   			"slos",
                    		lv_slos_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.Slo");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:661:2: (otherlv_2= ',' ( (lv_slos_3_0= ruleSlo ) ) )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==20) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // InternalDescartesQL.g:661:4: otherlv_2= ',' ( (lv_slos_3_0= ruleSlo ) )
            	    {
            	    otherlv_2=(Token)match(input,20,FOLLOW_11); 

            	        	newLeafNode(otherlv_2, grammarAccess.getSloQueryAccess().getCommaKeyword_2_0());
            	        
            	    // InternalDescartesQL.g:665:1: ( (lv_slos_3_0= ruleSlo ) )
            	    // InternalDescartesQL.g:666:1: (lv_slos_3_0= ruleSlo )
            	    {
            	    // InternalDescartesQL.g:666:1: (lv_slos_3_0= ruleSlo )
            	    // InternalDescartesQL.g:667:3: lv_slos_3_0= ruleSlo
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSloQueryAccess().getSlosSloParserRuleCall_2_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_12);
            	    lv_slos_3_0=ruleSlo();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSloQueryRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"slos",
            	            		lv_slos_3_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.Slo");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSloQuery"


    // $ANTLR start "entryRuleSla"
    // InternalDescartesQL.g:691:1: entryRuleSla returns [EObject current=null] : iv_ruleSla= ruleSla EOF ;
    public final EObject entryRuleSla() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSla = null;


        try {
            // InternalDescartesQL.g:692:2: (iv_ruleSla= ruleSla EOF )
            // InternalDescartesQL.g:693:2: iv_ruleSla= ruleSla EOF
            {
             newCompositeNode(grammarAccess.getSlaRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSla=ruleSla();

            state._fsp--;

             current =iv_ruleSla; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSla"


    // $ANTLR start "ruleSla"
    // InternalDescartesQL.g:700:1: ruleSla returns [EObject current=null] : ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= 'CONTAINS' otherlv_2= '(' ( (lv_weightedSlo_3_0= ruleWeightedSlo ) ) (otherlv_4= ',' ( (lv_weightedSlo_5_0= ruleWeightedSlo ) ) )* otherlv_6= ')' ) ;
    public final EObject ruleSla() throws RecognitionException {
        EObject current = null;

        Token lv_name_0_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_weightedSlo_3_0 = null;

        EObject lv_weightedSlo_5_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:703:28: ( ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= 'CONTAINS' otherlv_2= '(' ( (lv_weightedSlo_3_0= ruleWeightedSlo ) ) (otherlv_4= ',' ( (lv_weightedSlo_5_0= ruleWeightedSlo ) ) )* otherlv_6= ')' ) )
            // InternalDescartesQL.g:704:1: ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= 'CONTAINS' otherlv_2= '(' ( (lv_weightedSlo_3_0= ruleWeightedSlo ) ) (otherlv_4= ',' ( (lv_weightedSlo_5_0= ruleWeightedSlo ) ) )* otherlv_6= ')' )
            {
            // InternalDescartesQL.g:704:1: ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= 'CONTAINS' otherlv_2= '(' ( (lv_weightedSlo_3_0= ruleWeightedSlo ) ) (otherlv_4= ',' ( (lv_weightedSlo_5_0= ruleWeightedSlo ) ) )* otherlv_6= ')' )
            // InternalDescartesQL.g:704:2: ( (lv_name_0_0= RULE_ID ) ) otherlv_1= 'CONTAINS' otherlv_2= '(' ( (lv_weightedSlo_3_0= ruleWeightedSlo ) ) (otherlv_4= ',' ( (lv_weightedSlo_5_0= ruleWeightedSlo ) ) )* otherlv_6= ')'
            {
            // InternalDescartesQL.g:704:2: ( (lv_name_0_0= RULE_ID ) )
            // InternalDescartesQL.g:705:1: (lv_name_0_0= RULE_ID )
            {
            // InternalDescartesQL.g:705:1: (lv_name_0_0= RULE_ID )
            // InternalDescartesQL.g:706:3: lv_name_0_0= RULE_ID
            {
            lv_name_0_0=(Token)match(input,RULE_ID,FOLLOW_13); 

            			newLeafNode(lv_name_0_0, grammarAccess.getSlaAccess().getNameIDTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getSlaRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_0_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }

            otherlv_1=(Token)match(input,22,FOLLOW_14); 

                	newLeafNode(otherlv_1, grammarAccess.getSlaAccess().getCONTAINSKeyword_1());
                
            otherlv_2=(Token)match(input,23,FOLLOW_11); 

                	newLeafNode(otherlv_2, grammarAccess.getSlaAccess().getLeftParenthesisKeyword_2());
                
            // InternalDescartesQL.g:730:1: ( (lv_weightedSlo_3_0= ruleWeightedSlo ) )
            // InternalDescartesQL.g:731:1: (lv_weightedSlo_3_0= ruleWeightedSlo )
            {
            // InternalDescartesQL.g:731:1: (lv_weightedSlo_3_0= ruleWeightedSlo )
            // InternalDescartesQL.g:732:3: lv_weightedSlo_3_0= ruleWeightedSlo
            {
             
            	        newCompositeNode(grammarAccess.getSlaAccess().getWeightedSloWeightedSloParserRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_15);
            lv_weightedSlo_3_0=ruleWeightedSlo();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSlaRule());
            	        }
                   		add(
                   			current, 
                   			"weightedSlo",
                    		lv_weightedSlo_3_0, 
                    		"tools.descartes.dql.lang.DescartesQL.WeightedSlo");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:748:2: (otherlv_4= ',' ( (lv_weightedSlo_5_0= ruleWeightedSlo ) ) )*
            loop13:
            do {
                int alt13=2;
                int LA13_0 = input.LA(1);

                if ( (LA13_0==20) ) {
                    alt13=1;
                }


                switch (alt13) {
            	case 1 :
            	    // InternalDescartesQL.g:748:4: otherlv_4= ',' ( (lv_weightedSlo_5_0= ruleWeightedSlo ) )
            	    {
            	    otherlv_4=(Token)match(input,20,FOLLOW_11); 

            	        	newLeafNode(otherlv_4, grammarAccess.getSlaAccess().getCommaKeyword_4_0());
            	        
            	    // InternalDescartesQL.g:752:1: ( (lv_weightedSlo_5_0= ruleWeightedSlo ) )
            	    // InternalDescartesQL.g:753:1: (lv_weightedSlo_5_0= ruleWeightedSlo )
            	    {
            	    // InternalDescartesQL.g:753:1: (lv_weightedSlo_5_0= ruleWeightedSlo )
            	    // InternalDescartesQL.g:754:3: lv_weightedSlo_5_0= ruleWeightedSlo
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSlaAccess().getWeightedSloWeightedSloParserRuleCall_4_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_15);
            	    lv_weightedSlo_5_0=ruleWeightedSlo();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSlaRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"weightedSlo",
            	            		lv_weightedSlo_5_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.WeightedSlo");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);

            otherlv_6=(Token)match(input,24,FOLLOW_2); 

                	newLeafNode(otherlv_6, grammarAccess.getSlaAccess().getRightParenthesisKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSla"


    // $ANTLR start "entryRuleSlo"
    // InternalDescartesQL.g:782:1: entryRuleSlo returns [EObject current=null] : iv_ruleSlo= ruleSlo EOF ;
    public final EObject entryRuleSlo() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSlo = null;


        try {
            // InternalDescartesQL.g:783:2: (iv_ruleSlo= ruleSlo EOF )
            // InternalDescartesQL.g:784:2: iv_ruleSlo= ruleSlo EOF
            {
             newCompositeNode(grammarAccess.getSloRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSlo=ruleSlo();

            state._fsp--;

             current =iv_ruleSlo; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSlo"


    // $ANTLR start "ruleSlo"
    // InternalDescartesQL.g:791:1: ruleSlo returns [EObject current=null] : ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (lv_metricClauseType_2_0= ruleMetricClauseType ) ) ( (lv_comparator_3_0= ruleComparator ) ) ( (lv_value_4_0= ruleVariableValue ) ) ( (lv_fuz_5_0= ruleFuzziness ) )? ( (lv_pen_6_0= rulePenalty ) )? ( (lv_violation_7_0= ruleViolation ) )? ) ;
    public final EObject ruleSlo() throws RecognitionException {
        EObject current = null;

        Token lv_name_0_0=null;
        Token otherlv_1=null;
        EObject lv_metricClauseType_2_0 = null;

        Enumerator lv_comparator_3_0 = null;

        EObject lv_value_4_0 = null;

        EObject lv_fuz_5_0 = null;

        EObject lv_pen_6_0 = null;

        EObject lv_violation_7_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:794:28: ( ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (lv_metricClauseType_2_0= ruleMetricClauseType ) ) ( (lv_comparator_3_0= ruleComparator ) ) ( (lv_value_4_0= ruleVariableValue ) ) ( (lv_fuz_5_0= ruleFuzziness ) )? ( (lv_pen_6_0= rulePenalty ) )? ( (lv_violation_7_0= ruleViolation ) )? ) )
            // InternalDescartesQL.g:795:1: ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (lv_metricClauseType_2_0= ruleMetricClauseType ) ) ( (lv_comparator_3_0= ruleComparator ) ) ( (lv_value_4_0= ruleVariableValue ) ) ( (lv_fuz_5_0= ruleFuzziness ) )? ( (lv_pen_6_0= rulePenalty ) )? ( (lv_violation_7_0= ruleViolation ) )? )
            {
            // InternalDescartesQL.g:795:1: ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (lv_metricClauseType_2_0= ruleMetricClauseType ) ) ( (lv_comparator_3_0= ruleComparator ) ) ( (lv_value_4_0= ruleVariableValue ) ) ( (lv_fuz_5_0= ruleFuzziness ) )? ( (lv_pen_6_0= rulePenalty ) )? ( (lv_violation_7_0= ruleViolation ) )? )
            // InternalDescartesQL.g:795:2: ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (lv_metricClauseType_2_0= ruleMetricClauseType ) ) ( (lv_comparator_3_0= ruleComparator ) ) ( (lv_value_4_0= ruleVariableValue ) ) ( (lv_fuz_5_0= ruleFuzziness ) )? ( (lv_pen_6_0= rulePenalty ) )? ( (lv_violation_7_0= ruleViolation ) )?
            {
            // InternalDescartesQL.g:795:2: ( (lv_name_0_0= RULE_ID ) )
            // InternalDescartesQL.g:796:1: (lv_name_0_0= RULE_ID )
            {
            // InternalDescartesQL.g:796:1: (lv_name_0_0= RULE_ID )
            // InternalDescartesQL.g:797:3: lv_name_0_0= RULE_ID
            {
            lv_name_0_0=(Token)match(input,RULE_ID,FOLLOW_16); 

            			newLeafNode(lv_name_0_0, grammarAccess.getSloAccess().getNameIDTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getSloRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_0_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }

            otherlv_1=(Token)match(input,25,FOLLOW_17); 

                	newLeafNode(otherlv_1, grammarAccess.getSloAccess().getColonKeyword_1());
                
            // InternalDescartesQL.g:817:1: ( (lv_metricClauseType_2_0= ruleMetricClauseType ) )
            // InternalDescartesQL.g:818:1: (lv_metricClauseType_2_0= ruleMetricClauseType )
            {
            // InternalDescartesQL.g:818:1: (lv_metricClauseType_2_0= ruleMetricClauseType )
            // InternalDescartesQL.g:819:3: lv_metricClauseType_2_0= ruleMetricClauseType
            {
             
            	        newCompositeNode(grammarAccess.getSloAccess().getMetricClauseTypeMetricClauseTypeParserRuleCall_2_0()); 
            	    
            pushFollow(FOLLOW_18);
            lv_metricClauseType_2_0=ruleMetricClauseType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSloRule());
            	        }
                   		set(
                   			current, 
                   			"metricClauseType",
                    		lv_metricClauseType_2_0, 
                    		"tools.descartes.dql.lang.DescartesQL.MetricClauseType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:835:2: ( (lv_comparator_3_0= ruleComparator ) )
            // InternalDescartesQL.g:836:1: (lv_comparator_3_0= ruleComparator )
            {
            // InternalDescartesQL.g:836:1: (lv_comparator_3_0= ruleComparator )
            // InternalDescartesQL.g:837:3: lv_comparator_3_0= ruleComparator
            {
             
            	        newCompositeNode(grammarAccess.getSloAccess().getComparatorComparatorEnumRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_19);
            lv_comparator_3_0=ruleComparator();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSloRule());
            	        }
                   		set(
                   			current, 
                   			"comparator",
                    		lv_comparator_3_0, 
                    		"tools.descartes.dql.lang.DescartesQL.Comparator");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:853:2: ( (lv_value_4_0= ruleVariableValue ) )
            // InternalDescartesQL.g:854:1: (lv_value_4_0= ruleVariableValue )
            {
            // InternalDescartesQL.g:854:1: (lv_value_4_0= ruleVariableValue )
            // InternalDescartesQL.g:855:3: lv_value_4_0= ruleVariableValue
            {
             
            	        newCompositeNode(grammarAccess.getSloAccess().getValueVariableValueParserRuleCall_4_0()); 
            	    
            pushFollow(FOLLOW_20);
            lv_value_4_0=ruleVariableValue();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSloRule());
            	        }
                   		set(
                   			current, 
                   			"value",
                    		lv_value_4_0, 
                    		"tools.descartes.dql.lang.DescartesQL.VariableValue");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:871:2: ( (lv_fuz_5_0= ruleFuzziness ) )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==27) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // InternalDescartesQL.g:872:1: (lv_fuz_5_0= ruleFuzziness )
                    {
                    // InternalDescartesQL.g:872:1: (lv_fuz_5_0= ruleFuzziness )
                    // InternalDescartesQL.g:873:3: lv_fuz_5_0= ruleFuzziness
                    {
                     
                    	        newCompositeNode(grammarAccess.getSloAccess().getFuzFuzzinessParserRuleCall_5_0()); 
                    	    
                    pushFollow(FOLLOW_21);
                    lv_fuz_5_0=ruleFuzziness();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSloRule());
                    	        }
                           		set(
                           			current, 
                           			"fuz",
                            		lv_fuz_5_0, 
                            		"tools.descartes.dql.lang.DescartesQL.Fuzziness");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:889:3: ( (lv_pen_6_0= rulePenalty ) )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==28) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // InternalDescartesQL.g:890:1: (lv_pen_6_0= rulePenalty )
                    {
                    // InternalDescartesQL.g:890:1: (lv_pen_6_0= rulePenalty )
                    // InternalDescartesQL.g:891:3: lv_pen_6_0= rulePenalty
                    {
                     
                    	        newCompositeNode(grammarAccess.getSloAccess().getPenPenaltyParserRuleCall_6_0()); 
                    	    
                    pushFollow(FOLLOW_22);
                    lv_pen_6_0=rulePenalty();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSloRule());
                    	        }
                           		set(
                           			current, 
                           			"pen",
                            		lv_pen_6_0, 
                            		"tools.descartes.dql.lang.DescartesQL.Penalty");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:907:3: ( (lv_violation_7_0= ruleViolation ) )?
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==17||LA16_0==29) ) {
                alt16=1;
            }
            switch (alt16) {
                case 1 :
                    // InternalDescartesQL.g:908:1: (lv_violation_7_0= ruleViolation )
                    {
                    // InternalDescartesQL.g:908:1: (lv_violation_7_0= ruleViolation )
                    // InternalDescartesQL.g:909:3: lv_violation_7_0= ruleViolation
                    {
                     
                    	        newCompositeNode(grammarAccess.getSloAccess().getViolationViolationParserRuleCall_7_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_violation_7_0=ruleViolation();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSloRule());
                    	        }
                           		set(
                           			current, 
                           			"violation",
                            		lv_violation_7_0, 
                            		"tools.descartes.dql.lang.DescartesQL.Violation");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSlo"


    // $ANTLR start "entryRuleWeightedSlo"
    // InternalDescartesQL.g:933:1: entryRuleWeightedSlo returns [EObject current=null] : iv_ruleWeightedSlo= ruleWeightedSlo EOF ;
    public final EObject entryRuleWeightedSlo() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleWeightedSlo = null;


        try {
            // InternalDescartesQL.g:934:2: (iv_ruleWeightedSlo= ruleWeightedSlo EOF )
            // InternalDescartesQL.g:935:2: iv_ruleWeightedSlo= ruleWeightedSlo EOF
            {
             newCompositeNode(grammarAccess.getWeightedSloRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleWeightedSlo=ruleWeightedSlo();

            state._fsp--;

             current =iv_ruleWeightedSlo; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleWeightedSlo"


    // $ANTLR start "ruleWeightedSlo"
    // InternalDescartesQL.g:942:1: ruleWeightedSlo returns [EObject current=null] : ( ( (otherlv_0= RULE_ID ) ) (otherlv_1= '*' ( (lv_weight_2_0= RULE_INT ) ) )? ) ;
    public final EObject ruleWeightedSlo() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token lv_weight_2_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:945:28: ( ( ( (otherlv_0= RULE_ID ) ) (otherlv_1= '*' ( (lv_weight_2_0= RULE_INT ) ) )? ) )
            // InternalDescartesQL.g:946:1: ( ( (otherlv_0= RULE_ID ) ) (otherlv_1= '*' ( (lv_weight_2_0= RULE_INT ) ) )? )
            {
            // InternalDescartesQL.g:946:1: ( ( (otherlv_0= RULE_ID ) ) (otherlv_1= '*' ( (lv_weight_2_0= RULE_INT ) ) )? )
            // InternalDescartesQL.g:946:2: ( (otherlv_0= RULE_ID ) ) (otherlv_1= '*' ( (lv_weight_2_0= RULE_INT ) ) )?
            {
            // InternalDescartesQL.g:946:2: ( (otherlv_0= RULE_ID ) )
            // InternalDescartesQL.g:947:1: (otherlv_0= RULE_ID )
            {
            // InternalDescartesQL.g:947:1: (otherlv_0= RULE_ID )
            // InternalDescartesQL.g:948:3: otherlv_0= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getWeightedSloRule());
            	        }
                    
            otherlv_0=(Token)match(input,RULE_ID,FOLLOW_23); 

            		newLeafNode(otherlv_0, grammarAccess.getWeightedSloAccess().getSloSloCrossReference_0_0()); 
            	

            }


            }

            // InternalDescartesQL.g:959:2: (otherlv_1= '*' ( (lv_weight_2_0= RULE_INT ) ) )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==26) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // InternalDescartesQL.g:959:4: otherlv_1= '*' ( (lv_weight_2_0= RULE_INT ) )
                    {
                    otherlv_1=(Token)match(input,26,FOLLOW_24); 

                        	newLeafNode(otherlv_1, grammarAccess.getWeightedSloAccess().getAsteriskKeyword_1_0());
                        
                    // InternalDescartesQL.g:963:1: ( (lv_weight_2_0= RULE_INT ) )
                    // InternalDescartesQL.g:964:1: (lv_weight_2_0= RULE_INT )
                    {
                    // InternalDescartesQL.g:964:1: (lv_weight_2_0= RULE_INT )
                    // InternalDescartesQL.g:965:3: lv_weight_2_0= RULE_INT
                    {
                    lv_weight_2_0=(Token)match(input,RULE_INT,FOLLOW_2); 

                    			newLeafNode(lv_weight_2_0, grammarAccess.getWeightedSloAccess().getWeightINTTerminalRuleCall_1_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getWeightedSloRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"weight",
                            		lv_weight_2_0, 
                            		"org.eclipse.xtext.common.Terminals.INT");
                    	    

                    }


                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleWeightedSlo"


    // $ANTLR start "entryRuleFuzziness"
    // InternalDescartesQL.g:989:1: entryRuleFuzziness returns [EObject current=null] : iv_ruleFuzziness= ruleFuzziness EOF ;
    public final EObject entryRuleFuzziness() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFuzziness = null;


        try {
            // InternalDescartesQL.g:990:2: (iv_ruleFuzziness= ruleFuzziness EOF )
            // InternalDescartesQL.g:991:2: iv_ruleFuzziness= ruleFuzziness EOF
            {
             newCompositeNode(grammarAccess.getFuzzinessRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFuzziness=ruleFuzziness();

            state._fsp--;

             current =iv_ruleFuzziness; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFuzziness"


    // $ANTLR start "ruleFuzziness"
    // InternalDescartesQL.g:998:1: ruleFuzziness returns [EObject current=null] : ( ( (lv_type_0_0= 'FUZZINESS' ) ) ( (lv_deviation_1_0= ruleVariableValue ) ) ) ;
    public final EObject ruleFuzziness() throws RecognitionException {
        EObject current = null;

        Token lv_type_0_0=null;
        EObject lv_deviation_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1001:28: ( ( ( (lv_type_0_0= 'FUZZINESS' ) ) ( (lv_deviation_1_0= ruleVariableValue ) ) ) )
            // InternalDescartesQL.g:1002:1: ( ( (lv_type_0_0= 'FUZZINESS' ) ) ( (lv_deviation_1_0= ruleVariableValue ) ) )
            {
            // InternalDescartesQL.g:1002:1: ( ( (lv_type_0_0= 'FUZZINESS' ) ) ( (lv_deviation_1_0= ruleVariableValue ) ) )
            // InternalDescartesQL.g:1002:2: ( (lv_type_0_0= 'FUZZINESS' ) ) ( (lv_deviation_1_0= ruleVariableValue ) )
            {
            // InternalDescartesQL.g:1002:2: ( (lv_type_0_0= 'FUZZINESS' ) )
            // InternalDescartesQL.g:1003:1: (lv_type_0_0= 'FUZZINESS' )
            {
            // InternalDescartesQL.g:1003:1: (lv_type_0_0= 'FUZZINESS' )
            // InternalDescartesQL.g:1004:3: lv_type_0_0= 'FUZZINESS'
            {
            lv_type_0_0=(Token)match(input,27,FOLLOW_19); 

                    newLeafNode(lv_type_0_0, grammarAccess.getFuzzinessAccess().getTypeFUZZINESSKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getFuzzinessRule());
            	        }
                   		setWithLastConsumed(current, "type", lv_type_0_0, "FUZZINESS");
            	    

            }


            }

            // InternalDescartesQL.g:1017:2: ( (lv_deviation_1_0= ruleVariableValue ) )
            // InternalDescartesQL.g:1018:1: (lv_deviation_1_0= ruleVariableValue )
            {
            // InternalDescartesQL.g:1018:1: (lv_deviation_1_0= ruleVariableValue )
            // InternalDescartesQL.g:1019:3: lv_deviation_1_0= ruleVariableValue
            {
             
            	        newCompositeNode(grammarAccess.getFuzzinessAccess().getDeviationVariableValueParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_deviation_1_0=ruleVariableValue();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getFuzzinessRule());
            	        }
                   		set(
                   			current, 
                   			"deviation",
                    		lv_deviation_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.VariableValue");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFuzziness"


    // $ANTLR start "entryRulePenalty"
    // InternalDescartesQL.g:1043:1: entryRulePenalty returns [EObject current=null] : iv_rulePenalty= rulePenalty EOF ;
    public final EObject entryRulePenalty() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePenalty = null;


        try {
            // InternalDescartesQL.g:1044:2: (iv_rulePenalty= rulePenalty EOF )
            // InternalDescartesQL.g:1045:2: iv_rulePenalty= rulePenalty EOF
            {
             newCompositeNode(grammarAccess.getPenaltyRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePenalty=rulePenalty();

            state._fsp--;

             current =iv_rulePenalty; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePenalty"


    // $ANTLR start "rulePenalty"
    // InternalDescartesQL.g:1052:1: rulePenalty returns [EObject current=null] : ( ( (lv_type_0_0= 'PENALTY' ) ) ( (lv_value_1_0= RULE_DOUBLE ) ) ( (lv_currency_2_0= ruleCurrency ) )? ) ;
    public final EObject rulePenalty() throws RecognitionException {
        EObject current = null;

        Token lv_type_0_0=null;
        Token lv_value_1_0=null;
        Enumerator lv_currency_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1055:28: ( ( ( (lv_type_0_0= 'PENALTY' ) ) ( (lv_value_1_0= RULE_DOUBLE ) ) ( (lv_currency_2_0= ruleCurrency ) )? ) )
            // InternalDescartesQL.g:1056:1: ( ( (lv_type_0_0= 'PENALTY' ) ) ( (lv_value_1_0= RULE_DOUBLE ) ) ( (lv_currency_2_0= ruleCurrency ) )? )
            {
            // InternalDescartesQL.g:1056:1: ( ( (lv_type_0_0= 'PENALTY' ) ) ( (lv_value_1_0= RULE_DOUBLE ) ) ( (lv_currency_2_0= ruleCurrency ) )? )
            // InternalDescartesQL.g:1056:2: ( (lv_type_0_0= 'PENALTY' ) ) ( (lv_value_1_0= RULE_DOUBLE ) ) ( (lv_currency_2_0= ruleCurrency ) )?
            {
            // InternalDescartesQL.g:1056:2: ( (lv_type_0_0= 'PENALTY' ) )
            // InternalDescartesQL.g:1057:1: (lv_type_0_0= 'PENALTY' )
            {
            // InternalDescartesQL.g:1057:1: (lv_type_0_0= 'PENALTY' )
            // InternalDescartesQL.g:1058:3: lv_type_0_0= 'PENALTY'
            {
            lv_type_0_0=(Token)match(input,28,FOLLOW_9); 

                    newLeafNode(lv_type_0_0, grammarAccess.getPenaltyAccess().getTypePENALTYKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPenaltyRule());
            	        }
                   		setWithLastConsumed(current, "type", lv_type_0_0, "PENALTY");
            	    

            }


            }

            // InternalDescartesQL.g:1071:2: ( (lv_value_1_0= RULE_DOUBLE ) )
            // InternalDescartesQL.g:1072:1: (lv_value_1_0= RULE_DOUBLE )
            {
            // InternalDescartesQL.g:1072:1: (lv_value_1_0= RULE_DOUBLE )
            // InternalDescartesQL.g:1073:3: lv_value_1_0= RULE_DOUBLE
            {
            lv_value_1_0=(Token)match(input,RULE_DOUBLE,FOLLOW_25); 

            			newLeafNode(lv_value_1_0, grammarAccess.getPenaltyAccess().getValueDOUBLETerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPenaltyRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"value",
                    		lv_value_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.DOUBLE");
            	    

            }


            }

            // InternalDescartesQL.g:1089:2: ( (lv_currency_2_0= ruleCurrency ) )?
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( ((LA18_0>=79 && LA18_0<=80)) ) {
                alt18=1;
            }
            switch (alt18) {
                case 1 :
                    // InternalDescartesQL.g:1090:1: (lv_currency_2_0= ruleCurrency )
                    {
                    // InternalDescartesQL.g:1090:1: (lv_currency_2_0= ruleCurrency )
                    // InternalDescartesQL.g:1091:3: lv_currency_2_0= ruleCurrency
                    {
                     
                    	        newCompositeNode(grammarAccess.getPenaltyAccess().getCurrencyCurrencyEnumRuleCall_2_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_currency_2_0=ruleCurrency();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getPenaltyRule());
                    	        }
                           		set(
                           			current, 
                           			"currency",
                            		lv_currency_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.Currency");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePenalty"


    // $ANTLR start "entryRuleViolation"
    // InternalDescartesQL.g:1115:1: entryRuleViolation returns [EObject current=null] : iv_ruleViolation= ruleViolation EOF ;
    public final EObject entryRuleViolation() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleViolation = null;


        try {
            // InternalDescartesQL.g:1116:2: (iv_ruleViolation= ruleViolation EOF )
            // InternalDescartesQL.g:1117:2: iv_ruleViolation= ruleViolation EOF
            {
             newCompositeNode(grammarAccess.getViolationRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleViolation=ruleViolation();

            state._fsp--;

             current =iv_ruleViolation; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleViolation"


    // $ANTLR start "ruleViolation"
    // InternalDescartesQL.g:1124:1: ruleViolation returns [EObject current=null] : ( (otherlv_0= 'PER' ( (lv_amount_1_0= RULE_INT ) ) otherlv_2= 'VIOLATIONS' ) | (otherlv_3= 'SATISFACTION-LEVEL' ( (lv_percentage_4_0= RULE_DOUBLE ) ) otherlv_5= 'PERCENT' ) ) ;
    public final EObject ruleViolation() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_amount_1_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token lv_percentage_4_0=null;
        Token otherlv_5=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1127:28: ( ( (otherlv_0= 'PER' ( (lv_amount_1_0= RULE_INT ) ) otherlv_2= 'VIOLATIONS' ) | (otherlv_3= 'SATISFACTION-LEVEL' ( (lv_percentage_4_0= RULE_DOUBLE ) ) otherlv_5= 'PERCENT' ) ) )
            // InternalDescartesQL.g:1128:1: ( (otherlv_0= 'PER' ( (lv_amount_1_0= RULE_INT ) ) otherlv_2= 'VIOLATIONS' ) | (otherlv_3= 'SATISFACTION-LEVEL' ( (lv_percentage_4_0= RULE_DOUBLE ) ) otherlv_5= 'PERCENT' ) )
            {
            // InternalDescartesQL.g:1128:1: ( (otherlv_0= 'PER' ( (lv_amount_1_0= RULE_INT ) ) otherlv_2= 'VIOLATIONS' ) | (otherlv_3= 'SATISFACTION-LEVEL' ( (lv_percentage_4_0= RULE_DOUBLE ) ) otherlv_5= 'PERCENT' ) )
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==29) ) {
                alt19=1;
            }
            else if ( (LA19_0==17) ) {
                alt19=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 19, 0, input);

                throw nvae;
            }
            switch (alt19) {
                case 1 :
                    // InternalDescartesQL.g:1128:2: (otherlv_0= 'PER' ( (lv_amount_1_0= RULE_INT ) ) otherlv_2= 'VIOLATIONS' )
                    {
                    // InternalDescartesQL.g:1128:2: (otherlv_0= 'PER' ( (lv_amount_1_0= RULE_INT ) ) otherlv_2= 'VIOLATIONS' )
                    // InternalDescartesQL.g:1128:4: otherlv_0= 'PER' ( (lv_amount_1_0= RULE_INT ) ) otherlv_2= 'VIOLATIONS'
                    {
                    otherlv_0=(Token)match(input,29,FOLLOW_24); 

                        	newLeafNode(otherlv_0, grammarAccess.getViolationAccess().getPERKeyword_0_0());
                        
                    // InternalDescartesQL.g:1132:1: ( (lv_amount_1_0= RULE_INT ) )
                    // InternalDescartesQL.g:1133:1: (lv_amount_1_0= RULE_INT )
                    {
                    // InternalDescartesQL.g:1133:1: (lv_amount_1_0= RULE_INT )
                    // InternalDescartesQL.g:1134:3: lv_amount_1_0= RULE_INT
                    {
                    lv_amount_1_0=(Token)match(input,RULE_INT,FOLLOW_26); 

                    			newLeafNode(lv_amount_1_0, grammarAccess.getViolationAccess().getAmountINTTerminalRuleCall_0_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getViolationRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"amount",
                            		lv_amount_1_0, 
                            		"org.eclipse.xtext.common.Terminals.INT");
                    	    

                    }


                    }

                    otherlv_2=(Token)match(input,30,FOLLOW_2); 

                        	newLeafNode(otherlv_2, grammarAccess.getViolationAccess().getVIOLATIONSKeyword_0_2());
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:1155:6: (otherlv_3= 'SATISFACTION-LEVEL' ( (lv_percentage_4_0= RULE_DOUBLE ) ) otherlv_5= 'PERCENT' )
                    {
                    // InternalDescartesQL.g:1155:6: (otherlv_3= 'SATISFACTION-LEVEL' ( (lv_percentage_4_0= RULE_DOUBLE ) ) otherlv_5= 'PERCENT' )
                    // InternalDescartesQL.g:1155:8: otherlv_3= 'SATISFACTION-LEVEL' ( (lv_percentage_4_0= RULE_DOUBLE ) ) otherlv_5= 'PERCENT'
                    {
                    otherlv_3=(Token)match(input,17,FOLLOW_9); 

                        	newLeafNode(otherlv_3, grammarAccess.getViolationAccess().getSATISFACTIONLEVELKeyword_1_0());
                        
                    // InternalDescartesQL.g:1159:1: ( (lv_percentage_4_0= RULE_DOUBLE ) )
                    // InternalDescartesQL.g:1160:1: (lv_percentage_4_0= RULE_DOUBLE )
                    {
                    // InternalDescartesQL.g:1160:1: (lv_percentage_4_0= RULE_DOUBLE )
                    // InternalDescartesQL.g:1161:3: lv_percentage_4_0= RULE_DOUBLE
                    {
                    lv_percentage_4_0=(Token)match(input,RULE_DOUBLE,FOLLOW_10); 

                    			newLeafNode(lv_percentage_4_0, grammarAccess.getViolationAccess().getPercentageDOUBLETerminalRuleCall_1_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getViolationRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"percentage",
                            		lv_percentage_4_0, 
                            		"tools.descartes.dql.lang.DescartesQL.DOUBLE");
                    	    

                    }


                    }

                    otherlv_5=(Token)match(input,18,FOLLOW_2); 

                        	newLeafNode(otherlv_5, grammarAccess.getViolationAccess().getPERCENTKeyword_1_2());
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleViolation"


    // $ANTLR start "entryRuleModelStructureQuery"
    // InternalDescartesQL.g:1189:1: entryRuleModelStructureQuery returns [EObject current=null] : iv_ruleModelStructureQuery= ruleModelStructureQuery EOF ;
    public final EObject entryRuleModelStructureQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModelStructureQuery = null;


        try {
            // InternalDescartesQL.g:1190:2: (iv_ruleModelStructureQuery= ruleModelStructureQuery EOF )
            // InternalDescartesQL.g:1191:2: iv_ruleModelStructureQuery= ruleModelStructureQuery EOF
            {
             newCompositeNode(grammarAccess.getModelStructureQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleModelStructureQuery=ruleModelStructureQuery();

            state._fsp--;

             current =iv_ruleModelStructureQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModelStructureQuery"


    // $ANTLR start "ruleModelStructureQuery"
    // InternalDescartesQL.g:1198:1: ruleModelStructureQuery returns [EObject current=null] : this_ListQuery_0= ruleListQuery ;
    public final EObject ruleModelStructureQuery() throws RecognitionException {
        EObject current = null;

        EObject this_ListQuery_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1201:28: (this_ListQuery_0= ruleListQuery )
            // InternalDescartesQL.g:1203:5: this_ListQuery_0= ruleListQuery
            {
             
                    newCompositeNode(grammarAccess.getModelStructureQueryAccess().getListQueryParserRuleCall()); 
                
            pushFollow(FOLLOW_2);
            this_ListQuery_0=ruleListQuery();

            state._fsp--;

             
                    current = this_ListQuery_0; 
                    afterParserOrEnumRuleCall();
                

            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModelStructureQuery"


    // $ANTLR start "entryRulePerformanceMetricsQuery"
    // InternalDescartesQL.g:1219:1: entryRulePerformanceMetricsQuery returns [EObject current=null] : iv_rulePerformanceMetricsQuery= rulePerformanceMetricsQuery EOF ;
    public final EObject entryRulePerformanceMetricsQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePerformanceMetricsQuery = null;


        try {
            // InternalDescartesQL.g:1220:2: (iv_rulePerformanceMetricsQuery= rulePerformanceMetricsQuery EOF )
            // InternalDescartesQL.g:1221:2: iv_rulePerformanceMetricsQuery= rulePerformanceMetricsQuery EOF
            {
             newCompositeNode(grammarAccess.getPerformanceMetricsQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePerformanceMetricsQuery=rulePerformanceMetricsQuery();

            state._fsp--;

             current =iv_rulePerformanceMetricsQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePerformanceMetricsQuery"


    // $ANTLR start "rulePerformanceMetricsQuery"
    // InternalDescartesQL.g:1228:1: rulePerformanceMetricsQuery returns [EObject current=null] : this_SelectQuery_0= ruleSelectQuery ;
    public final EObject rulePerformanceMetricsQuery() throws RecognitionException {
        EObject current = null;

        EObject this_SelectQuery_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1231:28: (this_SelectQuery_0= ruleSelectQuery )
            // InternalDescartesQL.g:1233:5: this_SelectQuery_0= ruleSelectQuery
            {
             
                    newCompositeNode(grammarAccess.getPerformanceMetricsQueryAccess().getSelectQueryParserRuleCall()); 
                
            pushFollow(FOLLOW_2);
            this_SelectQuery_0=ruleSelectQuery();

            state._fsp--;

             
                    current = this_SelectQuery_0; 
                    afterParserOrEnumRuleCall();
                

            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePerformanceMetricsQuery"


    // $ANTLR start "entryRulePerformanceIssueQuery"
    // InternalDescartesQL.g:1249:1: entryRulePerformanceIssueQuery returns [EObject current=null] : iv_rulePerformanceIssueQuery= rulePerformanceIssueQuery EOF ;
    public final EObject entryRulePerformanceIssueQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePerformanceIssueQuery = null;


        try {
            // InternalDescartesQL.g:1250:2: (iv_rulePerformanceIssueQuery= rulePerformanceIssueQuery EOF )
            // InternalDescartesQL.g:1251:2: iv_rulePerformanceIssueQuery= rulePerformanceIssueQuery EOF
            {
             newCompositeNode(grammarAccess.getPerformanceIssueQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePerformanceIssueQuery=rulePerformanceIssueQuery();

            state._fsp--;

             current =iv_rulePerformanceIssueQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePerformanceIssueQuery"


    // $ANTLR start "rulePerformanceIssueQuery"
    // InternalDescartesQL.g:1258:1: rulePerformanceIssueQuery returns [EObject current=null] : this_DetectQuery_0= ruleDetectQuery ;
    public final EObject rulePerformanceIssueQuery() throws RecognitionException {
        EObject current = null;

        EObject this_DetectQuery_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1261:28: (this_DetectQuery_0= ruleDetectQuery )
            // InternalDescartesQL.g:1263:5: this_DetectQuery_0= ruleDetectQuery
            {
             
                    newCompositeNode(grammarAccess.getPerformanceIssueQueryAccess().getDetectQueryParserRuleCall()); 
                
            pushFollow(FOLLOW_2);
            this_DetectQuery_0=ruleDetectQuery();

            state._fsp--;

             
                    current = this_DetectQuery_0; 
                    afterParserOrEnumRuleCall();
                

            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePerformanceIssueQuery"


    // $ANTLR start "entryRuleConnectorCapabilityQuery"
    // InternalDescartesQL.g:1279:1: entryRuleConnectorCapabilityQuery returns [EObject current=null] : iv_ruleConnectorCapabilityQuery= ruleConnectorCapabilityQuery EOF ;
    public final EObject entryRuleConnectorCapabilityQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConnectorCapabilityQuery = null;


        try {
            // InternalDescartesQL.g:1280:2: (iv_ruleConnectorCapabilityQuery= ruleConnectorCapabilityQuery EOF )
            // InternalDescartesQL.g:1281:2: iv_ruleConnectorCapabilityQuery= ruleConnectorCapabilityQuery EOF
            {
             newCompositeNode(grammarAccess.getConnectorCapabilityQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleConnectorCapabilityQuery=ruleConnectorCapabilityQuery();

            state._fsp--;

             current =iv_ruleConnectorCapabilityQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConnectorCapabilityQuery"


    // $ANTLR start "ruleConnectorCapabilityQuery"
    // InternalDescartesQL.g:1288:1: ruleConnectorCapabilityQuery returns [EObject current=null] : this_GetQuery_0= ruleGetQuery ;
    public final EObject ruleConnectorCapabilityQuery() throws RecognitionException {
        EObject current = null;

        EObject this_GetQuery_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1291:28: (this_GetQuery_0= ruleGetQuery )
            // InternalDescartesQL.g:1293:5: this_GetQuery_0= ruleGetQuery
            {
             
                    newCompositeNode(grammarAccess.getConnectorCapabilityQueryAccess().getGetQueryParserRuleCall()); 
                
            pushFollow(FOLLOW_2);
            this_GetQuery_0=ruleGetQuery();

            state._fsp--;

             
                    current = this_GetQuery_0; 
                    afterParserOrEnumRuleCall();
                

            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConnectorCapabilityQuery"


    // $ANTLR start "entryRuleListQuery"
    // InternalDescartesQL.g:1309:1: entryRuleListQuery returns [EObject current=null] : iv_ruleListQuery= ruleListQuery EOF ;
    public final EObject entryRuleListQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleListQuery = null;


        try {
            // InternalDescartesQL.g:1310:2: (iv_ruleListQuery= ruleListQuery EOF )
            // InternalDescartesQL.g:1311:2: iv_ruleListQuery= ruleListQuery EOF
            {
             newCompositeNode(grammarAccess.getListQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleListQuery=ruleListQuery();

            state._fsp--;

             current =iv_ruleListQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleListQuery"


    // $ANTLR start "ruleListQuery"
    // InternalDescartesQL.g:1318:1: ruleListQuery returns [EObject current=null] : (otherlv_0= 'LIST' ( ( (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery ) ) ) ( (lv_filterClause_2_0= ruleFilterClause ) )? ( (lv_usingClause_3_0= ruleUsingClause ) ) ) ;
    public final EObject ruleListQuery() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_queryType_1_1 = null;

        EObject lv_queryType_1_2 = null;

        EObject lv_queryType_1_3 = null;

        EObject lv_filterClause_2_0 = null;

        EObject lv_usingClause_3_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1321:28: ( (otherlv_0= 'LIST' ( ( (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery ) ) ) ( (lv_filterClause_2_0= ruleFilterClause ) )? ( (lv_usingClause_3_0= ruleUsingClause ) ) ) )
            // InternalDescartesQL.g:1322:1: (otherlv_0= 'LIST' ( ( (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery ) ) ) ( (lv_filterClause_2_0= ruleFilterClause ) )? ( (lv_usingClause_3_0= ruleUsingClause ) ) )
            {
            // InternalDescartesQL.g:1322:1: (otherlv_0= 'LIST' ( ( (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery ) ) ) ( (lv_filterClause_2_0= ruleFilterClause ) )? ( (lv_usingClause_3_0= ruleUsingClause ) ) )
            // InternalDescartesQL.g:1322:3: otherlv_0= 'LIST' ( ( (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery ) ) ) ( (lv_filterClause_2_0= ruleFilterClause ) )? ( (lv_usingClause_3_0= ruleUsingClause ) )
            {
            otherlv_0=(Token)match(input,31,FOLLOW_27); 

                	newLeafNode(otherlv_0, grammarAccess.getListQueryAccess().getLISTKeyword_0());
                
            // InternalDescartesQL.g:1326:1: ( ( (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery ) ) )
            // InternalDescartesQL.g:1327:1: ( (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery ) )
            {
            // InternalDescartesQL.g:1327:1: ( (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery ) )
            // InternalDescartesQL.g:1328:1: (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery )
            {
            // InternalDescartesQL.g:1328:1: (lv_queryType_1_1= ruleListEntitiesQuery | lv_queryType_1_2= ruleListMetricsQuery | lv_queryType_1_3= ruleListDoFQuery )
            int alt20=3;
            switch ( input.LA(1) ) {
            case 37:
                {
                alt20=1;
                }
                break;
            case 38:
                {
                alt20=2;
                }
                break;
            case 36:
                {
                alt20=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }

            switch (alt20) {
                case 1 :
                    // InternalDescartesQL.g:1329:3: lv_queryType_1_1= ruleListEntitiesQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getListQueryAccess().getQueryTypeListEntitiesQueryParserRuleCall_1_0_0()); 
                    	    
                    pushFollow(FOLLOW_28);
                    lv_queryType_1_1=ruleListEntitiesQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getListQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"queryType",
                            		lv_queryType_1_1, 
                            		"tools.descartes.dql.lang.DescartesQL.ListEntitiesQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:1344:8: lv_queryType_1_2= ruleListMetricsQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getListQueryAccess().getQueryTypeListMetricsQueryParserRuleCall_1_0_1()); 
                    	    
                    pushFollow(FOLLOW_28);
                    lv_queryType_1_2=ruleListMetricsQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getListQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"queryType",
                            		lv_queryType_1_2, 
                            		"tools.descartes.dql.lang.DescartesQL.ListMetricsQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:1359:8: lv_queryType_1_3= ruleListDoFQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getListQueryAccess().getQueryTypeListDoFQueryParserRuleCall_1_0_2()); 
                    	    
                    pushFollow(FOLLOW_28);
                    lv_queryType_1_3=ruleListDoFQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getListQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"queryType",
                            		lv_queryType_1_3, 
                            		"tools.descartes.dql.lang.DescartesQL.ListDoFQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }

            // InternalDescartesQL.g:1377:2: ( (lv_filterClause_2_0= ruleFilterClause ) )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==63) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // InternalDescartesQL.g:1378:1: (lv_filterClause_2_0= ruleFilterClause )
                    {
                    // InternalDescartesQL.g:1378:1: (lv_filterClause_2_0= ruleFilterClause )
                    // InternalDescartesQL.g:1379:3: lv_filterClause_2_0= ruleFilterClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getListQueryAccess().getFilterClauseFilterClauseParserRuleCall_2_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_filterClause_2_0=ruleFilterClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getListQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"filterClause",
                            		lv_filterClause_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.FilterClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:1395:3: ( (lv_usingClause_3_0= ruleUsingClause ) )
            // InternalDescartesQL.g:1396:1: (lv_usingClause_3_0= ruleUsingClause )
            {
            // InternalDescartesQL.g:1396:1: (lv_usingClause_3_0= ruleUsingClause )
            // InternalDescartesQL.g:1397:3: lv_usingClause_3_0= ruleUsingClause
            {
             
            	        newCompositeNode(grammarAccess.getListQueryAccess().getUsingClauseUsingClauseParserRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_usingClause_3_0=ruleUsingClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getListQueryRule());
            	        }
                   		set(
                   			current, 
                   			"usingClause",
                    		lv_usingClause_3_0, 
                    		"tools.descartes.dql.lang.DescartesQL.UsingClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleListQuery"


    // $ANTLR start "entryRuleGetQuery"
    // InternalDescartesQL.g:1421:1: entryRuleGetQuery returns [EObject current=null] : iv_ruleGetQuery= ruleGetQuery EOF ;
    public final EObject entryRuleGetQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGetQuery = null;


        try {
            // InternalDescartesQL.g:1422:2: (iv_ruleGetQuery= ruleGetQuery EOF )
            // InternalDescartesQL.g:1423:2: iv_ruleGetQuery= ruleGetQuery EOF
            {
             newCompositeNode(grammarAccess.getGetQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleGetQuery=ruleGetQuery();

            state._fsp--;

             current =iv_ruleGetQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGetQuery"


    // $ANTLR start "ruleGetQuery"
    // InternalDescartesQL.g:1430:1: ruleGetQuery returns [EObject current=null] : (otherlv_0= 'GET' ( ( (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery ) ) ) ( (lv_usingClause_2_0= ruleUsingClause ) ) ) ;
    public final EObject ruleGetQuery() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_queryTape_1_1 = null;

        EObject lv_queryTape_1_2 = null;

        EObject lv_queryTape_1_3 = null;

        EObject lv_usingClause_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1433:28: ( (otherlv_0= 'GET' ( ( (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery ) ) ) ( (lv_usingClause_2_0= ruleUsingClause ) ) ) )
            // InternalDescartesQL.g:1434:1: (otherlv_0= 'GET' ( ( (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery ) ) ) ( (lv_usingClause_2_0= ruleUsingClause ) ) )
            {
            // InternalDescartesQL.g:1434:1: (otherlv_0= 'GET' ( ( (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery ) ) ) ( (lv_usingClause_2_0= ruleUsingClause ) ) )
            // InternalDescartesQL.g:1434:3: otherlv_0= 'GET' ( ( (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery ) ) ) ( (lv_usingClause_2_0= ruleUsingClause ) )
            {
            otherlv_0=(Token)match(input,32,FOLLOW_29); 

                	newLeafNode(otherlv_0, grammarAccess.getGetQueryAccess().getGETKeyword_0());
                
            // InternalDescartesQL.g:1438:1: ( ( (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery ) ) )
            // InternalDescartesQL.g:1439:1: ( (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery ) )
            {
            // InternalDescartesQL.g:1439:1: ( (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery ) )
            // InternalDescartesQL.g:1440:1: (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery )
            {
            // InternalDescartesQL.g:1440:1: (lv_queryTape_1_1= ruleGetExplorationStrategiesQuery | lv_queryTape_1_2= ruleGetTimeUnitsQuery | lv_queryTape_1_3= ruleGetConstraintsQuery )
            int alt22=3;
            switch ( input.LA(1) ) {
            case 34:
                {
                alt22=1;
                }
                break;
            case 35:
                {
                alt22=2;
                }
                break;
            case 33:
                {
                alt22=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 22, 0, input);

                throw nvae;
            }

            switch (alt22) {
                case 1 :
                    // InternalDescartesQL.g:1441:3: lv_queryTape_1_1= ruleGetExplorationStrategiesQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getGetQueryAccess().getQueryTapeGetExplorationStrategiesQueryParserRuleCall_1_0_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_queryTape_1_1=ruleGetExplorationStrategiesQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGetQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"queryTape",
                            		lv_queryTape_1_1, 
                            		"tools.descartes.dql.lang.DescartesQL.GetExplorationStrategiesQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:1456:8: lv_queryTape_1_2= ruleGetTimeUnitsQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getGetQueryAccess().getQueryTapeGetTimeUnitsQueryParserRuleCall_1_0_1()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_queryTape_1_2=ruleGetTimeUnitsQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGetQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"queryTape",
                            		lv_queryTape_1_2, 
                            		"tools.descartes.dql.lang.DescartesQL.GetTimeUnitsQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:1471:8: lv_queryTape_1_3= ruleGetConstraintsQuery
                    {
                     
                    	        newCompositeNode(grammarAccess.getGetQueryAccess().getQueryTapeGetConstraintsQueryParserRuleCall_1_0_2()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_queryTape_1_3=ruleGetConstraintsQuery();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getGetQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"queryTape",
                            		lv_queryTape_1_3, 
                            		"tools.descartes.dql.lang.DescartesQL.GetConstraintsQuery");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }

            // InternalDescartesQL.g:1489:2: ( (lv_usingClause_2_0= ruleUsingClause ) )
            // InternalDescartesQL.g:1490:1: (lv_usingClause_2_0= ruleUsingClause )
            {
            // InternalDescartesQL.g:1490:1: (lv_usingClause_2_0= ruleUsingClause )
            // InternalDescartesQL.g:1491:3: lv_usingClause_2_0= ruleUsingClause
            {
             
            	        newCompositeNode(grammarAccess.getGetQueryAccess().getUsingClauseUsingClauseParserRuleCall_2_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_usingClause_2_0=ruleUsingClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getGetQueryRule());
            	        }
                   		set(
                   			current, 
                   			"usingClause",
                    		lv_usingClause_2_0, 
                    		"tools.descartes.dql.lang.DescartesQL.UsingClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGetQuery"


    // $ANTLR start "entryRuleGetConstraintsQuery"
    // InternalDescartesQL.g:1515:1: entryRuleGetConstraintsQuery returns [EObject current=null] : iv_ruleGetConstraintsQuery= ruleGetConstraintsQuery EOF ;
    public final EObject entryRuleGetConstraintsQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGetConstraintsQuery = null;


        try {
            // InternalDescartesQL.g:1516:2: (iv_ruleGetConstraintsQuery= ruleGetConstraintsQuery EOF )
            // InternalDescartesQL.g:1517:2: iv_ruleGetConstraintsQuery= ruleGetConstraintsQuery EOF
            {
             newCompositeNode(grammarAccess.getGetConstraintsQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleGetConstraintsQuery=ruleGetConstraintsQuery();

            state._fsp--;

             current =iv_ruleGetConstraintsQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGetConstraintsQuery"


    // $ANTLR start "ruleGetConstraintsQuery"
    // InternalDescartesQL.g:1524:1: ruleGetConstraintsQuery returns [EObject current=null] : ( (lv_mode_0_0= 'CONSTRAINTS' ) ) ;
    public final EObject ruleGetConstraintsQuery() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1527:28: ( ( (lv_mode_0_0= 'CONSTRAINTS' ) ) )
            // InternalDescartesQL.g:1528:1: ( (lv_mode_0_0= 'CONSTRAINTS' ) )
            {
            // InternalDescartesQL.g:1528:1: ( (lv_mode_0_0= 'CONSTRAINTS' ) )
            // InternalDescartesQL.g:1529:1: (lv_mode_0_0= 'CONSTRAINTS' )
            {
            // InternalDescartesQL.g:1529:1: (lv_mode_0_0= 'CONSTRAINTS' )
            // InternalDescartesQL.g:1530:3: lv_mode_0_0= 'CONSTRAINTS'
            {
            lv_mode_0_0=(Token)match(input,33,FOLLOW_2); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getGetConstraintsQueryAccess().getModeCONSTRAINTSKeyword_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getGetConstraintsQueryRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "CONSTRAINTS");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGetConstraintsQuery"


    // $ANTLR start "entryRuleGetExplorationStrategiesQuery"
    // InternalDescartesQL.g:1551:1: entryRuleGetExplorationStrategiesQuery returns [EObject current=null] : iv_ruleGetExplorationStrategiesQuery= ruleGetExplorationStrategiesQuery EOF ;
    public final EObject entryRuleGetExplorationStrategiesQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGetExplorationStrategiesQuery = null;


        try {
            // InternalDescartesQL.g:1552:2: (iv_ruleGetExplorationStrategiesQuery= ruleGetExplorationStrategiesQuery EOF )
            // InternalDescartesQL.g:1553:2: iv_ruleGetExplorationStrategiesQuery= ruleGetExplorationStrategiesQuery EOF
            {
             newCompositeNode(grammarAccess.getGetExplorationStrategiesQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleGetExplorationStrategiesQuery=ruleGetExplorationStrategiesQuery();

            state._fsp--;

             current =iv_ruleGetExplorationStrategiesQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGetExplorationStrategiesQuery"


    // $ANTLR start "ruleGetExplorationStrategiesQuery"
    // InternalDescartesQL.g:1560:1: ruleGetExplorationStrategiesQuery returns [EObject current=null] : ( (lv_mode_0_0= 'EXPLORATION STRATEGIES' ) ) ;
    public final EObject ruleGetExplorationStrategiesQuery() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1563:28: ( ( (lv_mode_0_0= 'EXPLORATION STRATEGIES' ) ) )
            // InternalDescartesQL.g:1564:1: ( (lv_mode_0_0= 'EXPLORATION STRATEGIES' ) )
            {
            // InternalDescartesQL.g:1564:1: ( (lv_mode_0_0= 'EXPLORATION STRATEGIES' ) )
            // InternalDescartesQL.g:1565:1: (lv_mode_0_0= 'EXPLORATION STRATEGIES' )
            {
            // InternalDescartesQL.g:1565:1: (lv_mode_0_0= 'EXPLORATION STRATEGIES' )
            // InternalDescartesQL.g:1566:3: lv_mode_0_0= 'EXPLORATION STRATEGIES'
            {
            lv_mode_0_0=(Token)match(input,34,FOLLOW_2); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getGetExplorationStrategiesQueryAccess().getModeEXPLORATIONSTRATEGIESKeyword_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getGetExplorationStrategiesQueryRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "EXPLORATION STRATEGIES");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGetExplorationStrategiesQuery"


    // $ANTLR start "entryRuleGetTimeUnitsQuery"
    // InternalDescartesQL.g:1587:1: entryRuleGetTimeUnitsQuery returns [EObject current=null] : iv_ruleGetTimeUnitsQuery= ruleGetTimeUnitsQuery EOF ;
    public final EObject entryRuleGetTimeUnitsQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGetTimeUnitsQuery = null;


        try {
            // InternalDescartesQL.g:1588:2: (iv_ruleGetTimeUnitsQuery= ruleGetTimeUnitsQuery EOF )
            // InternalDescartesQL.g:1589:2: iv_ruleGetTimeUnitsQuery= ruleGetTimeUnitsQuery EOF
            {
             newCompositeNode(grammarAccess.getGetTimeUnitsQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleGetTimeUnitsQuery=ruleGetTimeUnitsQuery();

            state._fsp--;

             current =iv_ruleGetTimeUnitsQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGetTimeUnitsQuery"


    // $ANTLR start "ruleGetTimeUnitsQuery"
    // InternalDescartesQL.g:1596:1: ruleGetTimeUnitsQuery returns [EObject current=null] : ( (lv_mode_0_0= 'TIME UNITS' ) ) ;
    public final EObject ruleGetTimeUnitsQuery() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1599:28: ( ( (lv_mode_0_0= 'TIME UNITS' ) ) )
            // InternalDescartesQL.g:1600:1: ( (lv_mode_0_0= 'TIME UNITS' ) )
            {
            // InternalDescartesQL.g:1600:1: ( (lv_mode_0_0= 'TIME UNITS' ) )
            // InternalDescartesQL.g:1601:1: (lv_mode_0_0= 'TIME UNITS' )
            {
            // InternalDescartesQL.g:1601:1: (lv_mode_0_0= 'TIME UNITS' )
            // InternalDescartesQL.g:1602:3: lv_mode_0_0= 'TIME UNITS'
            {
            lv_mode_0_0=(Token)match(input,35,FOLLOW_2); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getGetTimeUnitsQueryAccess().getModeTIMEUNITSKeyword_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getGetTimeUnitsQueryRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "TIME UNITS");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGetTimeUnitsQuery"


    // $ANTLR start "entryRuleListDoFQuery"
    // InternalDescartesQL.g:1623:1: entryRuleListDoFQuery returns [EObject current=null] : iv_ruleListDoFQuery= ruleListDoFQuery EOF ;
    public final EObject entryRuleListDoFQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleListDoFQuery = null;


        try {
            // InternalDescartesQL.g:1624:2: (iv_ruleListDoFQuery= ruleListDoFQuery EOF )
            // InternalDescartesQL.g:1625:2: iv_ruleListDoFQuery= ruleListDoFQuery EOF
            {
             newCompositeNode(grammarAccess.getListDoFQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleListDoFQuery=ruleListDoFQuery();

            state._fsp--;

             current =iv_ruleListDoFQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleListDoFQuery"


    // $ANTLR start "ruleListDoFQuery"
    // InternalDescartesQL.g:1632:1: ruleListDoFQuery returns [EObject current=null] : ( ( (lv_mode_0_0= 'DOF' ) ) ( (lv_withClause_1_0= ruleWithClause ) )? ) ;
    public final EObject ruleListDoFQuery() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        EObject lv_withClause_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1635:28: ( ( ( (lv_mode_0_0= 'DOF' ) ) ( (lv_withClause_1_0= ruleWithClause ) )? ) )
            // InternalDescartesQL.g:1636:1: ( ( (lv_mode_0_0= 'DOF' ) ) ( (lv_withClause_1_0= ruleWithClause ) )? )
            {
            // InternalDescartesQL.g:1636:1: ( ( (lv_mode_0_0= 'DOF' ) ) ( (lv_withClause_1_0= ruleWithClause ) )? )
            // InternalDescartesQL.g:1636:2: ( (lv_mode_0_0= 'DOF' ) ) ( (lv_withClause_1_0= ruleWithClause ) )?
            {
            // InternalDescartesQL.g:1636:2: ( (lv_mode_0_0= 'DOF' ) )
            // InternalDescartesQL.g:1637:1: (lv_mode_0_0= 'DOF' )
            {
            // InternalDescartesQL.g:1637:1: (lv_mode_0_0= 'DOF' )
            // InternalDescartesQL.g:1638:3: lv_mode_0_0= 'DOF'
            {
            lv_mode_0_0=(Token)match(input,36,FOLLOW_30); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getListDoFQueryAccess().getModeDOFKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getListDoFQueryRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "DOF");
            	    

            }


            }

            // InternalDescartesQL.g:1651:2: ( (lv_withClause_1_0= ruleWithClause ) )?
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==61) ) {
                alt23=1;
            }
            switch (alt23) {
                case 1 :
                    // InternalDescartesQL.g:1652:1: (lv_withClause_1_0= ruleWithClause )
                    {
                    // InternalDescartesQL.g:1652:1: (lv_withClause_1_0= ruleWithClause )
                    // InternalDescartesQL.g:1653:3: lv_withClause_1_0= ruleWithClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getListDoFQueryAccess().getWithClauseWithClauseParserRuleCall_1_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_withClause_1_0=ruleWithClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getListDoFQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"withClause",
                            		lv_withClause_1_0, 
                            		"tools.descartes.dql.lang.DescartesQL.WithClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleListDoFQuery"


    // $ANTLR start "entryRuleListEntitiesQuery"
    // InternalDescartesQL.g:1677:1: entryRuleListEntitiesQuery returns [EObject current=null] : iv_ruleListEntitiesQuery= ruleListEntitiesQuery EOF ;
    public final EObject entryRuleListEntitiesQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleListEntitiesQuery = null;


        try {
            // InternalDescartesQL.g:1678:2: (iv_ruleListEntitiesQuery= ruleListEntitiesQuery EOF )
            // InternalDescartesQL.g:1679:2: iv_ruleListEntitiesQuery= ruleListEntitiesQuery EOF
            {
             newCompositeNode(grammarAccess.getListEntitiesQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleListEntitiesQuery=ruleListEntitiesQuery();

            state._fsp--;

             current =iv_ruleListEntitiesQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleListEntitiesQuery"


    // $ANTLR start "ruleListEntitiesQuery"
    // InternalDescartesQL.g:1686:1: ruleListEntitiesQuery returns [EObject current=null] : ( (lv_mode_0_0= 'ENTITIES' ) ) ;
    public final EObject ruleListEntitiesQuery() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1689:28: ( ( (lv_mode_0_0= 'ENTITIES' ) ) )
            // InternalDescartesQL.g:1690:1: ( (lv_mode_0_0= 'ENTITIES' ) )
            {
            // InternalDescartesQL.g:1690:1: ( (lv_mode_0_0= 'ENTITIES' ) )
            // InternalDescartesQL.g:1691:1: (lv_mode_0_0= 'ENTITIES' )
            {
            // InternalDescartesQL.g:1691:1: (lv_mode_0_0= 'ENTITIES' )
            // InternalDescartesQL.g:1692:3: lv_mode_0_0= 'ENTITIES'
            {
            lv_mode_0_0=(Token)match(input,37,FOLLOW_2); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getListEntitiesQueryAccess().getModeENTITIESKeyword_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getListEntitiesQueryRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "ENTITIES");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleListEntitiesQuery"


    // $ANTLR start "entryRuleListMetricsQuery"
    // InternalDescartesQL.g:1713:1: entryRuleListMetricsQuery returns [EObject current=null] : iv_ruleListMetricsQuery= ruleListMetricsQuery EOF ;
    public final EObject entryRuleListMetricsQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleListMetricsQuery = null;


        try {
            // InternalDescartesQL.g:1714:2: (iv_ruleListMetricsQuery= ruleListMetricsQuery EOF )
            // InternalDescartesQL.g:1715:2: iv_ruleListMetricsQuery= ruleListMetricsQuery EOF
            {
             newCompositeNode(grammarAccess.getListMetricsQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleListMetricsQuery=ruleListMetricsQuery();

            state._fsp--;

             current =iv_ruleListMetricsQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleListMetricsQuery"


    // $ANTLR start "ruleListMetricsQuery"
    // InternalDescartesQL.g:1722:1: ruleListMetricsQuery returns [EObject current=null] : ( ( (lv_mode_0_0= 'METRICS' ) ) otherlv_1= '(' ( (lv_entityReferenceClause_2_0= ruleEntityReferenceClause ) ) otherlv_3= ')' ) ;
    public final EObject ruleListMetricsQuery() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        EObject lv_entityReferenceClause_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1725:28: ( ( ( (lv_mode_0_0= 'METRICS' ) ) otherlv_1= '(' ( (lv_entityReferenceClause_2_0= ruleEntityReferenceClause ) ) otherlv_3= ')' ) )
            // InternalDescartesQL.g:1726:1: ( ( (lv_mode_0_0= 'METRICS' ) ) otherlv_1= '(' ( (lv_entityReferenceClause_2_0= ruleEntityReferenceClause ) ) otherlv_3= ')' )
            {
            // InternalDescartesQL.g:1726:1: ( ( (lv_mode_0_0= 'METRICS' ) ) otherlv_1= '(' ( (lv_entityReferenceClause_2_0= ruleEntityReferenceClause ) ) otherlv_3= ')' )
            // InternalDescartesQL.g:1726:2: ( (lv_mode_0_0= 'METRICS' ) ) otherlv_1= '(' ( (lv_entityReferenceClause_2_0= ruleEntityReferenceClause ) ) otherlv_3= ')'
            {
            // InternalDescartesQL.g:1726:2: ( (lv_mode_0_0= 'METRICS' ) )
            // InternalDescartesQL.g:1727:1: (lv_mode_0_0= 'METRICS' )
            {
            // InternalDescartesQL.g:1727:1: (lv_mode_0_0= 'METRICS' )
            // InternalDescartesQL.g:1728:3: lv_mode_0_0= 'METRICS'
            {
            lv_mode_0_0=(Token)match(input,38,FOLLOW_14); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getListMetricsQueryAccess().getModeMETRICSKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getListMetricsQueryRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "METRICS");
            	    

            }


            }

            otherlv_1=(Token)match(input,23,FOLLOW_31); 

                	newLeafNode(otherlv_1, grammarAccess.getListMetricsQueryAccess().getLeftParenthesisKeyword_1());
                
            // InternalDescartesQL.g:1745:1: ( (lv_entityReferenceClause_2_0= ruleEntityReferenceClause ) )
            // InternalDescartesQL.g:1746:1: (lv_entityReferenceClause_2_0= ruleEntityReferenceClause )
            {
            // InternalDescartesQL.g:1746:1: (lv_entityReferenceClause_2_0= ruleEntityReferenceClause )
            // InternalDescartesQL.g:1747:3: lv_entityReferenceClause_2_0= ruleEntityReferenceClause
            {
             
            	        newCompositeNode(grammarAccess.getListMetricsQueryAccess().getEntityReferenceClauseEntityReferenceClauseParserRuleCall_2_0()); 
            	    
            pushFollow(FOLLOW_32);
            lv_entityReferenceClause_2_0=ruleEntityReferenceClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getListMetricsQueryRule());
            	        }
                   		set(
                   			current, 
                   			"entityReferenceClause",
                    		lv_entityReferenceClause_2_0, 
                    		"tools.descartes.dql.lang.DescartesQL.EntityReferenceClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_3=(Token)match(input,24,FOLLOW_2); 

                	newLeafNode(otherlv_3, grammarAccess.getListMetricsQueryAccess().getRightParenthesisKeyword_3());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleListMetricsQuery"


    // $ANTLR start "entryRuleSelectQuery"
    // InternalDescartesQL.g:1775:1: entryRuleSelectQuery returns [EObject current=null] : iv_ruleSelectQuery= ruleSelectQuery EOF ;
    public final EObject entryRuleSelectQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSelectQuery = null;


        try {
            // InternalDescartesQL.g:1776:2: (iv_ruleSelectQuery= ruleSelectQuery EOF )
            // InternalDescartesQL.g:1777:2: iv_ruleSelectQuery= ruleSelectQuery EOF
            {
             newCompositeNode(grammarAccess.getSelectQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSelectQuery=ruleSelectQuery();

            state._fsp--;

             current =iv_ruleSelectQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSelectQuery"


    // $ANTLR start "ruleSelectQuery"
    // InternalDescartesQL.g:1784:1: ruleSelectQuery returns [EObject current=null] : (otherlv_0= 'SELECT' ( (lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses ) ) ( (lv_constraintClause_2_0= ruleConstraintClause ) )? ( (lv_dofClause_3_0= ruleDoFClause ) )? ( (lv_forClause_4_0= ruleForClause ) ) ( (lv_usingClause_5_0= ruleUsingClause ) ) ( (lv_observeClause_6_0= ruleObserveClause ) )? ) ;
    public final EObject ruleSelectQuery() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_metricReferenceClauses_1_0 = null;

        EObject lv_constraintClause_2_0 = null;

        EObject lv_dofClause_3_0 = null;

        EObject lv_forClause_4_0 = null;

        EObject lv_usingClause_5_0 = null;

        EObject lv_observeClause_6_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1787:28: ( (otherlv_0= 'SELECT' ( (lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses ) ) ( (lv_constraintClause_2_0= ruleConstraintClause ) )? ( (lv_dofClause_3_0= ruleDoFClause ) )? ( (lv_forClause_4_0= ruleForClause ) ) ( (lv_usingClause_5_0= ruleUsingClause ) ) ( (lv_observeClause_6_0= ruleObserveClause ) )? ) )
            // InternalDescartesQL.g:1788:1: (otherlv_0= 'SELECT' ( (lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses ) ) ( (lv_constraintClause_2_0= ruleConstraintClause ) )? ( (lv_dofClause_3_0= ruleDoFClause ) )? ( (lv_forClause_4_0= ruleForClause ) ) ( (lv_usingClause_5_0= ruleUsingClause ) ) ( (lv_observeClause_6_0= ruleObserveClause ) )? )
            {
            // InternalDescartesQL.g:1788:1: (otherlv_0= 'SELECT' ( (lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses ) ) ( (lv_constraintClause_2_0= ruleConstraintClause ) )? ( (lv_dofClause_3_0= ruleDoFClause ) )? ( (lv_forClause_4_0= ruleForClause ) ) ( (lv_usingClause_5_0= ruleUsingClause ) ) ( (lv_observeClause_6_0= ruleObserveClause ) )? )
            // InternalDescartesQL.g:1788:3: otherlv_0= 'SELECT' ( (lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses ) ) ( (lv_constraintClause_2_0= ruleConstraintClause ) )? ( (lv_dofClause_3_0= ruleDoFClause ) )? ( (lv_forClause_4_0= ruleForClause ) ) ( (lv_usingClause_5_0= ruleUsingClause ) ) ( (lv_observeClause_6_0= ruleObserveClause ) )?
            {
            otherlv_0=(Token)match(input,39,FOLLOW_17); 

                	newLeafNode(otherlv_0, grammarAccess.getSelectQueryAccess().getSELECTKeyword_0());
                
            // InternalDescartesQL.g:1792:1: ( (lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses ) )
            // InternalDescartesQL.g:1793:1: (lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses )
            {
            // InternalDescartesQL.g:1793:1: (lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses )
            // InternalDescartesQL.g:1794:3: lv_metricReferenceClauses_1_0= ruleMetricReferenceClauses
            {
             
            	        newCompositeNode(grammarAccess.getSelectQueryAccess().getMetricReferenceClausesMetricReferenceClausesParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_33);
            lv_metricReferenceClauses_1_0=ruleMetricReferenceClauses();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSelectQueryRule());
            	        }
                   		set(
                   			current, 
                   			"metricReferenceClauses",
                    		lv_metricReferenceClauses_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.MetricReferenceClauses");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:1810:2: ( (lv_constraintClause_2_0= ruleConstraintClause ) )?
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==42) ) {
                alt24=1;
            }
            switch (alt24) {
                case 1 :
                    // InternalDescartesQL.g:1811:1: (lv_constraintClause_2_0= ruleConstraintClause )
                    {
                    // InternalDescartesQL.g:1811:1: (lv_constraintClause_2_0= ruleConstraintClause )
                    // InternalDescartesQL.g:1812:3: lv_constraintClause_2_0= ruleConstraintClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getSelectQueryAccess().getConstraintClauseConstraintClauseParserRuleCall_2_0()); 
                    	    
                    pushFollow(FOLLOW_34);
                    lv_constraintClause_2_0=ruleConstraintClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSelectQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"constraintClause",
                            		lv_constraintClause_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ConstraintClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:1828:3: ( (lv_dofClause_3_0= ruleDoFClause ) )?
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==43) ) {
                alt25=1;
            }
            switch (alt25) {
                case 1 :
                    // InternalDescartesQL.g:1829:1: (lv_dofClause_3_0= ruleDoFClause )
                    {
                    // InternalDescartesQL.g:1829:1: (lv_dofClause_3_0= ruleDoFClause )
                    // InternalDescartesQL.g:1830:3: lv_dofClause_3_0= ruleDoFClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getSelectQueryAccess().getDofClauseDoFClauseParserRuleCall_3_0()); 
                    	    
                    pushFollow(FOLLOW_35);
                    lv_dofClause_3_0=ruleDoFClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSelectQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"dofClause",
                            		lv_dofClause_3_0, 
                            		"tools.descartes.dql.lang.DescartesQL.DoFClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:1846:3: ( (lv_forClause_4_0= ruleForClause ) )
            // InternalDescartesQL.g:1847:1: (lv_forClause_4_0= ruleForClause )
            {
            // InternalDescartesQL.g:1847:1: (lv_forClause_4_0= ruleForClause )
            // InternalDescartesQL.g:1848:3: lv_forClause_4_0= ruleForClause
            {
             
            	        newCompositeNode(grammarAccess.getSelectQueryAccess().getForClauseForClauseParserRuleCall_4_0()); 
            	    
            pushFollow(FOLLOW_6);
            lv_forClause_4_0=ruleForClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSelectQueryRule());
            	        }
                   		set(
                   			current, 
                   			"forClause",
                    		lv_forClause_4_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ForClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:1864:2: ( (lv_usingClause_5_0= ruleUsingClause ) )
            // InternalDescartesQL.g:1865:1: (lv_usingClause_5_0= ruleUsingClause )
            {
            // InternalDescartesQL.g:1865:1: (lv_usingClause_5_0= ruleUsingClause )
            // InternalDescartesQL.g:1866:3: lv_usingClause_5_0= ruleUsingClause
            {
             
            	        newCompositeNode(grammarAccess.getSelectQueryAccess().getUsingClauseUsingClauseParserRuleCall_5_0()); 
            	    
            pushFollow(FOLLOW_36);
            lv_usingClause_5_0=ruleUsingClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSelectQueryRule());
            	        }
                   		set(
                   			current, 
                   			"usingClause",
                    		lv_usingClause_5_0, 
                    		"tools.descartes.dql.lang.DescartesQL.UsingClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:1882:2: ( (lv_observeClause_6_0= ruleObserveClause ) )?
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==65) ) {
                alt26=1;
            }
            switch (alt26) {
                case 1 :
                    // InternalDescartesQL.g:1883:1: (lv_observeClause_6_0= ruleObserveClause )
                    {
                    // InternalDescartesQL.g:1883:1: (lv_observeClause_6_0= ruleObserveClause )
                    // InternalDescartesQL.g:1884:3: lv_observeClause_6_0= ruleObserveClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getSelectQueryAccess().getObserveClauseObserveClauseParserRuleCall_6_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_observeClause_6_0=ruleObserveClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSelectQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"observeClause",
                            		lv_observeClause_6_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ObserveClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSelectQuery"


    // $ANTLR start "entryRuleMetricReferenceClauses"
    // InternalDescartesQL.g:1908:1: entryRuleMetricReferenceClauses returns [EObject current=null] : iv_ruleMetricReferenceClauses= ruleMetricReferenceClauses EOF ;
    public final EObject entryRuleMetricReferenceClauses() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMetricReferenceClauses = null;


        try {
            // InternalDescartesQL.g:1909:2: (iv_ruleMetricReferenceClauses= ruleMetricReferenceClauses EOF )
            // InternalDescartesQL.g:1910:2: iv_ruleMetricReferenceClauses= ruleMetricReferenceClauses EOF
            {
             newCompositeNode(grammarAccess.getMetricReferenceClausesRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMetricReferenceClauses=ruleMetricReferenceClauses();

            state._fsp--;

             current =iv_ruleMetricReferenceClauses; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMetricReferenceClauses"


    // $ANTLR start "ruleMetricReferenceClauses"
    // InternalDescartesQL.g:1917:1: ruleMetricReferenceClauses returns [EObject current=null] : ( ( (lv_metricClauseTypes_0_0= ruleMetricClauseType ) ) (otherlv_1= ',' ( (lv_metricClauseTypes_2_0= ruleMetricClauseType ) ) )* ) ;
    public final EObject ruleMetricReferenceClauses() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_metricClauseTypes_0_0 = null;

        EObject lv_metricClauseTypes_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1920:28: ( ( ( (lv_metricClauseTypes_0_0= ruleMetricClauseType ) ) (otherlv_1= ',' ( (lv_metricClauseTypes_2_0= ruleMetricClauseType ) ) )* ) )
            // InternalDescartesQL.g:1921:1: ( ( (lv_metricClauseTypes_0_0= ruleMetricClauseType ) ) (otherlv_1= ',' ( (lv_metricClauseTypes_2_0= ruleMetricClauseType ) ) )* )
            {
            // InternalDescartesQL.g:1921:1: ( ( (lv_metricClauseTypes_0_0= ruleMetricClauseType ) ) (otherlv_1= ',' ( (lv_metricClauseTypes_2_0= ruleMetricClauseType ) ) )* )
            // InternalDescartesQL.g:1921:2: ( (lv_metricClauseTypes_0_0= ruleMetricClauseType ) ) (otherlv_1= ',' ( (lv_metricClauseTypes_2_0= ruleMetricClauseType ) ) )*
            {
            // InternalDescartesQL.g:1921:2: ( (lv_metricClauseTypes_0_0= ruleMetricClauseType ) )
            // InternalDescartesQL.g:1922:1: (lv_metricClauseTypes_0_0= ruleMetricClauseType )
            {
            // InternalDescartesQL.g:1922:1: (lv_metricClauseTypes_0_0= ruleMetricClauseType )
            // InternalDescartesQL.g:1923:3: lv_metricClauseTypes_0_0= ruleMetricClauseType
            {
             
            	        newCompositeNode(grammarAccess.getMetricReferenceClausesAccess().getMetricClauseTypesMetricClauseTypeParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_12);
            lv_metricClauseTypes_0_0=ruleMetricClauseType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getMetricReferenceClausesRule());
            	        }
                   		add(
                   			current, 
                   			"metricClauseTypes",
                    		lv_metricClauseTypes_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.MetricClauseType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:1939:2: (otherlv_1= ',' ( (lv_metricClauseTypes_2_0= ruleMetricClauseType ) ) )*
            loop27:
            do {
                int alt27=2;
                int LA27_0 = input.LA(1);

                if ( (LA27_0==20) ) {
                    alt27=1;
                }


                switch (alt27) {
            	case 1 :
            	    // InternalDescartesQL.g:1939:4: otherlv_1= ',' ( (lv_metricClauseTypes_2_0= ruleMetricClauseType ) )
            	    {
            	    otherlv_1=(Token)match(input,20,FOLLOW_17); 

            	        	newLeafNode(otherlv_1, grammarAccess.getMetricReferenceClausesAccess().getCommaKeyword_1_0());
            	        
            	    // InternalDescartesQL.g:1943:1: ( (lv_metricClauseTypes_2_0= ruleMetricClauseType ) )
            	    // InternalDescartesQL.g:1944:1: (lv_metricClauseTypes_2_0= ruleMetricClauseType )
            	    {
            	    // InternalDescartesQL.g:1944:1: (lv_metricClauseTypes_2_0= ruleMetricClauseType )
            	    // InternalDescartesQL.g:1945:3: lv_metricClauseTypes_2_0= ruleMetricClauseType
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getMetricReferenceClausesAccess().getMetricClauseTypesMetricClauseTypeParserRuleCall_1_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_12);
            	    lv_metricClauseTypes_2_0=ruleMetricClauseType();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getMetricReferenceClausesRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"metricClauseTypes",
            	            		lv_metricClauseTypes_2_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.MetricClauseType");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop27;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMetricReferenceClauses"


    // $ANTLR start "entryRuleMetricClauseType"
    // InternalDescartesQL.g:1969:1: entryRuleMetricClauseType returns [EObject current=null] : iv_ruleMetricClauseType= ruleMetricClauseType EOF ;
    public final EObject entryRuleMetricClauseType() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMetricClauseType = null;


        try {
            // InternalDescartesQL.g:1970:2: (iv_ruleMetricClauseType= ruleMetricClauseType EOF )
            // InternalDescartesQL.g:1971:2: iv_ruleMetricClauseType= ruleMetricClauseType EOF
            {
             newCompositeNode(grammarAccess.getMetricClauseTypeRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMetricClauseType=ruleMetricClauseType();

            state._fsp--;

             current =iv_ruleMetricClauseType; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMetricClauseType"


    // $ANTLR start "ruleMetricClauseType"
    // InternalDescartesQL.g:1978:1: ruleMetricClauseType returns [EObject current=null] : (this_MetricClause_0= ruleMetricClause | this_AggregateMetricClause_1= ruleAggregateMetricClause ) ;
    public final EObject ruleMetricClauseType() throws RecognitionException {
        EObject current = null;

        EObject this_MetricClause_0 = null;

        EObject this_AggregateMetricClause_1 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:1981:28: ( (this_MetricClause_0= ruleMetricClause | this_AggregateMetricClause_1= ruleAggregateMetricClause ) )
            // InternalDescartesQL.g:1982:1: (this_MetricClause_0= ruleMetricClause | this_AggregateMetricClause_1= ruleAggregateMetricClause )
            {
            // InternalDescartesQL.g:1982:1: (this_MetricClause_0= ruleMetricClause | this_AggregateMetricClause_1= ruleAggregateMetricClause )
            int alt28=2;
            int LA28_0 = input.LA(1);

            if ( (LA28_0==RULE_ID) ) {
                alt28=1;
            }
            else if ( ((LA28_0>=97 && LA28_0<=106)) ) {
                alt28=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 28, 0, input);

                throw nvae;
            }
            switch (alt28) {
                case 1 :
                    // InternalDescartesQL.g:1983:5: this_MetricClause_0= ruleMetricClause
                    {
                     
                            newCompositeNode(grammarAccess.getMetricClauseTypeAccess().getMetricClauseParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_2);
                    this_MetricClause_0=ruleMetricClause();

                    state._fsp--;

                     
                            current = this_MetricClause_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:1993:5: this_AggregateMetricClause_1= ruleAggregateMetricClause
                    {
                     
                            newCompositeNode(grammarAccess.getMetricClauseTypeAccess().getAggregateMetricClauseParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_2);
                    this_AggregateMetricClause_1=ruleAggregateMetricClause();

                    state._fsp--;

                     
                            current = this_AggregateMetricClause_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMetricClauseType"


    // $ANTLR start "entryRuleDetectQuery"
    // InternalDescartesQL.g:2009:1: entryRuleDetectQuery returns [EObject current=null] : iv_ruleDetectQuery= ruleDetectQuery EOF ;
    public final EObject entryRuleDetectQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDetectQuery = null;


        try {
            // InternalDescartesQL.g:2010:2: (iv_ruleDetectQuery= ruleDetectQuery EOF )
            // InternalDescartesQL.g:2011:2: iv_ruleDetectQuery= ruleDetectQuery EOF
            {
             newCompositeNode(grammarAccess.getDetectQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDetectQuery=ruleDetectQuery();

            state._fsp--;

             current =iv_ruleDetectQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDetectQuery"


    // $ANTLR start "ruleDetectQuery"
    // InternalDescartesQL.g:2018:1: ruleDetectQuery returns [EObject current=null] : (otherlv_0= 'DETECT' ( (lv_queryType_1_0= ruleDetectBottlenecksQuery ) ) ) ;
    public final EObject ruleDetectQuery() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_queryType_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2021:28: ( (otherlv_0= 'DETECT' ( (lv_queryType_1_0= ruleDetectBottlenecksQuery ) ) ) )
            // InternalDescartesQL.g:2022:1: (otherlv_0= 'DETECT' ( (lv_queryType_1_0= ruleDetectBottlenecksQuery ) ) )
            {
            // InternalDescartesQL.g:2022:1: (otherlv_0= 'DETECT' ( (lv_queryType_1_0= ruleDetectBottlenecksQuery ) ) )
            // InternalDescartesQL.g:2022:3: otherlv_0= 'DETECT' ( (lv_queryType_1_0= ruleDetectBottlenecksQuery ) )
            {
            otherlv_0=(Token)match(input,40,FOLLOW_37); 

                	newLeafNode(otherlv_0, grammarAccess.getDetectQueryAccess().getDETECTKeyword_0());
                
            // InternalDescartesQL.g:2026:1: ( (lv_queryType_1_0= ruleDetectBottlenecksQuery ) )
            // InternalDescartesQL.g:2027:1: (lv_queryType_1_0= ruleDetectBottlenecksQuery )
            {
            // InternalDescartesQL.g:2027:1: (lv_queryType_1_0= ruleDetectBottlenecksQuery )
            // InternalDescartesQL.g:2028:3: lv_queryType_1_0= ruleDetectBottlenecksQuery
            {
             
            	        newCompositeNode(grammarAccess.getDetectQueryAccess().getQueryTypeDetectBottlenecksQueryParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_queryType_1_0=ruleDetectBottlenecksQuery();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getDetectQueryRule());
            	        }
                   		set(
                   			current, 
                   			"queryType",
                    		lv_queryType_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.DetectBottlenecksQuery");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDetectQuery"


    // $ANTLR start "entryRuleDetectBottlenecksQuery"
    // InternalDescartesQL.g:2052:1: entryRuleDetectBottlenecksQuery returns [EObject current=null] : iv_ruleDetectBottlenecksQuery= ruleDetectBottlenecksQuery EOF ;
    public final EObject entryRuleDetectBottlenecksQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDetectBottlenecksQuery = null;


        try {
            // InternalDescartesQL.g:2053:2: (iv_ruleDetectBottlenecksQuery= ruleDetectBottlenecksQuery EOF )
            // InternalDescartesQL.g:2054:2: iv_ruleDetectBottlenecksQuery= ruleDetectBottlenecksQuery EOF
            {
             newCompositeNode(grammarAccess.getDetectBottlenecksQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDetectBottlenecksQuery=ruleDetectBottlenecksQuery();

            state._fsp--;

             current =iv_ruleDetectBottlenecksQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDetectBottlenecksQuery"


    // $ANTLR start "ruleDetectBottlenecksQuery"
    // InternalDescartesQL.g:2061:1: ruleDetectBottlenecksQuery returns [EObject current=null] : (otherlv_0= 'BOTTLENECKS' ( (lv_dofClause_1_0= ruleDoFClause ) ) ( (lv_usingClause_2_0= ruleUsingClause ) ) ) ;
    public final EObject ruleDetectBottlenecksQuery() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_dofClause_1_0 = null;

        EObject lv_usingClause_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2064:28: ( (otherlv_0= 'BOTTLENECKS' ( (lv_dofClause_1_0= ruleDoFClause ) ) ( (lv_usingClause_2_0= ruleUsingClause ) ) ) )
            // InternalDescartesQL.g:2065:1: (otherlv_0= 'BOTTLENECKS' ( (lv_dofClause_1_0= ruleDoFClause ) ) ( (lv_usingClause_2_0= ruleUsingClause ) ) )
            {
            // InternalDescartesQL.g:2065:1: (otherlv_0= 'BOTTLENECKS' ( (lv_dofClause_1_0= ruleDoFClause ) ) ( (lv_usingClause_2_0= ruleUsingClause ) ) )
            // InternalDescartesQL.g:2065:3: otherlv_0= 'BOTTLENECKS' ( (lv_dofClause_1_0= ruleDoFClause ) ) ( (lv_usingClause_2_0= ruleUsingClause ) )
            {
            otherlv_0=(Token)match(input,41,FOLLOW_38); 

                	newLeafNode(otherlv_0, grammarAccess.getDetectBottlenecksQueryAccess().getBOTTLENECKSKeyword_0());
                
            // InternalDescartesQL.g:2069:1: ( (lv_dofClause_1_0= ruleDoFClause ) )
            // InternalDescartesQL.g:2070:1: (lv_dofClause_1_0= ruleDoFClause )
            {
            // InternalDescartesQL.g:2070:1: (lv_dofClause_1_0= ruleDoFClause )
            // InternalDescartesQL.g:2071:3: lv_dofClause_1_0= ruleDoFClause
            {
             
            	        newCompositeNode(grammarAccess.getDetectBottlenecksQueryAccess().getDofClauseDoFClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_6);
            lv_dofClause_1_0=ruleDoFClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getDetectBottlenecksQueryRule());
            	        }
                   		set(
                   			current, 
                   			"dofClause",
                    		lv_dofClause_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.DoFClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:2087:2: ( (lv_usingClause_2_0= ruleUsingClause ) )
            // InternalDescartesQL.g:2088:1: (lv_usingClause_2_0= ruleUsingClause )
            {
            // InternalDescartesQL.g:2088:1: (lv_usingClause_2_0= ruleUsingClause )
            // InternalDescartesQL.g:2089:3: lv_usingClause_2_0= ruleUsingClause
            {
             
            	        newCompositeNode(grammarAccess.getDetectBottlenecksQueryAccess().getUsingClauseUsingClauseParserRuleCall_2_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_usingClause_2_0=ruleUsingClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getDetectBottlenecksQueryRule());
            	        }
                   		set(
                   			current, 
                   			"usingClause",
                    		lv_usingClause_2_0, 
                    		"tools.descartes.dql.lang.DescartesQL.UsingClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDetectBottlenecksQuery"


    // $ANTLR start "entryRuleConstraintClause"
    // InternalDescartesQL.g:2113:1: entryRuleConstraintClause returns [EObject current=null] : iv_ruleConstraintClause= ruleConstraintClause EOF ;
    public final EObject entryRuleConstraintClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConstraintClause = null;


        try {
            // InternalDescartesQL.g:2114:2: (iv_ruleConstraintClause= ruleConstraintClause EOF )
            // InternalDescartesQL.g:2115:2: iv_ruleConstraintClause= ruleConstraintClause EOF
            {
             newCompositeNode(grammarAccess.getConstraintClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleConstraintClause=ruleConstraintClause();

            state._fsp--;

             current =iv_ruleConstraintClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConstraintClause"


    // $ANTLR start "ruleConstraintClause"
    // InternalDescartesQL.g:2122:1: ruleConstraintClause returns [EObject current=null] : (otherlv_0= 'CONSTRAINED AS' ( (lv_type_1_0= RULE_STRING ) ) ) ;
    public final EObject ruleConstraintClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_type_1_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2125:28: ( (otherlv_0= 'CONSTRAINED AS' ( (lv_type_1_0= RULE_STRING ) ) ) )
            // InternalDescartesQL.g:2126:1: (otherlv_0= 'CONSTRAINED AS' ( (lv_type_1_0= RULE_STRING ) ) )
            {
            // InternalDescartesQL.g:2126:1: (otherlv_0= 'CONSTRAINED AS' ( (lv_type_1_0= RULE_STRING ) ) )
            // InternalDescartesQL.g:2126:3: otherlv_0= 'CONSTRAINED AS' ( (lv_type_1_0= RULE_STRING ) )
            {
            otherlv_0=(Token)match(input,42,FOLLOW_39); 

                	newLeafNode(otherlv_0, grammarAccess.getConstraintClauseAccess().getCONSTRAINEDASKeyword_0());
                
            // InternalDescartesQL.g:2130:1: ( (lv_type_1_0= RULE_STRING ) )
            // InternalDescartesQL.g:2131:1: (lv_type_1_0= RULE_STRING )
            {
            // InternalDescartesQL.g:2131:1: (lv_type_1_0= RULE_STRING )
            // InternalDescartesQL.g:2132:3: lv_type_1_0= RULE_STRING
            {
            lv_type_1_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            			newLeafNode(lv_type_1_0, grammarAccess.getConstraintClauseAccess().getTypeSTRINGTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConstraintClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"type",
                    		lv_type_1_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConstraintClause"


    // $ANTLR start "entryRuleDoFClause"
    // InternalDescartesQL.g:2156:1: entryRuleDoFClause returns [EObject current=null] : iv_ruleDoFClause= ruleDoFClause EOF ;
    public final EObject entryRuleDoFClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDoFClause = null;


        try {
            // InternalDescartesQL.g:2157:2: (iv_ruleDoFClause= ruleDoFClause EOF )
            // InternalDescartesQL.g:2158:2: iv_ruleDoFClause= ruleDoFClause EOF
            {
             newCompositeNode(grammarAccess.getDoFClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDoFClause=ruleDoFClause();

            state._fsp--;

             current =iv_ruleDoFClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDoFClause"


    // $ANTLR start "ruleDoFClause"
    // InternalDescartesQL.g:2165:1: ruleDoFClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'EVALUATE DOF' ) ) ( (lv_varyingClause_1_0= ruleVaryingClause ) )? ( (lv_explorationStrategy_2_0= ruleExplorationStrategyClause ) )? ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_withClause_4_0= ruleWithClause ) )? ) ;
    public final EObject ruleDoFClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        EObject lv_varyingClause_1_0 = null;

        EObject lv_explorationStrategy_2_0 = null;

        EObject lv_constraintClause_3_0 = null;

        EObject lv_withClause_4_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2168:28: ( ( ( (lv_mode_0_0= 'EVALUATE DOF' ) ) ( (lv_varyingClause_1_0= ruleVaryingClause ) )? ( (lv_explorationStrategy_2_0= ruleExplorationStrategyClause ) )? ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_withClause_4_0= ruleWithClause ) )? ) )
            // InternalDescartesQL.g:2169:1: ( ( (lv_mode_0_0= 'EVALUATE DOF' ) ) ( (lv_varyingClause_1_0= ruleVaryingClause ) )? ( (lv_explorationStrategy_2_0= ruleExplorationStrategyClause ) )? ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_withClause_4_0= ruleWithClause ) )? )
            {
            // InternalDescartesQL.g:2169:1: ( ( (lv_mode_0_0= 'EVALUATE DOF' ) ) ( (lv_varyingClause_1_0= ruleVaryingClause ) )? ( (lv_explorationStrategy_2_0= ruleExplorationStrategyClause ) )? ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_withClause_4_0= ruleWithClause ) )? )
            // InternalDescartesQL.g:2169:2: ( (lv_mode_0_0= 'EVALUATE DOF' ) ) ( (lv_varyingClause_1_0= ruleVaryingClause ) )? ( (lv_explorationStrategy_2_0= ruleExplorationStrategyClause ) )? ( (lv_constraintClause_3_0= ruleConstraintClause ) )? ( (lv_withClause_4_0= ruleWithClause ) )?
            {
            // InternalDescartesQL.g:2169:2: ( (lv_mode_0_0= 'EVALUATE DOF' ) )
            // InternalDescartesQL.g:2170:1: (lv_mode_0_0= 'EVALUATE DOF' )
            {
            // InternalDescartesQL.g:2170:1: (lv_mode_0_0= 'EVALUATE DOF' )
            // InternalDescartesQL.g:2171:3: lv_mode_0_0= 'EVALUATE DOF'
            {
            lv_mode_0_0=(Token)match(input,43,FOLLOW_40); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getDoFClauseAccess().getModeEVALUATEDOFKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getDoFClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "EVALUATE DOF");
            	    

            }


            }

            // InternalDescartesQL.g:2184:2: ( (lv_varyingClause_1_0= ruleVaryingClause ) )?
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==53) ) {
                alt29=1;
            }
            switch (alt29) {
                case 1 :
                    // InternalDescartesQL.g:2185:1: (lv_varyingClause_1_0= ruleVaryingClause )
                    {
                    // InternalDescartesQL.g:2185:1: (lv_varyingClause_1_0= ruleVaryingClause )
                    // InternalDescartesQL.g:2186:3: lv_varyingClause_1_0= ruleVaryingClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getDoFClauseAccess().getVaryingClauseVaryingClauseParserRuleCall_1_0()); 
                    	    
                    pushFollow(FOLLOW_41);
                    lv_varyingClause_1_0=ruleVaryingClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDoFClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"varyingClause",
                            		lv_varyingClause_1_0, 
                            		"tools.descartes.dql.lang.DescartesQL.VaryingClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:2202:3: ( (lv_explorationStrategy_2_0= ruleExplorationStrategyClause ) )?
            int alt30=2;
            int LA30_0 = input.LA(1);

            if ( (LA30_0==44) ) {
                alt30=1;
            }
            switch (alt30) {
                case 1 :
                    // InternalDescartesQL.g:2203:1: (lv_explorationStrategy_2_0= ruleExplorationStrategyClause )
                    {
                    // InternalDescartesQL.g:2203:1: (lv_explorationStrategy_2_0= ruleExplorationStrategyClause )
                    // InternalDescartesQL.g:2204:3: lv_explorationStrategy_2_0= ruleExplorationStrategyClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getDoFClauseAccess().getExplorationStrategyExplorationStrategyClauseParserRuleCall_2_0()); 
                    	    
                    pushFollow(FOLLOW_42);
                    lv_explorationStrategy_2_0=ruleExplorationStrategyClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDoFClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"explorationStrategy",
                            		lv_explorationStrategy_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ExplorationStrategyClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:2220:3: ( (lv_constraintClause_3_0= ruleConstraintClause ) )?
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( (LA31_0==42) ) {
                alt31=1;
            }
            switch (alt31) {
                case 1 :
                    // InternalDescartesQL.g:2221:1: (lv_constraintClause_3_0= ruleConstraintClause )
                    {
                    // InternalDescartesQL.g:2221:1: (lv_constraintClause_3_0= ruleConstraintClause )
                    // InternalDescartesQL.g:2222:3: lv_constraintClause_3_0= ruleConstraintClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getDoFClauseAccess().getConstraintClauseConstraintClauseParserRuleCall_3_0()); 
                    	    
                    pushFollow(FOLLOW_30);
                    lv_constraintClause_3_0=ruleConstraintClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDoFClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"constraintClause",
                            		lv_constraintClause_3_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ConstraintClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:2238:3: ( (lv_withClause_4_0= ruleWithClause ) )?
            int alt32=2;
            int LA32_0 = input.LA(1);

            if ( (LA32_0==61) ) {
                alt32=1;
            }
            switch (alt32) {
                case 1 :
                    // InternalDescartesQL.g:2239:1: (lv_withClause_4_0= ruleWithClause )
                    {
                    // InternalDescartesQL.g:2239:1: (lv_withClause_4_0= ruleWithClause )
                    // InternalDescartesQL.g:2240:3: lv_withClause_4_0= ruleWithClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getDoFClauseAccess().getWithClauseWithClauseParserRuleCall_4_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_withClause_4_0=ruleWithClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDoFClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"withClause",
                            		lv_withClause_4_0, 
                            		"tools.descartes.dql.lang.DescartesQL.WithClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDoFClause"


    // $ANTLR start "entryRuleExplorationStrategyClause"
    // InternalDescartesQL.g:2264:1: entryRuleExplorationStrategyClause returns [EObject current=null] : iv_ruleExplorationStrategyClause= ruleExplorationStrategyClause EOF ;
    public final EObject entryRuleExplorationStrategyClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleExplorationStrategyClause = null;


        try {
            // InternalDescartesQL.g:2265:2: (iv_ruleExplorationStrategyClause= ruleExplorationStrategyClause EOF )
            // InternalDescartesQL.g:2266:2: iv_ruleExplorationStrategyClause= ruleExplorationStrategyClause EOF
            {
             newCompositeNode(grammarAccess.getExplorationStrategyClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleExplorationStrategyClause=ruleExplorationStrategyClause();

            state._fsp--;

             current =iv_ruleExplorationStrategyClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleExplorationStrategyClause"


    // $ANTLR start "ruleExplorationStrategyClause"
    // InternalDescartesQL.g:2273:1: ruleExplorationStrategyClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'GUIDED BY' ) ) ( (lv_name_1_0= RULE_STRING ) ) ( (lv_parameterClause_2_0= ruleConfigurationPropertiesClause ) )? ) ;
    public final EObject ruleExplorationStrategyClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        Token lv_name_1_0=null;
        EObject lv_parameterClause_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2276:28: ( ( ( (lv_mode_0_0= 'GUIDED BY' ) ) ( (lv_name_1_0= RULE_STRING ) ) ( (lv_parameterClause_2_0= ruleConfigurationPropertiesClause ) )? ) )
            // InternalDescartesQL.g:2277:1: ( ( (lv_mode_0_0= 'GUIDED BY' ) ) ( (lv_name_1_0= RULE_STRING ) ) ( (lv_parameterClause_2_0= ruleConfigurationPropertiesClause ) )? )
            {
            // InternalDescartesQL.g:2277:1: ( ( (lv_mode_0_0= 'GUIDED BY' ) ) ( (lv_name_1_0= RULE_STRING ) ) ( (lv_parameterClause_2_0= ruleConfigurationPropertiesClause ) )? )
            // InternalDescartesQL.g:2277:2: ( (lv_mode_0_0= 'GUIDED BY' ) ) ( (lv_name_1_0= RULE_STRING ) ) ( (lv_parameterClause_2_0= ruleConfigurationPropertiesClause ) )?
            {
            // InternalDescartesQL.g:2277:2: ( (lv_mode_0_0= 'GUIDED BY' ) )
            // InternalDescartesQL.g:2278:1: (lv_mode_0_0= 'GUIDED BY' )
            {
            // InternalDescartesQL.g:2278:1: (lv_mode_0_0= 'GUIDED BY' )
            // InternalDescartesQL.g:2279:3: lv_mode_0_0= 'GUIDED BY'
            {
            lv_mode_0_0=(Token)match(input,44,FOLLOW_39); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getExplorationStrategyClauseAccess().getModeGUIDEDBYKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getExplorationStrategyClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "GUIDED BY");
            	    

            }


            }

            // InternalDescartesQL.g:2292:2: ( (lv_name_1_0= RULE_STRING ) )
            // InternalDescartesQL.g:2293:1: (lv_name_1_0= RULE_STRING )
            {
            // InternalDescartesQL.g:2293:1: (lv_name_1_0= RULE_STRING )
            // InternalDescartesQL.g:2294:3: lv_name_1_0= RULE_STRING
            {
            lv_name_1_0=(Token)match(input,RULE_STRING,FOLLOW_43); 

            			newLeafNode(lv_name_1_0, grammarAccess.getExplorationStrategyClauseAccess().getNameSTRINGTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getExplorationStrategyClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }

            // InternalDescartesQL.g:2310:2: ( (lv_parameterClause_2_0= ruleConfigurationPropertiesClause ) )?
            int alt33=2;
            int LA33_0 = input.LA(1);

            if ( (LA33_0==45) ) {
                alt33=1;
            }
            switch (alt33) {
                case 1 :
                    // InternalDescartesQL.g:2311:1: (lv_parameterClause_2_0= ruleConfigurationPropertiesClause )
                    {
                    // InternalDescartesQL.g:2311:1: (lv_parameterClause_2_0= ruleConfigurationPropertiesClause )
                    // InternalDescartesQL.g:2312:3: lv_parameterClause_2_0= ruleConfigurationPropertiesClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getExplorationStrategyClauseAccess().getParameterClauseConfigurationPropertiesClauseParserRuleCall_2_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_parameterClause_2_0=ruleConfigurationPropertiesClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getExplorationStrategyClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"parameterClause",
                            		lv_parameterClause_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ConfigurationPropertiesClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleExplorationStrategyClause"


    // $ANTLR start "entryRuleConfigurationPropertiesClause"
    // InternalDescartesQL.g:2336:1: entryRuleConfigurationPropertiesClause returns [EObject current=null] : iv_ruleConfigurationPropertiesClause= ruleConfigurationPropertiesClause EOF ;
    public final EObject entryRuleConfigurationPropertiesClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConfigurationPropertiesClause = null;


        try {
            // InternalDescartesQL.g:2337:2: (iv_ruleConfigurationPropertiesClause= ruleConfigurationPropertiesClause EOF )
            // InternalDescartesQL.g:2338:2: iv_ruleConfigurationPropertiesClause= ruleConfigurationPropertiesClause EOF
            {
             newCompositeNode(grammarAccess.getConfigurationPropertiesClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleConfigurationPropertiesClause=ruleConfigurationPropertiesClause();

            state._fsp--;

             current =iv_ruleConfigurationPropertiesClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConfigurationPropertiesClause"


    // $ANTLR start "ruleConfigurationPropertiesClause"
    // InternalDescartesQL.g:2345:1: ruleConfigurationPropertiesClause returns [EObject current=null] : ( ( (lv_mode1_0_0= '[' ) ) ( (lv_properties_1_0= ruleConfigurationPropertyClause ) ) (otherlv_2= ',' ( (lv_properties_3_0= ruleConfigurationPropertyClause ) ) )* ( (lv_mode2_4_0= ']' ) ) ) ;
    public final EObject ruleConfigurationPropertiesClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode1_0_0=null;
        Token otherlv_2=null;
        Token lv_mode2_4_0=null;
        EObject lv_properties_1_0 = null;

        EObject lv_properties_3_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2348:28: ( ( ( (lv_mode1_0_0= '[' ) ) ( (lv_properties_1_0= ruleConfigurationPropertyClause ) ) (otherlv_2= ',' ( (lv_properties_3_0= ruleConfigurationPropertyClause ) ) )* ( (lv_mode2_4_0= ']' ) ) ) )
            // InternalDescartesQL.g:2349:1: ( ( (lv_mode1_0_0= '[' ) ) ( (lv_properties_1_0= ruleConfigurationPropertyClause ) ) (otherlv_2= ',' ( (lv_properties_3_0= ruleConfigurationPropertyClause ) ) )* ( (lv_mode2_4_0= ']' ) ) )
            {
            // InternalDescartesQL.g:2349:1: ( ( (lv_mode1_0_0= '[' ) ) ( (lv_properties_1_0= ruleConfigurationPropertyClause ) ) (otherlv_2= ',' ( (lv_properties_3_0= ruleConfigurationPropertyClause ) ) )* ( (lv_mode2_4_0= ']' ) ) )
            // InternalDescartesQL.g:2349:2: ( (lv_mode1_0_0= '[' ) ) ( (lv_properties_1_0= ruleConfigurationPropertyClause ) ) (otherlv_2= ',' ( (lv_properties_3_0= ruleConfigurationPropertyClause ) ) )* ( (lv_mode2_4_0= ']' ) )
            {
            // InternalDescartesQL.g:2349:2: ( (lv_mode1_0_0= '[' ) )
            // InternalDescartesQL.g:2350:1: (lv_mode1_0_0= '[' )
            {
            // InternalDescartesQL.g:2350:1: (lv_mode1_0_0= '[' )
            // InternalDescartesQL.g:2351:3: lv_mode1_0_0= '['
            {
            lv_mode1_0_0=(Token)match(input,45,FOLLOW_11); 

                    newLeafNode(lv_mode1_0_0, grammarAccess.getConfigurationPropertiesClauseAccess().getMode1LeftSquareBracketKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConfigurationPropertiesClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode1", lv_mode1_0_0, "[");
            	    

            }


            }

            // InternalDescartesQL.g:2364:2: ( (lv_properties_1_0= ruleConfigurationPropertyClause ) )
            // InternalDescartesQL.g:2365:1: (lv_properties_1_0= ruleConfigurationPropertyClause )
            {
            // InternalDescartesQL.g:2365:1: (lv_properties_1_0= ruleConfigurationPropertyClause )
            // InternalDescartesQL.g:2366:3: lv_properties_1_0= ruleConfigurationPropertyClause
            {
             
            	        newCompositeNode(grammarAccess.getConfigurationPropertiesClauseAccess().getPropertiesConfigurationPropertyClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_44);
            lv_properties_1_0=ruleConfigurationPropertyClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getConfigurationPropertiesClauseRule());
            	        }
                   		add(
                   			current, 
                   			"properties",
                    		lv_properties_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ConfigurationPropertyClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:2382:2: (otherlv_2= ',' ( (lv_properties_3_0= ruleConfigurationPropertyClause ) ) )*
            loop34:
            do {
                int alt34=2;
                int LA34_0 = input.LA(1);

                if ( (LA34_0==20) ) {
                    alt34=1;
                }


                switch (alt34) {
            	case 1 :
            	    // InternalDescartesQL.g:2382:4: otherlv_2= ',' ( (lv_properties_3_0= ruleConfigurationPropertyClause ) )
            	    {
            	    otherlv_2=(Token)match(input,20,FOLLOW_11); 

            	        	newLeafNode(otherlv_2, grammarAccess.getConfigurationPropertiesClauseAccess().getCommaKeyword_2_0());
            	        
            	    // InternalDescartesQL.g:2386:1: ( (lv_properties_3_0= ruleConfigurationPropertyClause ) )
            	    // InternalDescartesQL.g:2387:1: (lv_properties_3_0= ruleConfigurationPropertyClause )
            	    {
            	    // InternalDescartesQL.g:2387:1: (lv_properties_3_0= ruleConfigurationPropertyClause )
            	    // InternalDescartesQL.g:2388:3: lv_properties_3_0= ruleConfigurationPropertyClause
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getConfigurationPropertiesClauseAccess().getPropertiesConfigurationPropertyClauseParserRuleCall_2_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_44);
            	    lv_properties_3_0=ruleConfigurationPropertyClause();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getConfigurationPropertiesClauseRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"properties",
            	            		lv_properties_3_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.ConfigurationPropertyClause");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop34;
                }
            } while (true);

            // InternalDescartesQL.g:2404:4: ( (lv_mode2_4_0= ']' ) )
            // InternalDescartesQL.g:2405:1: (lv_mode2_4_0= ']' )
            {
            // InternalDescartesQL.g:2405:1: (lv_mode2_4_0= ']' )
            // InternalDescartesQL.g:2406:3: lv_mode2_4_0= ']'
            {
            lv_mode2_4_0=(Token)match(input,46,FOLLOW_2); 

                    newLeafNode(lv_mode2_4_0, grammarAccess.getConfigurationPropertiesClauseAccess().getMode2RightSquareBracketKeyword_3_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConfigurationPropertiesClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode2", lv_mode2_4_0, "]");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConfigurationPropertiesClause"


    // $ANTLR start "entryRuleConfigurationPropertyClause"
    // InternalDescartesQL.g:2427:1: entryRuleConfigurationPropertyClause returns [EObject current=null] : iv_ruleConfigurationPropertyClause= ruleConfigurationPropertyClause EOF ;
    public final EObject entryRuleConfigurationPropertyClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConfigurationPropertyClause = null;


        try {
            // InternalDescartesQL.g:2428:2: (iv_ruleConfigurationPropertyClause= ruleConfigurationPropertyClause EOF )
            // InternalDescartesQL.g:2429:2: iv_ruleConfigurationPropertyClause= ruleConfigurationPropertyClause EOF
            {
             newCompositeNode(grammarAccess.getConfigurationPropertyClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleConfigurationPropertyClause=ruleConfigurationPropertyClause();

            state._fsp--;

             current =iv_ruleConfigurationPropertyClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConfigurationPropertyClause"


    // $ANTLR start "ruleConfigurationPropertyClause"
    // InternalDescartesQL.g:2436:1: ruleConfigurationPropertyClause returns [EObject current=null] : ( ( (lv_key_0_0= RULE_ID ) ) (otherlv_1= '.' ( (lv_key_2_0= RULE_ID ) ) )* otherlv_3= '=' ( (lv_value_4_0= RULE_STRING ) ) ) ;
    public final EObject ruleConfigurationPropertyClause() throws RecognitionException {
        EObject current = null;

        Token lv_key_0_0=null;
        Token otherlv_1=null;
        Token lv_key_2_0=null;
        Token otherlv_3=null;
        Token lv_value_4_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2439:28: ( ( ( (lv_key_0_0= RULE_ID ) ) (otherlv_1= '.' ( (lv_key_2_0= RULE_ID ) ) )* otherlv_3= '=' ( (lv_value_4_0= RULE_STRING ) ) ) )
            // InternalDescartesQL.g:2440:1: ( ( (lv_key_0_0= RULE_ID ) ) (otherlv_1= '.' ( (lv_key_2_0= RULE_ID ) ) )* otherlv_3= '=' ( (lv_value_4_0= RULE_STRING ) ) )
            {
            // InternalDescartesQL.g:2440:1: ( ( (lv_key_0_0= RULE_ID ) ) (otherlv_1= '.' ( (lv_key_2_0= RULE_ID ) ) )* otherlv_3= '=' ( (lv_value_4_0= RULE_STRING ) ) )
            // InternalDescartesQL.g:2440:2: ( (lv_key_0_0= RULE_ID ) ) (otherlv_1= '.' ( (lv_key_2_0= RULE_ID ) ) )* otherlv_3= '=' ( (lv_value_4_0= RULE_STRING ) )
            {
            // InternalDescartesQL.g:2440:2: ( (lv_key_0_0= RULE_ID ) )
            // InternalDescartesQL.g:2441:1: (lv_key_0_0= RULE_ID )
            {
            // InternalDescartesQL.g:2441:1: (lv_key_0_0= RULE_ID )
            // InternalDescartesQL.g:2442:3: lv_key_0_0= RULE_ID
            {
            lv_key_0_0=(Token)match(input,RULE_ID,FOLLOW_45); 

            			newLeafNode(lv_key_0_0, grammarAccess.getConfigurationPropertyClauseAccess().getKeyIDTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConfigurationPropertyClauseRule());
            	        }
                   		addWithLastConsumed(
                   			current, 
                   			"key",
                    		lv_key_0_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }

            // InternalDescartesQL.g:2458:2: (otherlv_1= '.' ( (lv_key_2_0= RULE_ID ) ) )*
            loop35:
            do {
                int alt35=2;
                int LA35_0 = input.LA(1);

                if ( (LA35_0==47) ) {
                    alt35=1;
                }


                switch (alt35) {
            	case 1 :
            	    // InternalDescartesQL.g:2458:4: otherlv_1= '.' ( (lv_key_2_0= RULE_ID ) )
            	    {
            	    otherlv_1=(Token)match(input,47,FOLLOW_11); 

            	        	newLeafNode(otherlv_1, grammarAccess.getConfigurationPropertyClauseAccess().getFullStopKeyword_1_0());
            	        
            	    // InternalDescartesQL.g:2462:1: ( (lv_key_2_0= RULE_ID ) )
            	    // InternalDescartesQL.g:2463:1: (lv_key_2_0= RULE_ID )
            	    {
            	    // InternalDescartesQL.g:2463:1: (lv_key_2_0= RULE_ID )
            	    // InternalDescartesQL.g:2464:3: lv_key_2_0= RULE_ID
            	    {
            	    lv_key_2_0=(Token)match(input,RULE_ID,FOLLOW_45); 

            	    			newLeafNode(lv_key_2_0, grammarAccess.getConfigurationPropertyClauseAccess().getKeyIDTerminalRuleCall_1_1_0()); 
            	    		

            	    	        if (current==null) {
            	    	            current = createModelElement(grammarAccess.getConfigurationPropertyClauseRule());
            	    	        }
            	           		addWithLastConsumed(
            	           			current, 
            	           			"key",
            	            		lv_key_2_0, 
            	            		"org.eclipse.xtext.common.Terminals.ID");
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop35;
                }
            } while (true);

            otherlv_3=(Token)match(input,48,FOLLOW_39); 

                	newLeafNode(otherlv_3, grammarAccess.getConfigurationPropertyClauseAccess().getEqualsSignKeyword_2());
                
            // InternalDescartesQL.g:2484:1: ( (lv_value_4_0= RULE_STRING ) )
            // InternalDescartesQL.g:2485:1: (lv_value_4_0= RULE_STRING )
            {
            // InternalDescartesQL.g:2485:1: (lv_value_4_0= RULE_STRING )
            // InternalDescartesQL.g:2486:3: lv_value_4_0= RULE_STRING
            {
            lv_value_4_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            			newLeafNode(lv_value_4_0, grammarAccess.getConfigurationPropertyClauseAccess().getValueSTRINGTerminalRuleCall_3_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConfigurationPropertyClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"value",
                    		lv_value_4_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConfigurationPropertyClause"


    // $ANTLR start "entryRuleDoFVariationClause"
    // InternalDescartesQL.g:2510:1: entryRuleDoFVariationClause returns [EObject current=null] : iv_ruleDoFVariationClause= ruleDoFVariationClause EOF ;
    public final EObject entryRuleDoFVariationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDoFVariationClause = null;


        try {
            // InternalDescartesQL.g:2511:2: (iv_ruleDoFVariationClause= ruleDoFVariationClause EOF )
            // InternalDescartesQL.g:2512:2: iv_ruleDoFVariationClause= ruleDoFVariationClause EOF
            {
             newCompositeNode(grammarAccess.getDoFVariationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDoFVariationClause=ruleDoFVariationClause();

            state._fsp--;

             current =iv_ruleDoFVariationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDoFVariationClause"


    // $ANTLR start "ruleDoFVariationClause"
    // InternalDescartesQL.g:2519:1: ruleDoFVariationClause returns [EObject current=null] : ( ( (lv_mode1_0_0= '<' ) ) ( ( (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause ) ) ) ( (lv_mode2_2_0= '>' ) ) ) ;
    public final EObject ruleDoFVariationClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode1_0_0=null;
        Token lv_mode2_2_0=null;
        EObject lv_variation_1_1 = null;

        EObject lv_variation_1_2 = null;

        EObject lv_variation_1_3 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2522:28: ( ( ( (lv_mode1_0_0= '<' ) ) ( ( (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause ) ) ) ( (lv_mode2_2_0= '>' ) ) ) )
            // InternalDescartesQL.g:2523:1: ( ( (lv_mode1_0_0= '<' ) ) ( ( (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause ) ) ) ( (lv_mode2_2_0= '>' ) ) )
            {
            // InternalDescartesQL.g:2523:1: ( ( (lv_mode1_0_0= '<' ) ) ( ( (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause ) ) ) ( (lv_mode2_2_0= '>' ) ) )
            // InternalDescartesQL.g:2523:2: ( (lv_mode1_0_0= '<' ) ) ( ( (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause ) ) ) ( (lv_mode2_2_0= '>' ) )
            {
            // InternalDescartesQL.g:2523:2: ( (lv_mode1_0_0= '<' ) )
            // InternalDescartesQL.g:2524:1: (lv_mode1_0_0= '<' )
            {
            // InternalDescartesQL.g:2524:1: (lv_mode1_0_0= '<' )
            // InternalDescartesQL.g:2525:3: lv_mode1_0_0= '<'
            {
            lv_mode1_0_0=(Token)match(input,49,FOLLOW_19); 

                    newLeafNode(lv_mode1_0_0, grammarAccess.getDoFVariationClauseAccess().getMode1LessThanSignKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getDoFVariationClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode1", lv_mode1_0_0, "<");
            	    

            }


            }

            // InternalDescartesQL.g:2538:2: ( ( (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause ) ) )
            // InternalDescartesQL.g:2539:1: ( (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause ) )
            {
            // InternalDescartesQL.g:2539:1: ( (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause ) )
            // InternalDescartesQL.g:2540:1: (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause )
            {
            // InternalDescartesQL.g:2540:1: (lv_variation_1_1= ruleIntervalVariationClause | lv_variation_1_2= ruleValueVariationClause | lv_variation_1_3= ruleDoubleValueVariationClause )
            int alt36=3;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==RULE_INT) ) {
                int LA36_1 = input.LA(2);

                if ( (LA36_1==20||LA36_1==50) ) {
                    alt36=2;
                }
                else if ( (LA36_1==51) ) {
                    alt36=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 36, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA36_0==RULE_DOUBLE) ) {
                alt36=3;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;
            }
            switch (alt36) {
                case 1 :
                    // InternalDescartesQL.g:2541:3: lv_variation_1_1= ruleIntervalVariationClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getDoFVariationClauseAccess().getVariationIntervalVariationClauseParserRuleCall_1_0_0()); 
                    	    
                    pushFollow(FOLLOW_46);
                    lv_variation_1_1=ruleIntervalVariationClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDoFVariationClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"variation",
                            		lv_variation_1_1, 
                            		"tools.descartes.dql.lang.DescartesQL.IntervalVariationClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:2556:8: lv_variation_1_2= ruleValueVariationClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getDoFVariationClauseAccess().getVariationValueVariationClauseParserRuleCall_1_0_1()); 
                    	    
                    pushFollow(FOLLOW_46);
                    lv_variation_1_2=ruleValueVariationClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDoFVariationClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"variation",
                            		lv_variation_1_2, 
                            		"tools.descartes.dql.lang.DescartesQL.ValueVariationClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:2571:8: lv_variation_1_3= ruleDoubleValueVariationClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getDoFVariationClauseAccess().getVariationDoubleValueVariationClauseParserRuleCall_1_0_2()); 
                    	    
                    pushFollow(FOLLOW_46);
                    lv_variation_1_3=ruleDoubleValueVariationClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDoFVariationClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"variation",
                            		lv_variation_1_3, 
                            		"tools.descartes.dql.lang.DescartesQL.DoubleValueVariationClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }

            // InternalDescartesQL.g:2589:2: ( (lv_mode2_2_0= '>' ) )
            // InternalDescartesQL.g:2590:1: (lv_mode2_2_0= '>' )
            {
            // InternalDescartesQL.g:2590:1: (lv_mode2_2_0= '>' )
            // InternalDescartesQL.g:2591:3: lv_mode2_2_0= '>'
            {
            lv_mode2_2_0=(Token)match(input,50,FOLLOW_2); 

                    newLeafNode(lv_mode2_2_0, grammarAccess.getDoFVariationClauseAccess().getMode2GreaterThanSignKeyword_2_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getDoFVariationClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode2", lv_mode2_2_0, ">");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDoFVariationClause"


    // $ANTLR start "entryRuleValueVariationClause"
    // InternalDescartesQL.g:2612:1: entryRuleValueVariationClause returns [EObject current=null] : iv_ruleValueVariationClause= ruleValueVariationClause EOF ;
    public final EObject entryRuleValueVariationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleValueVariationClause = null;


        try {
            // InternalDescartesQL.g:2613:2: (iv_ruleValueVariationClause= ruleValueVariationClause EOF )
            // InternalDescartesQL.g:2614:2: iv_ruleValueVariationClause= ruleValueVariationClause EOF
            {
             newCompositeNode(grammarAccess.getValueVariationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleValueVariationClause=ruleValueVariationClause();

            state._fsp--;

             current =iv_ruleValueVariationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleValueVariationClause"


    // $ANTLR start "ruleValueVariationClause"
    // InternalDescartesQL.g:2621:1: ruleValueVariationClause returns [EObject current=null] : ( ( (lv_value_0_0= RULE_INT ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_INT ) ) )* ) ;
    public final EObject ruleValueVariationClause() throws RecognitionException {
        EObject current = null;

        Token lv_value_0_0=null;
        Token otherlv_1=null;
        Token lv_value_2_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2624:28: ( ( ( (lv_value_0_0= RULE_INT ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_INT ) ) )* ) )
            // InternalDescartesQL.g:2625:1: ( ( (lv_value_0_0= RULE_INT ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_INT ) ) )* )
            {
            // InternalDescartesQL.g:2625:1: ( ( (lv_value_0_0= RULE_INT ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_INT ) ) )* )
            // InternalDescartesQL.g:2625:2: ( (lv_value_0_0= RULE_INT ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_INT ) ) )*
            {
            // InternalDescartesQL.g:2625:2: ( (lv_value_0_0= RULE_INT ) )
            // InternalDescartesQL.g:2626:1: (lv_value_0_0= RULE_INT )
            {
            // InternalDescartesQL.g:2626:1: (lv_value_0_0= RULE_INT )
            // InternalDescartesQL.g:2627:3: lv_value_0_0= RULE_INT
            {
            lv_value_0_0=(Token)match(input,RULE_INT,FOLLOW_12); 

            			newLeafNode(lv_value_0_0, grammarAccess.getValueVariationClauseAccess().getValueINTTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getValueVariationClauseRule());
            	        }
                   		addWithLastConsumed(
                   			current, 
                   			"value",
                    		lv_value_0_0, 
                    		"org.eclipse.xtext.common.Terminals.INT");
            	    

            }


            }

            // InternalDescartesQL.g:2643:2: (otherlv_1= ',' ( (lv_value_2_0= RULE_INT ) ) )*
            loop37:
            do {
                int alt37=2;
                int LA37_0 = input.LA(1);

                if ( (LA37_0==20) ) {
                    int LA37_2 = input.LA(2);

                    if ( (LA37_2==RULE_INT) ) {
                        alt37=1;
                    }


                }


                switch (alt37) {
            	case 1 :
            	    // InternalDescartesQL.g:2643:4: otherlv_1= ',' ( (lv_value_2_0= RULE_INT ) )
            	    {
            	    otherlv_1=(Token)match(input,20,FOLLOW_24); 

            	        	newLeafNode(otherlv_1, grammarAccess.getValueVariationClauseAccess().getCommaKeyword_1_0());
            	        
            	    // InternalDescartesQL.g:2647:1: ( (lv_value_2_0= RULE_INT ) )
            	    // InternalDescartesQL.g:2648:1: (lv_value_2_0= RULE_INT )
            	    {
            	    // InternalDescartesQL.g:2648:1: (lv_value_2_0= RULE_INT )
            	    // InternalDescartesQL.g:2649:3: lv_value_2_0= RULE_INT
            	    {
            	    lv_value_2_0=(Token)match(input,RULE_INT,FOLLOW_12); 

            	    			newLeafNode(lv_value_2_0, grammarAccess.getValueVariationClauseAccess().getValueINTTerminalRuleCall_1_1_0()); 
            	    		

            	    	        if (current==null) {
            	    	            current = createModelElement(grammarAccess.getValueVariationClauseRule());
            	    	        }
            	           		addWithLastConsumed(
            	           			current, 
            	           			"value",
            	            		lv_value_2_0, 
            	            		"org.eclipse.xtext.common.Terminals.INT");
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop37;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleValueVariationClause"


    // $ANTLR start "entryRuleDoubleValueVariationClause"
    // InternalDescartesQL.g:2673:1: entryRuleDoubleValueVariationClause returns [EObject current=null] : iv_ruleDoubleValueVariationClause= ruleDoubleValueVariationClause EOF ;
    public final EObject entryRuleDoubleValueVariationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDoubleValueVariationClause = null;


        try {
            // InternalDescartesQL.g:2674:2: (iv_ruleDoubleValueVariationClause= ruleDoubleValueVariationClause EOF )
            // InternalDescartesQL.g:2675:2: iv_ruleDoubleValueVariationClause= ruleDoubleValueVariationClause EOF
            {
             newCompositeNode(grammarAccess.getDoubleValueVariationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDoubleValueVariationClause=ruleDoubleValueVariationClause();

            state._fsp--;

             current =iv_ruleDoubleValueVariationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDoubleValueVariationClause"


    // $ANTLR start "ruleDoubleValueVariationClause"
    // InternalDescartesQL.g:2682:1: ruleDoubleValueVariationClause returns [EObject current=null] : ( ( (lv_value_0_0= RULE_DOUBLE ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_DOUBLE ) ) )* ) ;
    public final EObject ruleDoubleValueVariationClause() throws RecognitionException {
        EObject current = null;

        Token lv_value_0_0=null;
        Token otherlv_1=null;
        Token lv_value_2_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2685:28: ( ( ( (lv_value_0_0= RULE_DOUBLE ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_DOUBLE ) ) )* ) )
            // InternalDescartesQL.g:2686:1: ( ( (lv_value_0_0= RULE_DOUBLE ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_DOUBLE ) ) )* )
            {
            // InternalDescartesQL.g:2686:1: ( ( (lv_value_0_0= RULE_DOUBLE ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_DOUBLE ) ) )* )
            // InternalDescartesQL.g:2686:2: ( (lv_value_0_0= RULE_DOUBLE ) ) (otherlv_1= ',' ( (lv_value_2_0= RULE_DOUBLE ) ) )*
            {
            // InternalDescartesQL.g:2686:2: ( (lv_value_0_0= RULE_DOUBLE ) )
            // InternalDescartesQL.g:2687:1: (lv_value_0_0= RULE_DOUBLE )
            {
            // InternalDescartesQL.g:2687:1: (lv_value_0_0= RULE_DOUBLE )
            // InternalDescartesQL.g:2688:3: lv_value_0_0= RULE_DOUBLE
            {
            lv_value_0_0=(Token)match(input,RULE_DOUBLE,FOLLOW_12); 

            			newLeafNode(lv_value_0_0, grammarAccess.getDoubleValueVariationClauseAccess().getValueDOUBLETerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getDoubleValueVariationClauseRule());
            	        }
                   		addWithLastConsumed(
                   			current, 
                   			"value",
                    		lv_value_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.DOUBLE");
            	    

            }


            }

            // InternalDescartesQL.g:2704:2: (otherlv_1= ',' ( (lv_value_2_0= RULE_DOUBLE ) ) )*
            loop38:
            do {
                int alt38=2;
                int LA38_0 = input.LA(1);

                if ( (LA38_0==20) ) {
                    alt38=1;
                }


                switch (alt38) {
            	case 1 :
            	    // InternalDescartesQL.g:2704:4: otherlv_1= ',' ( (lv_value_2_0= RULE_DOUBLE ) )
            	    {
            	    otherlv_1=(Token)match(input,20,FOLLOW_9); 

            	        	newLeafNode(otherlv_1, grammarAccess.getDoubleValueVariationClauseAccess().getCommaKeyword_1_0());
            	        
            	    // InternalDescartesQL.g:2708:1: ( (lv_value_2_0= RULE_DOUBLE ) )
            	    // InternalDescartesQL.g:2709:1: (lv_value_2_0= RULE_DOUBLE )
            	    {
            	    // InternalDescartesQL.g:2709:1: (lv_value_2_0= RULE_DOUBLE )
            	    // InternalDescartesQL.g:2710:3: lv_value_2_0= RULE_DOUBLE
            	    {
            	    lv_value_2_0=(Token)match(input,RULE_DOUBLE,FOLLOW_12); 

            	    			newLeafNode(lv_value_2_0, grammarAccess.getDoubleValueVariationClauseAccess().getValueDOUBLETerminalRuleCall_1_1_0()); 
            	    		

            	    	        if (current==null) {
            	    	            current = createModelElement(grammarAccess.getDoubleValueVariationClauseRule());
            	    	        }
            	           		addWithLastConsumed(
            	           			current, 
            	           			"value",
            	            		lv_value_2_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.DOUBLE");
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop38;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDoubleValueVariationClause"


    // $ANTLR start "entryRuleIntervalVariationClause"
    // InternalDescartesQL.g:2734:1: entryRuleIntervalVariationClause returns [EObject current=null] : iv_ruleIntervalVariationClause= ruleIntervalVariationClause EOF ;
    public final EObject entryRuleIntervalVariationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleIntervalVariationClause = null;


        try {
            // InternalDescartesQL.g:2735:2: (iv_ruleIntervalVariationClause= ruleIntervalVariationClause EOF )
            // InternalDescartesQL.g:2736:2: iv_ruleIntervalVariationClause= ruleIntervalVariationClause EOF
            {
             newCompositeNode(grammarAccess.getIntervalVariationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleIntervalVariationClause=ruleIntervalVariationClause();

            state._fsp--;

             current =iv_ruleIntervalVariationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIntervalVariationClause"


    // $ANTLR start "ruleIntervalVariationClause"
    // InternalDescartesQL.g:2743:1: ruleIntervalVariationClause returns [EObject current=null] : ( ( (lv_start_0_0= RULE_INT ) ) otherlv_1= '..' ( (lv_end_2_0= RULE_INT ) ) otherlv_3= 'BY' ( (lv_step_4_0= RULE_INT ) ) ) ;
    public final EObject ruleIntervalVariationClause() throws RecognitionException {
        EObject current = null;

        Token lv_start_0_0=null;
        Token otherlv_1=null;
        Token lv_end_2_0=null;
        Token otherlv_3=null;
        Token lv_step_4_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2746:28: ( ( ( (lv_start_0_0= RULE_INT ) ) otherlv_1= '..' ( (lv_end_2_0= RULE_INT ) ) otherlv_3= 'BY' ( (lv_step_4_0= RULE_INT ) ) ) )
            // InternalDescartesQL.g:2747:1: ( ( (lv_start_0_0= RULE_INT ) ) otherlv_1= '..' ( (lv_end_2_0= RULE_INT ) ) otherlv_3= 'BY' ( (lv_step_4_0= RULE_INT ) ) )
            {
            // InternalDescartesQL.g:2747:1: ( ( (lv_start_0_0= RULE_INT ) ) otherlv_1= '..' ( (lv_end_2_0= RULE_INT ) ) otherlv_3= 'BY' ( (lv_step_4_0= RULE_INT ) ) )
            // InternalDescartesQL.g:2747:2: ( (lv_start_0_0= RULE_INT ) ) otherlv_1= '..' ( (lv_end_2_0= RULE_INT ) ) otherlv_3= 'BY' ( (lv_step_4_0= RULE_INT ) )
            {
            // InternalDescartesQL.g:2747:2: ( (lv_start_0_0= RULE_INT ) )
            // InternalDescartesQL.g:2748:1: (lv_start_0_0= RULE_INT )
            {
            // InternalDescartesQL.g:2748:1: (lv_start_0_0= RULE_INT )
            // InternalDescartesQL.g:2749:3: lv_start_0_0= RULE_INT
            {
            lv_start_0_0=(Token)match(input,RULE_INT,FOLLOW_47); 

            			newLeafNode(lv_start_0_0, grammarAccess.getIntervalVariationClauseAccess().getStartINTTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getIntervalVariationClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"start",
                    		lv_start_0_0, 
                    		"org.eclipse.xtext.common.Terminals.INT");
            	    

            }


            }

            otherlv_1=(Token)match(input,51,FOLLOW_24); 

                	newLeafNode(otherlv_1, grammarAccess.getIntervalVariationClauseAccess().getFullStopFullStopKeyword_1());
                
            // InternalDescartesQL.g:2769:1: ( (lv_end_2_0= RULE_INT ) )
            // InternalDescartesQL.g:2770:1: (lv_end_2_0= RULE_INT )
            {
            // InternalDescartesQL.g:2770:1: (lv_end_2_0= RULE_INT )
            // InternalDescartesQL.g:2771:3: lv_end_2_0= RULE_INT
            {
            lv_end_2_0=(Token)match(input,RULE_INT,FOLLOW_48); 

            			newLeafNode(lv_end_2_0, grammarAccess.getIntervalVariationClauseAccess().getEndINTTerminalRuleCall_2_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getIntervalVariationClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"end",
                    		lv_end_2_0, 
                    		"org.eclipse.xtext.common.Terminals.INT");
            	    

            }


            }

            otherlv_3=(Token)match(input,52,FOLLOW_24); 

                	newLeafNode(otherlv_3, grammarAccess.getIntervalVariationClauseAccess().getBYKeyword_3());
                
            // InternalDescartesQL.g:2791:1: ( (lv_step_4_0= RULE_INT ) )
            // InternalDescartesQL.g:2792:1: (lv_step_4_0= RULE_INT )
            {
            // InternalDescartesQL.g:2792:1: (lv_step_4_0= RULE_INT )
            // InternalDescartesQL.g:2793:3: lv_step_4_0= RULE_INT
            {
            lv_step_4_0=(Token)match(input,RULE_INT,FOLLOW_2); 

            			newLeafNode(lv_step_4_0, grammarAccess.getIntervalVariationClauseAccess().getStepINTTerminalRuleCall_4_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getIntervalVariationClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"step",
                    		lv_step_4_0, 
                    		"org.eclipse.xtext.common.Terminals.INT");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIntervalVariationClause"


    // $ANTLR start "entryRuleVaryingClause"
    // InternalDescartesQL.g:2817:1: entryRuleVaryingClause returns [EObject current=null] : iv_ruleVaryingClause= ruleVaryingClause EOF ;
    public final EObject entryRuleVaryingClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleVaryingClause = null;


        try {
            // InternalDescartesQL.g:2818:2: (iv_ruleVaryingClause= ruleVaryingClause EOF )
            // InternalDescartesQL.g:2819:2: iv_ruleVaryingClause= ruleVaryingClause EOF
            {
             newCompositeNode(grammarAccess.getVaryingClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleVaryingClause=ruleVaryingClause();

            state._fsp--;

             current =iv_ruleVaryingClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleVaryingClause"


    // $ANTLR start "ruleVaryingClause"
    // InternalDescartesQL.g:2826:1: ruleVaryingClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'VARYING' ) ) ( (lv_dofReferences_1_0= ruleDoFReference ) ) (otherlv_2= ',' ( (lv_dofReferences_3_0= ruleDoFReference ) ) )* ) ;
    public final EObject ruleVaryingClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        Token otherlv_2=null;
        EObject lv_dofReferences_1_0 = null;

        EObject lv_dofReferences_3_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2829:28: ( ( ( (lv_mode_0_0= 'VARYING' ) ) ( (lv_dofReferences_1_0= ruleDoFReference ) ) (otherlv_2= ',' ( (lv_dofReferences_3_0= ruleDoFReference ) ) )* ) )
            // InternalDescartesQL.g:2830:1: ( ( (lv_mode_0_0= 'VARYING' ) ) ( (lv_dofReferences_1_0= ruleDoFReference ) ) (otherlv_2= ',' ( (lv_dofReferences_3_0= ruleDoFReference ) ) )* )
            {
            // InternalDescartesQL.g:2830:1: ( ( (lv_mode_0_0= 'VARYING' ) ) ( (lv_dofReferences_1_0= ruleDoFReference ) ) (otherlv_2= ',' ( (lv_dofReferences_3_0= ruleDoFReference ) ) )* )
            // InternalDescartesQL.g:2830:2: ( (lv_mode_0_0= 'VARYING' ) ) ( (lv_dofReferences_1_0= ruleDoFReference ) ) (otherlv_2= ',' ( (lv_dofReferences_3_0= ruleDoFReference ) ) )*
            {
            // InternalDescartesQL.g:2830:2: ( (lv_mode_0_0= 'VARYING' ) )
            // InternalDescartesQL.g:2831:1: (lv_mode_0_0= 'VARYING' )
            {
            // InternalDescartesQL.g:2831:1: (lv_mode_0_0= 'VARYING' )
            // InternalDescartesQL.g:2832:3: lv_mode_0_0= 'VARYING'
            {
            lv_mode_0_0=(Token)match(input,53,FOLLOW_39); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getVaryingClauseAccess().getModeVARYINGKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getVaryingClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "VARYING");
            	    

            }


            }

            // InternalDescartesQL.g:2845:2: ( (lv_dofReferences_1_0= ruleDoFReference ) )
            // InternalDescartesQL.g:2846:1: (lv_dofReferences_1_0= ruleDoFReference )
            {
            // InternalDescartesQL.g:2846:1: (lv_dofReferences_1_0= ruleDoFReference )
            // InternalDescartesQL.g:2847:3: lv_dofReferences_1_0= ruleDoFReference
            {
             
            	        newCompositeNode(grammarAccess.getVaryingClauseAccess().getDofReferencesDoFReferenceParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_12);
            lv_dofReferences_1_0=ruleDoFReference();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getVaryingClauseRule());
            	        }
                   		add(
                   			current, 
                   			"dofReferences",
                    		lv_dofReferences_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.DoFReference");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:2863:2: (otherlv_2= ',' ( (lv_dofReferences_3_0= ruleDoFReference ) ) )*
            loop39:
            do {
                int alt39=2;
                int LA39_0 = input.LA(1);

                if ( (LA39_0==20) ) {
                    alt39=1;
                }


                switch (alt39) {
            	case 1 :
            	    // InternalDescartesQL.g:2863:4: otherlv_2= ',' ( (lv_dofReferences_3_0= ruleDoFReference ) )
            	    {
            	    otherlv_2=(Token)match(input,20,FOLLOW_39); 

            	        	newLeafNode(otherlv_2, grammarAccess.getVaryingClauseAccess().getCommaKeyword_2_0());
            	        
            	    // InternalDescartesQL.g:2867:1: ( (lv_dofReferences_3_0= ruleDoFReference ) )
            	    // InternalDescartesQL.g:2868:1: (lv_dofReferences_3_0= ruleDoFReference )
            	    {
            	    // InternalDescartesQL.g:2868:1: (lv_dofReferences_3_0= ruleDoFReference )
            	    // InternalDescartesQL.g:2869:3: lv_dofReferences_3_0= ruleDoFReference
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getVaryingClauseAccess().getDofReferencesDoFReferenceParserRuleCall_2_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_12);
            	    lv_dofReferences_3_0=ruleDoFReference();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getVaryingClauseRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"dofReferences",
            	            		lv_dofReferences_3_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.DoFReference");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop39;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleVaryingClause"


    // $ANTLR start "entryRuleDoFReference"
    // InternalDescartesQL.g:2893:1: entryRuleDoFReference returns [EObject current=null] : iv_ruleDoFReference= ruleDoFReference EOF ;
    public final EObject entryRuleDoFReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDoFReference = null;


        try {
            // InternalDescartesQL.g:2894:2: (iv_ruleDoFReference= ruleDoFReference EOF )
            // InternalDescartesQL.g:2895:2: iv_ruleDoFReference= ruleDoFReference EOF
            {
             newCompositeNode(grammarAccess.getDoFReferenceRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDoFReference=ruleDoFReference();

            state._fsp--;

             current =iv_ruleDoFReference; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDoFReference"


    // $ANTLR start "ruleDoFReference"
    // InternalDescartesQL.g:2902:1: ruleDoFReference returns [EObject current=null] : ( ( (lv_doFIdentifier_0_0= RULE_STRING ) ) ( (lv_doFAliasClause_1_0= ruleAliasClause ) )? ( ( (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause ) ) )? ) ;
    public final EObject ruleDoFReference() throws RecognitionException {
        EObject current = null;

        Token lv_doFIdentifier_0_0=null;
        EObject lv_doFAliasClause_1_0 = null;

        EObject lv_doFVariationClause_2_1 = null;

        EObject lv_doFVariationClause_2_2 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2905:28: ( ( ( (lv_doFIdentifier_0_0= RULE_STRING ) ) ( (lv_doFAliasClause_1_0= ruleAliasClause ) )? ( ( (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause ) ) )? ) )
            // InternalDescartesQL.g:2906:1: ( ( (lv_doFIdentifier_0_0= RULE_STRING ) ) ( (lv_doFAliasClause_1_0= ruleAliasClause ) )? ( ( (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause ) ) )? )
            {
            // InternalDescartesQL.g:2906:1: ( ( (lv_doFIdentifier_0_0= RULE_STRING ) ) ( (lv_doFAliasClause_1_0= ruleAliasClause ) )? ( ( (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause ) ) )? )
            // InternalDescartesQL.g:2906:2: ( (lv_doFIdentifier_0_0= RULE_STRING ) ) ( (lv_doFAliasClause_1_0= ruleAliasClause ) )? ( ( (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause ) ) )?
            {
            // InternalDescartesQL.g:2906:2: ( (lv_doFIdentifier_0_0= RULE_STRING ) )
            // InternalDescartesQL.g:2907:1: (lv_doFIdentifier_0_0= RULE_STRING )
            {
            // InternalDescartesQL.g:2907:1: (lv_doFIdentifier_0_0= RULE_STRING )
            // InternalDescartesQL.g:2908:3: lv_doFIdentifier_0_0= RULE_STRING
            {
            lv_doFIdentifier_0_0=(Token)match(input,RULE_STRING,FOLLOW_49); 

            			newLeafNode(lv_doFIdentifier_0_0, grammarAccess.getDoFReferenceAccess().getDoFIdentifierSTRINGTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getDoFReferenceRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"doFIdentifier",
                    		lv_doFIdentifier_0_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }

            // InternalDescartesQL.g:2924:2: ( (lv_doFAliasClause_1_0= ruleAliasClause ) )?
            int alt40=2;
            int LA40_0 = input.LA(1);

            if ( (LA40_0==59) ) {
                alt40=1;
            }
            switch (alt40) {
                case 1 :
                    // InternalDescartesQL.g:2925:1: (lv_doFAliasClause_1_0= ruleAliasClause )
                    {
                    // InternalDescartesQL.g:2925:1: (lv_doFAliasClause_1_0= ruleAliasClause )
                    // InternalDescartesQL.g:2926:3: lv_doFAliasClause_1_0= ruleAliasClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getDoFReferenceAccess().getDoFAliasClauseAliasClauseParserRuleCall_1_0()); 
                    	    
                    pushFollow(FOLLOW_50);
                    lv_doFAliasClause_1_0=ruleAliasClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDoFReferenceRule());
                    	        }
                           		set(
                           			current, 
                           			"doFAliasClause",
                            		lv_doFAliasClause_1_0, 
                            		"tools.descartes.dql.lang.DescartesQL.AliasClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:2942:3: ( ( (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause ) ) )?
            int alt42=2;
            int LA42_0 = input.LA(1);

            if ( (LA42_0==45||LA42_0==49) ) {
                alt42=1;
            }
            switch (alt42) {
                case 1 :
                    // InternalDescartesQL.g:2943:1: ( (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause ) )
                    {
                    // InternalDescartesQL.g:2943:1: ( (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause ) )
                    // InternalDescartesQL.g:2944:1: (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause )
                    {
                    // InternalDescartesQL.g:2944:1: (lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause | lv_doFVariationClause_2_2= ruleDoFVariationClause )
                    int alt41=2;
                    int LA41_0 = input.LA(1);

                    if ( (LA41_0==45) ) {
                        alt41=1;
                    }
                    else if ( (LA41_0==49) ) {
                        alt41=2;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 41, 0, input);

                        throw nvae;
                    }
                    switch (alt41) {
                        case 1 :
                            // InternalDescartesQL.g:2945:3: lv_doFVariationClause_2_1= ruleConfigurationPropertiesClause
                            {
                             
                            	        newCompositeNode(grammarAccess.getDoFReferenceAccess().getDoFVariationClauseConfigurationPropertiesClauseParserRuleCall_2_0_0()); 
                            	    
                            pushFollow(FOLLOW_2);
                            lv_doFVariationClause_2_1=ruleConfigurationPropertiesClause();

                            state._fsp--;


                            	        if (current==null) {
                            	            current = createModelElementForParent(grammarAccess.getDoFReferenceRule());
                            	        }
                                   		set(
                                   			current, 
                                   			"doFVariationClause",
                                    		lv_doFVariationClause_2_1, 
                                    		"tools.descartes.dql.lang.DescartesQL.ConfigurationPropertiesClause");
                            	        afterParserOrEnumRuleCall();
                            	    

                            }
                            break;
                        case 2 :
                            // InternalDescartesQL.g:2960:8: lv_doFVariationClause_2_2= ruleDoFVariationClause
                            {
                             
                            	        newCompositeNode(grammarAccess.getDoFReferenceAccess().getDoFVariationClauseDoFVariationClauseParserRuleCall_2_0_1()); 
                            	    
                            pushFollow(FOLLOW_2);
                            lv_doFVariationClause_2_2=ruleDoFVariationClause();

                            state._fsp--;


                            	        if (current==null) {
                            	            current = createModelElementForParent(grammarAccess.getDoFReferenceRule());
                            	        }
                                   		set(
                                   			current, 
                                   			"doFVariationClause",
                                    		lv_doFVariationClause_2_2, 
                                    		"tools.descartes.dql.lang.DescartesQL.DoFVariationClause");
                            	        afterParserOrEnumRuleCall();
                            	    

                            }
                            break;

                    }


                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDoFReference"


    // $ANTLR start "entryRuleMetricClause"
    // InternalDescartesQL.g:2986:1: entryRuleMetricClause returns [EObject current=null] : iv_ruleMetricClause= ruleMetricClause EOF ;
    public final EObject entryRuleMetricClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMetricClause = null;


        try {
            // InternalDescartesQL.g:2987:2: (iv_ruleMetricClause= ruleMetricClause EOF )
            // InternalDescartesQL.g:2988:2: iv_ruleMetricClause= ruleMetricClause EOF
            {
             newCompositeNode(grammarAccess.getMetricClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMetricClause=ruleMetricClause();

            state._fsp--;

             current =iv_ruleMetricClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMetricClause"


    // $ANTLR start "ruleMetricClause"
    // InternalDescartesQL.g:2995:1: ruleMetricClause returns [EObject current=null] : ( (lv_metricReference_0_0= ruleMetricReference ) ) ;
    public final EObject ruleMetricClause() throws RecognitionException {
        EObject current = null;

        EObject lv_metricReference_0_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:2998:28: ( ( (lv_metricReference_0_0= ruleMetricReference ) ) )
            // InternalDescartesQL.g:2999:1: ( (lv_metricReference_0_0= ruleMetricReference ) )
            {
            // InternalDescartesQL.g:2999:1: ( (lv_metricReference_0_0= ruleMetricReference ) )
            // InternalDescartesQL.g:3000:1: (lv_metricReference_0_0= ruleMetricReference )
            {
            // InternalDescartesQL.g:3000:1: (lv_metricReference_0_0= ruleMetricReference )
            // InternalDescartesQL.g:3001:3: lv_metricReference_0_0= ruleMetricReference
            {
             
            	        newCompositeNode(grammarAccess.getMetricClauseAccess().getMetricReferenceMetricReferenceParserRuleCall_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_metricReference_0_0=ruleMetricReference();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getMetricClauseRule());
            	        }
                   		set(
                   			current, 
                   			"metricReference",
                    		lv_metricReference_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.MetricReference");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMetricClause"


    // $ANTLR start "entryRuleAggregateMetricClause"
    // InternalDescartesQL.g:3025:1: entryRuleAggregateMetricClause returns [EObject current=null] : iv_ruleAggregateMetricClause= ruleAggregateMetricClause EOF ;
    public final EObject entryRuleAggregateMetricClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAggregateMetricClause = null;


        try {
            // InternalDescartesQL.g:3026:2: (iv_ruleAggregateMetricClause= ruleAggregateMetricClause EOF )
            // InternalDescartesQL.g:3027:2: iv_ruleAggregateMetricClause= ruleAggregateMetricClause EOF
            {
             newCompositeNode(grammarAccess.getAggregateMetricClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAggregateMetricClause=ruleAggregateMetricClause();

            state._fsp--;

             current =iv_ruleAggregateMetricClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAggregateMetricClause"


    // $ANTLR start "ruleAggregateMetricClause"
    // InternalDescartesQL.g:3034:1: ruleAggregateMetricClause returns [EObject current=null] : ( ( (lv_function_0_0= ruleStatisticalAggregateType ) ) otherlv_1= '(' ( ( (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses ) ) ) otherlv_3= ')' ( (lv_properties_4_0= ruleConfigurationPropertiesClause ) )? ) ;
    public final EObject ruleAggregateMetricClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Enumerator lv_function_0_0 = null;

        EObject lv_metrics_2_1 = null;

        EObject lv_metrics_2_2 = null;

        EObject lv_properties_4_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3037:28: ( ( ( (lv_function_0_0= ruleStatisticalAggregateType ) ) otherlv_1= '(' ( ( (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses ) ) ) otherlv_3= ')' ( (lv_properties_4_0= ruleConfigurationPropertiesClause ) )? ) )
            // InternalDescartesQL.g:3038:1: ( ( (lv_function_0_0= ruleStatisticalAggregateType ) ) otherlv_1= '(' ( ( (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses ) ) ) otherlv_3= ')' ( (lv_properties_4_0= ruleConfigurationPropertiesClause ) )? )
            {
            // InternalDescartesQL.g:3038:1: ( ( (lv_function_0_0= ruleStatisticalAggregateType ) ) otherlv_1= '(' ( ( (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses ) ) ) otherlv_3= ')' ( (lv_properties_4_0= ruleConfigurationPropertiesClause ) )? )
            // InternalDescartesQL.g:3038:2: ( (lv_function_0_0= ruleStatisticalAggregateType ) ) otherlv_1= '(' ( ( (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses ) ) ) otherlv_3= ')' ( (lv_properties_4_0= ruleConfigurationPropertiesClause ) )?
            {
            // InternalDescartesQL.g:3038:2: ( (lv_function_0_0= ruleStatisticalAggregateType ) )
            // InternalDescartesQL.g:3039:1: (lv_function_0_0= ruleStatisticalAggregateType )
            {
            // InternalDescartesQL.g:3039:1: (lv_function_0_0= ruleStatisticalAggregateType )
            // InternalDescartesQL.g:3040:3: lv_function_0_0= ruleStatisticalAggregateType
            {
             
            	        newCompositeNode(grammarAccess.getAggregateMetricClauseAccess().getFunctionStatisticalAggregateTypeEnumRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_14);
            lv_function_0_0=ruleStatisticalAggregateType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getAggregateMetricClauseRule());
            	        }
                   		set(
                   			current, 
                   			"function",
                    		lv_function_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.StatisticalAggregateType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_1=(Token)match(input,23,FOLLOW_51); 

                	newLeafNode(otherlv_1, grammarAccess.getAggregateMetricClauseAccess().getLeftParenthesisKeyword_1());
                
            // InternalDescartesQL.g:3060:1: ( ( (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses ) ) )
            // InternalDescartesQL.g:3061:1: ( (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses ) )
            {
            // InternalDescartesQL.g:3061:1: ( (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses ) )
            // InternalDescartesQL.g:3062:1: (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses )
            {
            // InternalDescartesQL.g:3062:1: (lv_metrics_2_1= ruleMetricStarClause | lv_metrics_2_2= ruleMetricClauses )
            int alt43=2;
            int LA43_0 = input.LA(1);

            if ( (LA43_0==54) ) {
                alt43=1;
            }
            else if ( (LA43_0==RULE_ID) ) {
                alt43=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 43, 0, input);

                throw nvae;
            }
            switch (alt43) {
                case 1 :
                    // InternalDescartesQL.g:3063:3: lv_metrics_2_1= ruleMetricStarClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getAggregateMetricClauseAccess().getMetricsMetricStarClauseParserRuleCall_2_0_0()); 
                    	    
                    pushFollow(FOLLOW_32);
                    lv_metrics_2_1=ruleMetricStarClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getAggregateMetricClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"metrics",
                            		lv_metrics_2_1, 
                            		"tools.descartes.dql.lang.DescartesQL.MetricStarClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:3078:8: lv_metrics_2_2= ruleMetricClauses
                    {
                     
                    	        newCompositeNode(grammarAccess.getAggregateMetricClauseAccess().getMetricsMetricClausesParserRuleCall_2_0_1()); 
                    	    
                    pushFollow(FOLLOW_32);
                    lv_metrics_2_2=ruleMetricClauses();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getAggregateMetricClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"metrics",
                            		lv_metrics_2_2, 
                            		"tools.descartes.dql.lang.DescartesQL.MetricClauses");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }

            otherlv_3=(Token)match(input,24,FOLLOW_43); 

                	newLeafNode(otherlv_3, grammarAccess.getAggregateMetricClauseAccess().getRightParenthesisKeyword_3());
                
            // InternalDescartesQL.g:3100:1: ( (lv_properties_4_0= ruleConfigurationPropertiesClause ) )?
            int alt44=2;
            int LA44_0 = input.LA(1);

            if ( (LA44_0==45) ) {
                alt44=1;
            }
            switch (alt44) {
                case 1 :
                    // InternalDescartesQL.g:3101:1: (lv_properties_4_0= ruleConfigurationPropertiesClause )
                    {
                    // InternalDescartesQL.g:3101:1: (lv_properties_4_0= ruleConfigurationPropertiesClause )
                    // InternalDescartesQL.g:3102:3: lv_properties_4_0= ruleConfigurationPropertiesClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getAggregateMetricClauseAccess().getPropertiesConfigurationPropertiesClauseParserRuleCall_4_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_properties_4_0=ruleConfigurationPropertiesClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getAggregateMetricClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"properties",
                            		lv_properties_4_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ConfigurationPropertiesClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAggregateMetricClause"


    // $ANTLR start "entryRuleMetricClauses"
    // InternalDescartesQL.g:3126:1: entryRuleMetricClauses returns [EObject current=null] : iv_ruleMetricClauses= ruleMetricClauses EOF ;
    public final EObject entryRuleMetricClauses() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMetricClauses = null;


        try {
            // InternalDescartesQL.g:3127:2: (iv_ruleMetricClauses= ruleMetricClauses EOF )
            // InternalDescartesQL.g:3128:2: iv_ruleMetricClauses= ruleMetricClauses EOF
            {
             newCompositeNode(grammarAccess.getMetricClausesRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMetricClauses=ruleMetricClauses();

            state._fsp--;

             current =iv_ruleMetricClauses; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMetricClauses"


    // $ANTLR start "ruleMetricClauses"
    // InternalDescartesQL.g:3135:1: ruleMetricClauses returns [EObject current=null] : ( ( (lv_metrics_0_0= ruleMetricClause ) ) (otherlv_1= ',' ( (lv_metrics_2_0= ruleMetricClause ) ) )* ) ;
    public final EObject ruleMetricClauses() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_metrics_0_0 = null;

        EObject lv_metrics_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3138:28: ( ( ( (lv_metrics_0_0= ruleMetricClause ) ) (otherlv_1= ',' ( (lv_metrics_2_0= ruleMetricClause ) ) )* ) )
            // InternalDescartesQL.g:3139:1: ( ( (lv_metrics_0_0= ruleMetricClause ) ) (otherlv_1= ',' ( (lv_metrics_2_0= ruleMetricClause ) ) )* )
            {
            // InternalDescartesQL.g:3139:1: ( ( (lv_metrics_0_0= ruleMetricClause ) ) (otherlv_1= ',' ( (lv_metrics_2_0= ruleMetricClause ) ) )* )
            // InternalDescartesQL.g:3139:2: ( (lv_metrics_0_0= ruleMetricClause ) ) (otherlv_1= ',' ( (lv_metrics_2_0= ruleMetricClause ) ) )*
            {
            // InternalDescartesQL.g:3139:2: ( (lv_metrics_0_0= ruleMetricClause ) )
            // InternalDescartesQL.g:3140:1: (lv_metrics_0_0= ruleMetricClause )
            {
            // InternalDescartesQL.g:3140:1: (lv_metrics_0_0= ruleMetricClause )
            // InternalDescartesQL.g:3141:3: lv_metrics_0_0= ruleMetricClause
            {
             
            	        newCompositeNode(grammarAccess.getMetricClausesAccess().getMetricsMetricClauseParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_12);
            lv_metrics_0_0=ruleMetricClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getMetricClausesRule());
            	        }
                   		add(
                   			current, 
                   			"metrics",
                    		lv_metrics_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.MetricClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:3157:2: (otherlv_1= ',' ( (lv_metrics_2_0= ruleMetricClause ) ) )*
            loop45:
            do {
                int alt45=2;
                int LA45_0 = input.LA(1);

                if ( (LA45_0==20) ) {
                    alt45=1;
                }


                switch (alt45) {
            	case 1 :
            	    // InternalDescartesQL.g:3157:4: otherlv_1= ',' ( (lv_metrics_2_0= ruleMetricClause ) )
            	    {
            	    otherlv_1=(Token)match(input,20,FOLLOW_11); 

            	        	newLeafNode(otherlv_1, grammarAccess.getMetricClausesAccess().getCommaKeyword_1_0());
            	        
            	    // InternalDescartesQL.g:3161:1: ( (lv_metrics_2_0= ruleMetricClause ) )
            	    // InternalDescartesQL.g:3162:1: (lv_metrics_2_0= ruleMetricClause )
            	    {
            	    // InternalDescartesQL.g:3162:1: (lv_metrics_2_0= ruleMetricClause )
            	    // InternalDescartesQL.g:3163:3: lv_metrics_2_0= ruleMetricClause
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getMetricClausesAccess().getMetricsMetricClauseParserRuleCall_1_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_12);
            	    lv_metrics_2_0=ruleMetricClause();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getMetricClausesRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"metrics",
            	            		lv_metrics_2_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.MetricClause");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop45;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMetricClauses"


    // $ANTLR start "entryRuleMetricStarClause"
    // InternalDescartesQL.g:3187:1: entryRuleMetricStarClause returns [EObject current=null] : iv_ruleMetricStarClause= ruleMetricStarClause EOF ;
    public final EObject entryRuleMetricStarClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMetricStarClause = null;


        try {
            // InternalDescartesQL.g:3188:2: (iv_ruleMetricStarClause= ruleMetricStarClause EOF )
            // InternalDescartesQL.g:3189:2: iv_ruleMetricStarClause= ruleMetricStarClause EOF
            {
             newCompositeNode(grammarAccess.getMetricStarClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMetricStarClause=ruleMetricStarClause();

            state._fsp--;

             current =iv_ruleMetricStarClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMetricStarClause"


    // $ANTLR start "ruleMetricStarClause"
    // InternalDescartesQL.g:3196:1: ruleMetricStarClause returns [EObject current=null] : (otherlv_0= '*.' ( (lv_metricName_1_0= RULE_ID ) ) ) ;
    public final EObject ruleMetricStarClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_metricName_1_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3199:28: ( (otherlv_0= '*.' ( (lv_metricName_1_0= RULE_ID ) ) ) )
            // InternalDescartesQL.g:3200:1: (otherlv_0= '*.' ( (lv_metricName_1_0= RULE_ID ) ) )
            {
            // InternalDescartesQL.g:3200:1: (otherlv_0= '*.' ( (lv_metricName_1_0= RULE_ID ) ) )
            // InternalDescartesQL.g:3200:3: otherlv_0= '*.' ( (lv_metricName_1_0= RULE_ID ) )
            {
            otherlv_0=(Token)match(input,54,FOLLOW_11); 

                	newLeafNode(otherlv_0, grammarAccess.getMetricStarClauseAccess().getAsteriskFullStopKeyword_0());
                
            // InternalDescartesQL.g:3204:1: ( (lv_metricName_1_0= RULE_ID ) )
            // InternalDescartesQL.g:3205:1: (lv_metricName_1_0= RULE_ID )
            {
            // InternalDescartesQL.g:3205:1: (lv_metricName_1_0= RULE_ID )
            // InternalDescartesQL.g:3206:3: lv_metricName_1_0= RULE_ID
            {
            lv_metricName_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            			newLeafNode(lv_metricName_1_0, grammarAccess.getMetricStarClauseAccess().getMetricNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getMetricStarClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"metricName",
                    		lv_metricName_1_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMetricStarClause"


    // $ANTLR start "entryRuleMetricReference"
    // InternalDescartesQL.g:3230:1: entryRuleMetricReference returns [EObject current=null] : iv_ruleMetricReference= ruleMetricReference EOF ;
    public final EObject entryRuleMetricReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMetricReference = null;


        try {
            // InternalDescartesQL.g:3231:2: (iv_ruleMetricReference= ruleMetricReference EOF )
            // InternalDescartesQL.g:3232:2: iv_ruleMetricReference= ruleMetricReference EOF
            {
             newCompositeNode(grammarAccess.getMetricReferenceRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMetricReference=ruleMetricReference();

            state._fsp--;

             current =iv_ruleMetricReference; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMetricReference"


    // $ANTLR start "ruleMetricReference"
    // InternalDescartesQL.g:3239:1: ruleMetricReference returns [EObject current=null] : ( ( (lv_entityReference_0_0= RULE_ID ) ) ( ( (lv_seperatorn_1_0= '.' ) ) ( (lv_navigationClause_2_0= ruleNavigationClause ) ) )? ( (lv_separator_3_0= '.' ) ) ( (lv_metricReference_4_0= RULE_ID ) ) ( ( (lv_separatorv_5_0= '.' ) ) ( (lv_statTypeReference_6_0= RULE_ID ) ) )? ) ;
    public final EObject ruleMetricReference() throws RecognitionException {
        EObject current = null;

        Token lv_entityReference_0_0=null;
        Token lv_seperatorn_1_0=null;
        Token lv_separator_3_0=null;
        Token lv_metricReference_4_0=null;
        Token lv_separatorv_5_0=null;
        Token lv_statTypeReference_6_0=null;
        EObject lv_navigationClause_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3242:28: ( ( ( (lv_entityReference_0_0= RULE_ID ) ) ( ( (lv_seperatorn_1_0= '.' ) ) ( (lv_navigationClause_2_0= ruleNavigationClause ) ) )? ( (lv_separator_3_0= '.' ) ) ( (lv_metricReference_4_0= RULE_ID ) ) ( ( (lv_separatorv_5_0= '.' ) ) ( (lv_statTypeReference_6_0= RULE_ID ) ) )? ) )
            // InternalDescartesQL.g:3243:1: ( ( (lv_entityReference_0_0= RULE_ID ) ) ( ( (lv_seperatorn_1_0= '.' ) ) ( (lv_navigationClause_2_0= ruleNavigationClause ) ) )? ( (lv_separator_3_0= '.' ) ) ( (lv_metricReference_4_0= RULE_ID ) ) ( ( (lv_separatorv_5_0= '.' ) ) ( (lv_statTypeReference_6_0= RULE_ID ) ) )? )
            {
            // InternalDescartesQL.g:3243:1: ( ( (lv_entityReference_0_0= RULE_ID ) ) ( ( (lv_seperatorn_1_0= '.' ) ) ( (lv_navigationClause_2_0= ruleNavigationClause ) ) )? ( (lv_separator_3_0= '.' ) ) ( (lv_metricReference_4_0= RULE_ID ) ) ( ( (lv_separatorv_5_0= '.' ) ) ( (lv_statTypeReference_6_0= RULE_ID ) ) )? )
            // InternalDescartesQL.g:3243:2: ( (lv_entityReference_0_0= RULE_ID ) ) ( ( (lv_seperatorn_1_0= '.' ) ) ( (lv_navigationClause_2_0= ruleNavigationClause ) ) )? ( (lv_separator_3_0= '.' ) ) ( (lv_metricReference_4_0= RULE_ID ) ) ( ( (lv_separatorv_5_0= '.' ) ) ( (lv_statTypeReference_6_0= RULE_ID ) ) )?
            {
            // InternalDescartesQL.g:3243:2: ( (lv_entityReference_0_0= RULE_ID ) )
            // InternalDescartesQL.g:3244:1: (lv_entityReference_0_0= RULE_ID )
            {
            // InternalDescartesQL.g:3244:1: (lv_entityReference_0_0= RULE_ID )
            // InternalDescartesQL.g:3245:3: lv_entityReference_0_0= RULE_ID
            {
            lv_entityReference_0_0=(Token)match(input,RULE_ID,FOLLOW_52); 

            			newLeafNode(lv_entityReference_0_0, grammarAccess.getMetricReferenceAccess().getEntityReferenceIDTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getMetricReferenceRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"entityReference",
                    		lv_entityReference_0_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }

            // InternalDescartesQL.g:3261:2: ( ( (lv_seperatorn_1_0= '.' ) ) ( (lv_navigationClause_2_0= ruleNavigationClause ) ) )?
            int alt46=2;
            int LA46_0 = input.LA(1);

            if ( (LA46_0==47) ) {
                int LA46_1 = input.LA(2);

                if ( ((LA46_1>=55 && LA46_1<=57)) ) {
                    alt46=1;
                }
            }
            switch (alt46) {
                case 1 :
                    // InternalDescartesQL.g:3261:3: ( (lv_seperatorn_1_0= '.' ) ) ( (lv_navigationClause_2_0= ruleNavigationClause ) )
                    {
                    // InternalDescartesQL.g:3261:3: ( (lv_seperatorn_1_0= '.' ) )
                    // InternalDescartesQL.g:3262:1: (lv_seperatorn_1_0= '.' )
                    {
                    // InternalDescartesQL.g:3262:1: (lv_seperatorn_1_0= '.' )
                    // InternalDescartesQL.g:3263:3: lv_seperatorn_1_0= '.'
                    {
                    lv_seperatorn_1_0=(Token)match(input,47,FOLLOW_53); 

                            newLeafNode(lv_seperatorn_1_0, grammarAccess.getMetricReferenceAccess().getSeperatornFullStopKeyword_1_0_0());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getMetricReferenceRule());
                    	        }
                           		setWithLastConsumed(current, "seperatorn", lv_seperatorn_1_0, ".");
                    	    

                    }


                    }

                    // InternalDescartesQL.g:3276:2: ( (lv_navigationClause_2_0= ruleNavigationClause ) )
                    // InternalDescartesQL.g:3277:1: (lv_navigationClause_2_0= ruleNavigationClause )
                    {
                    // InternalDescartesQL.g:3277:1: (lv_navigationClause_2_0= ruleNavigationClause )
                    // InternalDescartesQL.g:3278:3: lv_navigationClause_2_0= ruleNavigationClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getMetricReferenceAccess().getNavigationClauseNavigationClauseParserRuleCall_1_1_0()); 
                    	    
                    pushFollow(FOLLOW_52);
                    lv_navigationClause_2_0=ruleNavigationClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getMetricReferenceRule());
                    	        }
                           		set(
                           			current, 
                           			"navigationClause",
                            		lv_navigationClause_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.NavigationClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:3294:4: ( (lv_separator_3_0= '.' ) )
            // InternalDescartesQL.g:3295:1: (lv_separator_3_0= '.' )
            {
            // InternalDescartesQL.g:3295:1: (lv_separator_3_0= '.' )
            // InternalDescartesQL.g:3296:3: lv_separator_3_0= '.'
            {
            lv_separator_3_0=(Token)match(input,47,FOLLOW_11); 

                    newLeafNode(lv_separator_3_0, grammarAccess.getMetricReferenceAccess().getSeparatorFullStopKeyword_2_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getMetricReferenceRule());
            	        }
                   		setWithLastConsumed(current, "separator", lv_separator_3_0, ".");
            	    

            }


            }

            // InternalDescartesQL.g:3309:2: ( (lv_metricReference_4_0= RULE_ID ) )
            // InternalDescartesQL.g:3310:1: (lv_metricReference_4_0= RULE_ID )
            {
            // InternalDescartesQL.g:3310:1: (lv_metricReference_4_0= RULE_ID )
            // InternalDescartesQL.g:3311:3: lv_metricReference_4_0= RULE_ID
            {
            lv_metricReference_4_0=(Token)match(input,RULE_ID,FOLLOW_54); 

            			newLeafNode(lv_metricReference_4_0, grammarAccess.getMetricReferenceAccess().getMetricReferenceIDTerminalRuleCall_3_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getMetricReferenceRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"metricReference",
                    		lv_metricReference_4_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }

            // InternalDescartesQL.g:3327:2: ( ( (lv_separatorv_5_0= '.' ) ) ( (lv_statTypeReference_6_0= RULE_ID ) ) )?
            int alt47=2;
            int LA47_0 = input.LA(1);

            if ( (LA47_0==47) ) {
                alt47=1;
            }
            switch (alt47) {
                case 1 :
                    // InternalDescartesQL.g:3327:3: ( (lv_separatorv_5_0= '.' ) ) ( (lv_statTypeReference_6_0= RULE_ID ) )
                    {
                    // InternalDescartesQL.g:3327:3: ( (lv_separatorv_5_0= '.' ) )
                    // InternalDescartesQL.g:3328:1: (lv_separatorv_5_0= '.' )
                    {
                    // InternalDescartesQL.g:3328:1: (lv_separatorv_5_0= '.' )
                    // InternalDescartesQL.g:3329:3: lv_separatorv_5_0= '.'
                    {
                    lv_separatorv_5_0=(Token)match(input,47,FOLLOW_11); 

                            newLeafNode(lv_separatorv_5_0, grammarAccess.getMetricReferenceAccess().getSeparatorvFullStopKeyword_4_0_0());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getMetricReferenceRule());
                    	        }
                           		setWithLastConsumed(current, "separatorv", lv_separatorv_5_0, ".");
                    	    

                    }


                    }

                    // InternalDescartesQL.g:3342:2: ( (lv_statTypeReference_6_0= RULE_ID ) )
                    // InternalDescartesQL.g:3343:1: (lv_statTypeReference_6_0= RULE_ID )
                    {
                    // InternalDescartesQL.g:3343:1: (lv_statTypeReference_6_0= RULE_ID )
                    // InternalDescartesQL.g:3344:3: lv_statTypeReference_6_0= RULE_ID
                    {
                    lv_statTypeReference_6_0=(Token)match(input,RULE_ID,FOLLOW_2); 

                    			newLeafNode(lv_statTypeReference_6_0, grammarAccess.getMetricReferenceAccess().getStatTypeReferenceIDTerminalRuleCall_4_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getMetricReferenceRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"statTypeReference",
                            		lv_statTypeReference_6_0, 
                            		"org.eclipse.xtext.common.Terminals.ID");
                    	    

                    }


                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMetricReference"


    // $ANTLR start "entryRuleNavigationClause"
    // InternalDescartesQL.g:3368:1: entryRuleNavigationClause returns [EObject current=null] : iv_ruleNavigationClause= ruleNavigationClause EOF ;
    public final EObject entryRuleNavigationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleNavigationClause = null;


        try {
            // InternalDescartesQL.g:3369:2: (iv_ruleNavigationClause= ruleNavigationClause EOF )
            // InternalDescartesQL.g:3370:2: iv_ruleNavigationClause= ruleNavigationClause EOF
            {
             newCompositeNode(grammarAccess.getNavigationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleNavigationClause=ruleNavigationClause();

            state._fsp--;

             current =iv_ruleNavigationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleNavigationClause"


    // $ANTLR start "ruleNavigationClause"
    // InternalDescartesQL.g:3377:1: ruleNavigationClause returns [EObject current=null] : (this_ParentClause_0= ruleParentClause | this_ChildrenClause_1= ruleChildrenClause | this_FindClause_2= ruleFindClause ) ;
    public final EObject ruleNavigationClause() throws RecognitionException {
        EObject current = null;

        EObject this_ParentClause_0 = null;

        EObject this_ChildrenClause_1 = null;

        EObject this_FindClause_2 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3380:28: ( (this_ParentClause_0= ruleParentClause | this_ChildrenClause_1= ruleChildrenClause | this_FindClause_2= ruleFindClause ) )
            // InternalDescartesQL.g:3381:1: (this_ParentClause_0= ruleParentClause | this_ChildrenClause_1= ruleChildrenClause | this_FindClause_2= ruleFindClause )
            {
            // InternalDescartesQL.g:3381:1: (this_ParentClause_0= ruleParentClause | this_ChildrenClause_1= ruleChildrenClause | this_FindClause_2= ruleFindClause )
            int alt48=3;
            switch ( input.LA(1) ) {
            case 56:
                {
                alt48=1;
                }
                break;
            case 55:
                {
                alt48=2;
                }
                break;
            case 57:
                {
                alt48=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 48, 0, input);

                throw nvae;
            }

            switch (alt48) {
                case 1 :
                    // InternalDescartesQL.g:3382:5: this_ParentClause_0= ruleParentClause
                    {
                     
                            newCompositeNode(grammarAccess.getNavigationClauseAccess().getParentClauseParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_2);
                    this_ParentClause_0=ruleParentClause();

                    state._fsp--;

                     
                            current = this_ParentClause_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:3392:5: this_ChildrenClause_1= ruleChildrenClause
                    {
                     
                            newCompositeNode(grammarAccess.getNavigationClauseAccess().getChildrenClauseParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_2);
                    this_ChildrenClause_1=ruleChildrenClause();

                    state._fsp--;

                     
                            current = this_ChildrenClause_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:3402:5: this_FindClause_2= ruleFindClause
                    {
                     
                            newCompositeNode(grammarAccess.getNavigationClauseAccess().getFindClauseParserRuleCall_2()); 
                        
                    pushFollow(FOLLOW_2);
                    this_FindClause_2=ruleFindClause();

                    state._fsp--;

                     
                            current = this_FindClause_2; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleNavigationClause"


    // $ANTLR start "entryRuleChildrenClause"
    // InternalDescartesQL.g:3418:1: entryRuleChildrenClause returns [EObject current=null] : iv_ruleChildrenClause= ruleChildrenClause EOF ;
    public final EObject entryRuleChildrenClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleChildrenClause = null;


        try {
            // InternalDescartesQL.g:3419:2: (iv_ruleChildrenClause= ruleChildrenClause EOF )
            // InternalDescartesQL.g:3420:2: iv_ruleChildrenClause= ruleChildrenClause EOF
            {
             newCompositeNode(grammarAccess.getChildrenClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleChildrenClause=ruleChildrenClause();

            state._fsp--;

             current =iv_ruleChildrenClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleChildrenClause"


    // $ANTLR start "ruleChildrenClause"
    // InternalDescartesQL.g:3427:1: ruleChildrenClause returns [EObject current=null] : ( (lv_content_0_0= 'children' ) ) ;
    public final EObject ruleChildrenClause() throws RecognitionException {
        EObject current = null;

        Token lv_content_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3430:28: ( ( (lv_content_0_0= 'children' ) ) )
            // InternalDescartesQL.g:3431:1: ( (lv_content_0_0= 'children' ) )
            {
            // InternalDescartesQL.g:3431:1: ( (lv_content_0_0= 'children' ) )
            // InternalDescartesQL.g:3432:1: (lv_content_0_0= 'children' )
            {
            // InternalDescartesQL.g:3432:1: (lv_content_0_0= 'children' )
            // InternalDescartesQL.g:3433:3: lv_content_0_0= 'children'
            {
            lv_content_0_0=(Token)match(input,55,FOLLOW_2); 

                    newLeafNode(lv_content_0_0, grammarAccess.getChildrenClauseAccess().getContentChildrenKeyword_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getChildrenClauseRule());
            	        }
                   		setWithLastConsumed(current, "content", lv_content_0_0, "children");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleChildrenClause"


    // $ANTLR start "entryRuleParentClause"
    // InternalDescartesQL.g:3454:1: entryRuleParentClause returns [EObject current=null] : iv_ruleParentClause= ruleParentClause EOF ;
    public final EObject entryRuleParentClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleParentClause = null;


        try {
            // InternalDescartesQL.g:3455:2: (iv_ruleParentClause= ruleParentClause EOF )
            // InternalDescartesQL.g:3456:2: iv_ruleParentClause= ruleParentClause EOF
            {
             newCompositeNode(grammarAccess.getParentClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleParentClause=ruleParentClause();

            state._fsp--;

             current =iv_ruleParentClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleParentClause"


    // $ANTLR start "ruleParentClause"
    // InternalDescartesQL.g:3463:1: ruleParentClause returns [EObject current=null] : ( (lv_content_0_0= 'parent' ) ) ;
    public final EObject ruleParentClause() throws RecognitionException {
        EObject current = null;

        Token lv_content_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3466:28: ( ( (lv_content_0_0= 'parent' ) ) )
            // InternalDescartesQL.g:3467:1: ( (lv_content_0_0= 'parent' ) )
            {
            // InternalDescartesQL.g:3467:1: ( (lv_content_0_0= 'parent' ) )
            // InternalDescartesQL.g:3468:1: (lv_content_0_0= 'parent' )
            {
            // InternalDescartesQL.g:3468:1: (lv_content_0_0= 'parent' )
            // InternalDescartesQL.g:3469:3: lv_content_0_0= 'parent'
            {
            lv_content_0_0=(Token)match(input,56,FOLLOW_2); 

                    newLeafNode(lv_content_0_0, grammarAccess.getParentClauseAccess().getContentParentKeyword_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getParentClauseRule());
            	        }
                   		setWithLastConsumed(current, "content", lv_content_0_0, "parent");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleParentClause"


    // $ANTLR start "entryRuleFindClause"
    // InternalDescartesQL.g:3490:1: entryRuleFindClause returns [EObject current=null] : iv_ruleFindClause= ruleFindClause EOF ;
    public final EObject entryRuleFindClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFindClause = null;


        try {
            // InternalDescartesQL.g:3491:2: (iv_ruleFindClause= ruleFindClause EOF )
            // InternalDescartesQL.g:3492:2: iv_ruleFindClause= ruleFindClause EOF
            {
             newCompositeNode(grammarAccess.getFindClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFindClause=ruleFindClause();

            state._fsp--;

             current =iv_ruleFindClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFindClause"


    // $ANTLR start "ruleFindClause"
    // InternalDescartesQL.g:3499:1: ruleFindClause returns [EObject current=null] : ( ( (lv_start_0_0= 'find(' ) ) ( (lv_childName_1_0= RULE_STRING ) ) ( (lv_end_2_0= ')' ) ) ) ;
    public final EObject ruleFindClause() throws RecognitionException {
        EObject current = null;

        Token lv_start_0_0=null;
        Token lv_childName_1_0=null;
        Token lv_end_2_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3502:28: ( ( ( (lv_start_0_0= 'find(' ) ) ( (lv_childName_1_0= RULE_STRING ) ) ( (lv_end_2_0= ')' ) ) ) )
            // InternalDescartesQL.g:3503:1: ( ( (lv_start_0_0= 'find(' ) ) ( (lv_childName_1_0= RULE_STRING ) ) ( (lv_end_2_0= ')' ) ) )
            {
            // InternalDescartesQL.g:3503:1: ( ( (lv_start_0_0= 'find(' ) ) ( (lv_childName_1_0= RULE_STRING ) ) ( (lv_end_2_0= ')' ) ) )
            // InternalDescartesQL.g:3503:2: ( (lv_start_0_0= 'find(' ) ) ( (lv_childName_1_0= RULE_STRING ) ) ( (lv_end_2_0= ')' ) )
            {
            // InternalDescartesQL.g:3503:2: ( (lv_start_0_0= 'find(' ) )
            // InternalDescartesQL.g:3504:1: (lv_start_0_0= 'find(' )
            {
            // InternalDescartesQL.g:3504:1: (lv_start_0_0= 'find(' )
            // InternalDescartesQL.g:3505:3: lv_start_0_0= 'find('
            {
            lv_start_0_0=(Token)match(input,57,FOLLOW_39); 

                    newLeafNode(lv_start_0_0, grammarAccess.getFindClauseAccess().getStartFindKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getFindClauseRule());
            	        }
                   		setWithLastConsumed(current, "start", lv_start_0_0, "find(");
            	    

            }


            }

            // InternalDescartesQL.g:3518:2: ( (lv_childName_1_0= RULE_STRING ) )
            // InternalDescartesQL.g:3519:1: (lv_childName_1_0= RULE_STRING )
            {
            // InternalDescartesQL.g:3519:1: (lv_childName_1_0= RULE_STRING )
            // InternalDescartesQL.g:3520:3: lv_childName_1_0= RULE_STRING
            {
            lv_childName_1_0=(Token)match(input,RULE_STRING,FOLLOW_32); 

            			newLeafNode(lv_childName_1_0, grammarAccess.getFindClauseAccess().getChildNameSTRINGTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getFindClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"childName",
                    		lv_childName_1_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }

            // InternalDescartesQL.g:3536:2: ( (lv_end_2_0= ')' ) )
            // InternalDescartesQL.g:3537:1: (lv_end_2_0= ')' )
            {
            // InternalDescartesQL.g:3537:1: (lv_end_2_0= ')' )
            // InternalDescartesQL.g:3538:3: lv_end_2_0= ')'
            {
            lv_end_2_0=(Token)match(input,24,FOLLOW_2); 

                    newLeafNode(lv_end_2_0, grammarAccess.getFindClauseAccess().getEndRightParenthesisKeyword_2_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getFindClauseRule());
            	        }
                   		setWithLastConsumed(current, "end", lv_end_2_0, ")");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFindClause"


    // $ANTLR start "entryRuleForClause"
    // InternalDescartesQL.g:3559:1: entryRuleForClause returns [EObject current=null] : iv_ruleForClause= ruleForClause EOF ;
    public final EObject entryRuleForClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleForClause = null;


        try {
            // InternalDescartesQL.g:3560:2: (iv_ruleForClause= ruleForClause EOF )
            // InternalDescartesQL.g:3561:2: iv_ruleForClause= ruleForClause EOF
            {
             newCompositeNode(grammarAccess.getForClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleForClause=ruleForClause();

            state._fsp--;

             current =iv_ruleForClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleForClause"


    // $ANTLR start "ruleForClause"
    // InternalDescartesQL.g:3568:1: ruleForClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'FOR' ) ) ( (lv_entityReferenceClause_1_0= ruleEntityReferenceClause ) ) ) ;
    public final EObject ruleForClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        EObject lv_entityReferenceClause_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3571:28: ( ( ( (lv_mode_0_0= 'FOR' ) ) ( (lv_entityReferenceClause_1_0= ruleEntityReferenceClause ) ) ) )
            // InternalDescartesQL.g:3572:1: ( ( (lv_mode_0_0= 'FOR' ) ) ( (lv_entityReferenceClause_1_0= ruleEntityReferenceClause ) ) )
            {
            // InternalDescartesQL.g:3572:1: ( ( (lv_mode_0_0= 'FOR' ) ) ( (lv_entityReferenceClause_1_0= ruleEntityReferenceClause ) ) )
            // InternalDescartesQL.g:3572:2: ( (lv_mode_0_0= 'FOR' ) ) ( (lv_entityReferenceClause_1_0= ruleEntityReferenceClause ) )
            {
            // InternalDescartesQL.g:3572:2: ( (lv_mode_0_0= 'FOR' ) )
            // InternalDescartesQL.g:3573:1: (lv_mode_0_0= 'FOR' )
            {
            // InternalDescartesQL.g:3573:1: (lv_mode_0_0= 'FOR' )
            // InternalDescartesQL.g:3574:3: lv_mode_0_0= 'FOR'
            {
            lv_mode_0_0=(Token)match(input,58,FOLLOW_31); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getForClauseAccess().getModeFORKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getForClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "FOR");
            	    

            }


            }

            // InternalDescartesQL.g:3587:2: ( (lv_entityReferenceClause_1_0= ruleEntityReferenceClause ) )
            // InternalDescartesQL.g:3588:1: (lv_entityReferenceClause_1_0= ruleEntityReferenceClause )
            {
            // InternalDescartesQL.g:3588:1: (lv_entityReferenceClause_1_0= ruleEntityReferenceClause )
            // InternalDescartesQL.g:3589:3: lv_entityReferenceClause_1_0= ruleEntityReferenceClause
            {
             
            	        newCompositeNode(grammarAccess.getForClauseAccess().getEntityReferenceClauseEntityReferenceClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_entityReferenceClause_1_0=ruleEntityReferenceClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getForClauseRule());
            	        }
                   		set(
                   			current, 
                   			"entityReferenceClause",
                    		lv_entityReferenceClause_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.EntityReferenceClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleForClause"


    // $ANTLR start "entryRuleEntityReferenceClause"
    // InternalDescartesQL.g:3613:1: entryRuleEntityReferenceClause returns [EObject current=null] : iv_ruleEntityReferenceClause= ruleEntityReferenceClause EOF ;
    public final EObject entryRuleEntityReferenceClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEntityReferenceClause = null;


        try {
            // InternalDescartesQL.g:3614:2: (iv_ruleEntityReferenceClause= ruleEntityReferenceClause EOF )
            // InternalDescartesQL.g:3615:2: iv_ruleEntityReferenceClause= ruleEntityReferenceClause EOF
            {
             newCompositeNode(grammarAccess.getEntityReferenceClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEntityReferenceClause=ruleEntityReferenceClause();

            state._fsp--;

             current =iv_ruleEntityReferenceClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEntityReferenceClause"


    // $ANTLR start "ruleEntityReferenceClause"
    // InternalDescartesQL.g:3622:1: ruleEntityReferenceClause returns [EObject current=null] : ( ( (lv_entityReferences_0_0= ruleEntityReference ) ) (otherlv_1= ',' ( (lv_entityReferences_2_0= ruleEntityReference ) ) )* ) ;
    public final EObject ruleEntityReferenceClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_entityReferences_0_0 = null;

        EObject lv_entityReferences_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3625:28: ( ( ( (lv_entityReferences_0_0= ruleEntityReference ) ) (otherlv_1= ',' ( (lv_entityReferences_2_0= ruleEntityReference ) ) )* ) )
            // InternalDescartesQL.g:3626:1: ( ( (lv_entityReferences_0_0= ruleEntityReference ) ) (otherlv_1= ',' ( (lv_entityReferences_2_0= ruleEntityReference ) ) )* )
            {
            // InternalDescartesQL.g:3626:1: ( ( (lv_entityReferences_0_0= ruleEntityReference ) ) (otherlv_1= ',' ( (lv_entityReferences_2_0= ruleEntityReference ) ) )* )
            // InternalDescartesQL.g:3626:2: ( (lv_entityReferences_0_0= ruleEntityReference ) ) (otherlv_1= ',' ( (lv_entityReferences_2_0= ruleEntityReference ) ) )*
            {
            // InternalDescartesQL.g:3626:2: ( (lv_entityReferences_0_0= ruleEntityReference ) )
            // InternalDescartesQL.g:3627:1: (lv_entityReferences_0_0= ruleEntityReference )
            {
            // InternalDescartesQL.g:3627:1: (lv_entityReferences_0_0= ruleEntityReference )
            // InternalDescartesQL.g:3628:3: lv_entityReferences_0_0= ruleEntityReference
            {
             
            	        newCompositeNode(grammarAccess.getEntityReferenceClauseAccess().getEntityReferencesEntityReferenceParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_12);
            lv_entityReferences_0_0=ruleEntityReference();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getEntityReferenceClauseRule());
            	        }
                   		add(
                   			current, 
                   			"entityReferences",
                    		lv_entityReferences_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.EntityReference");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:3644:2: (otherlv_1= ',' ( (lv_entityReferences_2_0= ruleEntityReference ) ) )*
            loop49:
            do {
                int alt49=2;
                int LA49_0 = input.LA(1);

                if ( (LA49_0==20) ) {
                    alt49=1;
                }


                switch (alt49) {
            	case 1 :
            	    // InternalDescartesQL.g:3644:4: otherlv_1= ',' ( (lv_entityReferences_2_0= ruleEntityReference ) )
            	    {
            	    otherlv_1=(Token)match(input,20,FOLLOW_31); 

            	        	newLeafNode(otherlv_1, grammarAccess.getEntityReferenceClauseAccess().getCommaKeyword_1_0());
            	        
            	    // InternalDescartesQL.g:3648:1: ( (lv_entityReferences_2_0= ruleEntityReference ) )
            	    // InternalDescartesQL.g:3649:1: (lv_entityReferences_2_0= ruleEntityReference )
            	    {
            	    // InternalDescartesQL.g:3649:1: (lv_entityReferences_2_0= ruleEntityReference )
            	    // InternalDescartesQL.g:3650:3: lv_entityReferences_2_0= ruleEntityReference
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getEntityReferenceClauseAccess().getEntityReferencesEntityReferenceParserRuleCall_1_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_12);
            	    lv_entityReferences_2_0=ruleEntityReference();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getEntityReferenceClauseRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"entityReferences",
            	            		lv_entityReferences_2_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.EntityReference");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop49;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEntityReferenceClause"


    // $ANTLR start "entryRuleEntityReference"
    // InternalDescartesQL.g:3674:1: entryRuleEntityReference returns [EObject current=null] : iv_ruleEntityReference= ruleEntityReference EOF ;
    public final EObject entryRuleEntityReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEntityReference = null;


        try {
            // InternalDescartesQL.g:3675:2: (iv_ruleEntityReference= ruleEntityReference EOF )
            // InternalDescartesQL.g:3676:2: iv_ruleEntityReference= ruleEntityReference EOF
            {
             newCompositeNode(grammarAccess.getEntityReferenceRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEntityReference=ruleEntityReference();

            state._fsp--;

             current =iv_ruleEntityReference; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEntityReference"


    // $ANTLR start "ruleEntityReference"
    // InternalDescartesQL.g:3683:1: ruleEntityReference returns [EObject current=null] : ( ( (lv_type_0_0= RULE_ID ) )? ( (lv_identifier_1_0= RULE_STRING ) ) ( (lv_alias_2_0= ruleAliasClause ) )? ) ;
    public final EObject ruleEntityReference() throws RecognitionException {
        EObject current = null;

        Token lv_type_0_0=null;
        Token lv_identifier_1_0=null;
        EObject lv_alias_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3686:28: ( ( ( (lv_type_0_0= RULE_ID ) )? ( (lv_identifier_1_0= RULE_STRING ) ) ( (lv_alias_2_0= ruleAliasClause ) )? ) )
            // InternalDescartesQL.g:3687:1: ( ( (lv_type_0_0= RULE_ID ) )? ( (lv_identifier_1_0= RULE_STRING ) ) ( (lv_alias_2_0= ruleAliasClause ) )? )
            {
            // InternalDescartesQL.g:3687:1: ( ( (lv_type_0_0= RULE_ID ) )? ( (lv_identifier_1_0= RULE_STRING ) ) ( (lv_alias_2_0= ruleAliasClause ) )? )
            // InternalDescartesQL.g:3687:2: ( (lv_type_0_0= RULE_ID ) )? ( (lv_identifier_1_0= RULE_STRING ) ) ( (lv_alias_2_0= ruleAliasClause ) )?
            {
            // InternalDescartesQL.g:3687:2: ( (lv_type_0_0= RULE_ID ) )?
            int alt50=2;
            int LA50_0 = input.LA(1);

            if ( (LA50_0==RULE_ID) ) {
                alt50=1;
            }
            switch (alt50) {
                case 1 :
                    // InternalDescartesQL.g:3688:1: (lv_type_0_0= RULE_ID )
                    {
                    // InternalDescartesQL.g:3688:1: (lv_type_0_0= RULE_ID )
                    // InternalDescartesQL.g:3689:3: lv_type_0_0= RULE_ID
                    {
                    lv_type_0_0=(Token)match(input,RULE_ID,FOLLOW_39); 

                    			newLeafNode(lv_type_0_0, grammarAccess.getEntityReferenceAccess().getTypeIDTerminalRuleCall_0_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getEntityReferenceRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"type",
                            		lv_type_0_0, 
                            		"org.eclipse.xtext.common.Terminals.ID");
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:3705:3: ( (lv_identifier_1_0= RULE_STRING ) )
            // InternalDescartesQL.g:3706:1: (lv_identifier_1_0= RULE_STRING )
            {
            // InternalDescartesQL.g:3706:1: (lv_identifier_1_0= RULE_STRING )
            // InternalDescartesQL.g:3707:3: lv_identifier_1_0= RULE_STRING
            {
            lv_identifier_1_0=(Token)match(input,RULE_STRING,FOLLOW_55); 

            			newLeafNode(lv_identifier_1_0, grammarAccess.getEntityReferenceAccess().getIdentifierSTRINGTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getEntityReferenceRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"identifier",
                    		lv_identifier_1_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }

            // InternalDescartesQL.g:3723:2: ( (lv_alias_2_0= ruleAliasClause ) )?
            int alt51=2;
            int LA51_0 = input.LA(1);

            if ( (LA51_0==59) ) {
                alt51=1;
            }
            switch (alt51) {
                case 1 :
                    // InternalDescartesQL.g:3724:1: (lv_alias_2_0= ruleAliasClause )
                    {
                    // InternalDescartesQL.g:3724:1: (lv_alias_2_0= ruleAliasClause )
                    // InternalDescartesQL.g:3725:3: lv_alias_2_0= ruleAliasClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getEntityReferenceAccess().getAliasAliasClauseParserRuleCall_2_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_alias_2_0=ruleAliasClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getEntityReferenceRule());
                    	        }
                           		set(
                           			current, 
                           			"alias",
                            		lv_alias_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.AliasClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEntityReference"


    // $ANTLR start "entryRuleAliasClause"
    // InternalDescartesQL.g:3749:1: entryRuleAliasClause returns [EObject current=null] : iv_ruleAliasClause= ruleAliasClause EOF ;
    public final EObject entryRuleAliasClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAliasClause = null;


        try {
            // InternalDescartesQL.g:3750:2: (iv_ruleAliasClause= ruleAliasClause EOF )
            // InternalDescartesQL.g:3751:2: iv_ruleAliasClause= ruleAliasClause EOF
            {
             newCompositeNode(grammarAccess.getAliasClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAliasClause=ruleAliasClause();

            state._fsp--;

             current =iv_ruleAliasClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAliasClause"


    // $ANTLR start "ruleAliasClause"
    // InternalDescartesQL.g:3758:1: ruleAliasClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'AS' ) ) ( (lv_alias_1_0= RULE_ID ) ) ) ;
    public final EObject ruleAliasClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        Token lv_alias_1_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3761:28: ( ( ( (lv_mode_0_0= 'AS' ) ) ( (lv_alias_1_0= RULE_ID ) ) ) )
            // InternalDescartesQL.g:3762:1: ( ( (lv_mode_0_0= 'AS' ) ) ( (lv_alias_1_0= RULE_ID ) ) )
            {
            // InternalDescartesQL.g:3762:1: ( ( (lv_mode_0_0= 'AS' ) ) ( (lv_alias_1_0= RULE_ID ) ) )
            // InternalDescartesQL.g:3762:2: ( (lv_mode_0_0= 'AS' ) ) ( (lv_alias_1_0= RULE_ID ) )
            {
            // InternalDescartesQL.g:3762:2: ( (lv_mode_0_0= 'AS' ) )
            // InternalDescartesQL.g:3763:1: (lv_mode_0_0= 'AS' )
            {
            // InternalDescartesQL.g:3763:1: (lv_mode_0_0= 'AS' )
            // InternalDescartesQL.g:3764:3: lv_mode_0_0= 'AS'
            {
            lv_mode_0_0=(Token)match(input,59,FOLLOW_11); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getAliasClauseAccess().getModeASKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getAliasClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "AS");
            	    

            }


            }

            // InternalDescartesQL.g:3777:2: ( (lv_alias_1_0= RULE_ID ) )
            // InternalDescartesQL.g:3778:1: (lv_alias_1_0= RULE_ID )
            {
            // InternalDescartesQL.g:3778:1: (lv_alias_1_0= RULE_ID )
            // InternalDescartesQL.g:3779:3: lv_alias_1_0= RULE_ID
            {
            lv_alias_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            			newLeafNode(lv_alias_1_0, grammarAccess.getAliasClauseAccess().getAliasIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getAliasClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"alias",
                    		lv_alias_1_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAliasClause"


    // $ANTLR start "entryRuleUsingClause"
    // InternalDescartesQL.g:3803:1: entryRuleUsingClause returns [EObject current=null] : iv_ruleUsingClause= ruleUsingClause EOF ;
    public final EObject entryRuleUsingClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleUsingClause = null;


        try {
            // InternalDescartesQL.g:3804:2: (iv_ruleUsingClause= ruleUsingClause EOF )
            // InternalDescartesQL.g:3805:2: iv_ruleUsingClause= ruleUsingClause EOF
            {
             newCompositeNode(grammarAccess.getUsingClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleUsingClause=ruleUsingClause();

            state._fsp--;

             current =iv_ruleUsingClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleUsingClause"


    // $ANTLR start "ruleUsingClause"
    // InternalDescartesQL.g:3812:1: ruleUsingClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'USING' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) ) ) ;
    public final EObject ruleUsingClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        EObject lv_modelReference_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3815:28: ( ( ( (lv_mode_0_0= 'USING' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) ) ) )
            // InternalDescartesQL.g:3816:1: ( ( (lv_mode_0_0= 'USING' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) ) )
            {
            // InternalDescartesQL.g:3816:1: ( ( (lv_mode_0_0= 'USING' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) ) )
            // InternalDescartesQL.g:3816:2: ( (lv_mode_0_0= 'USING' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) )
            {
            // InternalDescartesQL.g:3816:2: ( (lv_mode_0_0= 'USING' ) )
            // InternalDescartesQL.g:3817:1: (lv_mode_0_0= 'USING' )
            {
            // InternalDescartesQL.g:3817:1: (lv_mode_0_0= 'USING' )
            // InternalDescartesQL.g:3818:3: lv_mode_0_0= 'USING'
            {
            lv_mode_0_0=(Token)match(input,60,FOLLOW_11); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getUsingClauseAccess().getModeUSINGKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getUsingClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "USING");
            	    

            }


            }

            // InternalDescartesQL.g:3831:2: ( (lv_modelReference_1_0= ruleModelReferenceClause ) )
            // InternalDescartesQL.g:3832:1: (lv_modelReference_1_0= ruleModelReferenceClause )
            {
            // InternalDescartesQL.g:3832:1: (lv_modelReference_1_0= ruleModelReferenceClause )
            // InternalDescartesQL.g:3833:3: lv_modelReference_1_0= ruleModelReferenceClause
            {
             
            	        newCompositeNode(grammarAccess.getUsingClauseAccess().getModelReferenceModelReferenceClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_modelReference_1_0=ruleModelReferenceClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getUsingClauseRule());
            	        }
                   		set(
                   			current, 
                   			"modelReference",
                    		lv_modelReference_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ModelReferenceClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleUsingClause"


    // $ANTLR start "entryRuleWithClause"
    // InternalDescartesQL.g:3857:1: entryRuleWithClause returns [EObject current=null] : iv_ruleWithClause= ruleWithClause EOF ;
    public final EObject entryRuleWithClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleWithClause = null;


        try {
            // InternalDescartesQL.g:3858:2: (iv_ruleWithClause= ruleWithClause EOF )
            // InternalDescartesQL.g:3859:2: iv_ruleWithClause= ruleWithClause EOF
            {
             newCompositeNode(grammarAccess.getWithClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleWithClause=ruleWithClause();

            state._fsp--;

             current =iv_ruleWithClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleWithClause"


    // $ANTLR start "ruleWithClause"
    // InternalDescartesQL.g:3866:1: ruleWithClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'WITH' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) ) ) ;
    public final EObject ruleWithClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        EObject lv_modelReference_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3869:28: ( ( ( (lv_mode_0_0= 'WITH' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) ) ) )
            // InternalDescartesQL.g:3870:1: ( ( (lv_mode_0_0= 'WITH' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) ) )
            {
            // InternalDescartesQL.g:3870:1: ( ( (lv_mode_0_0= 'WITH' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) ) )
            // InternalDescartesQL.g:3870:2: ( (lv_mode_0_0= 'WITH' ) ) ( (lv_modelReference_1_0= ruleModelReferenceClause ) )
            {
            // InternalDescartesQL.g:3870:2: ( (lv_mode_0_0= 'WITH' ) )
            // InternalDescartesQL.g:3871:1: (lv_mode_0_0= 'WITH' )
            {
            // InternalDescartesQL.g:3871:1: (lv_mode_0_0= 'WITH' )
            // InternalDescartesQL.g:3872:3: lv_mode_0_0= 'WITH'
            {
            lv_mode_0_0=(Token)match(input,61,FOLLOW_11); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getWithClauseAccess().getModeWITHKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getWithClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "WITH");
            	    

            }


            }

            // InternalDescartesQL.g:3885:2: ( (lv_modelReference_1_0= ruleModelReferenceClause ) )
            // InternalDescartesQL.g:3886:1: (lv_modelReference_1_0= ruleModelReferenceClause )
            {
            // InternalDescartesQL.g:3886:1: (lv_modelReference_1_0= ruleModelReferenceClause )
            // InternalDescartesQL.g:3887:3: lv_modelReference_1_0= ruleModelReferenceClause
            {
             
            	        newCompositeNode(grammarAccess.getWithClauseAccess().getModelReferenceModelReferenceClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_modelReference_1_0=ruleModelReferenceClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getWithClauseRule());
            	        }
                   		set(
                   			current, 
                   			"modelReference",
                    		lv_modelReference_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ModelReferenceClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleWithClause"


    // $ANTLR start "entryRuleModelReferenceClause"
    // InternalDescartesQL.g:3911:1: entryRuleModelReferenceClause returns [EObject current=null] : iv_ruleModelReferenceClause= ruleModelReferenceClause EOF ;
    public final EObject entryRuleModelReferenceClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModelReferenceClause = null;


        try {
            // InternalDescartesQL.g:3912:2: (iv_ruleModelReferenceClause= ruleModelReferenceClause EOF )
            // InternalDescartesQL.g:3913:2: iv_ruleModelReferenceClause= ruleModelReferenceClause EOF
            {
             newCompositeNode(grammarAccess.getModelReferenceClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleModelReferenceClause=ruleModelReferenceClause();

            state._fsp--;

             current =iv_ruleModelReferenceClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModelReferenceClause"


    // $ANTLR start "ruleModelReferenceClause"
    // InternalDescartesQL.g:3920:1: ruleModelReferenceClause returns [EObject current=null] : ( ( (lv_family_0_0= ruleModelFamily ) ) otherlv_1= '@' ( (lv_model_2_0= ruleModelLocation ) ) ) ;
    public final EObject ruleModelReferenceClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_family_0_0 = null;

        EObject lv_model_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3923:28: ( ( ( (lv_family_0_0= ruleModelFamily ) ) otherlv_1= '@' ( (lv_model_2_0= ruleModelLocation ) ) ) )
            // InternalDescartesQL.g:3924:1: ( ( (lv_family_0_0= ruleModelFamily ) ) otherlv_1= '@' ( (lv_model_2_0= ruleModelLocation ) ) )
            {
            // InternalDescartesQL.g:3924:1: ( ( (lv_family_0_0= ruleModelFamily ) ) otherlv_1= '@' ( (lv_model_2_0= ruleModelLocation ) ) )
            // InternalDescartesQL.g:3924:2: ( (lv_family_0_0= ruleModelFamily ) ) otherlv_1= '@' ( (lv_model_2_0= ruleModelLocation ) )
            {
            // InternalDescartesQL.g:3924:2: ( (lv_family_0_0= ruleModelFamily ) )
            // InternalDescartesQL.g:3925:1: (lv_family_0_0= ruleModelFamily )
            {
            // InternalDescartesQL.g:3925:1: (lv_family_0_0= ruleModelFamily )
            // InternalDescartesQL.g:3926:3: lv_family_0_0= ruleModelFamily
            {
             
            	        newCompositeNode(grammarAccess.getModelReferenceClauseAccess().getFamilyModelFamilyParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_56);
            lv_family_0_0=ruleModelFamily();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getModelReferenceClauseRule());
            	        }
                   		set(
                   			current, 
                   			"family",
                    		lv_family_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ModelFamily");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_1=(Token)match(input,62,FOLLOW_39); 

                	newLeafNode(otherlv_1, grammarAccess.getModelReferenceClauseAccess().getCommercialAtKeyword_1());
                
            // InternalDescartesQL.g:3946:1: ( (lv_model_2_0= ruleModelLocation ) )
            // InternalDescartesQL.g:3947:1: (lv_model_2_0= ruleModelLocation )
            {
            // InternalDescartesQL.g:3947:1: (lv_model_2_0= ruleModelLocation )
            // InternalDescartesQL.g:3948:3: lv_model_2_0= ruleModelLocation
            {
             
            	        newCompositeNode(grammarAccess.getModelReferenceClauseAccess().getModelModelLocationParserRuleCall_2_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_model_2_0=ruleModelLocation();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getModelReferenceClauseRule());
            	        }
                   		set(
                   			current, 
                   			"model",
                    		lv_model_2_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ModelLocation");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModelReferenceClause"


    // $ANTLR start "entryRuleModelFamily"
    // InternalDescartesQL.g:3972:1: entryRuleModelFamily returns [EObject current=null] : iv_ruleModelFamily= ruleModelFamily EOF ;
    public final EObject entryRuleModelFamily() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModelFamily = null;


        try {
            // InternalDescartesQL.g:3973:2: (iv_ruleModelFamily= ruleModelFamily EOF )
            // InternalDescartesQL.g:3974:2: iv_ruleModelFamily= ruleModelFamily EOF
            {
             newCompositeNode(grammarAccess.getModelFamilyRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleModelFamily=ruleModelFamily();

            state._fsp--;

             current =iv_ruleModelFamily; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModelFamily"


    // $ANTLR start "ruleModelFamily"
    // InternalDescartesQL.g:3981:1: ruleModelFamily returns [EObject current=null] : ( (lv_family_0_0= RULE_ID ) ) ;
    public final EObject ruleModelFamily() throws RecognitionException {
        EObject current = null;

        Token lv_family_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:3984:28: ( ( (lv_family_0_0= RULE_ID ) ) )
            // InternalDescartesQL.g:3985:1: ( (lv_family_0_0= RULE_ID ) )
            {
            // InternalDescartesQL.g:3985:1: ( (lv_family_0_0= RULE_ID ) )
            // InternalDescartesQL.g:3986:1: (lv_family_0_0= RULE_ID )
            {
            // InternalDescartesQL.g:3986:1: (lv_family_0_0= RULE_ID )
            // InternalDescartesQL.g:3987:3: lv_family_0_0= RULE_ID
            {
            lv_family_0_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            			newLeafNode(lv_family_0_0, grammarAccess.getModelFamilyAccess().getFamilyIDTerminalRuleCall_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getModelFamilyRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"family",
                    		lv_family_0_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModelFamily"


    // $ANTLR start "entryRuleModelLocation"
    // InternalDescartesQL.g:4011:1: entryRuleModelLocation returns [EObject current=null] : iv_ruleModelLocation= ruleModelLocation EOF ;
    public final EObject entryRuleModelLocation() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModelLocation = null;


        try {
            // InternalDescartesQL.g:4012:2: (iv_ruleModelLocation= ruleModelLocation EOF )
            // InternalDescartesQL.g:4013:2: iv_ruleModelLocation= ruleModelLocation EOF
            {
             newCompositeNode(grammarAccess.getModelLocationRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleModelLocation=ruleModelLocation();

            state._fsp--;

             current =iv_ruleModelLocation; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModelLocation"


    // $ANTLR start "ruleModelLocation"
    // InternalDescartesQL.g:4020:1: ruleModelLocation returns [EObject current=null] : ( (lv_location_0_0= RULE_STRING ) ) ;
    public final EObject ruleModelLocation() throws RecognitionException {
        EObject current = null;

        Token lv_location_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4023:28: ( ( (lv_location_0_0= RULE_STRING ) ) )
            // InternalDescartesQL.g:4024:1: ( (lv_location_0_0= RULE_STRING ) )
            {
            // InternalDescartesQL.g:4024:1: ( (lv_location_0_0= RULE_STRING ) )
            // InternalDescartesQL.g:4025:1: (lv_location_0_0= RULE_STRING )
            {
            // InternalDescartesQL.g:4025:1: (lv_location_0_0= RULE_STRING )
            // InternalDescartesQL.g:4026:3: lv_location_0_0= RULE_STRING
            {
            lv_location_0_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            			newLeafNode(lv_location_0_0, grammarAccess.getModelLocationAccess().getLocationSTRINGTerminalRuleCall_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getModelLocationRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"location",
                    		lv_location_0_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModelLocation"


    // $ANTLR start "entryRuleFilterClause"
    // InternalDescartesQL.g:4050:1: entryRuleFilterClause returns [EObject current=null] : iv_ruleFilterClause= ruleFilterClause EOF ;
    public final EObject entryRuleFilterClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFilterClause = null;


        try {
            // InternalDescartesQL.g:4051:2: (iv_ruleFilterClause= ruleFilterClause EOF )
            // InternalDescartesQL.g:4052:2: iv_ruleFilterClause= ruleFilterClause EOF
            {
             newCompositeNode(grammarAccess.getFilterClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFilterClause=ruleFilterClause();

            state._fsp--;

             current =iv_ruleFilterClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFilterClause"


    // $ANTLR start "ruleFilterClause"
    // InternalDescartesQL.g:4059:1: ruleFilterClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'FILTERED BY' ) ) ( (lv_filterConditions_1_0= ruleFilterConditionClause ) ) ( ( (lv_filterConjunctions_2_0= ruleFilterConjunction ) ) ( (lv_filterConditions_3_0= ruleFilterConditionClause ) ) )* ) ;
    public final EObject ruleFilterClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        EObject lv_filterConditions_1_0 = null;

        Enumerator lv_filterConjunctions_2_0 = null;

        EObject lv_filterConditions_3_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4062:28: ( ( ( (lv_mode_0_0= 'FILTERED BY' ) ) ( (lv_filterConditions_1_0= ruleFilterConditionClause ) ) ( ( (lv_filterConjunctions_2_0= ruleFilterConjunction ) ) ( (lv_filterConditions_3_0= ruleFilterConditionClause ) ) )* ) )
            // InternalDescartesQL.g:4063:1: ( ( (lv_mode_0_0= 'FILTERED BY' ) ) ( (lv_filterConditions_1_0= ruleFilterConditionClause ) ) ( ( (lv_filterConjunctions_2_0= ruleFilterConjunction ) ) ( (lv_filterConditions_3_0= ruleFilterConditionClause ) ) )* )
            {
            // InternalDescartesQL.g:4063:1: ( ( (lv_mode_0_0= 'FILTERED BY' ) ) ( (lv_filterConditions_1_0= ruleFilterConditionClause ) ) ( ( (lv_filterConjunctions_2_0= ruleFilterConjunction ) ) ( (lv_filterConditions_3_0= ruleFilterConditionClause ) ) )* )
            // InternalDescartesQL.g:4063:2: ( (lv_mode_0_0= 'FILTERED BY' ) ) ( (lv_filterConditions_1_0= ruleFilterConditionClause ) ) ( ( (lv_filterConjunctions_2_0= ruleFilterConjunction ) ) ( (lv_filterConditions_3_0= ruleFilterConditionClause ) ) )*
            {
            // InternalDescartesQL.g:4063:2: ( (lv_mode_0_0= 'FILTERED BY' ) )
            // InternalDescartesQL.g:4064:1: (lv_mode_0_0= 'FILTERED BY' )
            {
            // InternalDescartesQL.g:4064:1: (lv_mode_0_0= 'FILTERED BY' )
            // InternalDescartesQL.g:4065:3: lv_mode_0_0= 'FILTERED BY'
            {
            lv_mode_0_0=(Token)match(input,63,FOLLOW_57); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getFilterClauseAccess().getModeFILTEREDBYKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getFilterClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "FILTERED BY");
            	    

            }


            }

            // InternalDescartesQL.g:4078:2: ( (lv_filterConditions_1_0= ruleFilterConditionClause ) )
            // InternalDescartesQL.g:4079:1: (lv_filterConditions_1_0= ruleFilterConditionClause )
            {
            // InternalDescartesQL.g:4079:1: (lv_filterConditions_1_0= ruleFilterConditionClause )
            // InternalDescartesQL.g:4080:3: lv_filterConditions_1_0= ruleFilterConditionClause
            {
             
            	        newCompositeNode(grammarAccess.getFilterClauseAccess().getFilterConditionsFilterConditionClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_58);
            lv_filterConditions_1_0=ruleFilterConditionClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getFilterClauseRule());
            	        }
                   		add(
                   			current, 
                   			"filterConditions",
                    		lv_filterConditions_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.FilterConditionClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:4096:2: ( ( (lv_filterConjunctions_2_0= ruleFilterConjunction ) ) ( (lv_filterConditions_3_0= ruleFilterConditionClause ) ) )*
            loop52:
            do {
                int alt52=2;
                int LA52_0 = input.LA(1);

                if ( (LA52_0==68||(LA52_0>=81 && LA52_0<=82)) ) {
                    alt52=1;
                }


                switch (alt52) {
            	case 1 :
            	    // InternalDescartesQL.g:4096:3: ( (lv_filterConjunctions_2_0= ruleFilterConjunction ) ) ( (lv_filterConditions_3_0= ruleFilterConditionClause ) )
            	    {
            	    // InternalDescartesQL.g:4096:3: ( (lv_filterConjunctions_2_0= ruleFilterConjunction ) )
            	    // InternalDescartesQL.g:4097:1: (lv_filterConjunctions_2_0= ruleFilterConjunction )
            	    {
            	    // InternalDescartesQL.g:4097:1: (lv_filterConjunctions_2_0= ruleFilterConjunction )
            	    // InternalDescartesQL.g:4098:3: lv_filterConjunctions_2_0= ruleFilterConjunction
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getFilterClauseAccess().getFilterConjunctionsFilterConjunctionEnumRuleCall_2_0_0()); 
            	    	    
            	    pushFollow(FOLLOW_57);
            	    lv_filterConjunctions_2_0=ruleFilterConjunction();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getFilterClauseRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"filterConjunctions",
            	            		lv_filterConjunctions_2_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.FilterConjunction");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }

            	    // InternalDescartesQL.g:4114:2: ( (lv_filterConditions_3_0= ruleFilterConditionClause ) )
            	    // InternalDescartesQL.g:4115:1: (lv_filterConditions_3_0= ruleFilterConditionClause )
            	    {
            	    // InternalDescartesQL.g:4115:1: (lv_filterConditions_3_0= ruleFilterConditionClause )
            	    // InternalDescartesQL.g:4116:3: lv_filterConditions_3_0= ruleFilterConditionClause
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getFilterClauseAccess().getFilterConditionsFilterConditionClauseParserRuleCall_2_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_58);
            	    lv_filterConditions_3_0=ruleFilterConditionClause();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getFilterClauseRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"filterConditions",
            	            		lv_filterConditions_3_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.FilterConditionClause");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop52;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFilterClause"


    // $ANTLR start "entryRuleFilterConditionClause"
    // InternalDescartesQL.g:4140:1: entryRuleFilterConditionClause returns [EObject current=null] : iv_ruleFilterConditionClause= ruleFilterConditionClause EOF ;
    public final EObject entryRuleFilterConditionClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFilterConditionClause = null;


        try {
            // InternalDescartesQL.g:4141:2: (iv_ruleFilterConditionClause= ruleFilterConditionClause EOF )
            // InternalDescartesQL.g:4142:2: iv_ruleFilterConditionClause= ruleFilterConditionClause EOF
            {
             newCompositeNode(grammarAccess.getFilterConditionClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFilterConditionClause=ruleFilterConditionClause();

            state._fsp--;

             current =iv_ruleFilterConditionClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFilterConditionClause"


    // $ANTLR start "ruleFilterConditionClause"
    // InternalDescartesQL.g:4149:1: ruleFilterConditionClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'CONDITION' ) ) otherlv_1= '(' ( (lv_condition_2_0= ruleFilterConditionType ) ) otherlv_3= ',' ( (lv_value_4_0= ruleFilterConditionValue ) ) otherlv_5= ')' ) ;
    public final EObject ruleFilterConditionClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Enumerator lv_condition_2_0 = null;

        EObject lv_value_4_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4152:28: ( ( ( (lv_mode_0_0= 'CONDITION' ) ) otherlv_1= '(' ( (lv_condition_2_0= ruleFilterConditionType ) ) otherlv_3= ',' ( (lv_value_4_0= ruleFilterConditionValue ) ) otherlv_5= ')' ) )
            // InternalDescartesQL.g:4153:1: ( ( (lv_mode_0_0= 'CONDITION' ) ) otherlv_1= '(' ( (lv_condition_2_0= ruleFilterConditionType ) ) otherlv_3= ',' ( (lv_value_4_0= ruleFilterConditionValue ) ) otherlv_5= ')' )
            {
            // InternalDescartesQL.g:4153:1: ( ( (lv_mode_0_0= 'CONDITION' ) ) otherlv_1= '(' ( (lv_condition_2_0= ruleFilterConditionType ) ) otherlv_3= ',' ( (lv_value_4_0= ruleFilterConditionValue ) ) otherlv_5= ')' )
            // InternalDescartesQL.g:4153:2: ( (lv_mode_0_0= 'CONDITION' ) ) otherlv_1= '(' ( (lv_condition_2_0= ruleFilterConditionType ) ) otherlv_3= ',' ( (lv_value_4_0= ruleFilterConditionValue ) ) otherlv_5= ')'
            {
            // InternalDescartesQL.g:4153:2: ( (lv_mode_0_0= 'CONDITION' ) )
            // InternalDescartesQL.g:4154:1: (lv_mode_0_0= 'CONDITION' )
            {
            // InternalDescartesQL.g:4154:1: (lv_mode_0_0= 'CONDITION' )
            // InternalDescartesQL.g:4155:3: lv_mode_0_0= 'CONDITION'
            {
            lv_mode_0_0=(Token)match(input,64,FOLLOW_14); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getFilterConditionClauseAccess().getModeCONDITIONKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getFilterConditionClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "CONDITION");
            	    

            }


            }

            otherlv_1=(Token)match(input,23,FOLLOW_59); 

                	newLeafNode(otherlv_1, grammarAccess.getFilterConditionClauseAccess().getLeftParenthesisKeyword_1());
                
            // InternalDescartesQL.g:4172:1: ( (lv_condition_2_0= ruleFilterConditionType ) )
            // InternalDescartesQL.g:4173:1: (lv_condition_2_0= ruleFilterConditionType )
            {
            // InternalDescartesQL.g:4173:1: (lv_condition_2_0= ruleFilterConditionType )
            // InternalDescartesQL.g:4174:3: lv_condition_2_0= ruleFilterConditionType
            {
             
            	        newCompositeNode(grammarAccess.getFilterConditionClauseAccess().getConditionFilterConditionTypeEnumRuleCall_2_0()); 
            	    
            pushFollow(FOLLOW_60);
            lv_condition_2_0=ruleFilterConditionType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getFilterConditionClauseRule());
            	        }
                   		set(
                   			current, 
                   			"condition",
                    		lv_condition_2_0, 
                    		"tools.descartes.dql.lang.DescartesQL.FilterConditionType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_3=(Token)match(input,20,FOLLOW_39); 

                	newLeafNode(otherlv_3, grammarAccess.getFilterConditionClauseAccess().getCommaKeyword_3());
                
            // InternalDescartesQL.g:4194:1: ( (lv_value_4_0= ruleFilterConditionValue ) )
            // InternalDescartesQL.g:4195:1: (lv_value_4_0= ruleFilterConditionValue )
            {
            // InternalDescartesQL.g:4195:1: (lv_value_4_0= ruleFilterConditionValue )
            // InternalDescartesQL.g:4196:3: lv_value_4_0= ruleFilterConditionValue
            {
             
            	        newCompositeNode(grammarAccess.getFilterConditionClauseAccess().getValueFilterConditionValueParserRuleCall_4_0()); 
            	    
            pushFollow(FOLLOW_32);
            lv_value_4_0=ruleFilterConditionValue();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getFilterConditionClauseRule());
            	        }
                   		set(
                   			current, 
                   			"value",
                    		lv_value_4_0, 
                    		"tools.descartes.dql.lang.DescartesQL.FilterConditionValue");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_5=(Token)match(input,24,FOLLOW_2); 

                	newLeafNode(otherlv_5, grammarAccess.getFilterConditionClauseAccess().getRightParenthesisKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFilterConditionClause"


    // $ANTLR start "entryRuleFilterConditionValue"
    // InternalDescartesQL.g:4224:1: entryRuleFilterConditionValue returns [EObject current=null] : iv_ruleFilterConditionValue= ruleFilterConditionValue EOF ;
    public final EObject entryRuleFilterConditionValue() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFilterConditionValue = null;


        try {
            // InternalDescartesQL.g:4225:2: (iv_ruleFilterConditionValue= ruleFilterConditionValue EOF )
            // InternalDescartesQL.g:4226:2: iv_ruleFilterConditionValue= ruleFilterConditionValue EOF
            {
             newCompositeNode(grammarAccess.getFilterConditionValueRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFilterConditionValue=ruleFilterConditionValue();

            state._fsp--;

             current =iv_ruleFilterConditionValue; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFilterConditionValue"


    // $ANTLR start "ruleFilterConditionValue"
    // InternalDescartesQL.g:4233:1: ruleFilterConditionValue returns [EObject current=null] : ( (lv_value_0_0= RULE_STRING ) ) ;
    public final EObject ruleFilterConditionValue() throws RecognitionException {
        EObject current = null;

        Token lv_value_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4236:28: ( ( (lv_value_0_0= RULE_STRING ) ) )
            // InternalDescartesQL.g:4237:1: ( (lv_value_0_0= RULE_STRING ) )
            {
            // InternalDescartesQL.g:4237:1: ( (lv_value_0_0= RULE_STRING ) )
            // InternalDescartesQL.g:4238:1: (lv_value_0_0= RULE_STRING )
            {
            // InternalDescartesQL.g:4238:1: (lv_value_0_0= RULE_STRING )
            // InternalDescartesQL.g:4239:3: lv_value_0_0= RULE_STRING
            {
            lv_value_0_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            			newLeafNode(lv_value_0_0, grammarAccess.getFilterConditionValueAccess().getValueSTRINGTerminalRuleCall_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getFilterConditionValueRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"value",
                    		lv_value_0_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFilterConditionValue"


    // $ANTLR start "entryRuleObserveClause"
    // InternalDescartesQL.g:4263:1: entryRuleObserveClause returns [EObject current=null] : iv_ruleObserveClause= ruleObserveClause EOF ;
    public final EObject entryRuleObserveClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleObserveClause = null;


        try {
            // InternalDescartesQL.g:4264:2: (iv_ruleObserveClause= ruleObserveClause EOF )
            // InternalDescartesQL.g:4265:2: iv_ruleObserveClause= ruleObserveClause EOF
            {
             newCompositeNode(grammarAccess.getObserveClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleObserveClause=ruleObserveClause();

            state._fsp--;

             current =iv_ruleObserveClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleObserveClause"


    // $ANTLR start "ruleObserveClause"
    // InternalDescartesQL.g:4272:1: ruleObserveClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'OBSERVE' ) ) ( (lv_observation_1_0= ruleObservationClause ) ) ( (lv_sampleClause_2_0= ruleSampleClause ) )? ) ;
    public final EObject ruleObserveClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        EObject lv_observation_1_0 = null;

        EObject lv_sampleClause_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4275:28: ( ( ( (lv_mode_0_0= 'OBSERVE' ) ) ( (lv_observation_1_0= ruleObservationClause ) ) ( (lv_sampleClause_2_0= ruleSampleClause ) )? ) )
            // InternalDescartesQL.g:4276:1: ( ( (lv_mode_0_0= 'OBSERVE' ) ) ( (lv_observation_1_0= ruleObservationClause ) ) ( (lv_sampleClause_2_0= ruleSampleClause ) )? )
            {
            // InternalDescartesQL.g:4276:1: ( ( (lv_mode_0_0= 'OBSERVE' ) ) ( (lv_observation_1_0= ruleObservationClause ) ) ( (lv_sampleClause_2_0= ruleSampleClause ) )? )
            // InternalDescartesQL.g:4276:2: ( (lv_mode_0_0= 'OBSERVE' ) ) ( (lv_observation_1_0= ruleObservationClause ) ) ( (lv_sampleClause_2_0= ruleSampleClause ) )?
            {
            // InternalDescartesQL.g:4276:2: ( (lv_mode_0_0= 'OBSERVE' ) )
            // InternalDescartesQL.g:4277:1: (lv_mode_0_0= 'OBSERVE' )
            {
            // InternalDescartesQL.g:4277:1: (lv_mode_0_0= 'OBSERVE' )
            // InternalDescartesQL.g:4278:3: lv_mode_0_0= 'OBSERVE'
            {
            lv_mode_0_0=(Token)match(input,65,FOLLOW_61); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getObserveClauseAccess().getModeOBSERVEKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getObserveClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "OBSERVE");
            	    

            }


            }

            // InternalDescartesQL.g:4291:2: ( (lv_observation_1_0= ruleObservationClause ) )
            // InternalDescartesQL.g:4292:1: (lv_observation_1_0= ruleObservationClause )
            {
            // InternalDescartesQL.g:4292:1: (lv_observation_1_0= ruleObservationClause )
            // InternalDescartesQL.g:4293:3: lv_observation_1_0= ruleObservationClause
            {
             
            	        newCompositeNode(grammarAccess.getObserveClauseAccess().getObservationObservationClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_62);
            lv_observation_1_0=ruleObservationClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getObserveClauseRule());
            	        }
                   		set(
                   			current, 
                   			"observation",
                    		lv_observation_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ObservationClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:4309:2: ( (lv_sampleClause_2_0= ruleSampleClause ) )?
            int alt53=2;
            int LA53_0 = input.LA(1);

            if ( (LA53_0==66) ) {
                alt53=1;
            }
            switch (alt53) {
                case 1 :
                    // InternalDescartesQL.g:4310:1: (lv_sampleClause_2_0= ruleSampleClause )
                    {
                    // InternalDescartesQL.g:4310:1: (lv_sampleClause_2_0= ruleSampleClause )
                    // InternalDescartesQL.g:4311:3: lv_sampleClause_2_0= ruleSampleClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getObserveClauseAccess().getSampleClauseSampleClauseParserRuleCall_2_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_sampleClause_2_0=ruleSampleClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getObserveClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"sampleClause",
                            		lv_sampleClause_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.SampleClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleObserveClause"


    // $ANTLR start "entryRuleObservationClause"
    // InternalDescartesQL.g:4335:1: entryRuleObservationClause returns [EObject current=null] : iv_ruleObservationClause= ruleObservationClause EOF ;
    public final EObject entryRuleObservationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleObservationClause = null;


        try {
            // InternalDescartesQL.g:4336:2: (iv_ruleObservationClause= ruleObservationClause EOF )
            // InternalDescartesQL.g:4337:2: iv_ruleObservationClause= ruleObservationClause EOF
            {
             newCompositeNode(grammarAccess.getObservationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleObservationClause=ruleObservationClause();

            state._fsp--;

             current =iv_ruleObservationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleObservationClause"


    // $ANTLR start "ruleObservationClause"
    // InternalDescartesQL.g:4344:1: ruleObservationClause returns [EObject current=null] : (this_ConnectorTimeUnitClause_0= ruleConnectorTimeUnitClause | this_ConnectorInstanceReferenceClause_1= ruleConnectorInstanceReferenceClause | this_ObserveRelativeClause_2= ruleObserveRelativeClause | this_ObserveBetweenClause_3= ruleObserveBetweenClause ) ;
    public final EObject ruleObservationClause() throws RecognitionException {
        EObject current = null;

        EObject this_ConnectorTimeUnitClause_0 = null;

        EObject this_ConnectorInstanceReferenceClause_1 = null;

        EObject this_ObserveRelativeClause_2 = null;

        EObject this_ObserveBetweenClause_3 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4347:28: ( (this_ConnectorTimeUnitClause_0= ruleConnectorTimeUnitClause | this_ConnectorInstanceReferenceClause_1= ruleConnectorInstanceReferenceClause | this_ObserveRelativeClause_2= ruleObserveRelativeClause | this_ObserveBetweenClause_3= ruleObserveBetweenClause ) )
            // InternalDescartesQL.g:4348:1: (this_ConnectorTimeUnitClause_0= ruleConnectorTimeUnitClause | this_ConnectorInstanceReferenceClause_1= ruleConnectorInstanceReferenceClause | this_ObserveRelativeClause_2= ruleObserveRelativeClause | this_ObserveBetweenClause_3= ruleObserveBetweenClause )
            {
            // InternalDescartesQL.g:4348:1: (this_ConnectorTimeUnitClause_0= ruleConnectorTimeUnitClause | this_ConnectorInstanceReferenceClause_1= ruleConnectorInstanceReferenceClause | this_ObserveRelativeClause_2= ruleObserveRelativeClause | this_ObserveBetweenClause_3= ruleObserveBetweenClause )
            int alt54=4;
            switch ( input.LA(1) ) {
            case RULE_INT:
                {
                alt54=1;
                }
                break;
            case RULE_ID:
                {
                alt54=2;
                }
                break;
            case 85:
            case 86:
                {
                alt54=3;
                }
                break;
            case 67:
                {
                alt54=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 54, 0, input);

                throw nvae;
            }

            switch (alt54) {
                case 1 :
                    // InternalDescartesQL.g:4349:5: this_ConnectorTimeUnitClause_0= ruleConnectorTimeUnitClause
                    {
                     
                            newCompositeNode(grammarAccess.getObservationClauseAccess().getConnectorTimeUnitClauseParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_2);
                    this_ConnectorTimeUnitClause_0=ruleConnectorTimeUnitClause();

                    state._fsp--;

                     
                            current = this_ConnectorTimeUnitClause_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:4359:5: this_ConnectorInstanceReferenceClause_1= ruleConnectorInstanceReferenceClause
                    {
                     
                            newCompositeNode(grammarAccess.getObservationClauseAccess().getConnectorInstanceReferenceClauseParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_2);
                    this_ConnectorInstanceReferenceClause_1=ruleConnectorInstanceReferenceClause();

                    state._fsp--;

                     
                            current = this_ConnectorInstanceReferenceClause_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:4369:5: this_ObserveRelativeClause_2= ruleObserveRelativeClause
                    {
                     
                            newCompositeNode(grammarAccess.getObservationClauseAccess().getObserveRelativeClauseParserRuleCall_2()); 
                        
                    pushFollow(FOLLOW_2);
                    this_ObserveRelativeClause_2=ruleObserveRelativeClause();

                    state._fsp--;

                     
                            current = this_ObserveRelativeClause_2; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 4 :
                    // InternalDescartesQL.g:4379:5: this_ObserveBetweenClause_3= ruleObserveBetweenClause
                    {
                     
                            newCompositeNode(grammarAccess.getObservationClauseAccess().getObserveBetweenClauseParserRuleCall_3()); 
                        
                    pushFollow(FOLLOW_2);
                    this_ObserveBetweenClause_3=ruleObserveBetweenClause();

                    state._fsp--;

                     
                            current = this_ObserveBetweenClause_3; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleObservationClause"


    // $ANTLR start "entryRuleSampleClause"
    // InternalDescartesQL.g:4395:1: entryRuleSampleClause returns [EObject current=null] : iv_ruleSampleClause= ruleSampleClause EOF ;
    public final EObject entryRuleSampleClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSampleClause = null;


        try {
            // InternalDescartesQL.g:4396:2: (iv_ruleSampleClause= ruleSampleClause EOF )
            // InternalDescartesQL.g:4397:2: iv_ruleSampleClause= ruleSampleClause EOF
            {
             newCompositeNode(grammarAccess.getSampleClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSampleClause=ruleSampleClause();

            state._fsp--;

             current =iv_ruleSampleClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSampleClause"


    // $ANTLR start "ruleSampleClause"
    // InternalDescartesQL.g:4404:1: ruleSampleClause returns [EObject current=null] : ( ( (lv_mode_0_0= 'SAMPLED BY' ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_2_0= ruleRelativeTimeDurationClause ) )* ) ;
    public final EObject ruleSampleClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_0=null;
        EObject lv_durationClause_1_0 = null;

        EObject lv_durationClause_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4407:28: ( ( ( (lv_mode_0_0= 'SAMPLED BY' ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_2_0= ruleRelativeTimeDurationClause ) )* ) )
            // InternalDescartesQL.g:4408:1: ( ( (lv_mode_0_0= 'SAMPLED BY' ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_2_0= ruleRelativeTimeDurationClause ) )* )
            {
            // InternalDescartesQL.g:4408:1: ( ( (lv_mode_0_0= 'SAMPLED BY' ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_2_0= ruleRelativeTimeDurationClause ) )* )
            // InternalDescartesQL.g:4408:2: ( (lv_mode_0_0= 'SAMPLED BY' ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_2_0= ruleRelativeTimeDurationClause ) )*
            {
            // InternalDescartesQL.g:4408:2: ( (lv_mode_0_0= 'SAMPLED BY' ) )
            // InternalDescartesQL.g:4409:1: (lv_mode_0_0= 'SAMPLED BY' )
            {
            // InternalDescartesQL.g:4409:1: (lv_mode_0_0= 'SAMPLED BY' )
            // InternalDescartesQL.g:4410:3: lv_mode_0_0= 'SAMPLED BY'
            {
            lv_mode_0_0=(Token)match(input,66,FOLLOW_24); 

                    newLeafNode(lv_mode_0_0, grammarAccess.getSampleClauseAccess().getModeSAMPLEDBYKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getSampleClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode", lv_mode_0_0, "SAMPLED BY");
            	    

            }


            }

            // InternalDescartesQL.g:4423:2: ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) )
            // InternalDescartesQL.g:4424:1: (lv_durationClause_1_0= ruleRelativeTimeDurationClause )
            {
            // InternalDescartesQL.g:4424:1: (lv_durationClause_1_0= ruleRelativeTimeDurationClause )
            // InternalDescartesQL.g:4425:3: lv_durationClause_1_0= ruleRelativeTimeDurationClause
            {
             
            	        newCompositeNode(grammarAccess.getSampleClauseAccess().getDurationClauseRelativeTimeDurationClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_63);
            lv_durationClause_1_0=ruleRelativeTimeDurationClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSampleClauseRule());
            	        }
                   		add(
                   			current, 
                   			"durationClause",
                    		lv_durationClause_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.RelativeTimeDurationClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:4441:2: ( (lv_durationClause_2_0= ruleRelativeTimeDurationClause ) )*
            loop55:
            do {
                int alt55=2;
                int LA55_0 = input.LA(1);

                if ( (LA55_0==RULE_INT) ) {
                    alt55=1;
                }


                switch (alt55) {
            	case 1 :
            	    // InternalDescartesQL.g:4442:1: (lv_durationClause_2_0= ruleRelativeTimeDurationClause )
            	    {
            	    // InternalDescartesQL.g:4442:1: (lv_durationClause_2_0= ruleRelativeTimeDurationClause )
            	    // InternalDescartesQL.g:4443:3: lv_durationClause_2_0= ruleRelativeTimeDurationClause
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSampleClauseAccess().getDurationClauseRelativeTimeDurationClauseParserRuleCall_2_0()); 
            	    	    
            	    pushFollow(FOLLOW_63);
            	    lv_durationClause_2_0=ruleRelativeTimeDurationClause();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSampleClauseRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"durationClause",
            	            		lv_durationClause_2_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.RelativeTimeDurationClause");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop55;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSampleClause"


    // $ANTLR start "entryRuleConnectorTimeUnitClause"
    // InternalDescartesQL.g:4467:1: entryRuleConnectorTimeUnitClause returns [EObject current=null] : iv_ruleConnectorTimeUnitClause= ruleConnectorTimeUnitClause EOF ;
    public final EObject entryRuleConnectorTimeUnitClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConnectorTimeUnitClause = null;


        try {
            // InternalDescartesQL.g:4468:2: (iv_ruleConnectorTimeUnitClause= ruleConnectorTimeUnitClause EOF )
            // InternalDescartesQL.g:4469:2: iv_ruleConnectorTimeUnitClause= ruleConnectorTimeUnitClause EOF
            {
             newCompositeNode(grammarAccess.getConnectorTimeUnitClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleConnectorTimeUnitClause=ruleConnectorTimeUnitClause();

            state._fsp--;

             current =iv_ruleConnectorTimeUnitClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConnectorTimeUnitClause"


    // $ANTLR start "ruleConnectorTimeUnitClause"
    // InternalDescartesQL.g:4476:1: ruleConnectorTimeUnitClause returns [EObject current=null] : ( ( (lv_count_0_0= RULE_INT ) ) ( (lv_timeIndicator_1_0= RULE_ID ) ) ) ;
    public final EObject ruleConnectorTimeUnitClause() throws RecognitionException {
        EObject current = null;

        Token lv_count_0_0=null;
        Token lv_timeIndicator_1_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4479:28: ( ( ( (lv_count_0_0= RULE_INT ) ) ( (lv_timeIndicator_1_0= RULE_ID ) ) ) )
            // InternalDescartesQL.g:4480:1: ( ( (lv_count_0_0= RULE_INT ) ) ( (lv_timeIndicator_1_0= RULE_ID ) ) )
            {
            // InternalDescartesQL.g:4480:1: ( ( (lv_count_0_0= RULE_INT ) ) ( (lv_timeIndicator_1_0= RULE_ID ) ) )
            // InternalDescartesQL.g:4480:2: ( (lv_count_0_0= RULE_INT ) ) ( (lv_timeIndicator_1_0= RULE_ID ) )
            {
            // InternalDescartesQL.g:4480:2: ( (lv_count_0_0= RULE_INT ) )
            // InternalDescartesQL.g:4481:1: (lv_count_0_0= RULE_INT )
            {
            // InternalDescartesQL.g:4481:1: (lv_count_0_0= RULE_INT )
            // InternalDescartesQL.g:4482:3: lv_count_0_0= RULE_INT
            {
            lv_count_0_0=(Token)match(input,RULE_INT,FOLLOW_11); 

            			newLeafNode(lv_count_0_0, grammarAccess.getConnectorTimeUnitClauseAccess().getCountINTTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConnectorTimeUnitClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"count",
                    		lv_count_0_0, 
                    		"org.eclipse.xtext.common.Terminals.INT");
            	    

            }


            }

            // InternalDescartesQL.g:4498:2: ( (lv_timeIndicator_1_0= RULE_ID ) )
            // InternalDescartesQL.g:4499:1: (lv_timeIndicator_1_0= RULE_ID )
            {
            // InternalDescartesQL.g:4499:1: (lv_timeIndicator_1_0= RULE_ID )
            // InternalDescartesQL.g:4500:3: lv_timeIndicator_1_0= RULE_ID
            {
            lv_timeIndicator_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            			newLeafNode(lv_timeIndicator_1_0, grammarAccess.getConnectorTimeUnitClauseAccess().getTimeIndicatorIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConnectorTimeUnitClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"timeIndicator",
                    		lv_timeIndicator_1_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConnectorTimeUnitClause"


    // $ANTLR start "entryRuleConnectorInstanceReferenceClause"
    // InternalDescartesQL.g:4524:1: entryRuleConnectorInstanceReferenceClause returns [EObject current=null] : iv_ruleConnectorInstanceReferenceClause= ruleConnectorInstanceReferenceClause EOF ;
    public final EObject entryRuleConnectorInstanceReferenceClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConnectorInstanceReferenceClause = null;


        try {
            // InternalDescartesQL.g:4525:2: (iv_ruleConnectorInstanceReferenceClause= ruleConnectorInstanceReferenceClause EOF )
            // InternalDescartesQL.g:4526:2: iv_ruleConnectorInstanceReferenceClause= ruleConnectorInstanceReferenceClause EOF
            {
             newCompositeNode(grammarAccess.getConnectorInstanceReferenceClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleConnectorInstanceReferenceClause=ruleConnectorInstanceReferenceClause();

            state._fsp--;

             current =iv_ruleConnectorInstanceReferenceClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConnectorInstanceReferenceClause"


    // $ANTLR start "ruleConnectorInstanceReferenceClause"
    // InternalDescartesQL.g:4533:1: ruleConnectorInstanceReferenceClause returns [EObject current=null] : ( ( (lv_type_0_0= RULE_ID ) ) ( (lv_identifier_1_0= RULE_STRING ) ) ) ;
    public final EObject ruleConnectorInstanceReferenceClause() throws RecognitionException {
        EObject current = null;

        Token lv_type_0_0=null;
        Token lv_identifier_1_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4536:28: ( ( ( (lv_type_0_0= RULE_ID ) ) ( (lv_identifier_1_0= RULE_STRING ) ) ) )
            // InternalDescartesQL.g:4537:1: ( ( (lv_type_0_0= RULE_ID ) ) ( (lv_identifier_1_0= RULE_STRING ) ) )
            {
            // InternalDescartesQL.g:4537:1: ( ( (lv_type_0_0= RULE_ID ) ) ( (lv_identifier_1_0= RULE_STRING ) ) )
            // InternalDescartesQL.g:4537:2: ( (lv_type_0_0= RULE_ID ) ) ( (lv_identifier_1_0= RULE_STRING ) )
            {
            // InternalDescartesQL.g:4537:2: ( (lv_type_0_0= RULE_ID ) )
            // InternalDescartesQL.g:4538:1: (lv_type_0_0= RULE_ID )
            {
            // InternalDescartesQL.g:4538:1: (lv_type_0_0= RULE_ID )
            // InternalDescartesQL.g:4539:3: lv_type_0_0= RULE_ID
            {
            lv_type_0_0=(Token)match(input,RULE_ID,FOLLOW_39); 

            			newLeafNode(lv_type_0_0, grammarAccess.getConnectorInstanceReferenceClauseAccess().getTypeIDTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConnectorInstanceReferenceClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"type",
                    		lv_type_0_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }

            // InternalDescartesQL.g:4555:2: ( (lv_identifier_1_0= RULE_STRING ) )
            // InternalDescartesQL.g:4556:1: (lv_identifier_1_0= RULE_STRING )
            {
            // InternalDescartesQL.g:4556:1: (lv_identifier_1_0= RULE_STRING )
            // InternalDescartesQL.g:4557:3: lv_identifier_1_0= RULE_STRING
            {
            lv_identifier_1_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            			newLeafNode(lv_identifier_1_0, grammarAccess.getConnectorInstanceReferenceClauseAccess().getIdentifierSTRINGTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConnectorInstanceReferenceClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"identifier",
                    		lv_identifier_1_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConnectorInstanceReferenceClause"


    // $ANTLR start "entryRuleObserveRelativeClause"
    // InternalDescartesQL.g:4581:1: entryRuleObserveRelativeClause returns [EObject current=null] : iv_ruleObserveRelativeClause= ruleObserveRelativeClause EOF ;
    public final EObject entryRuleObserveRelativeClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleObserveRelativeClause = null;


        try {
            // InternalDescartesQL.g:4582:2: (iv_ruleObserveRelativeClause= ruleObserveRelativeClause EOF )
            // InternalDescartesQL.g:4583:2: iv_ruleObserveRelativeClause= ruleObserveRelativeClause EOF
            {
             newCompositeNode(grammarAccess.getObserveRelativeClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleObserveRelativeClause=ruleObserveRelativeClause();

            state._fsp--;

             current =iv_ruleObserveRelativeClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleObserveRelativeClause"


    // $ANTLR start "ruleObserveRelativeClause"
    // InternalDescartesQL.g:4590:1: ruleObserveRelativeClause returns [EObject current=null] : ( ( (lv_direction_0_0= ruleObserveRelativeDirectionType ) ) ( ( (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause ) ) ) ) ;
    public final EObject ruleObserveRelativeClause() throws RecognitionException {
        EObject current = null;

        Enumerator lv_direction_0_0 = null;

        EObject lv_timeTarget_1_1 = null;

        EObject lv_timeTarget_1_2 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4593:28: ( ( ( (lv_direction_0_0= ruleObserveRelativeDirectionType ) ) ( ( (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause ) ) ) ) )
            // InternalDescartesQL.g:4594:1: ( ( (lv_direction_0_0= ruleObserveRelativeDirectionType ) ) ( ( (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause ) ) ) )
            {
            // InternalDescartesQL.g:4594:1: ( ( (lv_direction_0_0= ruleObserveRelativeDirectionType ) ) ( ( (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause ) ) ) )
            // InternalDescartesQL.g:4594:2: ( (lv_direction_0_0= ruleObserveRelativeDirectionType ) ) ( ( (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause ) ) )
            {
            // InternalDescartesQL.g:4594:2: ( (lv_direction_0_0= ruleObserveRelativeDirectionType ) )
            // InternalDescartesQL.g:4595:1: (lv_direction_0_0= ruleObserveRelativeDirectionType )
            {
            // InternalDescartesQL.g:4595:1: (lv_direction_0_0= ruleObserveRelativeDirectionType )
            // InternalDescartesQL.g:4596:3: lv_direction_0_0= ruleObserveRelativeDirectionType
            {
             
            	        newCompositeNode(grammarAccess.getObserveRelativeClauseAccess().getDirectionObserveRelativeDirectionTypeEnumRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_64);
            lv_direction_0_0=ruleObserveRelativeDirectionType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getObserveRelativeClauseRule());
            	        }
                   		set(
                   			current, 
                   			"direction",
                    		lv_direction_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ObserveRelativeDirectionType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:4612:2: ( ( (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause ) ) )
            // InternalDescartesQL.g:4613:1: ( (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause ) )
            {
            // InternalDescartesQL.g:4613:1: ( (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause ) )
            // InternalDescartesQL.g:4614:1: (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause )
            {
            // InternalDescartesQL.g:4614:1: (lv_timeTarget_1_1= ruleAbsoluteTimeClause | lv_timeTarget_1_2= ruleRelativeTimeClause )
            int alt56=2;
            int LA56_0 = input.LA(1);

            if ( (LA56_0==RULE_STRING) ) {
                alt56=1;
            }
            else if ( (LA56_0==RULE_INT) ) {
                alt56=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 56, 0, input);

                throw nvae;
            }
            switch (alt56) {
                case 1 :
                    // InternalDescartesQL.g:4615:3: lv_timeTarget_1_1= ruleAbsoluteTimeClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getObserveRelativeClauseAccess().getTimeTargetAbsoluteTimeClauseParserRuleCall_1_0_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_timeTarget_1_1=ruleAbsoluteTimeClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getObserveRelativeClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"timeTarget",
                            		lv_timeTarget_1_1, 
                            		"tools.descartes.dql.lang.DescartesQL.AbsoluteTimeClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:4630:8: lv_timeTarget_1_2= ruleRelativeTimeClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getObserveRelativeClauseAccess().getTimeTargetRelativeTimeClauseParserRuleCall_1_0_1()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_timeTarget_1_2=ruleRelativeTimeClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getObserveRelativeClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"timeTarget",
                            		lv_timeTarget_1_2, 
                            		"tools.descartes.dql.lang.DescartesQL.RelativeTimeClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleObserveRelativeClause"


    // $ANTLR start "entryRuleObserveBetweenClause"
    // InternalDescartesQL.g:4656:1: entryRuleObserveBetweenClause returns [EObject current=null] : iv_ruleObserveBetweenClause= ruleObserveBetweenClause EOF ;
    public final EObject entryRuleObserveBetweenClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleObserveBetweenClause = null;


        try {
            // InternalDescartesQL.g:4657:2: (iv_ruleObserveBetweenClause= ruleObserveBetweenClause EOF )
            // InternalDescartesQL.g:4658:2: iv_ruleObserveBetweenClause= ruleObserveBetweenClause EOF
            {
             newCompositeNode(grammarAccess.getObserveBetweenClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleObserveBetweenClause=ruleObserveBetweenClause();

            state._fsp--;

             current =iv_ruleObserveBetweenClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleObserveBetweenClause"


    // $ANTLR start "ruleObserveBetweenClause"
    // InternalDescartesQL.g:4665:1: ruleObserveBetweenClause returns [EObject current=null] : ( ( (lv_mode1_0_0= 'BETWEEN' ) ) ( ( (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause ) ) ) ( (lv_mode2_2_0= 'AND' ) ) ( ( (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause ) ) ) ) ;
    public final EObject ruleObserveBetweenClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode1_0_0=null;
        Token lv_mode2_2_0=null;
        EObject lv_startingTime_1_1 = null;

        EObject lv_startingTime_1_2 = null;

        EObject lv_endingTime_3_1 = null;

        EObject lv_endingTime_3_2 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4668:28: ( ( ( (lv_mode1_0_0= 'BETWEEN' ) ) ( ( (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause ) ) ) ( (lv_mode2_2_0= 'AND' ) ) ( ( (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause ) ) ) ) )
            // InternalDescartesQL.g:4669:1: ( ( (lv_mode1_0_0= 'BETWEEN' ) ) ( ( (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause ) ) ) ( (lv_mode2_2_0= 'AND' ) ) ( ( (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause ) ) ) )
            {
            // InternalDescartesQL.g:4669:1: ( ( (lv_mode1_0_0= 'BETWEEN' ) ) ( ( (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause ) ) ) ( (lv_mode2_2_0= 'AND' ) ) ( ( (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause ) ) ) )
            // InternalDescartesQL.g:4669:2: ( (lv_mode1_0_0= 'BETWEEN' ) ) ( ( (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause ) ) ) ( (lv_mode2_2_0= 'AND' ) ) ( ( (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause ) ) )
            {
            // InternalDescartesQL.g:4669:2: ( (lv_mode1_0_0= 'BETWEEN' ) )
            // InternalDescartesQL.g:4670:1: (lv_mode1_0_0= 'BETWEEN' )
            {
            // InternalDescartesQL.g:4670:1: (lv_mode1_0_0= 'BETWEEN' )
            // InternalDescartesQL.g:4671:3: lv_mode1_0_0= 'BETWEEN'
            {
            lv_mode1_0_0=(Token)match(input,67,FOLLOW_65); 

                    newLeafNode(lv_mode1_0_0, grammarAccess.getObserveBetweenClauseAccess().getMode1BETWEENKeyword_0_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getObserveBetweenClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode1", lv_mode1_0_0, "BETWEEN");
            	    

            }


            }

            // InternalDescartesQL.g:4684:2: ( ( (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause ) ) )
            // InternalDescartesQL.g:4685:1: ( (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause ) )
            {
            // InternalDescartesQL.g:4685:1: ( (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause ) )
            // InternalDescartesQL.g:4686:1: (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause )
            {
            // InternalDescartesQL.g:4686:1: (lv_startingTime_1_1= ruleAbsoluteTimeClause | lv_startingTime_1_2= ruleRelativeTimeWithSignClause )
            int alt57=2;
            int LA57_0 = input.LA(1);

            if ( (LA57_0==RULE_STRING) ) {
                alt57=1;
            }
            else if ( ((LA57_0>=87 && LA57_0<=88)) ) {
                alt57=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 57, 0, input);

                throw nvae;
            }
            switch (alt57) {
                case 1 :
                    // InternalDescartesQL.g:4687:3: lv_startingTime_1_1= ruleAbsoluteTimeClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getObserveBetweenClauseAccess().getStartingTimeAbsoluteTimeClauseParserRuleCall_1_0_0()); 
                    	    
                    pushFollow(FOLLOW_66);
                    lv_startingTime_1_1=ruleAbsoluteTimeClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getObserveBetweenClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"startingTime",
                            		lv_startingTime_1_1, 
                            		"tools.descartes.dql.lang.DescartesQL.AbsoluteTimeClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:4702:8: lv_startingTime_1_2= ruleRelativeTimeWithSignClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getObserveBetweenClauseAccess().getStartingTimeRelativeTimeWithSignClauseParserRuleCall_1_0_1()); 
                    	    
                    pushFollow(FOLLOW_66);
                    lv_startingTime_1_2=ruleRelativeTimeWithSignClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getObserveBetweenClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"startingTime",
                            		lv_startingTime_1_2, 
                            		"tools.descartes.dql.lang.DescartesQL.RelativeTimeWithSignClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }

            // InternalDescartesQL.g:4720:2: ( (lv_mode2_2_0= 'AND' ) )
            // InternalDescartesQL.g:4721:1: (lv_mode2_2_0= 'AND' )
            {
            // InternalDescartesQL.g:4721:1: (lv_mode2_2_0= 'AND' )
            // InternalDescartesQL.g:4722:3: lv_mode2_2_0= 'AND'
            {
            lv_mode2_2_0=(Token)match(input,68,FOLLOW_65); 

                    newLeafNode(lv_mode2_2_0, grammarAccess.getObserveBetweenClauseAccess().getMode2ANDKeyword_2_0());
                

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getObserveBetweenClauseRule());
            	        }
                   		setWithLastConsumed(current, "mode2", lv_mode2_2_0, "AND");
            	    

            }


            }

            // InternalDescartesQL.g:4735:2: ( ( (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause ) ) )
            // InternalDescartesQL.g:4736:1: ( (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause ) )
            {
            // InternalDescartesQL.g:4736:1: ( (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause ) )
            // InternalDescartesQL.g:4737:1: (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause )
            {
            // InternalDescartesQL.g:4737:1: (lv_endingTime_3_1= ruleAbsoluteTimeClause | lv_endingTime_3_2= ruleRelativeTimeWithSignClause )
            int alt58=2;
            int LA58_0 = input.LA(1);

            if ( (LA58_0==RULE_STRING) ) {
                alt58=1;
            }
            else if ( ((LA58_0>=87 && LA58_0<=88)) ) {
                alt58=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 58, 0, input);

                throw nvae;
            }
            switch (alt58) {
                case 1 :
                    // InternalDescartesQL.g:4738:3: lv_endingTime_3_1= ruleAbsoluteTimeClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getObserveBetweenClauseAccess().getEndingTimeAbsoluteTimeClauseParserRuleCall_3_0_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_endingTime_3_1=ruleAbsoluteTimeClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getObserveBetweenClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"endingTime",
                            		lv_endingTime_3_1, 
                            		"tools.descartes.dql.lang.DescartesQL.AbsoluteTimeClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:4753:8: lv_endingTime_3_2= ruleRelativeTimeWithSignClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getObserveBetweenClauseAccess().getEndingTimeRelativeTimeWithSignClauseParserRuleCall_3_0_1()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_endingTime_3_2=ruleRelativeTimeWithSignClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getObserveBetweenClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"endingTime",
                            		lv_endingTime_3_2, 
                            		"tools.descartes.dql.lang.DescartesQL.RelativeTimeWithSignClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleObserveBetweenClause"


    // $ANTLR start "entryRuleRelativeTimeWithSignClause"
    // InternalDescartesQL.g:4779:1: entryRuleRelativeTimeWithSignClause returns [EObject current=null] : iv_ruleRelativeTimeWithSignClause= ruleRelativeTimeWithSignClause EOF ;
    public final EObject entryRuleRelativeTimeWithSignClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRelativeTimeWithSignClause = null;


        try {
            // InternalDescartesQL.g:4780:2: (iv_ruleRelativeTimeWithSignClause= ruleRelativeTimeWithSignClause EOF )
            // InternalDescartesQL.g:4781:2: iv_ruleRelativeTimeWithSignClause= ruleRelativeTimeWithSignClause EOF
            {
             newCompositeNode(grammarAccess.getRelativeTimeWithSignClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleRelativeTimeWithSignClause=ruleRelativeTimeWithSignClause();

            state._fsp--;

             current =iv_ruleRelativeTimeWithSignClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRelativeTimeWithSignClause"


    // $ANTLR start "ruleRelativeTimeWithSignClause"
    // InternalDescartesQL.g:4788:1: ruleRelativeTimeWithSignClause returns [EObject current=null] : ( ( (lv_sign_0_0= ruleRelativeTimeSignType ) ) ( (lv_timeClause_1_0= ruleRelativeTimeClause ) ) ) ;
    public final EObject ruleRelativeTimeWithSignClause() throws RecognitionException {
        EObject current = null;

        Enumerator lv_sign_0_0 = null;

        EObject lv_timeClause_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4791:28: ( ( ( (lv_sign_0_0= ruleRelativeTimeSignType ) ) ( (lv_timeClause_1_0= ruleRelativeTimeClause ) ) ) )
            // InternalDescartesQL.g:4792:1: ( ( (lv_sign_0_0= ruleRelativeTimeSignType ) ) ( (lv_timeClause_1_0= ruleRelativeTimeClause ) ) )
            {
            // InternalDescartesQL.g:4792:1: ( ( (lv_sign_0_0= ruleRelativeTimeSignType ) ) ( (lv_timeClause_1_0= ruleRelativeTimeClause ) ) )
            // InternalDescartesQL.g:4792:2: ( (lv_sign_0_0= ruleRelativeTimeSignType ) ) ( (lv_timeClause_1_0= ruleRelativeTimeClause ) )
            {
            // InternalDescartesQL.g:4792:2: ( (lv_sign_0_0= ruleRelativeTimeSignType ) )
            // InternalDescartesQL.g:4793:1: (lv_sign_0_0= ruleRelativeTimeSignType )
            {
            // InternalDescartesQL.g:4793:1: (lv_sign_0_0= ruleRelativeTimeSignType )
            // InternalDescartesQL.g:4794:3: lv_sign_0_0= ruleRelativeTimeSignType
            {
             
            	        newCompositeNode(grammarAccess.getRelativeTimeWithSignClauseAccess().getSignRelativeTimeSignTypeEnumRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_64);
            lv_sign_0_0=ruleRelativeTimeSignType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getRelativeTimeWithSignClauseRule());
            	        }
                   		set(
                   			current, 
                   			"sign",
                    		lv_sign_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.RelativeTimeSignType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:4810:2: ( (lv_timeClause_1_0= ruleRelativeTimeClause ) )
            // InternalDescartesQL.g:4811:1: (lv_timeClause_1_0= ruleRelativeTimeClause )
            {
            // InternalDescartesQL.g:4811:1: (lv_timeClause_1_0= ruleRelativeTimeClause )
            // InternalDescartesQL.g:4812:3: lv_timeClause_1_0= ruleRelativeTimeClause
            {
             
            	        newCompositeNode(grammarAccess.getRelativeTimeWithSignClauseAccess().getTimeClauseRelativeTimeClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_timeClause_1_0=ruleRelativeTimeClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getRelativeTimeWithSignClauseRule());
            	        }
                   		set(
                   			current, 
                   			"timeClause",
                    		lv_timeClause_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.RelativeTimeClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRelativeTimeWithSignClause"


    // $ANTLR start "entryRuleAbsoluteTimeClause"
    // InternalDescartesQL.g:4840:1: entryRuleAbsoluteTimeClause returns [EObject current=null] : iv_ruleAbsoluteTimeClause= ruleAbsoluteTimeClause EOF ;
    public final EObject entryRuleAbsoluteTimeClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAbsoluteTimeClause = null;


        try {
            // InternalDescartesQL.g:4841:2: (iv_ruleAbsoluteTimeClause= ruleAbsoluteTimeClause EOF )
            // InternalDescartesQL.g:4842:2: iv_ruleAbsoluteTimeClause= ruleAbsoluteTimeClause EOF
            {
             newCompositeNode(grammarAccess.getAbsoluteTimeClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAbsoluteTimeClause=ruleAbsoluteTimeClause();

            state._fsp--;

             current =iv_ruleAbsoluteTimeClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAbsoluteTimeClause"


    // $ANTLR start "ruleAbsoluteTimeClause"
    // InternalDescartesQL.g:4849:1: ruleAbsoluteTimeClause returns [EObject current=null] : ( (lv_timeSpec_0_0= RULE_STRING ) ) ;
    public final EObject ruleAbsoluteTimeClause() throws RecognitionException {
        EObject current = null;

        Token lv_timeSpec_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4852:28: ( ( (lv_timeSpec_0_0= RULE_STRING ) ) )
            // InternalDescartesQL.g:4853:1: ( (lv_timeSpec_0_0= RULE_STRING ) )
            {
            // InternalDescartesQL.g:4853:1: ( (lv_timeSpec_0_0= RULE_STRING ) )
            // InternalDescartesQL.g:4854:1: (lv_timeSpec_0_0= RULE_STRING )
            {
            // InternalDescartesQL.g:4854:1: (lv_timeSpec_0_0= RULE_STRING )
            // InternalDescartesQL.g:4855:3: lv_timeSpec_0_0= RULE_STRING
            {
            lv_timeSpec_0_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            			newLeafNode(lv_timeSpec_0_0, grammarAccess.getAbsoluteTimeClauseAccess().getTimeSpecSTRINGTerminalRuleCall_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getAbsoluteTimeClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"timeSpec",
                    		lv_timeSpec_0_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAbsoluteTimeClause"


    // $ANTLR start "entryRuleRelativeTimeClause"
    // InternalDescartesQL.g:4879:1: entryRuleRelativeTimeClause returns [EObject current=null] : iv_ruleRelativeTimeClause= ruleRelativeTimeClause EOF ;
    public final EObject entryRuleRelativeTimeClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRelativeTimeClause = null;


        try {
            // InternalDescartesQL.g:4880:2: (iv_ruleRelativeTimeClause= ruleRelativeTimeClause EOF )
            // InternalDescartesQL.g:4881:2: iv_ruleRelativeTimeClause= ruleRelativeTimeClause EOF
            {
             newCompositeNode(grammarAccess.getRelativeTimeClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleRelativeTimeClause=ruleRelativeTimeClause();

            state._fsp--;

             current =iv_ruleRelativeTimeClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRelativeTimeClause"


    // $ANTLR start "ruleRelativeTimeClause"
    // InternalDescartesQL.g:4888:1: ruleRelativeTimeClause returns [EObject current=null] : ( ( (lv_durationClause_0_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) )* ) ;
    public final EObject ruleRelativeTimeClause() throws RecognitionException {
        EObject current = null;

        EObject lv_durationClause_0_0 = null;

        EObject lv_durationClause_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4891:28: ( ( ( (lv_durationClause_0_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) )* ) )
            // InternalDescartesQL.g:4892:1: ( ( (lv_durationClause_0_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) )* )
            {
            // InternalDescartesQL.g:4892:1: ( ( (lv_durationClause_0_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) )* )
            // InternalDescartesQL.g:4892:2: ( (lv_durationClause_0_0= ruleRelativeTimeDurationClause ) ) ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) )*
            {
            // InternalDescartesQL.g:4892:2: ( (lv_durationClause_0_0= ruleRelativeTimeDurationClause ) )
            // InternalDescartesQL.g:4893:1: (lv_durationClause_0_0= ruleRelativeTimeDurationClause )
            {
            // InternalDescartesQL.g:4893:1: (lv_durationClause_0_0= ruleRelativeTimeDurationClause )
            // InternalDescartesQL.g:4894:3: lv_durationClause_0_0= ruleRelativeTimeDurationClause
            {
             
            	        newCompositeNode(grammarAccess.getRelativeTimeClauseAccess().getDurationClauseRelativeTimeDurationClauseParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_63);
            lv_durationClause_0_0=ruleRelativeTimeDurationClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getRelativeTimeClauseRule());
            	        }
                   		add(
                   			current, 
                   			"durationClause",
                    		lv_durationClause_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.RelativeTimeDurationClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:4910:2: ( (lv_durationClause_1_0= ruleRelativeTimeDurationClause ) )*
            loop59:
            do {
                int alt59=2;
                int LA59_0 = input.LA(1);

                if ( (LA59_0==RULE_INT) ) {
                    alt59=1;
                }


                switch (alt59) {
            	case 1 :
            	    // InternalDescartesQL.g:4911:1: (lv_durationClause_1_0= ruleRelativeTimeDurationClause )
            	    {
            	    // InternalDescartesQL.g:4911:1: (lv_durationClause_1_0= ruleRelativeTimeDurationClause )
            	    // InternalDescartesQL.g:4912:3: lv_durationClause_1_0= ruleRelativeTimeDurationClause
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getRelativeTimeClauseAccess().getDurationClauseRelativeTimeDurationClauseParserRuleCall_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_63);
            	    lv_durationClause_1_0=ruleRelativeTimeDurationClause();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getRelativeTimeClauseRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"durationClause",
            	            		lv_durationClause_1_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.RelativeTimeDurationClause");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop59;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRelativeTimeClause"


    // $ANTLR start "entryRuleRelativeTimeDurationClause"
    // InternalDescartesQL.g:4936:1: entryRuleRelativeTimeDurationClause returns [EObject current=null] : iv_ruleRelativeTimeDurationClause= ruleRelativeTimeDurationClause EOF ;
    public final EObject entryRuleRelativeTimeDurationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRelativeTimeDurationClause = null;


        try {
            // InternalDescartesQL.g:4937:2: (iv_ruleRelativeTimeDurationClause= ruleRelativeTimeDurationClause EOF )
            // InternalDescartesQL.g:4938:2: iv_ruleRelativeTimeDurationClause= ruleRelativeTimeDurationClause EOF
            {
             newCompositeNode(grammarAccess.getRelativeTimeDurationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleRelativeTimeDurationClause=ruleRelativeTimeDurationClause();

            state._fsp--;

             current =iv_ruleRelativeTimeDurationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRelativeTimeDurationClause"


    // $ANTLR start "ruleRelativeTimeDurationClause"
    // InternalDescartesQL.g:4945:1: ruleRelativeTimeDurationClause returns [EObject current=null] : ( ( (lv_duration_0_0= RULE_INT ) ) ( (lv_timeModifier_1_0= ruleTimeModifierType ) ) ) ;
    public final EObject ruleRelativeTimeDurationClause() throws RecognitionException {
        EObject current = null;

        Token lv_duration_0_0=null;
        Enumerator lv_timeModifier_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:4948:28: ( ( ( (lv_duration_0_0= RULE_INT ) ) ( (lv_timeModifier_1_0= ruleTimeModifierType ) ) ) )
            // InternalDescartesQL.g:4949:1: ( ( (lv_duration_0_0= RULE_INT ) ) ( (lv_timeModifier_1_0= ruleTimeModifierType ) ) )
            {
            // InternalDescartesQL.g:4949:1: ( ( (lv_duration_0_0= RULE_INT ) ) ( (lv_timeModifier_1_0= ruleTimeModifierType ) ) )
            // InternalDescartesQL.g:4949:2: ( (lv_duration_0_0= RULE_INT ) ) ( (lv_timeModifier_1_0= ruleTimeModifierType ) )
            {
            // InternalDescartesQL.g:4949:2: ( (lv_duration_0_0= RULE_INT ) )
            // InternalDescartesQL.g:4950:1: (lv_duration_0_0= RULE_INT )
            {
            // InternalDescartesQL.g:4950:1: (lv_duration_0_0= RULE_INT )
            // InternalDescartesQL.g:4951:3: lv_duration_0_0= RULE_INT
            {
            lv_duration_0_0=(Token)match(input,RULE_INT,FOLLOW_67); 

            			newLeafNode(lv_duration_0_0, grammarAccess.getRelativeTimeDurationClauseAccess().getDurationINTTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getRelativeTimeDurationClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"duration",
                    		lv_duration_0_0, 
                    		"org.eclipse.xtext.common.Terminals.INT");
            	    

            }


            }

            // InternalDescartesQL.g:4967:2: ( (lv_timeModifier_1_0= ruleTimeModifierType ) )
            // InternalDescartesQL.g:4968:1: (lv_timeModifier_1_0= ruleTimeModifierType )
            {
            // InternalDescartesQL.g:4968:1: (lv_timeModifier_1_0= ruleTimeModifierType )
            // InternalDescartesQL.g:4969:3: lv_timeModifier_1_0= ruleTimeModifierType
            {
             
            	        newCompositeNode(grammarAccess.getRelativeTimeDurationClauseAccess().getTimeModifierTimeModifierTypeEnumRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_timeModifier_1_0=ruleTimeModifierType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getRelativeTimeDurationClauseRule());
            	        }
                   		set(
                   			current, 
                   			"timeModifier",
                    		lv_timeModifier_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.TimeModifierType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRelativeTimeDurationClause"


    // $ANTLR start "entryRuleWhatIfQuery"
    // InternalDescartesQL.g:4993:1: entryRuleWhatIfQuery returns [EObject current=null] : iv_ruleWhatIfQuery= ruleWhatIfQuery EOF ;
    public final EObject entryRuleWhatIfQuery() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleWhatIfQuery = null;


        try {
            // InternalDescartesQL.g:4994:2: (iv_ruleWhatIfQuery= ruleWhatIfQuery EOF )
            // InternalDescartesQL.g:4995:2: iv_ruleWhatIfQuery= ruleWhatIfQuery EOF
            {
             newCompositeNode(grammarAccess.getWhatIfQueryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleWhatIfQuery=ruleWhatIfQuery();

            state._fsp--;

             current =iv_ruleWhatIfQuery; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleWhatIfQuery"


    // $ANTLR start "ruleWhatIfQuery"
    // InternalDescartesQL.g:5002:1: ruleWhatIfQuery returns [EObject current=null] : (otherlv_0= 'WHAT IF' ( (lv_whatIfVariation_1_0= ruleWhatIfVariation ) ) (otherlv_2= 'SELECT' ( (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses ) ) ( (lv_forClause_4_0= ruleForClause ) ) )? ( (lv_filteringClause_5_0= ruleFilteringClause ) )? ( (lv_deltaClause_6_0= ruleDeltaClause ) )? ( (lv_usingClause_7_0= ruleUsingClause ) ) ) ;
    public final EObject ruleWhatIfQuery() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        EObject lv_whatIfVariation_1_0 = null;

        EObject lv_metricReferenceClauses_3_0 = null;

        EObject lv_forClause_4_0 = null;

        EObject lv_filteringClause_5_0 = null;

        AntlrDatatypeRuleToken lv_deltaClause_6_0 = null;

        EObject lv_usingClause_7_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5005:28: ( (otherlv_0= 'WHAT IF' ( (lv_whatIfVariation_1_0= ruleWhatIfVariation ) ) (otherlv_2= 'SELECT' ( (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses ) ) ( (lv_forClause_4_0= ruleForClause ) ) )? ( (lv_filteringClause_5_0= ruleFilteringClause ) )? ( (lv_deltaClause_6_0= ruleDeltaClause ) )? ( (lv_usingClause_7_0= ruleUsingClause ) ) ) )
            // InternalDescartesQL.g:5006:1: (otherlv_0= 'WHAT IF' ( (lv_whatIfVariation_1_0= ruleWhatIfVariation ) ) (otherlv_2= 'SELECT' ( (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses ) ) ( (lv_forClause_4_0= ruleForClause ) ) )? ( (lv_filteringClause_5_0= ruleFilteringClause ) )? ( (lv_deltaClause_6_0= ruleDeltaClause ) )? ( (lv_usingClause_7_0= ruleUsingClause ) ) )
            {
            // InternalDescartesQL.g:5006:1: (otherlv_0= 'WHAT IF' ( (lv_whatIfVariation_1_0= ruleWhatIfVariation ) ) (otherlv_2= 'SELECT' ( (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses ) ) ( (lv_forClause_4_0= ruleForClause ) ) )? ( (lv_filteringClause_5_0= ruleFilteringClause ) )? ( (lv_deltaClause_6_0= ruleDeltaClause ) )? ( (lv_usingClause_7_0= ruleUsingClause ) ) )
            // InternalDescartesQL.g:5006:3: otherlv_0= 'WHAT IF' ( (lv_whatIfVariation_1_0= ruleWhatIfVariation ) ) (otherlv_2= 'SELECT' ( (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses ) ) ( (lv_forClause_4_0= ruleForClause ) ) )? ( (lv_filteringClause_5_0= ruleFilteringClause ) )? ( (lv_deltaClause_6_0= ruleDeltaClause ) )? ( (lv_usingClause_7_0= ruleUsingClause ) )
            {
            otherlv_0=(Token)match(input,69,FOLLOW_39); 

                	newLeafNode(otherlv_0, grammarAccess.getWhatIfQueryAccess().getWHATIFKeyword_0());
                
            // InternalDescartesQL.g:5010:1: ( (lv_whatIfVariation_1_0= ruleWhatIfVariation ) )
            // InternalDescartesQL.g:5011:1: (lv_whatIfVariation_1_0= ruleWhatIfVariation )
            {
            // InternalDescartesQL.g:5011:1: (lv_whatIfVariation_1_0= ruleWhatIfVariation )
            // InternalDescartesQL.g:5012:3: lv_whatIfVariation_1_0= ruleWhatIfVariation
            {
             
            	        newCompositeNode(grammarAccess.getWhatIfQueryAccess().getWhatIfVariationWhatIfVariationParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_68);
            lv_whatIfVariation_1_0=ruleWhatIfVariation();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getWhatIfQueryRule());
            	        }
                   		set(
                   			current, 
                   			"whatIfVariation",
                    		lv_whatIfVariation_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.WhatIfVariation");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:5028:2: (otherlv_2= 'SELECT' ( (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses ) ) ( (lv_forClause_4_0= ruleForClause ) ) )?
            int alt60=2;
            int LA60_0 = input.LA(1);

            if ( (LA60_0==39) ) {
                alt60=1;
            }
            switch (alt60) {
                case 1 :
                    // InternalDescartesQL.g:5028:4: otherlv_2= 'SELECT' ( (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses ) ) ( (lv_forClause_4_0= ruleForClause ) )
                    {
                    otherlv_2=(Token)match(input,39,FOLLOW_17); 

                        	newLeafNode(otherlv_2, grammarAccess.getWhatIfQueryAccess().getSELECTKeyword_2_0());
                        
                    // InternalDescartesQL.g:5032:1: ( (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses ) )
                    // InternalDescartesQL.g:5033:1: (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses )
                    {
                    // InternalDescartesQL.g:5033:1: (lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses )
                    // InternalDescartesQL.g:5034:3: lv_metricReferenceClauses_3_0= ruleMetricReferenceClauses
                    {
                     
                    	        newCompositeNode(grammarAccess.getWhatIfQueryAccess().getMetricReferenceClausesMetricReferenceClausesParserRuleCall_2_1_0()); 
                    	    
                    pushFollow(FOLLOW_35);
                    lv_metricReferenceClauses_3_0=ruleMetricReferenceClauses();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getWhatIfQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"metricReferenceClauses",
                            		lv_metricReferenceClauses_3_0, 
                            		"tools.descartes.dql.lang.DescartesQL.MetricReferenceClauses");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }

                    // InternalDescartesQL.g:5050:2: ( (lv_forClause_4_0= ruleForClause ) )
                    // InternalDescartesQL.g:5051:1: (lv_forClause_4_0= ruleForClause )
                    {
                    // InternalDescartesQL.g:5051:1: (lv_forClause_4_0= ruleForClause )
                    // InternalDescartesQL.g:5052:3: lv_forClause_4_0= ruleForClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getWhatIfQueryAccess().getForClauseForClauseParserRuleCall_2_2_0()); 
                    	    
                    pushFollow(FOLLOW_69);
                    lv_forClause_4_0=ruleForClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getWhatIfQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"forClause",
                            		lv_forClause_4_0, 
                            		"tools.descartes.dql.lang.DescartesQL.ForClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:5068:4: ( (lv_filteringClause_5_0= ruleFilteringClause ) )?
            int alt61=2;
            int LA61_0 = input.LA(1);

            if ( (LA61_0==71) ) {
                alt61=1;
            }
            switch (alt61) {
                case 1 :
                    // InternalDescartesQL.g:5069:1: (lv_filteringClause_5_0= ruleFilteringClause )
                    {
                    // InternalDescartesQL.g:5069:1: (lv_filteringClause_5_0= ruleFilteringClause )
                    // InternalDescartesQL.g:5070:3: lv_filteringClause_5_0= ruleFilteringClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getWhatIfQueryAccess().getFilteringClauseFilteringClauseParserRuleCall_3_0()); 
                    	    
                    pushFollow(FOLLOW_70);
                    lv_filteringClause_5_0=ruleFilteringClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getWhatIfQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"filteringClause",
                            		lv_filteringClause_5_0, 
                            		"tools.descartes.dql.lang.DescartesQL.FilteringClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:5086:3: ( (lv_deltaClause_6_0= ruleDeltaClause ) )?
            int alt62=2;
            int LA62_0 = input.LA(1);

            if ( (LA62_0==70) ) {
                alt62=1;
            }
            switch (alt62) {
                case 1 :
                    // InternalDescartesQL.g:5087:1: (lv_deltaClause_6_0= ruleDeltaClause )
                    {
                    // InternalDescartesQL.g:5087:1: (lv_deltaClause_6_0= ruleDeltaClause )
                    // InternalDescartesQL.g:5088:3: lv_deltaClause_6_0= ruleDeltaClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getWhatIfQueryAccess().getDeltaClauseDeltaClauseParserRuleCall_4_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_deltaClause_6_0=ruleDeltaClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getWhatIfQueryRule());
                    	        }
                           		set(
                           			current, 
                           			"deltaClause",
                            		lv_deltaClause_6_0, 
                            		"tools.descartes.dql.lang.DescartesQL.DeltaClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalDescartesQL.g:5104:3: ( (lv_usingClause_7_0= ruleUsingClause ) )
            // InternalDescartesQL.g:5105:1: (lv_usingClause_7_0= ruleUsingClause )
            {
            // InternalDescartesQL.g:5105:1: (lv_usingClause_7_0= ruleUsingClause )
            // InternalDescartesQL.g:5106:3: lv_usingClause_7_0= ruleUsingClause
            {
             
            	        newCompositeNode(grammarAccess.getWhatIfQueryAccess().getUsingClauseUsingClauseParserRuleCall_5_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_usingClause_7_0=ruleUsingClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getWhatIfQueryRule());
            	        }
                   		set(
                   			current, 
                   			"usingClause",
                    		lv_usingClause_7_0, 
                    		"tools.descartes.dql.lang.DescartesQL.UsingClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleWhatIfQuery"


    // $ANTLR start "entryRuleDeltaClause"
    // InternalDescartesQL.g:5130:1: entryRuleDeltaClause returns [String current=null] : iv_ruleDeltaClause= ruleDeltaClause EOF ;
    public final String entryRuleDeltaClause() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleDeltaClause = null;


        try {
            // InternalDescartesQL.g:5131:2: (iv_ruleDeltaClause= ruleDeltaClause EOF )
            // InternalDescartesQL.g:5132:2: iv_ruleDeltaClause= ruleDeltaClause EOF
            {
             newCompositeNode(grammarAccess.getDeltaClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDeltaClause=ruleDeltaClause();

            state._fsp--;

             current =iv_ruleDeltaClause.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDeltaClause"


    // $ANTLR start "ruleDeltaClause"
    // InternalDescartesQL.g:5139:1: ruleDeltaClause returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : kw= 'DELTA' ;
    public final AntlrDatatypeRuleToken ruleDeltaClause() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5142:28: (kw= 'DELTA' )
            // InternalDescartesQL.g:5144:2: kw= 'DELTA'
            {
            kw=(Token)match(input,70,FOLLOW_2); 

                    current.merge(kw);
                    newLeafNode(kw, grammarAccess.getDeltaClauseAccess().getDELTAKeyword()); 
                

            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDeltaClause"


    // $ANTLR start "entryRuleWhatIfVariation"
    // InternalDescartesQL.g:5157:1: entryRuleWhatIfVariation returns [EObject current=null] : iv_ruleWhatIfVariation= ruleWhatIfVariation EOF ;
    public final EObject entryRuleWhatIfVariation() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleWhatIfVariation = null;


        try {
            // InternalDescartesQL.g:5158:2: (iv_ruleWhatIfVariation= ruleWhatIfVariation EOF )
            // InternalDescartesQL.g:5159:2: iv_ruleWhatIfVariation= ruleWhatIfVariation EOF
            {
             newCompositeNode(grammarAccess.getWhatIfVariationRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleWhatIfVariation=ruleWhatIfVariation();

            state._fsp--;

             current =iv_ruleWhatIfVariation; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleWhatIfVariation"


    // $ANTLR start "ruleWhatIfVariation"
    // InternalDescartesQL.g:5166:1: ruleWhatIfVariation returns [EObject current=null] : ( ( (lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause ) ) (otherlv_1= ',' ( (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause ) ) )* ) ;
    public final EObject ruleWhatIfVariation() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_whatIfVariationClause_0_0 = null;

        EObject lv_whatIfVariationClause_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5169:28: ( ( ( (lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause ) ) (otherlv_1= ',' ( (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause ) ) )* ) )
            // InternalDescartesQL.g:5170:1: ( ( (lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause ) ) (otherlv_1= ',' ( (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause ) ) )* )
            {
            // InternalDescartesQL.g:5170:1: ( ( (lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause ) ) (otherlv_1= ',' ( (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause ) ) )* )
            // InternalDescartesQL.g:5170:2: ( (lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause ) ) (otherlv_1= ',' ( (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause ) ) )*
            {
            // InternalDescartesQL.g:5170:2: ( (lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause ) )
            // InternalDescartesQL.g:5171:1: (lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause )
            {
            // InternalDescartesQL.g:5171:1: (lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause )
            // InternalDescartesQL.g:5172:3: lv_whatIfVariationClause_0_0= ruleWhatIfVariationClause
            {
             
            	        newCompositeNode(grammarAccess.getWhatIfVariationAccess().getWhatIfVariationClauseWhatIfVariationClauseParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_12);
            lv_whatIfVariationClause_0_0=ruleWhatIfVariationClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getWhatIfVariationRule());
            	        }
                   		add(
                   			current, 
                   			"whatIfVariationClause",
                    		lv_whatIfVariationClause_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.WhatIfVariationClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:5188:2: (otherlv_1= ',' ( (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause ) ) )*
            loop63:
            do {
                int alt63=2;
                int LA63_0 = input.LA(1);

                if ( (LA63_0==20) ) {
                    alt63=1;
                }


                switch (alt63) {
            	case 1 :
            	    // InternalDescartesQL.g:5188:4: otherlv_1= ',' ( (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause ) )
            	    {
            	    otherlv_1=(Token)match(input,20,FOLLOW_39); 

            	        	newLeafNode(otherlv_1, grammarAccess.getWhatIfVariationAccess().getCommaKeyword_1_0());
            	        
            	    // InternalDescartesQL.g:5192:1: ( (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause ) )
            	    // InternalDescartesQL.g:5193:1: (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause )
            	    {
            	    // InternalDescartesQL.g:5193:1: (lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause )
            	    // InternalDescartesQL.g:5194:3: lv_whatIfVariationClause_2_0= ruleWhatIfVariationClause
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getWhatIfVariationAccess().getWhatIfVariationClauseWhatIfVariationClauseParserRuleCall_1_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_12);
            	    lv_whatIfVariationClause_2_0=ruleWhatIfVariationClause();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getWhatIfVariationRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"whatIfVariationClause",
            	            		lv_whatIfVariationClause_2_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.WhatIfVariationClause");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop63;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleWhatIfVariation"


    // $ANTLR start "entryRuleFilteringClause"
    // InternalDescartesQL.g:5218:1: entryRuleFilteringClause returns [EObject current=null] : iv_ruleFilteringClause= ruleFilteringClause EOF ;
    public final EObject entryRuleFilteringClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFilteringClause = null;


        try {
            // InternalDescartesQL.g:5219:2: (iv_ruleFilteringClause= ruleFilteringClause EOF )
            // InternalDescartesQL.g:5220:2: iv_ruleFilteringClause= ruleFilteringClause EOF
            {
             newCompositeNode(grammarAccess.getFilteringClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFilteringClause=ruleFilteringClause();

            state._fsp--;

             current =iv_ruleFilteringClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFilteringClause"


    // $ANTLR start "ruleFilteringClause"
    // InternalDescartesQL.g:5227:1: ruleFilteringClause returns [EObject current=null] : (otherlv_0= 'FILTERING' ( ( (lv_filteringRule_1_0= ruleFilteringRule ) ) | ( (lv_filteringStrategy_2_0= ruleFilteringStrategy ) ) ) ) ;
    public final EObject ruleFilteringClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_filteringRule_1_0 = null;

        EObject lv_filteringStrategy_2_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5230:28: ( (otherlv_0= 'FILTERING' ( ( (lv_filteringRule_1_0= ruleFilteringRule ) ) | ( (lv_filteringStrategy_2_0= ruleFilteringStrategy ) ) ) ) )
            // InternalDescartesQL.g:5231:1: (otherlv_0= 'FILTERING' ( ( (lv_filteringRule_1_0= ruleFilteringRule ) ) | ( (lv_filteringStrategy_2_0= ruleFilteringStrategy ) ) ) )
            {
            // InternalDescartesQL.g:5231:1: (otherlv_0= 'FILTERING' ( ( (lv_filteringRule_1_0= ruleFilteringRule ) ) | ( (lv_filteringStrategy_2_0= ruleFilteringStrategy ) ) ) )
            // InternalDescartesQL.g:5231:3: otherlv_0= 'FILTERING' ( ( (lv_filteringRule_1_0= ruleFilteringRule ) ) | ( (lv_filteringStrategy_2_0= ruleFilteringStrategy ) ) )
            {
            otherlv_0=(Token)match(input,71,FOLLOW_71); 

                	newLeafNode(otherlv_0, grammarAccess.getFilteringClauseAccess().getFILTERINGKeyword_0());
                
            // InternalDescartesQL.g:5235:1: ( ( (lv_filteringRule_1_0= ruleFilteringRule ) ) | ( (lv_filteringStrategy_2_0= ruleFilteringStrategy ) ) )
            int alt64=2;
            int LA64_0 = input.LA(1);

            if ( (LA64_0==RULE_DOUBLE||LA64_0==RULE_INT) ) {
                alt64=1;
            }
            else if ( (LA64_0==RULE_STRING) ) {
                alt64=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 64, 0, input);

                throw nvae;
            }
            switch (alt64) {
                case 1 :
                    // InternalDescartesQL.g:5235:2: ( (lv_filteringRule_1_0= ruleFilteringRule ) )
                    {
                    // InternalDescartesQL.g:5235:2: ( (lv_filteringRule_1_0= ruleFilteringRule ) )
                    // InternalDescartesQL.g:5236:1: (lv_filteringRule_1_0= ruleFilteringRule )
                    {
                    // InternalDescartesQL.g:5236:1: (lv_filteringRule_1_0= ruleFilteringRule )
                    // InternalDescartesQL.g:5237:3: lv_filteringRule_1_0= ruleFilteringRule
                    {
                     
                    	        newCompositeNode(grammarAccess.getFilteringClauseAccess().getFilteringRuleFilteringRuleParserRuleCall_1_0_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_filteringRule_1_0=ruleFilteringRule();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getFilteringClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"filteringRule",
                            		lv_filteringRule_1_0, 
                            		"tools.descartes.dql.lang.DescartesQL.FilteringRule");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5254:6: ( (lv_filteringStrategy_2_0= ruleFilteringStrategy ) )
                    {
                    // InternalDescartesQL.g:5254:6: ( (lv_filteringStrategy_2_0= ruleFilteringStrategy ) )
                    // InternalDescartesQL.g:5255:1: (lv_filteringStrategy_2_0= ruleFilteringStrategy )
                    {
                    // InternalDescartesQL.g:5255:1: (lv_filteringStrategy_2_0= ruleFilteringStrategy )
                    // InternalDescartesQL.g:5256:3: lv_filteringStrategy_2_0= ruleFilteringStrategy
                    {
                     
                    	        newCompositeNode(grammarAccess.getFilteringClauseAccess().getFilteringStrategyFilteringStrategyParserRuleCall_1_1_0()); 
                    	    
                    pushFollow(FOLLOW_2);
                    lv_filteringStrategy_2_0=ruleFilteringStrategy();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getFilteringClauseRule());
                    	        }
                           		set(
                           			current, 
                           			"filteringStrategy",
                            		lv_filteringStrategy_2_0, 
                            		"tools.descartes.dql.lang.DescartesQL.FilteringStrategy");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFilteringClause"


    // $ANTLR start "entryRuleFilteringStrategy"
    // InternalDescartesQL.g:5280:1: entryRuleFilteringStrategy returns [EObject current=null] : iv_ruleFilteringStrategy= ruleFilteringStrategy EOF ;
    public final EObject entryRuleFilteringStrategy() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFilteringStrategy = null;


        try {
            // InternalDescartesQL.g:5281:2: (iv_ruleFilteringStrategy= ruleFilteringStrategy EOF )
            // InternalDescartesQL.g:5282:2: iv_ruleFilteringStrategy= ruleFilteringStrategy EOF
            {
             newCompositeNode(grammarAccess.getFilteringStrategyRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFilteringStrategy=ruleFilteringStrategy();

            state._fsp--;

             current =iv_ruleFilteringStrategy; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFilteringStrategy"


    // $ANTLR start "ruleFilteringStrategy"
    // InternalDescartesQL.g:5289:1: ruleFilteringStrategy returns [EObject current=null] : ( (lv_filteringStrategy_0_0= RULE_STRING ) ) ;
    public final EObject ruleFilteringStrategy() throws RecognitionException {
        EObject current = null;

        Token lv_filteringStrategy_0_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5292:28: ( ( (lv_filteringStrategy_0_0= RULE_STRING ) ) )
            // InternalDescartesQL.g:5293:1: ( (lv_filteringStrategy_0_0= RULE_STRING ) )
            {
            // InternalDescartesQL.g:5293:1: ( (lv_filteringStrategy_0_0= RULE_STRING ) )
            // InternalDescartesQL.g:5294:1: (lv_filteringStrategy_0_0= RULE_STRING )
            {
            // InternalDescartesQL.g:5294:1: (lv_filteringStrategy_0_0= RULE_STRING )
            // InternalDescartesQL.g:5295:3: lv_filteringStrategy_0_0= RULE_STRING
            {
            lv_filteringStrategy_0_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            			newLeafNode(lv_filteringStrategy_0_0, grammarAccess.getFilteringStrategyAccess().getFilteringStrategySTRINGTerminalRuleCall_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getFilteringStrategyRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"filteringStrategy",
                    		lv_filteringStrategy_0_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFilteringStrategy"


    // $ANTLR start "entryRuleFilteringRule"
    // InternalDescartesQL.g:5319:1: entryRuleFilteringRule returns [EObject current=null] : iv_ruleFilteringRule= ruleFilteringRule EOF ;
    public final EObject entryRuleFilteringRule() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFilteringRule = null;


        try {
            // InternalDescartesQL.g:5320:2: (iv_ruleFilteringRule= ruleFilteringRule EOF )
            // InternalDescartesQL.g:5321:2: iv_ruleFilteringRule= ruleFilteringRule EOF
            {
             newCompositeNode(grammarAccess.getFilteringRuleRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFilteringRule=ruleFilteringRule();

            state._fsp--;

             current =iv_ruleFilteringRule; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFilteringRule"


    // $ANTLR start "ruleFilteringRule"
    // InternalDescartesQL.g:5328:1: ruleFilteringRule returns [EObject current=null] : ( ( (lv_filteringValue_0_0= ruleVariableValue ) ) ( (lv_modifier_1_0= '%' ) )? ) ;
    public final EObject ruleFilteringRule() throws RecognitionException {
        EObject current = null;

        Token lv_modifier_1_0=null;
        EObject lv_filteringValue_0_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5331:28: ( ( ( (lv_filteringValue_0_0= ruleVariableValue ) ) ( (lv_modifier_1_0= '%' ) )? ) )
            // InternalDescartesQL.g:5332:1: ( ( (lv_filteringValue_0_0= ruleVariableValue ) ) ( (lv_modifier_1_0= '%' ) )? )
            {
            // InternalDescartesQL.g:5332:1: ( ( (lv_filteringValue_0_0= ruleVariableValue ) ) ( (lv_modifier_1_0= '%' ) )? )
            // InternalDescartesQL.g:5332:2: ( (lv_filteringValue_0_0= ruleVariableValue ) ) ( (lv_modifier_1_0= '%' ) )?
            {
            // InternalDescartesQL.g:5332:2: ( (lv_filteringValue_0_0= ruleVariableValue ) )
            // InternalDescartesQL.g:5333:1: (lv_filteringValue_0_0= ruleVariableValue )
            {
            // InternalDescartesQL.g:5333:1: (lv_filteringValue_0_0= ruleVariableValue )
            // InternalDescartesQL.g:5334:3: lv_filteringValue_0_0= ruleVariableValue
            {
             
            	        newCompositeNode(grammarAccess.getFilteringRuleAccess().getFilteringValueVariableValueParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_72);
            lv_filteringValue_0_0=ruleVariableValue();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getFilteringRuleRule());
            	        }
                   		set(
                   			current, 
                   			"filteringValue",
                    		lv_filteringValue_0_0, 
                    		"tools.descartes.dql.lang.DescartesQL.VariableValue");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:5350:2: ( (lv_modifier_1_0= '%' ) )?
            int alt65=2;
            int LA65_0 = input.LA(1);

            if ( (LA65_0==72) ) {
                alt65=1;
            }
            switch (alt65) {
                case 1 :
                    // InternalDescartesQL.g:5351:1: (lv_modifier_1_0= '%' )
                    {
                    // InternalDescartesQL.g:5351:1: (lv_modifier_1_0= '%' )
                    // InternalDescartesQL.g:5352:3: lv_modifier_1_0= '%'
                    {
                    lv_modifier_1_0=(Token)match(input,72,FOLLOW_2); 

                            newLeafNode(lv_modifier_1_0, grammarAccess.getFilteringRuleAccess().getModifierPercentSignKeyword_1_0());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getFilteringRuleRule());
                    	        }
                           		setWithLastConsumed(current, "modifier", lv_modifier_1_0, "%");
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFilteringRule"


    // $ANTLR start "entryRuleWhatIfVariationClause"
    // InternalDescartesQL.g:5373:1: entryRuleWhatIfVariationClause returns [EObject current=null] : iv_ruleWhatIfVariationClause= ruleWhatIfVariationClause EOF ;
    public final EObject entryRuleWhatIfVariationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleWhatIfVariationClause = null;


        try {
            // InternalDescartesQL.g:5374:2: (iv_ruleWhatIfVariationClause= ruleWhatIfVariationClause EOF )
            // InternalDescartesQL.g:5375:2: iv_ruleWhatIfVariationClause= ruleWhatIfVariationClause EOF
            {
             newCompositeNode(grammarAccess.getWhatIfVariationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleWhatIfVariationClause=ruleWhatIfVariationClause();

            state._fsp--;

             current =iv_ruleWhatIfVariationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleWhatIfVariationClause"


    // $ANTLR start "ruleWhatIfVariationClause"
    // InternalDescartesQL.g:5382:1: ruleWhatIfVariationClause returns [EObject current=null] : ( ( (lv_variationPoint_0_0= RULE_STRING ) ) ( (lv_values_1_0= ruleWhatIfValueVariationClause ) ) ) ;
    public final EObject ruleWhatIfVariationClause() throws RecognitionException {
        EObject current = null;

        Token lv_variationPoint_0_0=null;
        EObject lv_values_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5385:28: ( ( ( (lv_variationPoint_0_0= RULE_STRING ) ) ( (lv_values_1_0= ruleWhatIfValueVariationClause ) ) ) )
            // InternalDescartesQL.g:5386:1: ( ( (lv_variationPoint_0_0= RULE_STRING ) ) ( (lv_values_1_0= ruleWhatIfValueVariationClause ) ) )
            {
            // InternalDescartesQL.g:5386:1: ( ( (lv_variationPoint_0_0= RULE_STRING ) ) ( (lv_values_1_0= ruleWhatIfValueVariationClause ) ) )
            // InternalDescartesQL.g:5386:2: ( (lv_variationPoint_0_0= RULE_STRING ) ) ( (lv_values_1_0= ruleWhatIfValueVariationClause ) )
            {
            // InternalDescartesQL.g:5386:2: ( (lv_variationPoint_0_0= RULE_STRING ) )
            // InternalDescartesQL.g:5387:1: (lv_variationPoint_0_0= RULE_STRING )
            {
            // InternalDescartesQL.g:5387:1: (lv_variationPoint_0_0= RULE_STRING )
            // InternalDescartesQL.g:5388:3: lv_variationPoint_0_0= RULE_STRING
            {
            lv_variationPoint_0_0=(Token)match(input,RULE_STRING,FOLLOW_73); 

            			newLeafNode(lv_variationPoint_0_0, grammarAccess.getWhatIfVariationClauseAccess().getVariationPointSTRINGTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getWhatIfVariationClauseRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"variationPoint",
                    		lv_variationPoint_0_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }

            // InternalDescartesQL.g:5404:2: ( (lv_values_1_0= ruleWhatIfValueVariationClause ) )
            // InternalDescartesQL.g:5405:1: (lv_values_1_0= ruleWhatIfValueVariationClause )
            {
            // InternalDescartesQL.g:5405:1: (lv_values_1_0= ruleWhatIfValueVariationClause )
            // InternalDescartesQL.g:5406:3: lv_values_1_0= ruleWhatIfValueVariationClause
            {
             
            	        newCompositeNode(grammarAccess.getWhatIfVariationClauseAccess().getValuesWhatIfValueVariationClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_values_1_0=ruleWhatIfValueVariationClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getWhatIfVariationClauseRule());
            	        }
                   		set(
                   			current, 
                   			"values",
                    		lv_values_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.WhatIfValueVariationClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleWhatIfVariationClause"


    // $ANTLR start "entryRuleWhatIfValueVariationClause"
    // InternalDescartesQL.g:5430:1: entryRuleWhatIfValueVariationClause returns [EObject current=null] : iv_ruleWhatIfValueVariationClause= ruleWhatIfValueVariationClause EOF ;
    public final EObject entryRuleWhatIfValueVariationClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleWhatIfValueVariationClause = null;


        try {
            // InternalDescartesQL.g:5431:2: (iv_ruleWhatIfValueVariationClause= ruleWhatIfValueVariationClause EOF )
            // InternalDescartesQL.g:5432:2: iv_ruleWhatIfValueVariationClause= ruleWhatIfValueVariationClause EOF
            {
             newCompositeNode(grammarAccess.getWhatIfValueVariationClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleWhatIfValueVariationClause=ruleWhatIfValueVariationClause();

            state._fsp--;

             current =iv_ruleWhatIfValueVariationClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleWhatIfValueVariationClause"


    // $ANTLR start "ruleWhatIfValueVariationClause"
    // InternalDescartesQL.g:5439:1: ruleWhatIfValueVariationClause returns [EObject current=null] : (otherlv_0= '<' ( ( (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction ) ) ) (otherlv_2= ',' ( ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) ) )+ )* otherlv_4= '>' ) ;
    public final EObject ruleWhatIfValueVariationClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject lv_variationClause_1_1 = null;

        EObject lv_variationClause_1_2 = null;

        EObject lv_variationClause_1_3 = null;

        EObject lv_variationClause_1_4 = null;

        EObject lv_variationClause_3_1 = null;

        EObject lv_variationClause_3_2 = null;

        EObject lv_variationClause_3_3 = null;

        EObject lv_variationClause_3_4 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5442:28: ( (otherlv_0= '<' ( ( (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction ) ) ) (otherlv_2= ',' ( ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) ) )+ )* otherlv_4= '>' ) )
            // InternalDescartesQL.g:5443:1: (otherlv_0= '<' ( ( (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction ) ) ) (otherlv_2= ',' ( ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) ) )+ )* otherlv_4= '>' )
            {
            // InternalDescartesQL.g:5443:1: (otherlv_0= '<' ( ( (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction ) ) ) (otherlv_2= ',' ( ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) ) )+ )* otherlv_4= '>' )
            // InternalDescartesQL.g:5443:3: otherlv_0= '<' ( ( (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction ) ) ) (otherlv_2= ',' ( ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) ) )+ )* otherlv_4= '>'
            {
            otherlv_0=(Token)match(input,49,FOLLOW_74); 

                	newLeafNode(otherlv_0, grammarAccess.getWhatIfValueVariationClauseAccess().getLessThanSignKeyword_0());
                
            // InternalDescartesQL.g:5447:1: ( ( (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction ) ) )
            // InternalDescartesQL.g:5448:1: ( (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction ) )
            {
            // InternalDescartesQL.g:5448:1: ( (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction ) )
            // InternalDescartesQL.g:5449:1: (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction )
            {
            // InternalDescartesQL.g:5449:1: (lv_variationClause_1_1= ruleIntervalVariationClause | lv_variationClause_1_2= ruleValueVariationClause | lv_variationClause_1_3= ruleArithmeticClause | lv_variationClause_1_4= ruleVariationInstruction )
            int alt66=4;
            switch ( input.LA(1) ) {
            case RULE_INT:
                {
                int LA66_1 = input.LA(2);

                if ( (LA66_1==51) ) {
                    alt66=1;
                }
                else if ( (LA66_1==20||LA66_1==50) ) {
                    alt66=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 66, 1, input);

                    throw nvae;
                }
                }
                break;
            case 73:
            case 74:
            case 75:
                {
                alt66=3;
                }
                break;
            case RULE_ID:
                {
                alt66=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 66, 0, input);

                throw nvae;
            }

            switch (alt66) {
                case 1 :
                    // InternalDescartesQL.g:5450:3: lv_variationClause_1_1= ruleIntervalVariationClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getWhatIfValueVariationClauseAccess().getVariationClauseIntervalVariationClauseParserRuleCall_1_0_0()); 
                    	    
                    pushFollow(FOLLOW_75);
                    lv_variationClause_1_1=ruleIntervalVariationClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getWhatIfValueVariationClauseRule());
                    	        }
                           		add(
                           			current, 
                           			"variationClause",
                            		lv_variationClause_1_1, 
                            		"tools.descartes.dql.lang.DescartesQL.IntervalVariationClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5465:8: lv_variationClause_1_2= ruleValueVariationClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getWhatIfValueVariationClauseAccess().getVariationClauseValueVariationClauseParserRuleCall_1_0_1()); 
                    	    
                    pushFollow(FOLLOW_75);
                    lv_variationClause_1_2=ruleValueVariationClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getWhatIfValueVariationClauseRule());
                    	        }
                           		add(
                           			current, 
                           			"variationClause",
                            		lv_variationClause_1_2, 
                            		"tools.descartes.dql.lang.DescartesQL.ValueVariationClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:5480:8: lv_variationClause_1_3= ruleArithmeticClause
                    {
                     
                    	        newCompositeNode(grammarAccess.getWhatIfValueVariationClauseAccess().getVariationClauseArithmeticClauseParserRuleCall_1_0_2()); 
                    	    
                    pushFollow(FOLLOW_75);
                    lv_variationClause_1_3=ruleArithmeticClause();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getWhatIfValueVariationClauseRule());
                    	        }
                           		add(
                           			current, 
                           			"variationClause",
                            		lv_variationClause_1_3, 
                            		"tools.descartes.dql.lang.DescartesQL.ArithmeticClause");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;
                case 4 :
                    // InternalDescartesQL.g:5495:8: lv_variationClause_1_4= ruleVariationInstruction
                    {
                     
                    	        newCompositeNode(grammarAccess.getWhatIfValueVariationClauseAccess().getVariationClauseVariationInstructionParserRuleCall_1_0_3()); 
                    	    
                    pushFollow(FOLLOW_75);
                    lv_variationClause_1_4=ruleVariationInstruction();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getWhatIfValueVariationClauseRule());
                    	        }
                           		add(
                           			current, 
                           			"variationClause",
                            		lv_variationClause_1_4, 
                            		"tools.descartes.dql.lang.DescartesQL.VariationInstruction");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }
                    break;

            }


            }


            }

            // InternalDescartesQL.g:5513:2: (otherlv_2= ',' ( ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) ) )+ )*
            loop69:
            do {
                int alt69=2;
                int LA69_0 = input.LA(1);

                if ( (LA69_0==20) ) {
                    alt69=1;
                }


                switch (alt69) {
            	case 1 :
            	    // InternalDescartesQL.g:5513:4: otherlv_2= ',' ( ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) ) )+
            	    {
            	    otherlv_2=(Token)match(input,20,FOLLOW_74); 

            	        	newLeafNode(otherlv_2, grammarAccess.getWhatIfValueVariationClauseAccess().getCommaKeyword_2_0());
            	        
            	    // InternalDescartesQL.g:5517:1: ( ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) ) )+
            	    int cnt68=0;
            	    loop68:
            	    do {
            	        int alt68=2;
            	        int LA68_0 = input.LA(1);

            	        if ( ((LA68_0>=RULE_ID && LA68_0<=RULE_INT)||(LA68_0>=73 && LA68_0<=75)) ) {
            	            alt68=1;
            	        }


            	        switch (alt68) {
            	    	case 1 :
            	    	    // InternalDescartesQL.g:5518:1: ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) )
            	    	    {
            	    	    // InternalDescartesQL.g:5518:1: ( (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction ) )
            	    	    // InternalDescartesQL.g:5519:1: (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction )
            	    	    {
            	    	    // InternalDescartesQL.g:5519:1: (lv_variationClause_3_1= ruleIntervalVariationClause | lv_variationClause_3_2= ruleValueVariationClause | lv_variationClause_3_3= ruleArithmeticClause | lv_variationClause_3_4= ruleVariationInstruction )
            	    	    int alt67=4;
            	    	    switch ( input.LA(1) ) {
            	    	    case RULE_INT:
            	    	        {
            	    	        int LA67_1 = input.LA(2);

            	    	        if ( (LA67_1==51) ) {
            	    	            alt67=1;
            	    	        }
            	    	        else if ( ((LA67_1>=RULE_ID && LA67_1<=RULE_INT)||LA67_1==20||LA67_1==50||(LA67_1>=73 && LA67_1<=75)) ) {
            	    	            alt67=2;
            	    	        }
            	    	        else {
            	    	            NoViableAltException nvae =
            	    	                new NoViableAltException("", 67, 1, input);

            	    	            throw nvae;
            	    	        }
            	    	        }
            	    	        break;
            	    	    case 73:
            	    	    case 74:
            	    	    case 75:
            	    	        {
            	    	        alt67=3;
            	    	        }
            	    	        break;
            	    	    case RULE_ID:
            	    	        {
            	    	        alt67=4;
            	    	        }
            	    	        break;
            	    	    default:
            	    	        NoViableAltException nvae =
            	    	            new NoViableAltException("", 67, 0, input);

            	    	        throw nvae;
            	    	    }

            	    	    switch (alt67) {
            	    	        case 1 :
            	    	            // InternalDescartesQL.g:5520:3: lv_variationClause_3_1= ruleIntervalVariationClause
            	    	            {
            	    	             
            	    	            	        newCompositeNode(grammarAccess.getWhatIfValueVariationClauseAccess().getVariationClauseIntervalVariationClauseParserRuleCall_2_1_0_0()); 
            	    	            	    
            	    	            pushFollow(FOLLOW_76);
            	    	            lv_variationClause_3_1=ruleIntervalVariationClause();

            	    	            state._fsp--;


            	    	            	        if (current==null) {
            	    	            	            current = createModelElementForParent(grammarAccess.getWhatIfValueVariationClauseRule());
            	    	            	        }
            	    	                   		add(
            	    	                   			current, 
            	    	                   			"variationClause",
            	    	                    		lv_variationClause_3_1, 
            	    	                    		"tools.descartes.dql.lang.DescartesQL.IntervalVariationClause");
            	    	            	        afterParserOrEnumRuleCall();
            	    	            	    

            	    	            }
            	    	            break;
            	    	        case 2 :
            	    	            // InternalDescartesQL.g:5535:8: lv_variationClause_3_2= ruleValueVariationClause
            	    	            {
            	    	             
            	    	            	        newCompositeNode(grammarAccess.getWhatIfValueVariationClauseAccess().getVariationClauseValueVariationClauseParserRuleCall_2_1_0_1()); 
            	    	            	    
            	    	            pushFollow(FOLLOW_76);
            	    	            lv_variationClause_3_2=ruleValueVariationClause();

            	    	            state._fsp--;


            	    	            	        if (current==null) {
            	    	            	            current = createModelElementForParent(grammarAccess.getWhatIfValueVariationClauseRule());
            	    	            	        }
            	    	                   		add(
            	    	                   			current, 
            	    	                   			"variationClause",
            	    	                    		lv_variationClause_3_2, 
            	    	                    		"tools.descartes.dql.lang.DescartesQL.ValueVariationClause");
            	    	            	        afterParserOrEnumRuleCall();
            	    	            	    

            	    	            }
            	    	            break;
            	    	        case 3 :
            	    	            // InternalDescartesQL.g:5550:8: lv_variationClause_3_3= ruleArithmeticClause
            	    	            {
            	    	             
            	    	            	        newCompositeNode(grammarAccess.getWhatIfValueVariationClauseAccess().getVariationClauseArithmeticClauseParserRuleCall_2_1_0_2()); 
            	    	            	    
            	    	            pushFollow(FOLLOW_76);
            	    	            lv_variationClause_3_3=ruleArithmeticClause();

            	    	            state._fsp--;


            	    	            	        if (current==null) {
            	    	            	            current = createModelElementForParent(grammarAccess.getWhatIfValueVariationClauseRule());
            	    	            	        }
            	    	                   		add(
            	    	                   			current, 
            	    	                   			"variationClause",
            	    	                    		lv_variationClause_3_3, 
            	    	                    		"tools.descartes.dql.lang.DescartesQL.ArithmeticClause");
            	    	            	        afterParserOrEnumRuleCall();
            	    	            	    

            	    	            }
            	    	            break;
            	    	        case 4 :
            	    	            // InternalDescartesQL.g:5565:8: lv_variationClause_3_4= ruleVariationInstruction
            	    	            {
            	    	             
            	    	            	        newCompositeNode(grammarAccess.getWhatIfValueVariationClauseAccess().getVariationClauseVariationInstructionParserRuleCall_2_1_0_3()); 
            	    	            	    
            	    	            pushFollow(FOLLOW_76);
            	    	            lv_variationClause_3_4=ruleVariationInstruction();

            	    	            state._fsp--;


            	    	            	        if (current==null) {
            	    	            	            current = createModelElementForParent(grammarAccess.getWhatIfValueVariationClauseRule());
            	    	            	        }
            	    	                   		add(
            	    	                   			current, 
            	    	                   			"variationClause",
            	    	                    		lv_variationClause_3_4, 
            	    	                    		"tools.descartes.dql.lang.DescartesQL.VariationInstruction");
            	    	            	        afterParserOrEnumRuleCall();
            	    	            	    

            	    	            }
            	    	            break;

            	    	    }


            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    if ( cnt68 >= 1 ) break loop68;
            	                EarlyExitException eee =
            	                    new EarlyExitException(68, input);
            	                throw eee;
            	        }
            	        cnt68++;
            	    } while (true);


            	    }
            	    break;

            	default :
            	    break loop69;
                }
            } while (true);

            otherlv_4=(Token)match(input,50,FOLLOW_2); 

                	newLeafNode(otherlv_4, grammarAccess.getWhatIfValueVariationClauseAccess().getGreaterThanSignKeyword_3());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleWhatIfValueVariationClause"


    // $ANTLR start "entryRuleVariationInstruction"
    // InternalDescartesQL.g:5597:1: entryRuleVariationInstruction returns [EObject current=null] : iv_ruleVariationInstruction= ruleVariationInstruction EOF ;
    public final EObject entryRuleVariationInstruction() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleVariationInstruction = null;


        try {
            // InternalDescartesQL.g:5598:2: (iv_ruleVariationInstruction= ruleVariationInstruction EOF )
            // InternalDescartesQL.g:5599:2: iv_ruleVariationInstruction= ruleVariationInstruction EOF
            {
             newCompositeNode(grammarAccess.getVariationInstructionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleVariationInstruction=ruleVariationInstruction();

            state._fsp--;

             current =iv_ruleVariationInstruction; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleVariationInstruction"


    // $ANTLR start "ruleVariationInstruction"
    // InternalDescartesQL.g:5606:1: ruleVariationInstruction returns [EObject current=null] : ( ( (lv_variation_0_0= RULE_ID ) ) (otherlv_1= '(' ( (lv_argument_2_0= RULE_STRING ) ) otherlv_3= ')' ) ) ;
    public final EObject ruleVariationInstruction() throws RecognitionException {
        EObject current = null;

        Token lv_variation_0_0=null;
        Token otherlv_1=null;
        Token lv_argument_2_0=null;
        Token otherlv_3=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5609:28: ( ( ( (lv_variation_0_0= RULE_ID ) ) (otherlv_1= '(' ( (lv_argument_2_0= RULE_STRING ) ) otherlv_3= ')' ) ) )
            // InternalDescartesQL.g:5610:1: ( ( (lv_variation_0_0= RULE_ID ) ) (otherlv_1= '(' ( (lv_argument_2_0= RULE_STRING ) ) otherlv_3= ')' ) )
            {
            // InternalDescartesQL.g:5610:1: ( ( (lv_variation_0_0= RULE_ID ) ) (otherlv_1= '(' ( (lv_argument_2_0= RULE_STRING ) ) otherlv_3= ')' ) )
            // InternalDescartesQL.g:5610:2: ( (lv_variation_0_0= RULE_ID ) ) (otherlv_1= '(' ( (lv_argument_2_0= RULE_STRING ) ) otherlv_3= ')' )
            {
            // InternalDescartesQL.g:5610:2: ( (lv_variation_0_0= RULE_ID ) )
            // InternalDescartesQL.g:5611:1: (lv_variation_0_0= RULE_ID )
            {
            // InternalDescartesQL.g:5611:1: (lv_variation_0_0= RULE_ID )
            // InternalDescartesQL.g:5612:3: lv_variation_0_0= RULE_ID
            {
            lv_variation_0_0=(Token)match(input,RULE_ID,FOLLOW_14); 

            			newLeafNode(lv_variation_0_0, grammarAccess.getVariationInstructionAccess().getVariationIDTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getVariationInstructionRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"variation",
                    		lv_variation_0_0, 
                    		"org.eclipse.xtext.common.Terminals.ID");
            	    

            }


            }

            // InternalDescartesQL.g:5628:2: (otherlv_1= '(' ( (lv_argument_2_0= RULE_STRING ) ) otherlv_3= ')' )
            // InternalDescartesQL.g:5628:4: otherlv_1= '(' ( (lv_argument_2_0= RULE_STRING ) ) otherlv_3= ')'
            {
            otherlv_1=(Token)match(input,23,FOLLOW_39); 

                	newLeafNode(otherlv_1, grammarAccess.getVariationInstructionAccess().getLeftParenthesisKeyword_1_0());
                
            // InternalDescartesQL.g:5632:1: ( (lv_argument_2_0= RULE_STRING ) )
            // InternalDescartesQL.g:5633:1: (lv_argument_2_0= RULE_STRING )
            {
            // InternalDescartesQL.g:5633:1: (lv_argument_2_0= RULE_STRING )
            // InternalDescartesQL.g:5634:3: lv_argument_2_0= RULE_STRING
            {
            lv_argument_2_0=(Token)match(input,RULE_STRING,FOLLOW_32); 

            			newLeafNode(lv_argument_2_0, grammarAccess.getVariationInstructionAccess().getArgumentSTRINGTerminalRuleCall_1_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getVariationInstructionRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"argument",
                    		lv_argument_2_0, 
                    		"org.eclipse.xtext.common.Terminals.STRING");
            	    

            }


            }

            otherlv_3=(Token)match(input,24,FOLLOW_2); 

                	newLeafNode(otherlv_3, grammarAccess.getVariationInstructionAccess().getRightParenthesisKeyword_1_2());
                

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleVariationInstruction"


    // $ANTLR start "entryRuleMultipleArithmeticClause"
    // InternalDescartesQL.g:5662:1: entryRuleMultipleArithmeticClause returns [EObject current=null] : iv_ruleMultipleArithmeticClause= ruleMultipleArithmeticClause EOF ;
    public final EObject entryRuleMultipleArithmeticClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMultipleArithmeticClause = null;


        try {
            // InternalDescartesQL.g:5663:2: (iv_ruleMultipleArithmeticClause= ruleMultipleArithmeticClause EOF )
            // InternalDescartesQL.g:5664:2: iv_ruleMultipleArithmeticClause= ruleMultipleArithmeticClause EOF
            {
             newCompositeNode(grammarAccess.getMultipleArithmeticClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMultipleArithmeticClause=ruleMultipleArithmeticClause();

            state._fsp--;

             current =iv_ruleMultipleArithmeticClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMultipleArithmeticClause"


    // $ANTLR start "ruleMultipleArithmeticClause"
    // InternalDescartesQL.g:5671:1: ruleMultipleArithmeticClause returns [EObject current=null] : (otherlv_0= '<' ( (lv_multiClause_1_0= ruleArithmeticClause ) ) (otherlv_2= ',' ( (lv_multiClause_3_0= ruleArithmeticClause ) ) )* otherlv_4= '>' ) ;
    public final EObject ruleMultipleArithmeticClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject lv_multiClause_1_0 = null;

        EObject lv_multiClause_3_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5674:28: ( (otherlv_0= '<' ( (lv_multiClause_1_0= ruleArithmeticClause ) ) (otherlv_2= ',' ( (lv_multiClause_3_0= ruleArithmeticClause ) ) )* otherlv_4= '>' ) )
            // InternalDescartesQL.g:5675:1: (otherlv_0= '<' ( (lv_multiClause_1_0= ruleArithmeticClause ) ) (otherlv_2= ',' ( (lv_multiClause_3_0= ruleArithmeticClause ) ) )* otherlv_4= '>' )
            {
            // InternalDescartesQL.g:5675:1: (otherlv_0= '<' ( (lv_multiClause_1_0= ruleArithmeticClause ) ) (otherlv_2= ',' ( (lv_multiClause_3_0= ruleArithmeticClause ) ) )* otherlv_4= '>' )
            // InternalDescartesQL.g:5675:3: otherlv_0= '<' ( (lv_multiClause_1_0= ruleArithmeticClause ) ) (otherlv_2= ',' ( (lv_multiClause_3_0= ruleArithmeticClause ) ) )* otherlv_4= '>'
            {
            otherlv_0=(Token)match(input,49,FOLLOW_77); 

                	newLeafNode(otherlv_0, grammarAccess.getMultipleArithmeticClauseAccess().getLessThanSignKeyword_0());
                
            // InternalDescartesQL.g:5679:1: ( (lv_multiClause_1_0= ruleArithmeticClause ) )
            // InternalDescartesQL.g:5680:1: (lv_multiClause_1_0= ruleArithmeticClause )
            {
            // InternalDescartesQL.g:5680:1: (lv_multiClause_1_0= ruleArithmeticClause )
            // InternalDescartesQL.g:5681:3: lv_multiClause_1_0= ruleArithmeticClause
            {
             
            	        newCompositeNode(grammarAccess.getMultipleArithmeticClauseAccess().getMultiClauseArithmeticClauseParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_75);
            lv_multiClause_1_0=ruleArithmeticClause();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getMultipleArithmeticClauseRule());
            	        }
                   		add(
                   			current, 
                   			"multiClause",
                    		lv_multiClause_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.ArithmeticClause");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalDescartesQL.g:5697:2: (otherlv_2= ',' ( (lv_multiClause_3_0= ruleArithmeticClause ) ) )*
            loop70:
            do {
                int alt70=2;
                int LA70_0 = input.LA(1);

                if ( (LA70_0==20) ) {
                    alt70=1;
                }


                switch (alt70) {
            	case 1 :
            	    // InternalDescartesQL.g:5697:4: otherlv_2= ',' ( (lv_multiClause_3_0= ruleArithmeticClause ) )
            	    {
            	    otherlv_2=(Token)match(input,20,FOLLOW_77); 

            	        	newLeafNode(otherlv_2, grammarAccess.getMultipleArithmeticClauseAccess().getCommaKeyword_2_0());
            	        
            	    // InternalDescartesQL.g:5701:1: ( (lv_multiClause_3_0= ruleArithmeticClause ) )
            	    // InternalDescartesQL.g:5702:1: (lv_multiClause_3_0= ruleArithmeticClause )
            	    {
            	    // InternalDescartesQL.g:5702:1: (lv_multiClause_3_0= ruleArithmeticClause )
            	    // InternalDescartesQL.g:5703:3: lv_multiClause_3_0= ruleArithmeticClause
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getMultipleArithmeticClauseAccess().getMultiClauseArithmeticClauseParserRuleCall_2_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_75);
            	    lv_multiClause_3_0=ruleArithmeticClause();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getMultipleArithmeticClauseRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"multiClause",
            	            		lv_multiClause_3_0, 
            	            		"tools.descartes.dql.lang.DescartesQL.ArithmeticClause");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop70;
                }
            } while (true);

            otherlv_4=(Token)match(input,50,FOLLOW_2); 

                	newLeafNode(otherlv_4, grammarAccess.getMultipleArithmeticClauseAccess().getGreaterThanSignKeyword_3());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMultipleArithmeticClause"


    // $ANTLR start "entryRuleArithmeticClause"
    // InternalDescartesQL.g:5731:1: entryRuleArithmeticClause returns [EObject current=null] : iv_ruleArithmeticClause= ruleArithmeticClause EOF ;
    public final EObject entryRuleArithmeticClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleArithmeticClause = null;


        try {
            // InternalDescartesQL.g:5732:2: (iv_ruleArithmeticClause= ruleArithmeticClause EOF )
            // InternalDescartesQL.g:5733:2: iv_ruleArithmeticClause= ruleArithmeticClause EOF
            {
             newCompositeNode(grammarAccess.getArithmeticClauseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleArithmeticClause=ruleArithmeticClause();

            state._fsp--;

             current =iv_ruleArithmeticClause; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleArithmeticClause"


    // $ANTLR start "ruleArithmeticClause"
    // InternalDescartesQL.g:5740:1: ruleArithmeticClause returns [EObject current=null] : ( ( ( (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' ) ) ) ( (lv_value_1_0= ruleVariableValue ) ) ) ;
    public final EObject ruleArithmeticClause() throws RecognitionException {
        EObject current = null;

        Token lv_mode_0_1=null;
        Token lv_mode_0_2=null;
        Token lv_mode_0_3=null;
        EObject lv_value_1_0 = null;


         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5743:28: ( ( ( ( (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' ) ) ) ( (lv_value_1_0= ruleVariableValue ) ) ) )
            // InternalDescartesQL.g:5744:1: ( ( ( (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' ) ) ) ( (lv_value_1_0= ruleVariableValue ) ) )
            {
            // InternalDescartesQL.g:5744:1: ( ( ( (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' ) ) ) ( (lv_value_1_0= ruleVariableValue ) ) )
            // InternalDescartesQL.g:5744:2: ( ( (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' ) ) ) ( (lv_value_1_0= ruleVariableValue ) )
            {
            // InternalDescartesQL.g:5744:2: ( ( (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' ) ) )
            // InternalDescartesQL.g:5745:1: ( (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' ) )
            {
            // InternalDescartesQL.g:5745:1: ( (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' ) )
            // InternalDescartesQL.g:5746:1: (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' )
            {
            // InternalDescartesQL.g:5746:1: (lv_mode_0_1= 'ADD' | lv_mode_0_2= 'SUB' | lv_mode_0_3= 'MULTIPLY' )
            int alt71=3;
            switch ( input.LA(1) ) {
            case 73:
                {
                alt71=1;
                }
                break;
            case 74:
                {
                alt71=2;
                }
                break;
            case 75:
                {
                alt71=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 71, 0, input);

                throw nvae;
            }

            switch (alt71) {
                case 1 :
                    // InternalDescartesQL.g:5747:3: lv_mode_0_1= 'ADD'
                    {
                    lv_mode_0_1=(Token)match(input,73,FOLLOW_19); 

                            newLeafNode(lv_mode_0_1, grammarAccess.getArithmeticClauseAccess().getModeADDKeyword_0_0_0());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getArithmeticClauseRule());
                    	        }
                           		setWithLastConsumed(current, "mode", lv_mode_0_1, null);
                    	    

                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5759:8: lv_mode_0_2= 'SUB'
                    {
                    lv_mode_0_2=(Token)match(input,74,FOLLOW_19); 

                            newLeafNode(lv_mode_0_2, grammarAccess.getArithmeticClauseAccess().getModeSUBKeyword_0_0_1());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getArithmeticClauseRule());
                    	        }
                           		setWithLastConsumed(current, "mode", lv_mode_0_2, null);
                    	    

                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:5771:8: lv_mode_0_3= 'MULTIPLY'
                    {
                    lv_mode_0_3=(Token)match(input,75,FOLLOW_19); 

                            newLeafNode(lv_mode_0_3, grammarAccess.getArithmeticClauseAccess().getModeMULTIPLYKeyword_0_0_2());
                        

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getArithmeticClauseRule());
                    	        }
                           		setWithLastConsumed(current, "mode", lv_mode_0_3, null);
                    	    

                    }
                    break;

            }


            }


            }

            // InternalDescartesQL.g:5786:2: ( (lv_value_1_0= ruleVariableValue ) )
            // InternalDescartesQL.g:5787:1: (lv_value_1_0= ruleVariableValue )
            {
            // InternalDescartesQL.g:5787:1: (lv_value_1_0= ruleVariableValue )
            // InternalDescartesQL.g:5788:3: lv_value_1_0= ruleVariableValue
            {
             
            	        newCompositeNode(grammarAccess.getArithmeticClauseAccess().getValueVariableValueParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_2);
            lv_value_1_0=ruleVariableValue();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getArithmeticClauseRule());
            	        }
                   		set(
                   			current, 
                   			"value",
                    		lv_value_1_0, 
                    		"tools.descartes.dql.lang.DescartesQL.VariableValue");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleArithmeticClause"


    // $ANTLR start "entryRuleVariableValue"
    // InternalDescartesQL.g:5812:1: entryRuleVariableValue returns [EObject current=null] : iv_ruleVariableValue= ruleVariableValue EOF ;
    public final EObject entryRuleVariableValue() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleVariableValue = null;


        try {
            // InternalDescartesQL.g:5813:2: (iv_ruleVariableValue= ruleVariableValue EOF )
            // InternalDescartesQL.g:5814:2: iv_ruleVariableValue= ruleVariableValue EOF
            {
             newCompositeNode(grammarAccess.getVariableValueRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleVariableValue=ruleVariableValue();

            state._fsp--;

             current =iv_ruleVariableValue; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleVariableValue"


    // $ANTLR start "ruleVariableValue"
    // InternalDescartesQL.g:5821:1: ruleVariableValue returns [EObject current=null] : ( ( (lv_intValue_0_0= RULE_INT ) ) | ( (lv_doubleValue_1_0= RULE_DOUBLE ) ) ) ;
    public final EObject ruleVariableValue() throws RecognitionException {
        EObject current = null;

        Token lv_intValue_0_0=null;
        Token lv_doubleValue_1_0=null;

         enterRule(); 
            
        try {
            // InternalDescartesQL.g:5824:28: ( ( ( (lv_intValue_0_0= RULE_INT ) ) | ( (lv_doubleValue_1_0= RULE_DOUBLE ) ) ) )
            // InternalDescartesQL.g:5825:1: ( ( (lv_intValue_0_0= RULE_INT ) ) | ( (lv_doubleValue_1_0= RULE_DOUBLE ) ) )
            {
            // InternalDescartesQL.g:5825:1: ( ( (lv_intValue_0_0= RULE_INT ) ) | ( (lv_doubleValue_1_0= RULE_DOUBLE ) ) )
            int alt72=2;
            int LA72_0 = input.LA(1);

            if ( (LA72_0==RULE_INT) ) {
                alt72=1;
            }
            else if ( (LA72_0==RULE_DOUBLE) ) {
                alt72=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 72, 0, input);

                throw nvae;
            }
            switch (alt72) {
                case 1 :
                    // InternalDescartesQL.g:5825:2: ( (lv_intValue_0_0= RULE_INT ) )
                    {
                    // InternalDescartesQL.g:5825:2: ( (lv_intValue_0_0= RULE_INT ) )
                    // InternalDescartesQL.g:5826:1: (lv_intValue_0_0= RULE_INT )
                    {
                    // InternalDescartesQL.g:5826:1: (lv_intValue_0_0= RULE_INT )
                    // InternalDescartesQL.g:5827:3: lv_intValue_0_0= RULE_INT
                    {
                    lv_intValue_0_0=(Token)match(input,RULE_INT,FOLLOW_2); 

                    			newLeafNode(lv_intValue_0_0, grammarAccess.getVariableValueAccess().getIntValueINTTerminalRuleCall_0_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getVariableValueRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"intValue",
                            		lv_intValue_0_0, 
                            		"org.eclipse.xtext.common.Terminals.INT");
                    	    

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5844:6: ( (lv_doubleValue_1_0= RULE_DOUBLE ) )
                    {
                    // InternalDescartesQL.g:5844:6: ( (lv_doubleValue_1_0= RULE_DOUBLE ) )
                    // InternalDescartesQL.g:5845:1: (lv_doubleValue_1_0= RULE_DOUBLE )
                    {
                    // InternalDescartesQL.g:5845:1: (lv_doubleValue_1_0= RULE_DOUBLE )
                    // InternalDescartesQL.g:5846:3: lv_doubleValue_1_0= RULE_DOUBLE
                    {
                    lv_doubleValue_1_0=(Token)match(input,RULE_DOUBLE,FOLLOW_2); 

                    			newLeafNode(lv_doubleValue_1_0, grammarAccess.getVariableValueAccess().getDoubleValueDOUBLETerminalRuleCall_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getVariableValueRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"doubleValue",
                            		lv_doubleValue_1_0, 
                            		"tools.descartes.dql.lang.DescartesQL.DOUBLE");
                    	    

                    }


                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleVariableValue"


    // $ANTLR start "ruleComparator"
    // InternalDescartesQL.g:5870:1: ruleComparator returns [Enumerator current=null] : ( (enumLiteral_0= '<' ) | (enumLiteral_1= '<=' ) | (enumLiteral_2= '>' ) | (enumLiteral_3= '>=' ) | (enumLiteral_4= '==' ) ) ;
    public final Enumerator ruleComparator() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;
        Token enumLiteral_3=null;
        Token enumLiteral_4=null;

         enterRule(); 
        try {
            // InternalDescartesQL.g:5872:28: ( ( (enumLiteral_0= '<' ) | (enumLiteral_1= '<=' ) | (enumLiteral_2= '>' ) | (enumLiteral_3= '>=' ) | (enumLiteral_4= '==' ) ) )
            // InternalDescartesQL.g:5873:1: ( (enumLiteral_0= '<' ) | (enumLiteral_1= '<=' ) | (enumLiteral_2= '>' ) | (enumLiteral_3= '>=' ) | (enumLiteral_4= '==' ) )
            {
            // InternalDescartesQL.g:5873:1: ( (enumLiteral_0= '<' ) | (enumLiteral_1= '<=' ) | (enumLiteral_2= '>' ) | (enumLiteral_3= '>=' ) | (enumLiteral_4= '==' ) )
            int alt73=5;
            switch ( input.LA(1) ) {
            case 49:
                {
                alt73=1;
                }
                break;
            case 76:
                {
                alt73=2;
                }
                break;
            case 50:
                {
                alt73=3;
                }
                break;
            case 77:
                {
                alt73=4;
                }
                break;
            case 78:
                {
                alt73=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 73, 0, input);

                throw nvae;
            }

            switch (alt73) {
                case 1 :
                    // InternalDescartesQL.g:5873:2: (enumLiteral_0= '<' )
                    {
                    // InternalDescartesQL.g:5873:2: (enumLiteral_0= '<' )
                    // InternalDescartesQL.g:5873:4: enumLiteral_0= '<'
                    {
                    enumLiteral_0=(Token)match(input,49,FOLLOW_2); 

                            current = grammarAccess.getComparatorAccess().getLessEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getComparatorAccess().getLessEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5879:6: (enumLiteral_1= '<=' )
                    {
                    // InternalDescartesQL.g:5879:6: (enumLiteral_1= '<=' )
                    // InternalDescartesQL.g:5879:8: enumLiteral_1= '<='
                    {
                    enumLiteral_1=(Token)match(input,76,FOLLOW_2); 

                            current = grammarAccess.getComparatorAccess().getLessEqualEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getComparatorAccess().getLessEqualEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:5885:6: (enumLiteral_2= '>' )
                    {
                    // InternalDescartesQL.g:5885:6: (enumLiteral_2= '>' )
                    // InternalDescartesQL.g:5885:8: enumLiteral_2= '>'
                    {
                    enumLiteral_2=(Token)match(input,50,FOLLOW_2); 

                            current = grammarAccess.getComparatorAccess().getGreaterEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_2, grammarAccess.getComparatorAccess().getGreaterEnumLiteralDeclaration_2()); 
                        

                    }


                    }
                    break;
                case 4 :
                    // InternalDescartesQL.g:5891:6: (enumLiteral_3= '>=' )
                    {
                    // InternalDescartesQL.g:5891:6: (enumLiteral_3= '>=' )
                    // InternalDescartesQL.g:5891:8: enumLiteral_3= '>='
                    {
                    enumLiteral_3=(Token)match(input,77,FOLLOW_2); 

                            current = grammarAccess.getComparatorAccess().getGreaterEqualEnumLiteralDeclaration_3().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_3, grammarAccess.getComparatorAccess().getGreaterEqualEnumLiteralDeclaration_3()); 
                        

                    }


                    }
                    break;
                case 5 :
                    // InternalDescartesQL.g:5897:6: (enumLiteral_4= '==' )
                    {
                    // InternalDescartesQL.g:5897:6: (enumLiteral_4= '==' )
                    // InternalDescartesQL.g:5897:8: enumLiteral_4= '=='
                    {
                    enumLiteral_4=(Token)match(input,78,FOLLOW_2); 

                            current = grammarAccess.getComparatorAccess().getEqualEnumLiteralDeclaration_4().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_4, grammarAccess.getComparatorAccess().getEqualEnumLiteralDeclaration_4()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleComparator"


    // $ANTLR start "ruleCurrency"
    // InternalDescartesQL.g:5907:1: ruleCurrency returns [Enumerator current=null] : ( (enumLiteral_0= 'EUR' ) | (enumLiteral_1= 'USD' ) ) ;
    public final Enumerator ruleCurrency() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // InternalDescartesQL.g:5909:28: ( ( (enumLiteral_0= 'EUR' ) | (enumLiteral_1= 'USD' ) ) )
            // InternalDescartesQL.g:5910:1: ( (enumLiteral_0= 'EUR' ) | (enumLiteral_1= 'USD' ) )
            {
            // InternalDescartesQL.g:5910:1: ( (enumLiteral_0= 'EUR' ) | (enumLiteral_1= 'USD' ) )
            int alt74=2;
            int LA74_0 = input.LA(1);

            if ( (LA74_0==79) ) {
                alt74=1;
            }
            else if ( (LA74_0==80) ) {
                alt74=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 74, 0, input);

                throw nvae;
            }
            switch (alt74) {
                case 1 :
                    // InternalDescartesQL.g:5910:2: (enumLiteral_0= 'EUR' )
                    {
                    // InternalDescartesQL.g:5910:2: (enumLiteral_0= 'EUR' )
                    // InternalDescartesQL.g:5910:4: enumLiteral_0= 'EUR'
                    {
                    enumLiteral_0=(Token)match(input,79,FOLLOW_2); 

                            current = grammarAccess.getCurrencyAccess().getEuroEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getCurrencyAccess().getEuroEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5916:6: (enumLiteral_1= 'USD' )
                    {
                    // InternalDescartesQL.g:5916:6: (enumLiteral_1= 'USD' )
                    // InternalDescartesQL.g:5916:8: enumLiteral_1= 'USD'
                    {
                    enumLiteral_1=(Token)match(input,80,FOLLOW_2); 

                            current = grammarAccess.getCurrencyAccess().getUsDollarEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getCurrencyAccess().getUsDollarEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleCurrency"


    // $ANTLR start "ruleFilterConjunction"
    // InternalDescartesQL.g:5926:1: ruleFilterConjunction returns [Enumerator current=null] : ( (enumLiteral_0= 'AND' ) | (enumLiteral_1= 'XOR' ) | (enumLiteral_2= 'OR' ) ) ;
    public final Enumerator ruleFilterConjunction() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;

         enterRule(); 
        try {
            // InternalDescartesQL.g:5928:28: ( ( (enumLiteral_0= 'AND' ) | (enumLiteral_1= 'XOR' ) | (enumLiteral_2= 'OR' ) ) )
            // InternalDescartesQL.g:5929:1: ( (enumLiteral_0= 'AND' ) | (enumLiteral_1= 'XOR' ) | (enumLiteral_2= 'OR' ) )
            {
            // InternalDescartesQL.g:5929:1: ( (enumLiteral_0= 'AND' ) | (enumLiteral_1= 'XOR' ) | (enumLiteral_2= 'OR' ) )
            int alt75=3;
            switch ( input.LA(1) ) {
            case 68:
                {
                alt75=1;
                }
                break;
            case 81:
                {
                alt75=2;
                }
                break;
            case 82:
                {
                alt75=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 75, 0, input);

                throw nvae;
            }

            switch (alt75) {
                case 1 :
                    // InternalDescartesQL.g:5929:2: (enumLiteral_0= 'AND' )
                    {
                    // InternalDescartesQL.g:5929:2: (enumLiteral_0= 'AND' )
                    // InternalDescartesQL.g:5929:4: enumLiteral_0= 'AND'
                    {
                    enumLiteral_0=(Token)match(input,68,FOLLOW_2); 

                            current = grammarAccess.getFilterConjunctionAccess().getANDEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getFilterConjunctionAccess().getANDEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5935:6: (enumLiteral_1= 'XOR' )
                    {
                    // InternalDescartesQL.g:5935:6: (enumLiteral_1= 'XOR' )
                    // InternalDescartesQL.g:5935:8: enumLiteral_1= 'XOR'
                    {
                    enumLiteral_1=(Token)match(input,81,FOLLOW_2); 

                            current = grammarAccess.getFilterConjunctionAccess().getXOREnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getFilterConjunctionAccess().getXOREnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:5941:6: (enumLiteral_2= 'OR' )
                    {
                    // InternalDescartesQL.g:5941:6: (enumLiteral_2= 'OR' )
                    // InternalDescartesQL.g:5941:8: enumLiteral_2= 'OR'
                    {
                    enumLiteral_2=(Token)match(input,82,FOLLOW_2); 

                            current = grammarAccess.getFilterConjunctionAccess().getOREnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_2, grammarAccess.getFilterConjunctionAccess().getOREnumLiteralDeclaration_2()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFilterConjunction"


    // $ANTLR start "ruleFilterConditionType"
    // InternalDescartesQL.g:5951:1: ruleFilterConditionType returns [Enumerator current=null] : ( (enumLiteral_0= 'INSTANCEOF' ) | (enumLiteral_1= 'CLASSREGEX' ) ) ;
    public final Enumerator ruleFilterConditionType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // InternalDescartesQL.g:5953:28: ( ( (enumLiteral_0= 'INSTANCEOF' ) | (enumLiteral_1= 'CLASSREGEX' ) ) )
            // InternalDescartesQL.g:5954:1: ( (enumLiteral_0= 'INSTANCEOF' ) | (enumLiteral_1= 'CLASSREGEX' ) )
            {
            // InternalDescartesQL.g:5954:1: ( (enumLiteral_0= 'INSTANCEOF' ) | (enumLiteral_1= 'CLASSREGEX' ) )
            int alt76=2;
            int LA76_0 = input.LA(1);

            if ( (LA76_0==83) ) {
                alt76=1;
            }
            else if ( (LA76_0==84) ) {
                alt76=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 76, 0, input);

                throw nvae;
            }
            switch (alt76) {
                case 1 :
                    // InternalDescartesQL.g:5954:2: (enumLiteral_0= 'INSTANCEOF' )
                    {
                    // InternalDescartesQL.g:5954:2: (enumLiteral_0= 'INSTANCEOF' )
                    // InternalDescartesQL.g:5954:4: enumLiteral_0= 'INSTANCEOF'
                    {
                    enumLiteral_0=(Token)match(input,83,FOLLOW_2); 

                            current = grammarAccess.getFilterConditionTypeAccess().getINSTANCEOFEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getFilterConditionTypeAccess().getINSTANCEOFEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5960:6: (enumLiteral_1= 'CLASSREGEX' )
                    {
                    // InternalDescartesQL.g:5960:6: (enumLiteral_1= 'CLASSREGEX' )
                    // InternalDescartesQL.g:5960:8: enumLiteral_1= 'CLASSREGEX'
                    {
                    enumLiteral_1=(Token)match(input,84,FOLLOW_2); 

                            current = grammarAccess.getFilterConditionTypeAccess().getCLASSREGEXEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getFilterConditionTypeAccess().getCLASSREGEXEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFilterConditionType"


    // $ANTLR start "ruleObserveRelativeDirectionType"
    // InternalDescartesQL.g:5970:1: ruleObserveRelativeDirectionType returns [Enumerator current=null] : ( (enumLiteral_0= 'SINCE' ) | (enumLiteral_1= 'NEXT' ) ) ;
    public final Enumerator ruleObserveRelativeDirectionType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // InternalDescartesQL.g:5972:28: ( ( (enumLiteral_0= 'SINCE' ) | (enumLiteral_1= 'NEXT' ) ) )
            // InternalDescartesQL.g:5973:1: ( (enumLiteral_0= 'SINCE' ) | (enumLiteral_1= 'NEXT' ) )
            {
            // InternalDescartesQL.g:5973:1: ( (enumLiteral_0= 'SINCE' ) | (enumLiteral_1= 'NEXT' ) )
            int alt77=2;
            int LA77_0 = input.LA(1);

            if ( (LA77_0==85) ) {
                alt77=1;
            }
            else if ( (LA77_0==86) ) {
                alt77=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 77, 0, input);

                throw nvae;
            }
            switch (alt77) {
                case 1 :
                    // InternalDescartesQL.g:5973:2: (enumLiteral_0= 'SINCE' )
                    {
                    // InternalDescartesQL.g:5973:2: (enumLiteral_0= 'SINCE' )
                    // InternalDescartesQL.g:5973:4: enumLiteral_0= 'SINCE'
                    {
                    enumLiteral_0=(Token)match(input,85,FOLLOW_2); 

                            current = grammarAccess.getObserveRelativeDirectionTypeAccess().getSINCEEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getObserveRelativeDirectionTypeAccess().getSINCEEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5979:6: (enumLiteral_1= 'NEXT' )
                    {
                    // InternalDescartesQL.g:5979:6: (enumLiteral_1= 'NEXT' )
                    // InternalDescartesQL.g:5979:8: enumLiteral_1= 'NEXT'
                    {
                    enumLiteral_1=(Token)match(input,86,FOLLOW_2); 

                            current = grammarAccess.getObserveRelativeDirectionTypeAccess().getNEXTEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getObserveRelativeDirectionTypeAccess().getNEXTEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleObserveRelativeDirectionType"


    // $ANTLR start "ruleRelativeTimeSignType"
    // InternalDescartesQL.g:5989:1: ruleRelativeTimeSignType returns [Enumerator current=null] : ( (enumLiteral_0= '-' ) | (enumLiteral_1= '+' ) ) ;
    public final Enumerator ruleRelativeTimeSignType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // InternalDescartesQL.g:5991:28: ( ( (enumLiteral_0= '-' ) | (enumLiteral_1= '+' ) ) )
            // InternalDescartesQL.g:5992:1: ( (enumLiteral_0= '-' ) | (enumLiteral_1= '+' ) )
            {
            // InternalDescartesQL.g:5992:1: ( (enumLiteral_0= '-' ) | (enumLiteral_1= '+' ) )
            int alt78=2;
            int LA78_0 = input.LA(1);

            if ( (LA78_0==87) ) {
                alt78=1;
            }
            else if ( (LA78_0==88) ) {
                alt78=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 78, 0, input);

                throw nvae;
            }
            switch (alt78) {
                case 1 :
                    // InternalDescartesQL.g:5992:2: (enumLiteral_0= '-' )
                    {
                    // InternalDescartesQL.g:5992:2: (enumLiteral_0= '-' )
                    // InternalDescartesQL.g:5992:4: enumLiteral_0= '-'
                    {
                    enumLiteral_0=(Token)match(input,87,FOLLOW_2); 

                            current = grammarAccess.getRelativeTimeSignTypeAccess().getMINUSEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getRelativeTimeSignTypeAccess().getMINUSEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:5998:6: (enumLiteral_1= '+' )
                    {
                    // InternalDescartesQL.g:5998:6: (enumLiteral_1= '+' )
                    // InternalDescartesQL.g:5998:8: enumLiteral_1= '+'
                    {
                    enumLiteral_1=(Token)match(input,88,FOLLOW_2); 

                            current = grammarAccess.getRelativeTimeSignTypeAccess().getPLUSEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getRelativeTimeSignTypeAccess().getPLUSEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRelativeTimeSignType"


    // $ANTLR start "ruleTimeModifierType"
    // InternalDescartesQL.g:6008:1: ruleTimeModifierType returns [Enumerator current=null] : ( (enumLiteral_0= 'y' ) | (enumLiteral_1= 'm' ) | (enumLiteral_2= 'w' ) | (enumLiteral_3= 'd' ) | (enumLiteral_4= 'h' ) | (enumLiteral_5= 'M' ) | (enumLiteral_6= 's' ) | (enumLiteral_7= 'S' ) ) ;
    public final Enumerator ruleTimeModifierType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;
        Token enumLiteral_3=null;
        Token enumLiteral_4=null;
        Token enumLiteral_5=null;
        Token enumLiteral_6=null;
        Token enumLiteral_7=null;

         enterRule(); 
        try {
            // InternalDescartesQL.g:6010:28: ( ( (enumLiteral_0= 'y' ) | (enumLiteral_1= 'm' ) | (enumLiteral_2= 'w' ) | (enumLiteral_3= 'd' ) | (enumLiteral_4= 'h' ) | (enumLiteral_5= 'M' ) | (enumLiteral_6= 's' ) | (enumLiteral_7= 'S' ) ) )
            // InternalDescartesQL.g:6011:1: ( (enumLiteral_0= 'y' ) | (enumLiteral_1= 'm' ) | (enumLiteral_2= 'w' ) | (enumLiteral_3= 'd' ) | (enumLiteral_4= 'h' ) | (enumLiteral_5= 'M' ) | (enumLiteral_6= 's' ) | (enumLiteral_7= 'S' ) )
            {
            // InternalDescartesQL.g:6011:1: ( (enumLiteral_0= 'y' ) | (enumLiteral_1= 'm' ) | (enumLiteral_2= 'w' ) | (enumLiteral_3= 'd' ) | (enumLiteral_4= 'h' ) | (enumLiteral_5= 'M' ) | (enumLiteral_6= 's' ) | (enumLiteral_7= 'S' ) )
            int alt79=8;
            switch ( input.LA(1) ) {
            case 89:
                {
                alt79=1;
                }
                break;
            case 90:
                {
                alt79=2;
                }
                break;
            case 91:
                {
                alt79=3;
                }
                break;
            case 92:
                {
                alt79=4;
                }
                break;
            case 93:
                {
                alt79=5;
                }
                break;
            case 94:
                {
                alt79=6;
                }
                break;
            case 95:
                {
                alt79=7;
                }
                break;
            case 96:
                {
                alt79=8;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 79, 0, input);

                throw nvae;
            }

            switch (alt79) {
                case 1 :
                    // InternalDescartesQL.g:6011:2: (enumLiteral_0= 'y' )
                    {
                    // InternalDescartesQL.g:6011:2: (enumLiteral_0= 'y' )
                    // InternalDescartesQL.g:6011:4: enumLiteral_0= 'y'
                    {
                    enumLiteral_0=(Token)match(input,89,FOLLOW_2); 

                            current = grammarAccess.getTimeModifierTypeAccess().getYEAREnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getTimeModifierTypeAccess().getYEAREnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:6017:6: (enumLiteral_1= 'm' )
                    {
                    // InternalDescartesQL.g:6017:6: (enumLiteral_1= 'm' )
                    // InternalDescartesQL.g:6017:8: enumLiteral_1= 'm'
                    {
                    enumLiteral_1=(Token)match(input,90,FOLLOW_2); 

                            current = grammarAccess.getTimeModifierTypeAccess().getMONTHEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getTimeModifierTypeAccess().getMONTHEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:6023:6: (enumLiteral_2= 'w' )
                    {
                    // InternalDescartesQL.g:6023:6: (enumLiteral_2= 'w' )
                    // InternalDescartesQL.g:6023:8: enumLiteral_2= 'w'
                    {
                    enumLiteral_2=(Token)match(input,91,FOLLOW_2); 

                            current = grammarAccess.getTimeModifierTypeAccess().getWEEKEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_2, grammarAccess.getTimeModifierTypeAccess().getWEEKEnumLiteralDeclaration_2()); 
                        

                    }


                    }
                    break;
                case 4 :
                    // InternalDescartesQL.g:6029:6: (enumLiteral_3= 'd' )
                    {
                    // InternalDescartesQL.g:6029:6: (enumLiteral_3= 'd' )
                    // InternalDescartesQL.g:6029:8: enumLiteral_3= 'd'
                    {
                    enumLiteral_3=(Token)match(input,92,FOLLOW_2); 

                            current = grammarAccess.getTimeModifierTypeAccess().getDAYEnumLiteralDeclaration_3().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_3, grammarAccess.getTimeModifierTypeAccess().getDAYEnumLiteralDeclaration_3()); 
                        

                    }


                    }
                    break;
                case 5 :
                    // InternalDescartesQL.g:6035:6: (enumLiteral_4= 'h' )
                    {
                    // InternalDescartesQL.g:6035:6: (enumLiteral_4= 'h' )
                    // InternalDescartesQL.g:6035:8: enumLiteral_4= 'h'
                    {
                    enumLiteral_4=(Token)match(input,93,FOLLOW_2); 

                            current = grammarAccess.getTimeModifierTypeAccess().getHOUREnumLiteralDeclaration_4().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_4, grammarAccess.getTimeModifierTypeAccess().getHOUREnumLiteralDeclaration_4()); 
                        

                    }


                    }
                    break;
                case 6 :
                    // InternalDescartesQL.g:6041:6: (enumLiteral_5= 'M' )
                    {
                    // InternalDescartesQL.g:6041:6: (enumLiteral_5= 'M' )
                    // InternalDescartesQL.g:6041:8: enumLiteral_5= 'M'
                    {
                    enumLiteral_5=(Token)match(input,94,FOLLOW_2); 

                            current = grammarAccess.getTimeModifierTypeAccess().getMINUTEEnumLiteralDeclaration_5().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_5, grammarAccess.getTimeModifierTypeAccess().getMINUTEEnumLiteralDeclaration_5()); 
                        

                    }


                    }
                    break;
                case 7 :
                    // InternalDescartesQL.g:6047:6: (enumLiteral_6= 's' )
                    {
                    // InternalDescartesQL.g:6047:6: (enumLiteral_6= 's' )
                    // InternalDescartesQL.g:6047:8: enumLiteral_6= 's'
                    {
                    enumLiteral_6=(Token)match(input,95,FOLLOW_2); 

                            current = grammarAccess.getTimeModifierTypeAccess().getSECONDEnumLiteralDeclaration_6().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_6, grammarAccess.getTimeModifierTypeAccess().getSECONDEnumLiteralDeclaration_6()); 
                        

                    }


                    }
                    break;
                case 8 :
                    // InternalDescartesQL.g:6053:6: (enumLiteral_7= 'S' )
                    {
                    // InternalDescartesQL.g:6053:6: (enumLiteral_7= 'S' )
                    // InternalDescartesQL.g:6053:8: enumLiteral_7= 'S'
                    {
                    enumLiteral_7=(Token)match(input,96,FOLLOW_2); 

                            current = grammarAccess.getTimeModifierTypeAccess().getMILLISECONDEnumLiteralDeclaration_7().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_7, grammarAccess.getTimeModifierTypeAccess().getMILLISECONDEnumLiteralDeclaration_7()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTimeModifierType"


    // $ANTLR start "ruleStatisticalAggregateType"
    // InternalDescartesQL.g:6063:1: ruleStatisticalAggregateType returns [Enumerator current=null] : ( (enumLiteral_0= 'MIN' ) | (enumLiteral_1= 'MAX' ) | (enumLiteral_2= 'GEOMEAN' ) | (enumLiteral_3= 'N' ) | (enumLiteral_4= 'SUM' ) | (enumLiteral_5= 'SUMOFSQUARES' ) | (enumLiteral_6= 'STDDEV' ) | (enumLiteral_7= 'VAR' ) | (enumLiteral_8= 'PERCENTILE' ) | (enumLiteral_9= 'MEAN' ) ) ;
    public final Enumerator ruleStatisticalAggregateType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;
        Token enumLiteral_3=null;
        Token enumLiteral_4=null;
        Token enumLiteral_5=null;
        Token enumLiteral_6=null;
        Token enumLiteral_7=null;
        Token enumLiteral_8=null;
        Token enumLiteral_9=null;

         enterRule(); 
        try {
            // InternalDescartesQL.g:6065:28: ( ( (enumLiteral_0= 'MIN' ) | (enumLiteral_1= 'MAX' ) | (enumLiteral_2= 'GEOMEAN' ) | (enumLiteral_3= 'N' ) | (enumLiteral_4= 'SUM' ) | (enumLiteral_5= 'SUMOFSQUARES' ) | (enumLiteral_6= 'STDDEV' ) | (enumLiteral_7= 'VAR' ) | (enumLiteral_8= 'PERCENTILE' ) | (enumLiteral_9= 'MEAN' ) ) )
            // InternalDescartesQL.g:6066:1: ( (enumLiteral_0= 'MIN' ) | (enumLiteral_1= 'MAX' ) | (enumLiteral_2= 'GEOMEAN' ) | (enumLiteral_3= 'N' ) | (enumLiteral_4= 'SUM' ) | (enumLiteral_5= 'SUMOFSQUARES' ) | (enumLiteral_6= 'STDDEV' ) | (enumLiteral_7= 'VAR' ) | (enumLiteral_8= 'PERCENTILE' ) | (enumLiteral_9= 'MEAN' ) )
            {
            // InternalDescartesQL.g:6066:1: ( (enumLiteral_0= 'MIN' ) | (enumLiteral_1= 'MAX' ) | (enumLiteral_2= 'GEOMEAN' ) | (enumLiteral_3= 'N' ) | (enumLiteral_4= 'SUM' ) | (enumLiteral_5= 'SUMOFSQUARES' ) | (enumLiteral_6= 'STDDEV' ) | (enumLiteral_7= 'VAR' ) | (enumLiteral_8= 'PERCENTILE' ) | (enumLiteral_9= 'MEAN' ) )
            int alt80=10;
            switch ( input.LA(1) ) {
            case 97:
                {
                alt80=1;
                }
                break;
            case 98:
                {
                alt80=2;
                }
                break;
            case 99:
                {
                alt80=3;
                }
                break;
            case 100:
                {
                alt80=4;
                }
                break;
            case 101:
                {
                alt80=5;
                }
                break;
            case 102:
                {
                alt80=6;
                }
                break;
            case 103:
                {
                alt80=7;
                }
                break;
            case 104:
                {
                alt80=8;
                }
                break;
            case 105:
                {
                alt80=9;
                }
                break;
            case 106:
                {
                alt80=10;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 80, 0, input);

                throw nvae;
            }

            switch (alt80) {
                case 1 :
                    // InternalDescartesQL.g:6066:2: (enumLiteral_0= 'MIN' )
                    {
                    // InternalDescartesQL.g:6066:2: (enumLiteral_0= 'MIN' )
                    // InternalDescartesQL.g:6066:4: enumLiteral_0= 'MIN'
                    {
                    enumLiteral_0=(Token)match(input,97,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getMINEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getStatisticalAggregateTypeAccess().getMINEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // InternalDescartesQL.g:6072:6: (enumLiteral_1= 'MAX' )
                    {
                    // InternalDescartesQL.g:6072:6: (enumLiteral_1= 'MAX' )
                    // InternalDescartesQL.g:6072:8: enumLiteral_1= 'MAX'
                    {
                    enumLiteral_1=(Token)match(input,98,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getMAXEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getStatisticalAggregateTypeAccess().getMAXEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;
                case 3 :
                    // InternalDescartesQL.g:6078:6: (enumLiteral_2= 'GEOMEAN' )
                    {
                    // InternalDescartesQL.g:6078:6: (enumLiteral_2= 'GEOMEAN' )
                    // InternalDescartesQL.g:6078:8: enumLiteral_2= 'GEOMEAN'
                    {
                    enumLiteral_2=(Token)match(input,99,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getGEOMEANEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_2, grammarAccess.getStatisticalAggregateTypeAccess().getGEOMEANEnumLiteralDeclaration_2()); 
                        

                    }


                    }
                    break;
                case 4 :
                    // InternalDescartesQL.g:6084:6: (enumLiteral_3= 'N' )
                    {
                    // InternalDescartesQL.g:6084:6: (enumLiteral_3= 'N' )
                    // InternalDescartesQL.g:6084:8: enumLiteral_3= 'N'
                    {
                    enumLiteral_3=(Token)match(input,100,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getNEnumLiteralDeclaration_3().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_3, grammarAccess.getStatisticalAggregateTypeAccess().getNEnumLiteralDeclaration_3()); 
                        

                    }


                    }
                    break;
                case 5 :
                    // InternalDescartesQL.g:6090:6: (enumLiteral_4= 'SUM' )
                    {
                    // InternalDescartesQL.g:6090:6: (enumLiteral_4= 'SUM' )
                    // InternalDescartesQL.g:6090:8: enumLiteral_4= 'SUM'
                    {
                    enumLiteral_4=(Token)match(input,101,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getSUMEnumLiteralDeclaration_4().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_4, grammarAccess.getStatisticalAggregateTypeAccess().getSUMEnumLiteralDeclaration_4()); 
                        

                    }


                    }
                    break;
                case 6 :
                    // InternalDescartesQL.g:6096:6: (enumLiteral_5= 'SUMOFSQUARES' )
                    {
                    // InternalDescartesQL.g:6096:6: (enumLiteral_5= 'SUMOFSQUARES' )
                    // InternalDescartesQL.g:6096:8: enumLiteral_5= 'SUMOFSQUARES'
                    {
                    enumLiteral_5=(Token)match(input,102,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getSUMOFSQUARESEnumLiteralDeclaration_5().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_5, grammarAccess.getStatisticalAggregateTypeAccess().getSUMOFSQUARESEnumLiteralDeclaration_5()); 
                        

                    }


                    }
                    break;
                case 7 :
                    // InternalDescartesQL.g:6102:6: (enumLiteral_6= 'STDDEV' )
                    {
                    // InternalDescartesQL.g:6102:6: (enumLiteral_6= 'STDDEV' )
                    // InternalDescartesQL.g:6102:8: enumLiteral_6= 'STDDEV'
                    {
                    enumLiteral_6=(Token)match(input,103,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getSTDDEVEnumLiteralDeclaration_6().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_6, grammarAccess.getStatisticalAggregateTypeAccess().getSTDDEVEnumLiteralDeclaration_6()); 
                        

                    }


                    }
                    break;
                case 8 :
                    // InternalDescartesQL.g:6108:6: (enumLiteral_7= 'VAR' )
                    {
                    // InternalDescartesQL.g:6108:6: (enumLiteral_7= 'VAR' )
                    // InternalDescartesQL.g:6108:8: enumLiteral_7= 'VAR'
                    {
                    enumLiteral_7=(Token)match(input,104,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getVAREnumLiteralDeclaration_7().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_7, grammarAccess.getStatisticalAggregateTypeAccess().getVAREnumLiteralDeclaration_7()); 
                        

                    }


                    }
                    break;
                case 9 :
                    // InternalDescartesQL.g:6114:6: (enumLiteral_8= 'PERCENTILE' )
                    {
                    // InternalDescartesQL.g:6114:6: (enumLiteral_8= 'PERCENTILE' )
                    // InternalDescartesQL.g:6114:8: enumLiteral_8= 'PERCENTILE'
                    {
                    enumLiteral_8=(Token)match(input,105,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getPERCENTILEEnumLiteralDeclaration_8().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_8, grammarAccess.getStatisticalAggregateTypeAccess().getPERCENTILEEnumLiteralDeclaration_8()); 
                        

                    }


                    }
                    break;
                case 10 :
                    // InternalDescartesQL.g:6120:6: (enumLiteral_9= 'MEAN' )
                    {
                    // InternalDescartesQL.g:6120:6: (enumLiteral_9= 'MEAN' )
                    // InternalDescartesQL.g:6120:8: enumLiteral_9= 'MEAN'
                    {
                    enumLiteral_9=(Token)match(input,106,FOLLOW_2); 

                            current = grammarAccess.getStatisticalAggregateTypeAccess().getMEANEnumLiteralDeclaration_9().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_9, grammarAccess.getStatisticalAggregateTypeAccess().getMEANEnumLiteralDeclaration_9()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStatisticalAggregateType"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x14000C0000000000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x14020C0000020000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x14000C0000020000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000100002L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000001100000L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000000020L,0x000007FE00000000L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0006000000000000L,0x0000000000007000L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000038020002L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000030020002L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000020020002L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000004000002L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x0000000000000002L,0x0000000000018000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000007000000000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x94000C0000000000L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x0000000E00000000L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x2000000000000002L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x00000000000000A0L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x04000C0000000000L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0400080000000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0400000000000000L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000002L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x0000020000000000L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000080000000000L});
    public static final BitSet FOLLOW_39 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_40 = new BitSet(new long[]{0x2020140000000002L});
    public static final BitSet FOLLOW_41 = new BitSet(new long[]{0x2000140000000002L});
    public static final BitSet FOLLOW_42 = new BitSet(new long[]{0x2000040000000002L});
    public static final BitSet FOLLOW_43 = new BitSet(new long[]{0x0000200000000002L});
    public static final BitSet FOLLOW_44 = new BitSet(new long[]{0x0000400000100000L});
    public static final BitSet FOLLOW_45 = new BitSet(new long[]{0x0001800000000000L});
    public static final BitSet FOLLOW_46 = new BitSet(new long[]{0x0004000000000000L});
    public static final BitSet FOLLOW_47 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_48 = new BitSet(new long[]{0x0010000000000000L});
    public static final BitSet FOLLOW_49 = new BitSet(new long[]{0x0802200000000002L});
    public static final BitSet FOLLOW_50 = new BitSet(new long[]{0x0002200000000002L});
    public static final BitSet FOLLOW_51 = new BitSet(new long[]{0x0040000000000020L});
    public static final BitSet FOLLOW_52 = new BitSet(new long[]{0x0000800000000000L});
    public static final BitSet FOLLOW_53 = new BitSet(new long[]{0x0380000000000000L});
    public static final BitSet FOLLOW_54 = new BitSet(new long[]{0x0000800000000002L});
    public static final BitSet FOLLOW_55 = new BitSet(new long[]{0x0800000000000002L});
    public static final BitSet FOLLOW_56 = new BitSet(new long[]{0x4000000000000000L});
    public static final BitSet FOLLOW_57 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_58 = new BitSet(new long[]{0x0000000000000002L,0x0000000000060010L});
    public static final BitSet FOLLOW_59 = new BitSet(new long[]{0x0000000000000000L,0x0000000000180000L});
    public static final BitSet FOLLOW_60 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_61 = new BitSet(new long[]{0x0000000000000060L,0x0000000000600008L});
    public static final BitSet FOLLOW_62 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L});
    public static final BitSet FOLLOW_63 = new BitSet(new long[]{0x0000000000000042L});
    public static final BitSet FOLLOW_64 = new BitSet(new long[]{0x00000000000000C0L});
    public static final BitSet FOLLOW_65 = new BitSet(new long[]{0x0000000000000080L,0x0000000001800000L});
    public static final BitSet FOLLOW_66 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_67 = new BitSet(new long[]{0x0000000000000000L,0x00000001FE000000L});
    public static final BitSet FOLLOW_68 = new BitSet(new long[]{0x14000C8000000000L,0x00000000000000C0L});
    public static final BitSet FOLLOW_69 = new BitSet(new long[]{0x14000C0000000000L,0x00000000000000C0L});
    public static final BitSet FOLLOW_70 = new BitSet(new long[]{0x14000C0000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_71 = new BitSet(new long[]{0x00000000000000D0L});
    public static final BitSet FOLLOW_72 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000100L});
    public static final BitSet FOLLOW_73 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_74 = new BitSet(new long[]{0x0000000000000060L,0x0000000000000E00L});
    public static final BitSet FOLLOW_75 = new BitSet(new long[]{0x0004000000100000L});
    public static final BitSet FOLLOW_76 = new BitSet(new long[]{0x0004000000100060L,0x0000000000000E00L});
    public static final BitSet FOLLOW_77 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000E00L});

}